/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2010, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.713.2.1 2010/08/18 18:35:30 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs,
							  int location, core_yyscan_t yyscanner);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 217 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     ARRAY = 285,
     AS = 286,
     ASC = 287,
     ASSERTION = 288,
     ASSIGNMENT = 289,
     ASYMMETRIC = 290,
     AT = 291,
     AUTHORIZATION = 292,
     BACKWARD = 293,
     BEFORE = 294,
     BEGIN_P = 295,
     BETWEEN = 296,
     BIGINT = 297,
     BINARY = 298,
     BIT = 299,
     BOOLEAN_P = 300,
     BOTH = 301,
     BY = 302,
     CACHE = 303,
     CALLED = 304,
     CASCADE = 305,
     CASCADED = 306,
     CASE = 307,
     CAST = 308,
     CATALOG_P = 309,
     CHAIN = 310,
     CHAR_P = 311,
     CHARACTER = 312,
     CHARACTERISTICS = 313,
     CHECK = 314,
     CHECKPOINT = 315,
     CLASS = 316,
     CLOSE = 317,
     CLUSTER = 318,
     COALESCE = 319,
     COLLATE = 320,
     COLUMN = 321,
     COMMENT = 322,
     COMMENTS = 323,
     COMMIT = 324,
     COMMITTED = 325,
     CONCURRENTLY = 326,
     CONFIGURATION = 327,
     CONNECTION = 328,
     CONSTRAINT = 329,
     CONSTRAINTS = 330,
     CONTENT_P = 331,
     CONTINUE_P = 332,
     CONVERSION_P = 333,
     COPY = 334,
     COST = 335,
     CREATE = 336,
     CREATEDB = 337,
     CREATEROLE = 338,
     CREATEUSER = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTERNAL = 392,
     EXTRACT = 393,
     FALSE_P = 394,
     FAMILY = 395,
     FETCH = 396,
     FIRST_P = 397,
     FLOAT_P = 398,
     FOLLOWING = 399,
     FOR = 400,
     FORCE = 401,
     FOREIGN = 402,
     FORWARD = 403,
     FREEZE = 404,
     FROM = 405,
     FULL = 406,
     FUNCTION = 407,
     FUNCTIONS = 408,
     GLOBAL = 409,
     GRANT = 410,
     GRANTED = 411,
     GREATEST = 412,
     GROUP_P = 413,
     HANDLER = 414,
     HAVING = 415,
     HEADER_P = 416,
     HOLD = 417,
     HOUR_P = 418,
     IDENTITY_P = 419,
     IF_P = 420,
     ILIKE = 421,
     IMMEDIATE = 422,
     IMMUTABLE = 423,
     IMPLICIT_P = 424,
     IN_P = 425,
     INCLUDING = 426,
     INCREMENT = 427,
     INDEX = 428,
     INDEXES = 429,
     INHERIT = 430,
     INHERITS = 431,
     INITIALLY = 432,
     INLINE_P = 433,
     INNER_P = 434,
     INOUT = 435,
     INPUT_P = 436,
     INSENSITIVE = 437,
     INSERT = 438,
     INSTEAD = 439,
     INT_P = 440,
     INTEGER = 441,
     INTERSECT = 442,
     INTERVAL = 443,
     INTO = 444,
     INVOKER = 445,
     IS = 446,
     ISNULL = 447,
     ISOLATION = 448,
     JOIN = 449,
     KEY = 450,
     LABEL = 451,
     LANGUAGE = 452,
     LARGE_P = 453,
     LAST_P = 454,
     LC_COLLATE_P = 455,
     LC_CTYPE_P = 456,
     LEADING = 457,
     LEAST = 458,
     LEFT = 459,
     LEVEL = 460,
     LIKE = 461,
     LIMIT = 462,
     LISTEN = 463,
     LOAD = 464,
     LOCAL = 465,
     LOCALTIME = 466,
     LOCALTIMESTAMP = 467,
     LOCATION = 468,
     LOCK_P = 469,
     LOGIN_P = 470,
     MAPPING = 471,
     MATCH = 472,
     MAXVALUE = 473,
     MINUTE_P = 474,
     MINVALUE = 475,
     MODE = 476,
     MONTH_P = 477,
     MOVE = 478,
     NAME_P = 479,
     NAMES = 480,
     NATIONAL = 481,
     NATURAL = 482,
     NCHAR = 483,
     NEXT = 484,
     NO = 485,
     NOCREATEDB = 486,
     NOCREATEROLE = 487,
     NOCREATEUSER = 488,
     NOINHERIT = 489,
     NOLOGIN_P = 490,
     NONE = 491,
     NOSUPERUSER = 492,
     NOT = 493,
     NOTHING = 494,
     NOTIFY = 495,
     NOTNULL = 496,
     NOWAIT = 497,
     NULL_P = 498,
     NULLIF = 499,
     NULLS_P = 500,
     NUMERIC = 501,
     OBJECT_P = 502,
     OF = 503,
     OFF = 504,
     OFFSET = 505,
     OIDS = 506,
     ON = 507,
     ONLY = 508,
     OPERATOR = 509,
     OPTION = 510,
     OPTIONS = 511,
     OR = 512,
     ORDER = 513,
     OUT_P = 514,
     OUTER_P = 515,
     OVER = 516,
     OVERLAPS = 517,
     OVERLAY = 518,
     OWNED = 519,
     OWNER = 520,
     PARSER = 521,
     PARTIAL = 522,
     PARTITION = 523,
     PASSWORD = 524,
     PLACING = 525,
     PLANS = 526,
     POSITION = 527,
     PRECEDING = 528,
     PRECISION = 529,
     PRESERVE = 530,
     PREPARE = 531,
     PREPARED = 532,
     PRIMARY = 533,
     PRIOR = 534,
     PRIVILEGES = 535,
     PROCEDURAL = 536,
     PROCEDURE = 537,
     QUOTE = 538,
     RANGE = 539,
     READ = 540,
     REAL = 541,
     REASSIGN = 542,
     RECHECK = 543,
     RECURSIVE = 544,
     REFERENCES = 545,
     REINDEX = 546,
     RELATIVE_P = 547,
     RELEASE = 548,
     RENAME = 549,
     REPEATABLE = 550,
     REPLACE = 551,
     REPLICA = 552,
     RESET = 553,
     RESTART = 554,
     RESTRICT = 555,
     RETURNING = 556,
     RETURNS = 557,
     REVOKE = 558,
     RIGHT = 559,
     ROLE = 560,
     ROLLBACK = 561,
     ROW = 562,
     ROWS = 563,
     RULE = 564,
     SAVEPOINT = 565,
     SCHEMA = 566,
     SCROLL = 567,
     SEARCH = 568,
     SECOND_P = 569,
     SECURITY = 570,
     SELECT = 571,
     SEQUENCE = 572,
     SEQUENCES = 573,
     SERIALIZABLE = 574,
     SERVER = 575,
     SESSION = 576,
     SESSION_USER = 577,
     SET = 578,
     SETOF = 579,
     SHARE = 580,
     SHOW = 581,
     SIMILAR = 582,
     SIMPLE = 583,
     SMALLINT = 584,
     SOME = 585,
     STABLE = 586,
     STANDALONE_P = 587,
     START = 588,
     STATEMENT = 589,
     STATISTICS = 590,
     STDIN = 591,
     STDOUT = 592,
     STORAGE = 593,
     STRICT_P = 594,
     STRIP_P = 595,
     SUBSTRING = 596,
     SUPERUSER_P = 597,
     SYMMETRIC = 598,
     SYSID = 599,
     SYSTEM_P = 600,
     TABLE = 601,
     TABLES = 602,
     TABLESPACE = 603,
     TEMP = 604,
     TEMPLATE = 605,
     TEMPORARY = 606,
     TEXT_P = 607,
     THEN = 608,
     TIME = 609,
     TIMESTAMP = 610,
     TO = 611,
     TRAILING = 612,
     TRANSACTION = 613,
     TREAT = 614,
     TRIGGER = 615,
     TRIM = 616,
     TRUE_P = 617,
     TRUNCATE = 618,
     TRUSTED = 619,
     TYPE_P = 620,
     UNBOUNDED = 621,
     UNCOMMITTED = 622,
     UNENCRYPTED = 623,
     UNION = 624,
     UNIQUE = 625,
     UNKNOWN = 626,
     UNLISTEN = 627,
     UNTIL = 628,
     UPDATE = 629,
     USER = 630,
     USING = 631,
     VACUUM = 632,
     VALID = 633,
     VALIDATOR = 634,
     VALUE_P = 635,
     VALUES = 636,
     VARCHAR = 637,
     VARIADIC = 638,
     VARYING = 639,
     VERBOSE = 640,
     VERSION_P = 641,
     VIEW = 642,
     VOLATILE = 643,
     WHEN = 644,
     WHERE = 645,
     WHITESPACE_P = 646,
     WINDOW = 647,
     WITH = 648,
     WITHOUT = 649,
     WORK = 650,
     WRAPPER = 651,
     WRITE = 652,
     XML_P = 653,
     XMLATTRIBUTES = 654,
     XMLCONCAT = 655,
     XMLELEMENT = 656,
     XMLFOREST = 657,
     XMLPARSE = 658,
     XMLPI = 659,
     XMLROOT = 660,
     XMLSERIALIZE = 661,
     YEAR_P = 662,
     YES_P = 663,
     ZONE = 664,
     NULLS_FIRST = 665,
     NULLS_LAST = 666,
     WITH_TIME = 667,
     POSTFIXOP = 668,
     UMINUS = 669
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 706 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 731 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  684
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   63683

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  432
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  517
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2105
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3865

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   669

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   421,     2,     2,
     426,   427,   419,   417,   430,   418,   428,   420,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   431,   429,
     414,   413,   415,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   424,     2,   425,   422,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   416,   423
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   218,
     224,   226,   227,   230,   231,   234,   235,   238,   241,   245,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   267,
     269,   271,   273,   277,   281,   284,   286,   289,   292,   295,
     299,   303,   309,   315,   316,   320,   326,   332,   337,   341,
     347,   351,   357,   363,   370,   372,   374,   378,   384,   391,
     396,   398,   399,   402,   403,   405,   407,   409,   411,   413,
     415,   418,   422,   426,   430,   434,   438,   442,   446,   450,
     453,   459,   462,   465,   468,   471,   475,   479,   483,   485,
     489,   491,   495,   497,   499,   501,   504,   507,   510,   512,
     514,   516,   518,   520,   522,   524,   528,   535,   537,   539,
     541,   543,   545,   546,   548,   550,   553,   557,   562,   566,
     569,   572,   574,   577,   581,   586,   590,   593,   598,   600,
     602,   604,   606,   608,   611,   614,   617,   620,   625,   630,
     635,   640,   642,   646,   649,   653,   658,   665,   672,   679,
     685,   691,   698,   705,   710,   718,   721,   728,   733,   737,
     741,   746,   751,   755,   759,   763,   768,   773,   777,   781,
     785,   789,   793,   797,   802,   807,   811,   814,   818,   822,
     826,   829,   832,   836,   839,   841,   843,   844,   847,   848,
     852,   855,   856,   858,   862,   866,   868,   874,   878,   881,
     884,   895,   902,   904,   906,   908,   910,   912,   914,   918,
     921,   922,   924,   926,   930,   934,   936,   938,   942,   946,
     950,   954,   959,   961,   962,   965,   966,   970,   971,   973,
     974,   976,   980,   983,   985,   987,   989,   991,   995,   996,
     998,  1002,  1004,  1006,  1018,  1029,  1031,  1033,  1036,  1039,
    1042,  1045,  1046,  1048,  1049,  1053,  1054,  1056,  1060,  1062,
    1066,  1068,  1070,  1072,  1074,  1076,  1080,  1085,  1088,  1089,
    1093,  1095,  1097,  1100,  1102,  1106,  1111,  1116,  1119,  1125,
    1127,  1130,  1133,  1136,  1140,  1144,  1148,  1149,  1151,  1153,
    1155,  1157,  1159,  1161,  1165,  1167,  1173,  1181,  1190,  1200,
    1212,  1216,  1217,  1219,  1223,  1225,  1228,  1231,  1234,  1235,
    1237,  1241,  1245,  1252,  1257,  1258,  1260,  1262,  1265,  1268,
    1269,  1273,  1277,  1280,  1282,  1284,  1287,  1290,  1295,  1296,
    1299,  1302,  1305,  1306,  1310,  1315,  1320,  1321,  1324,  1325,
    1330,  1331,  1339,  1345,  1349,  1350,  1352,  1356,  1358,  1361,
    1365,  1366,  1372,  1377,  1379,  1380,  1382,  1385,  1388,  1390,
    1393,  1397,  1400,  1403,  1406,  1409,  1413,  1417,  1419,  1423,
    1425,  1426,  1428,  1431,  1433,  1435,  1439,  1446,  1457,  1459,
    1460,  1462,  1465,  1468,  1469,  1472,  1475,  1477,  1478,  1484,
    1492,  1494,  1495,  1502,  1505,  1506,  1510,  1516,  1524,  1531,
    1540,  1548,  1555,  1562,  1567,  1568,  1570,  1574,  1579,  1581,
    1585,  1587,  1590,  1593,  1596,  1599,  1601,  1603,  1614,  1617,
    1618,  1621,  1624,  1626,  1627,  1632,  1639,  1645,  1650,  1655,
    1664,  1666,  1668,  1670,  1678,  1688,  1697,  1713,  1734,  1736,
    1738,  1740,  1744,  1746,  1748,  1750,  1754,  1756,  1760,  1761,
    1763,  1764,  1766,  1768,  1773,  1774,  1776,  1780,  1781,  1783,
    1785,  1787,  1789,  1791,  1793,  1796,  1797,  1799,  1802,  1804,
    1807,  1808,  1811,  1813,  1816,  1819,  1826,  1835,  1844,  1849,
    1855,  1860,  1865,  1870,  1874,  1882,  1891,  1898,  1905,  1912,
    1919,  1923,  1925,  1929,  1933,  1935,  1937,  1939,  1941,  1943,
    1945,  1949,  1953,  1957,  1959,  1963,  1967,  1969,  1970,  1972,
    1976,  1990,  1992,  1996,  2001,  2007,  2012,  2020,  2023,  2025,
    2026,  2029,  2030,  2032,  2033,  2040,  2049,  2058,  2060,  2064,
    2070,  2076,  2084,  2094,  2102,  2112,  2118,  2125,  2132,  2137,
    2139,  2141,  2143,  2145,  2147,  2149,  2151,  2153,  2157,  2161,
    2165,  2169,  2171,  2175,  2177,  2180,  2183,  2187,  2193,  2196,
    2199,  2200,  2207,  2215,  2223,  2231,  2240,  2249,  2256,  2265,
    2275,  2285,  2293,  2304,  2312,  2321,  2330,  2339,  2348,  2350,
    2352,  2354,  2356,  2358,  2360,  2362,  2364,  2366,  2368,  2370,
    2372,  2374,  2376,  2379,  2382,  2384,  2387,  2391,  2395,  2399,
    2403,  2408,  2413,  2417,  2421,  2425,  2430,  2435,  2439,  2444,
    2449,  2451,  2453,  2455,  2456,  2464,  2472,  2483,  2485,  2487,
    2490,  2495,  2501,  2503,  2507,  2510,  2513,  2516,  2519,  2521,
    2524,  2527,  2532,  2536,  2539,  2542,  2545,  2549,  2552,  2555,
    2561,  2567,  2573,  2575,  2579,  2581,  2584,  2588,  2589,  2591,
    2595,  2598,  2605,  2612,  2622,  2626,  2627,  2631,  2632,  2638,
    2641,  2642,  2646,  2650,  2654,  2662,  2670,  2681,  2683,  2685,
    2687,  2702,  2704,  2705,  2707,  2708,  2710,  2711,  2714,  2715,
    2717,  2721,  2726,  2731,  2738,  2740,  2743,  2744,  2746,  2748,
    2749,  2751,  2753,  2754,  2764,  2777,  2785,  2788,  2789,  2793,
    2796,  2798,  2802,  2806,  2809,  2811,  2815,  2819,  2823,  2826,
    2829,  2831,  2833,  2835,  2837,  2840,  2842,  2844,  2846,  2848,
    2853,  2859,  2861,  2865,  2869,  2871,  2874,  2879,  2885,  2887,
    2889,  2891,  2893,  2897,  2901,  2904,  2907,  2910,  2913,  2915,
    2918,  2921,  2923,  2925,  2927,  2931,  2934,  2935,  2938,  2940,
    2944,  2950,  2952,  2955,  2957,  2958,  2964,  2972,  2978,  2986,
    2992,  3000,  3004,  3010,  3016,  3022,  3024,  3028,  3031,  3033,
    3036,  3038,  3041,  3053,  3064,  3075,  3078,  3081,  3082,  3092,
    3095,  3096,  3101,  3106,  3111,  3113,  3115,  3117,  3118,  3126,
    3133,  3140,  3147,  3154,  3162,  3172,  3182,  3189,  3196,  3203,
    3210,  3217,  3226,  3235,  3242,  3249,  3256,  3262,  3268,  3277,
    3286,  3295,  3304,  3311,  3313,  3314,  3317,  3318,  3326,  3333,
    3340,  3347,  3354,  3361,  3368,  3376,  3383,  3390,  3397,  3404,
    3412,  3420,  3428,  3438,  3448,  3455,  3462,  3469,  3478,  3487,
    3496,  3503,  3508,  3513,  3518,  3526,  3531,  3536,  3541,  3547,
    3553,  3558,  3563,  3577,  3579,  3581,  3585,  3589,  3591,  3593,
    3595,  3597,  3599,  3601,  3603,  3604,  3606,  3608,  3610,  3612,
    3614,  3616,  3617,  3624,  3633,  3637,  3640,  3641,  3644,  3647,
    3650,  3653,  3657,  3661,  3664,  3667,  3670,  3673,  3677,  3680,
    3686,  3691,  3695,  3699,  3703,  3705,  3707,  3708,  3712,  3715,
    3718,  3720,  3724,  3727,  3729,  3730,  3739,  3750,  3754,  3759,
    3764,  3765,  3768,  3774,  3777,  3778,  3782,  3786,  3790,  3794,
    3798,  3802,  3806,  3810,  3814,  3818,  3822,  3826,  3830,  3835,
    3839,  3843,  3845,  3846,  3852,  3859,  3864,  3867,  3868,  3873,
    3877,  3883,  3890,  3895,  3902,  3909,  3915,  3923,  3925,  3926,
    3933,  3945,  3957,  3969,  3983,  3993,  4005,  4016,  4021,  4024,
    4030,  4033,  4034,  4039,  4045,  4051,  4056,  4063,  4065,  4069,
    4071,  4073,  4075,  4077,  4080,  4085,  4087,  4089,  4091,  4092,
    4094,  4095,  4097,  4098,  4102,  4103,  4106,  4111,  4115,  4121,
    4123,  4125,  4127,  4129,  4131,  4133,  4135,  4137,  4141,  4144,
    4146,  4148,  4150,  4152,  4154,  4156,  4157,  4163,  4167,  4168,
    4170,  4172,  4174,  4176,  4180,  4189,  4193,  4194,  4197,  4201,
    4204,  4208,  4214,  4216,  4221,  4224,  4226,  4230,  4233,  4236,
    4237,  4244,  4247,  4248,  4254,  4258,  4259,  4262,  4265,  4268,
    4272,  4274,  4278,  4280,  4283,  4285,  4286,  4294,  4296,  4300,
    4302,  4304,  4308,  4314,  4317,  4319,  4323,  4331,  4333,  4334,
    4338,  4341,  4344,  4347,  4348,  4351,  4354,  4356,  4358,  4362,
    4366,  4368,  4371,  4376,  4381,  4384,  4388,  4394,  4400,  4402,
    4404,  4414,  4416,  4419,  4424,  4429,  4434,  4437,  4441,  4443,
    4447,  4452,  4455,  4456,  4460,  4464,  4469,  4474,  4479,  4484,
    4487,  4489,  4491,  4492,  4494,  4496,  4497,  4499,  4505,  4507,
    4508,  4510,  4511,  4515,  4517,  4521,  4526,  4530,  4533,  4536,
    4538,  4540,  4542,  4543,  4546,  4551,  4557,  4560,  4564,  4566,
    4568,  4570,  4572,  4576,  4577,  4579,  4581,  4583,  4585,  4587,
    4591,  4592,  4595,  4596,  4598,  4602,  4604,  4605,  4607,  4610,
    4615,  4620,  4623,  4624,  4627,  4631,  4634,  4635,  4637,  4641,
    4643,  4646,  4648,  4651,  4657,  4664,  4670,  4672,  4675,  4677,
    4682,  4686,  4691,  4697,  4702,  4708,  4713,  4719,  4722,  4727,
    4729,  4732,  4735,  4738,  4740,  4742,  4743,  4748,  4751,  4753,
    4756,  4759,  4764,  4766,  4770,  4772,  4775,  4779,  4781,  4784,
    4785,  4788,  4793,  4794,  4796,  4800,  4803,  4806,  4810,  4816,
    4823,  4826,  4830,  4834,  4839,  4840,  4842,  4844,  4846,  4848,
    4850,  4853,  4859,  4861,  4863,  4865,  4867,  4870,  4874,  4878,
    4879,  4881,  4883,  4885,  4887,  4889,  4892,  4895,  4898,  4901,
    4904,  4906,  4910,  4911,  4913,  4915,  4917,  4919,  4925,  4928,
    4930,  4932,  4934,  4936,  4942,  4945,  4948,  4951,  4953,  4957,
    4961,  4964,  4966,  4967,  4971,  4972,  4978,  4981,  4987,  4990,
    4992,  4995,  4999,  5000,  5002,  5004,  5006,  5008,  5010,  5012,
    5016,  5020,  5024,  5028,  5032,  5036,  5040,  5041,  5043,  5048,
    5050,  5054,  5060,  5063,  5066,  5070,  5074,  5078,  5082,  5086,
    5090,  5094,  5098,  5102,  5106,  5109,  5112,  5116,  5120,  5123,
    5127,  5133,  5138,  5145,  5149,  5155,  5160,  5167,  5172,  5179,
    5185,  5193,  5197,  5200,  5205,  5208,  5212,  5216,  5221,  5225,
    5230,  5234,  5239,  5245,  5252,  5259,  5267,  5274,  5282,  5289,
    5297,  5301,  5306,  5311,  5318,  5321,  5325,  5330,  5332,  5336,
    5339,  5342,  5346,  5350,  5354,  5358,  5362,  5366,  5370,  5374,
    5378,  5382,  5385,  5388,  5394,  5401,  5408,  5416,  5420,  5425,
    5427,  5429,  5432,  5437,  5439,  5441,  5443,  5446,  5449,  5452,
    5454,  5459,  5465,  5472,  5481,  5488,  5496,  5504,  5510,  5512,
    5514,  5519,  5521,  5526,  5528,  5533,  5535,  5540,  5542,  5544,
    5546,  5548,  5550,  5552,  5559,  5564,  5569,  5574,  5579,  5586,
    5592,  5598,  5604,  5609,  5616,  5621,  5626,  5631,  5636,  5642,
    5650,  5658,  5668,  5673,  5680,  5686,  5694,  5702,  5710,  5713,
    5717,  5721,  5725,  5730,  5731,  5736,  5738,  5742,  5746,  5748,
    5750,  5752,  5755,  5758,  5759,  5762,  5763,  5765,  5769,  5773,
    5776,  5779,  5780,  5787,  5789,  5790,  5794,  5795,  5798,  5801,
    5802,  5804,  5809,  5812,  5815,  5818,  5821,  5824,  5829,  5833,
    5839,  5841,  5843,  5845,  5847,  5849,  5851,  5853,  5855,  5857,
    5859,  5861,  5863,  5865,  5867,  5869,  5874,  5876,  5881,  5883,
    5888,  5890,  5893,  5895,  5898,  5900,  5904,  5906,  5910,  5912,
    5916,  5918,  5922,  5926,  5930,  5933,  5935,  5939,  5943,  5944,
    5946,  5948,  5950,  5952,  5954,  5956,  5958,  5960,  5965,  5969,
    5972,  5976,  5977,  5981,  5985,  5988,  5991,  5993,  5994,  5997,
    6000,  6004,  6007,  6009,  6011,  6015,  6021,  6023,  6026,  6031,
    6034,  6035,  6037,  6038,  6040,  6043,  6046,  6049,  6053,  6059,
    6061,  6064,  6065,  6068,  6070,  6071,  6073,  6075,  6077,  6081,
    6085,  6087,  6091,  6095,  6098,  6100,  6102,  6104,  6108,  6110,
    6113,  6115,  6119,  6121,  6123,  6125,  6127,  6129,  6131,  6133,
    6136,  6138,  6140,  6142,  6144,  6146,  6149,  6155,  6158,  6162,
    6169,  6171,  6173,  6175,  6177,  6179,  6181,  6183,  6186,  6189,
    6191,  6193,  6195,  6197,  6199,  6201,  6203,  6205,  6207,  6209,
    6211,  6213,  6215,  6217,  6219,  6221,  6223,  6225,  6227,  6229,
    6231,  6233,  6235,  6237,  6239,  6241,  6243,  6245,  6247,  6249,
    6251,  6253,  6255,  6257,  6259,  6261,  6263,  6265,  6267,  6269,
    6271,  6273,  6275,  6277,  6279,  6281,  6283,  6285,  6287,  6289,
    6291,  6293,  6295,  6297,  6299,  6301,  6303,  6305,  6307,  6309,
    6311,  6313,  6315,  6317,  6319,  6321,  6323,  6325,  6327,  6329,
    6331,  6333,  6335,  6337,  6339,  6341,  6343,  6345,  6347,  6349,
    6351,  6353,  6355,  6357,  6359,  6361,  6363,  6365,  6367,  6369,
    6371,  6373,  6375,  6377,  6379,  6381,  6383,  6385,  6387,  6389,
    6391,  6393,  6395,  6397,  6399,  6401,  6403,  6405,  6407,  6409,
    6411,  6413,  6415,  6417,  6419,  6421,  6423,  6425,  6427,  6429,
    6431,  6433,  6435,  6437,  6439,  6441,  6443,  6445,  6447,  6449,
    6451,  6453,  6455,  6457,  6459,  6461,  6463,  6465,  6467,  6469,
    6471,  6473,  6475,  6477,  6479,  6481,  6483,  6485,  6487,  6489,
    6491,  6493,  6495,  6497,  6499,  6501,  6503,  6505,  6507,  6509,
    6511,  6513,  6515,  6517,  6519,  6521,  6523,  6525,  6527,  6529,
    6531,  6533,  6535,  6537,  6539,  6541,  6543,  6545,  6547,  6549,
    6551,  6553,  6555,  6557,  6559,  6561,  6563,  6565,  6567,  6569,
    6571,  6573,  6575,  6577,  6579,  6581,  6583,  6585,  6587,  6589,
    6591,  6593,  6595,  6597,  6599,  6601,  6603,  6605,  6607,  6609,
    6611,  6613,  6615,  6617,  6619,  6621,  6623,  6625,  6627,  6629,
    6631,  6633,  6635,  6637,  6639,  6641,  6643,  6645,  6647,  6649,
    6651,  6653,  6655,  6657,  6659,  6661,  6663,  6665,  6667,  6669,
    6671,  6673,  6675,  6677,  6679,  6681,  6683,  6685,  6687,  6689,
    6691,  6693,  6695,  6697,  6699,  6701,  6703,  6705,  6707,  6709,
    6711,  6713,  6715,  6717,  6719,  6721,  6723,  6725,  6727,  6729,
    6731,  6733,  6735,  6737,  6739,  6741,  6743,  6745,  6747,  6749,
    6751,  6753,  6755,  6757,  6759,  6761,  6763,  6765,  6767,  6769,
    6771,  6773,  6775,  6777,  6779,  6781,  6783,  6785,  6787,  6789,
    6791,  6793,  6795,  6797,  6799,  6801,  6803,  6805,  6807,  6809,
    6811,  6813,  6815,  6817,  6819,  6821,  6823,  6825,  6827,  6829,
    6831,  6833,  6835,  6837,  6839,  6841,  6843,  6845,  6847,  6849,
    6851,  6853,  6855,  6857,  6859,  6861,  6863,  6865,  6867,  6869,
    6871,  6873,  6875,  6877,  6879,  6881,  6883,  6885,  6887,  6889,
    6891,  6893,  6895,  6897,  6899,  6901,  6903,  6905,  6907,  6909,
    6911,  6913,  6915,  6917,  6919,  6921,  6923,  6925,  6927,  6929,
    6931,  6933,  6935,  6937,  6939,  6941,  6943,  6945,  6947,  6949,
    6951,  6953,  6955,  6957,  6959,  6961,  6963,  6965,  6967,  6969,
    6971,  6973,  6975,  6977,  6979,  6981,  6983,  6985,  6987,  6989,
    6991,  6993,  6995,  6997,  6999,  7001
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     433,     0,    -1,   434,    -1,   434,   429,   435,    -1,   435,
      -1,   737,    -1,   738,    -1,   654,    -1,   743,    -1,   564,
      -1,   578,    -1,   688,    -1,   451,    -1,   709,    -1,   710,
      -1,   711,    -1,   544,    -1,   476,    -1,   445,    -1,   443,
      -1,   746,    -1,   745,    -1,   582,    -1,   447,    -1,   446,
      -1,   753,    -1,   474,    -1,   486,    -1,   748,    -1,   632,
      -1,   471,    -1,   487,    -1,   537,    -1,   598,    -1,   699,
      -1,   747,    -1,   742,    -1,   562,    -1,   573,    -1,   669,
      -1,   450,    -1,   611,    -1,   617,    -1,   618,    -1,   551,
      -1,   454,    -1,   543,    -1,   502,    -1,   559,    -1,   583,
      -1,   436,    -1,   442,    -1,   579,    -1,   733,    -1,   770,
      -1,   789,    -1,   600,    -1,   776,    -1,   475,    -1,   696,
      -1,   599,    -1,   701,    -1,   563,    -1,   577,    -1,   453,
      -1,   621,    -1,   622,    -1,   623,    -1,   557,    -1,   720,
      -1,   625,    -1,   561,    -1,   597,    -1,   448,    -1,   449,
      -1,   581,    -1,   741,    -1,   768,    -1,   759,    -1,   635,
      -1,   639,    -1,   650,    -1,   659,    -1,   771,    -1,   723,
      -1,   732,    -1,   778,    -1,   721,    -1,   765,    -1,   624,
      -1,   703,    -1,   692,    -1,   691,    -1,   693,    -1,   706,
      -1,   640,    -1,   651,    -1,   713,    -1,   793,    -1,   725,
      -1,   630,    -1,   724,    -1,   782,    -1,   750,    -1,   468,
      -1,   458,    -1,   470,    -1,   730,    -1,    -1,    81,   305,
     940,   437,   438,    -1,   393,    -1,    -1,   438,   441,    -1,
      -1,   439,   440,    -1,    -1,   269,   939,    -1,   269,   243,
      -1,   126,   269,   939,    -1,   368,   269,   939,    -1,   342,
      -1,   237,    -1,   175,    -1,   234,    -1,    82,    -1,   231,
      -1,    83,    -1,   232,    -1,    84,    -1,   233,    -1,   215,
      -1,   235,    -1,    73,   207,   941,    -1,   378,   373,   939,
      -1,   375,   929,    -1,   440,    -1,   344,   938,    -1,    19,
     929,    -1,   305,   929,    -1,   170,   305,   929,    -1,   170,
     158,   929,    -1,    81,   375,   940,   437,   438,    -1,    24,
     305,   940,   437,   439,    -1,    -1,   170,    98,   931,    -1,
      24,   305,   940,   444,   469,    -1,    24,   375,   940,   437,
     439,    -1,    24,   375,   940,   469,    -1,   121,   305,   929,
      -1,   121,   305,   165,   135,   929,    -1,   121,   375,   929,
      -1,   121,   375,   165,   135,   929,    -1,    81,   158,   940,
     437,   438,    -1,    24,   158,   940,   452,   375,   929,    -1,
      18,    -1,   121,    -1,   121,   158,   929,    -1,   121,   158,
     165,   135,   929,    -1,    81,   311,   455,    37,   940,   456,
      -1,    81,   311,   942,   456,    -1,   942,    -1,    -1,   456,
     457,    -1,    -1,   502,    -1,   659,    -1,   543,    -1,   583,
      -1,   639,    -1,   730,    -1,   323,   459,    -1,   323,   210,
     459,    -1,   323,   321,   459,    -1,   460,   356,   461,    -1,
     460,   413,   461,    -1,   460,   356,   104,    -1,   460,   413,
     104,    -1,   460,   150,    87,    -1,   354,   409,   465,    -1,
     358,   728,    -1,   321,    58,    31,   358,   728,    -1,    54,
     939,    -1,   311,   939,    -1,   225,   466,    -1,   305,   467,
      -1,   321,    37,   467,    -1,   321,    37,   104,    -1,   398,
     255,   877,    -1,   942,    -1,   460,   428,   942,    -1,   462,
      -1,   461,   430,   462,    -1,   464,    -1,   467,    -1,   549,
      -1,   285,   367,    -1,   285,    70,    -1,   295,   285,    -1,
     319,    -1,   362,    -1,   139,    -1,   252,    -1,   249,    -1,
     939,    -1,     3,    -1,   864,   939,   866,    -1,   864,   426,
     938,   427,   939,   866,    -1,   549,    -1,   104,    -1,   210,
      -1,   939,    -1,   104,    -1,    -1,   942,    -1,   939,    -1,
     298,   460,    -1,   298,   354,   409,    -1,   298,   358,   193,
     205,    -1,   298,   321,    37,    -1,   298,    22,    -1,   323,
     459,    -1,   468,    -1,   326,   460,    -1,   326,   354,   409,
      -1,   326,   358,   193,   205,    -1,   326,   321,    37,    -1,
     326,    22,    -1,   323,    75,   472,   473,    -1,    22,    -1,
     927,    -1,   107,    -1,   167,    -1,    60,    -1,   115,    22,
      -1,   115,   349,    -1,   115,   351,    -1,   115,   271,    -1,
      24,   346,   836,   477,    -1,    24,   173,   928,   477,    -1,
      24,   317,   928,   477,    -1,    24,   387,   928,   477,    -1,
     478,    -1,   477,   430,   478,    -1,    18,   510,    -1,    18,
      66,   510,    -1,    24,   707,   942,   479,    -1,    24,   707,
     942,   121,   238,   243,    -1,    24,   707,   942,   323,   238,
     243,    -1,    24,   707,   942,   323,   335,   941,    -1,    24,
     707,   942,   323,   482,    -1,    24,   707,   942,   298,   482,
      -1,    24,   707,   942,   323,   338,   942,    -1,   121,   707,
     165,   135,   942,   480,    -1,   121,   707,   942,   480,    -1,
      24,   707,   942,   708,   365,   844,   481,    -1,    18,   519,
      -1,   121,    74,   165,   135,   930,   480,    -1,   121,    74,
     930,   480,    -1,   323,   393,   251,    -1,   323,   394,   251,
      -1,   323,   393,   315,   196,    -1,   323,   394,   315,   196,
      -1,    63,   252,   930,    -1,   323,   394,    63,    -1,   124,
     360,   930,    -1,   124,    25,   360,   930,    -1,   124,   297,
     360,   930,    -1,   124,   360,    22,    -1,   124,   360,   375,
      -1,   114,   360,   930,    -1,   114,   360,    22,    -1,   114,
     360,   375,    -1,   124,   309,   930,    -1,   124,    25,   309,
     930,    -1,   124,   297,   309,   930,    -1,   114,   309,   930,
      -1,   175,   928,    -1,   230,   175,   928,    -1,   265,   356,
     940,    -1,   323,   348,   930,    -1,   323,   482,    -1,   298,
     482,    -1,   323,   104,   868,    -1,   121,   104,    -1,    50,
      -1,   300,    -1,    -1,   376,   868,    -1,    -1,   426,   484,
     427,    -1,   393,   482,    -1,    -1,   485,    -1,   484,   430,
     485,    -1,   944,   413,   604,    -1,   944,    -1,   944,   428,
     944,   413,   604,    -1,   944,   428,   944,    -1,    62,   790,
      -1,    62,    22,    -1,    79,   493,   928,   521,   494,   488,
     489,   495,   437,   490,    -1,    79,   794,   356,   489,   437,
     490,    -1,   150,    -1,   356,    -1,   939,    -1,   336,    -1,
     337,    -1,   491,    -1,   426,   497,   427,    -1,   491,   492,
      -1,    -1,    43,    -1,   251,    -1,   110,   744,   939,    -1,
     243,   744,   939,    -1,    86,    -1,   161,    -1,   283,   744,
     939,    -1,   129,   744,   939,    -1,   146,   283,   522,    -1,
     146,   283,   419,    -1,   146,   238,   243,   522,    -1,    43,
      -1,    -1,   393,   251,    -1,    -1,   496,   111,   939,    -1,
      -1,   376,    -1,    -1,   498,    -1,   497,   430,   498,    -1,
     944,   499,    -1,   464,    -1,   467,    -1,   549,    -1,   419,
      -1,   426,   500,   427,    -1,    -1,   501,    -1,   500,   430,
     501,    -1,   464,    -1,   467,    -1,    81,   503,   346,   928,
     426,   504,   427,   532,   533,   534,   535,    -1,    81,   503,
     346,   928,   248,   628,   505,   533,   534,   535,    -1,   351,
      -1,   349,    -1,   210,   351,    -1,   210,   349,    -1,   154,
     351,    -1,   154,   349,    -1,    -1,   506,    -1,    -1,   426,
     507,   427,    -1,    -1,   508,    -1,   506,   430,   508,    -1,
     509,    -1,   507,   430,   509,    -1,   510,    -1,   516,    -1,
     519,    -1,   511,    -1,   519,    -1,   942,   844,   512,    -1,
     942,   393,   256,   512,    -1,   512,   513,    -1,    -1,    74,
     930,   514,    -1,   514,    -1,   515,    -1,   238,   243,    -1,
     243,    -1,   370,   685,   536,    -1,   278,   195,   685,   536,
      -1,    59,   426,   868,   427,    -1,   104,   869,    -1,   290,
     928,   521,   524,   528,    -1,   106,    -1,   238,   106,    -1,
     177,   107,    -1,   177,   167,    -1,   206,   928,   517,    -1,
     517,   171,   518,    -1,   517,   132,   518,    -1,    -1,   105,
      -1,    75,    -1,   174,    -1,   338,    -1,    68,    -1,    22,
      -1,    74,   930,   520,    -1,   520,    -1,    59,   426,   868,
     427,   594,    -1,   370,   426,   522,   427,   685,   536,   594,
      -1,   278,   195,   426,   522,   427,   685,   536,   594,    -1,
     131,   663,   426,   525,   427,   685,   536,   527,   594,    -1,
     147,   195,   426,   522,   427,   290,   928,   521,   524,   528,
     594,    -1,   426,   522,   427,    -1,    -1,   523,    -1,   522,
     430,   523,    -1,   942,    -1,   217,   151,    -1,   217,   267,
      -1,   217,   328,    -1,    -1,   526,    -1,   525,   430,   526,
      -1,   665,   393,   695,    -1,   665,   393,   254,   426,   695,
     427,    -1,   390,   426,   868,   427,    -1,    -1,   529,    -1,
     530,    -1,   529,   530,    -1,   530,   529,    -1,    -1,   252,
     374,   531,    -1,   252,   109,   531,    -1,   230,    17,    -1,
     300,    -1,    50,    -1,   323,   243,    -1,   323,   104,    -1,
     176,   426,   927,   427,    -1,    -1,   393,   482,    -1,   393,
     251,    -1,   394,   251,    -1,    -1,   252,    69,   121,    -1,
     252,    69,   109,   308,    -1,   252,    69,   275,   308,    -1,
      -1,   348,   930,    -1,    -1,   376,   173,   348,   930,    -1,
      -1,    81,   503,   346,   538,    31,   793,   542,    -1,   928,
     539,   533,   534,   535,    -1,   426,   540,   427,    -1,    -1,
     541,    -1,   540,   430,   541,    -1,   942,    -1,   393,    97,
      -1,   393,   230,    97,    -1,    -1,    81,   503,   317,   928,
     545,    -1,    24,   317,   928,   546,    -1,   546,    -1,    -1,
     547,    -1,   546,   547,    -1,    48,   549,    -1,    96,    -1,
     230,    96,    -1,   172,   548,   549,    -1,   218,   549,    -1,
     220,   549,    -1,   230,   218,    -1,   230,   220,    -1,   264,
      47,   628,    -1,   333,   437,   549,    -1,   299,    -1,   299,
     437,   549,    -1,    47,    -1,    -1,     4,    -1,   418,     4,
      -1,   941,    -1,   549,    -1,   550,   430,   549,    -1,    81,
     670,   552,   558,   197,   467,    -1,    81,   670,   552,   558,
     197,   467,   159,   553,   554,   556,    -1,   364,    -1,    -1,
     930,    -1,   930,   629,    -1,   178,   553,    -1,    -1,   379,
     553,    -1,   230,   379,    -1,   555,    -1,    -1,   121,   558,
     197,   467,   480,    -1,   121,   558,   197,   165,   135,   467,
     480,    -1,   281,    -1,    -1,    81,   348,   930,   560,   213,
     939,    -1,   265,   930,    -1,    -1,   121,   348,   930,    -1,
     121,   348,   165,   135,   930,    -1,    81,   147,    97,   396,
     930,   556,   565,    -1,   121,   147,    97,   396,   930,   480,
      -1,   121,   147,    97,   396,   165,   135,   930,   480,    -1,
      24,   147,    97,   396,   930,   555,   567,    -1,    24,   147,
      97,   396,   930,   555,    -1,    24,   147,    97,   396,   930,
     567,    -1,   256,   426,   566,   427,    -1,    -1,   570,    -1,
     566,   430,   570,    -1,   256,   426,   568,   427,    -1,   569,
      -1,   568,   430,   569,    -1,   570,    -1,   323,   570,    -1,
      18,   570,    -1,   121,   571,    -1,   571,   572,    -1,   944,
      -1,   939,    -1,    81,   320,   930,   574,   576,   147,    97,
     396,   930,   565,    -1,   365,   939,    -1,    -1,   386,   939,
      -1,   386,   243,    -1,   575,    -1,    -1,   121,   320,   930,
     480,    -1,   121,   320,   165,   135,   930,   480,    -1,    24,
     320,   930,   575,   567,    -1,    24,   320,   930,   575,    -1,
      24,   320,   930,   567,    -1,    81,   375,   216,   145,   580,
     320,   930,   565,    -1,    94,    -1,   375,    -1,   940,    -1,
     121,   375,   216,   145,   580,   320,   930,    -1,   121,   375,
     216,   165,   135,   145,   580,   320,   930,    -1,    24,   375,
     216,   145,   580,   320,   930,   567,    -1,    81,   360,   930,
     584,   585,   252,   928,   587,   590,   134,   282,   936,   426,
     591,   427,    -1,    81,    74,   360,   930,    20,   585,   252,
     928,   593,   594,   145,   122,   307,   590,   134,   282,   936,
     426,   591,   427,    -1,    39,    -1,    20,    -1,   586,    -1,
     585,   257,   586,    -1,   183,    -1,   109,    -1,   374,    -1,
     374,   248,   522,    -1,   363,    -1,   145,   588,   589,    -1,
      -1,   122,    -1,    -1,   307,    -1,   334,    -1,   389,   426,
     868,   427,    -1,    -1,   592,    -1,   591,   430,   592,    -1,
      -1,   938,    -1,     4,    -1,   939,    -1,     6,    -1,     7,
      -1,   942,    -1,   150,   928,    -1,    -1,   595,    -1,   595,
     596,    -1,   596,    -1,   596,   595,    -1,    -1,   238,   106,
      -1,   106,    -1,   177,   167,    -1,   177,   107,    -1,   121,
     360,   930,   252,   928,   480,    -1,   121,   360,   165,   135,
     930,   252,   928,   480,    -1,    81,    33,   930,    59,   426,
     868,   427,   594,    -1,   121,    33,   930,   480,    -1,    81,
      21,   936,   605,   601,    -1,    81,    21,   936,   606,    -1,
      81,   254,   695,   601,    -1,    81,   365,   628,   601,    -1,
      81,   365,   628,    -1,    81,   365,   628,    31,   426,   842,
     427,    -1,    81,   365,   628,    31,   128,   426,   609,   427,
      -1,    81,   352,   313,   266,   628,   601,    -1,    81,   352,
     313,   113,   628,   601,    -1,    81,   352,   313,   350,   628,
     601,    -1,    81,   352,   313,    72,   628,   601,    -1,   426,
     602,   427,    -1,   603,    -1,   602,   430,   603,    -1,   944,
     413,   604,    -1,   944,    -1,   679,    -1,   948,    -1,   894,
      -1,   549,    -1,   939,    -1,   426,   899,   427,    -1,   426,
     419,   427,    -1,   426,   607,   427,    -1,   608,    -1,   607,
     430,   608,    -1,     3,   413,   604,    -1,   610,    -1,    -1,
     939,    -1,   610,   430,   939,    -1,    81,   254,    61,   628,
     614,   145,   365,   844,   376,   932,   615,    31,   612,    -1,
     613,    -1,   612,   430,   613,    -1,   254,   938,   695,   616,
      -1,   254,   938,   695,   694,   616,    -1,   152,   938,   936,
     671,    -1,   152,   938,   426,   899,   427,   936,   671,    -1,
     338,   844,    -1,   104,    -1,    -1,   140,   628,    -1,    -1,
     288,    -1,    -1,    81,   254,   140,   628,   376,   932,    -1,
      24,   254,   140,   628,   376,   932,    18,   612,    -1,    24,
     254,   140,   628,   376,   932,   121,   619,    -1,   620,    -1,
     619,   430,   620,    -1,   254,   938,   426,   899,   427,    -1,
     152,   938,   426,   899,   427,    -1,   121,   254,    61,   628,
     376,   932,   480,    -1,   121,   254,    61,   165,   135,   628,
     376,   932,   480,    -1,   121,   254,   140,   628,   376,   932,
     480,    -1,   121,   254,   140,   165,   135,   628,   376,   932,
     480,    -1,   121,   264,    47,   929,   480,    -1,   287,   264,
      47,   929,   356,   930,    -1,   121,   626,   165,   135,   627,
     480,    -1,   121,   626,   627,   480,    -1,   346,    -1,   317,
      -1,   387,    -1,   173,    -1,   365,    -1,   119,    -1,    78,
      -1,   311,    -1,   352,   313,   266,    -1,   352,   313,   113,
      -1,   352,   313,   350,    -1,   352,   313,    72,    -1,   628,
      -1,   627,   430,   628,    -1,   942,    -1,   942,   629,    -1,
     428,   933,    -1,   629,   428,   933,    -1,   363,   803,   837,
     631,   480,    -1,    77,   164,    -1,   299,   164,    -1,    -1,
      67,   252,   633,   628,   191,   634,    -1,    67,   252,    21,
     936,   605,   191,   634,    -1,    67,   252,   152,   936,   671,
     191,   634,    -1,    67,   252,   254,   695,   694,   191,   634,
      -1,    67,   252,    74,   930,   252,   628,   191,   634,    -1,
      67,   252,   309,   930,   252,   628,   191,   634,    -1,    67,
     252,   309,   930,   191,   634,    -1,    67,   252,   360,   930,
     252,   628,   191,   634,    -1,    67,   252,   254,    61,   628,
     376,   932,   191,   634,    -1,    67,   252,   254,   140,   628,
     376,   932,   191,   634,    -1,    67,   252,   198,   247,   549,
     191,   634,    -1,    67,   252,    53,   426,   844,    31,   844,
     427,   191,   634,    -1,    67,   252,   558,   197,   628,   191,
     634,    -1,    67,   252,   352,   313,   266,   628,   191,   634,
      -1,    67,   252,   352,   313,   113,   628,   191,   634,    -1,
      67,   252,   352,   313,   350,   628,   191,   634,    -1,    67,
     252,   352,   313,    72,   628,   191,   634,    -1,    66,    -1,
      98,    -1,   311,    -1,   173,    -1,   317,    -1,   346,    -1,
     119,    -1,   365,    -1,   387,    -1,    78,    -1,   348,    -1,
     305,    -1,   939,    -1,   243,    -1,   141,   636,    -1,   223,
     636,    -1,   790,    -1,   637,   790,    -1,   229,   638,   790,
      -1,   279,   638,   790,    -1,   142,   638,   790,    -1,   199,
     638,   790,    -1,    15,   941,   638,   790,    -1,   292,   941,
     638,   790,    -1,   941,   638,   790,    -1,    22,   638,   790,
      -1,   148,   638,   790,    -1,   148,   941,   638,   790,    -1,
     148,    22,   638,   790,    -1,    38,   638,   790,    -1,    38,
     941,   638,   790,    -1,    38,    22,   638,   790,    -1,   150,
      -1,   170,    -1,   637,    -1,    -1,   155,   641,   252,   644,
     356,   645,   647,    -1,   303,   641,   252,   644,   150,   645,
     480,    -1,   303,   155,   255,   145,   641,   252,   644,   150,
     645,   480,    -1,   642,    -1,    22,    -1,    22,   280,    -1,
      22,   426,   522,   427,    -1,    22,   280,   426,   522,   427,
      -1,   643,    -1,   642,   430,   643,    -1,   316,   521,    -1,
     290,   521,    -1,    81,   521,    -1,   942,   521,    -1,   927,
      -1,   346,   927,    -1,   317,   927,    -1,   147,    97,   396,
     929,    -1,   147,   320,   929,    -1,   152,   648,    -1,    98,
     929,    -1,   197,   929,    -1,   198,   247,   550,    -1,   311,
     929,    -1,   348,   929,    -1,    22,   347,   170,   311,   929,
      -1,    22,   318,   170,   311,   929,    -1,    22,   153,   170,
     311,   929,    -1,   646,    -1,   645,   430,   646,    -1,   940,
      -1,   158,   940,    -1,   393,   155,   255,    -1,    -1,   649,
      -1,   648,   430,   649,    -1,   936,   671,    -1,   155,   642,
     356,   929,   652,   653,    -1,   303,   642,   150,   929,   653,
     480,    -1,   303,    19,   255,   145,   642,   150,   929,   653,
     480,    -1,   393,    19,   255,    -1,    -1,   156,    47,   940,
      -1,    -1,    24,   104,   280,   655,   657,    -1,   655,   656,
      -1,    -1,   170,   311,   929,    -1,   145,   305,   929,    -1,
     145,   375,   929,    -1,   155,   641,   252,   658,   356,   645,
     647,    -1,   303,   641,   252,   658,   150,   645,   480,    -1,
     303,   155,   255,   145,   641,   252,   658,   150,   645,   480,
      -1,   347,    -1,   153,    -1,   318,    -1,    81,   660,   173,
     661,   662,   252,   928,   663,   426,   664,   427,   483,   535,
     840,    -1,   370,    -1,    -1,    71,    -1,    -1,   934,    -1,
      -1,   376,   932,    -1,    -1,   665,    -1,   664,   430,   665,
      -1,   942,   666,   667,   668,    -1,   871,   666,   667,   668,
      -1,   426,   868,   427,   666,   667,   668,    -1,   628,    -1,
     376,   628,    -1,    -1,    32,    -1,   112,    -1,    -1,   410,
      -1,   411,    -1,    -1,    81,   670,   152,   936,   673,   302,
     678,   681,   685,    -1,    81,   670,   152,   936,   673,   302,
     346,   426,   687,   427,   681,   685,    -1,    81,   670,   152,
     936,   673,   681,   685,    -1,   257,   296,    -1,    -1,   426,
     672,   427,    -1,   426,   427,    -1,   675,    -1,   672,   430,
     675,    -1,   426,   674,   427,    -1,   426,   427,    -1,   680,
      -1,   674,   430,   680,    -1,   676,   677,   679,    -1,   677,
     676,   679,    -1,   677,   679,    -1,   676,   679,    -1,   679,
      -1,   170,    -1,   259,    -1,   180,    -1,   170,   259,    -1,
     383,    -1,   943,    -1,   679,    -1,   844,    -1,   943,   629,
     421,   365,    -1,   324,   943,   629,   421,   365,    -1,   675,
      -1,   675,   104,   868,    -1,   675,   413,   868,    -1,   683,
      -1,   681,   683,    -1,    49,   252,   243,   181,    -1,   302,
     243,   252,   243,   181,    -1,   339,    -1,   168,    -1,   331,
      -1,   388,    -1,   137,   315,   108,    -1,   137,   315,   190,
      -1,   315,   108,    -1,   315,   190,    -1,    80,   549,    -1,
     308,   549,    -1,   469,    -1,    31,   684,    -1,   197,   467,
      -1,   392,    -1,   682,    -1,   939,    -1,   939,   430,   939,
      -1,   393,   601,    -1,    -1,   677,   679,    -1,   686,    -1,
     687,   430,   686,    -1,    24,   152,   649,   689,   690,    -1,
     682,    -1,   689,   682,    -1,   300,    -1,    -1,   121,   152,
     936,   671,   480,    -1,   121,   152,   165,   135,   936,   671,
     480,    -1,   121,    21,   936,   605,   480,    -1,   121,    21,
     165,   135,   936,   605,   480,    -1,   121,   254,   695,   694,
     480,    -1,   121,   254,   165,   135,   695,   694,   480,    -1,
     426,   844,   427,    -1,   426,   844,   430,   844,   427,    -1,
     426,   236,   430,   844,   427,    -1,   426,   844,   430,   236,
     427,    -1,   891,    -1,   942,   428,   695,    -1,   117,   697,
      -1,   698,    -1,   697,   698,    -1,   939,    -1,   197,   467,
      -1,    81,    53,   426,   844,    31,   844,   427,   393,   152,
     649,   700,    -1,    81,    53,   426,   844,    31,   844,   427,
     394,   152,   700,    -1,    81,    53,   426,   844,    31,   844,
     427,   393,   180,   700,    -1,    31,   169,    -1,    31,    34,
      -1,    -1,   121,    53,   702,   426,   844,    31,   844,   427,
     480,    -1,   165,   135,    -1,    -1,   291,   704,   928,   705,
      -1,   291,   345,   930,   705,    -1,   291,    98,   930,   705,
      -1,   173,    -1,   346,    -1,   146,    -1,    -1,    24,    21,
     936,   605,   294,   356,   930,    -1,    24,    78,   628,   294,
     356,   930,    -1,    24,    98,   931,   294,   356,   931,    -1,
      24,   152,   649,   294,   356,   930,    -1,    24,   158,   940,
     294,   356,   940,    -1,    24,   558,   197,   930,   294,   356,
     930,    -1,    24,   254,    61,   628,   376,   932,   294,   356,
     930,    -1,    24,   254,   140,   628,   376,   932,   294,   356,
     930,    -1,    24,   311,   930,   294,   356,   930,    -1,    24,
     346,   836,   294,   356,   930,    -1,    24,   317,   928,   294,
     356,   930,    -1,    24,   387,   928,   294,   356,   930,    -1,
      24,   173,   928,   294,   356,   930,    -1,    24,   346,   836,
     294,   707,   930,   356,   930,    -1,    24,   360,   930,   252,
     928,   294,   356,   930,    -1,    24,   305,   940,   294,   356,
     940,    -1,    24,   375,   940,   294,   356,   940,    -1,    24,
     348,   930,   294,   356,   930,    -1,    24,   348,   930,   323,
     482,    -1,    24,   348,   930,   298,   482,    -1,    24,   352,
     313,   266,   628,   294,   356,   930,    -1,    24,   352,   313,
     113,   628,   294,   356,   930,    -1,    24,   352,   313,   350,
     628,   294,   356,   930,    -1,    24,   352,   313,    72,   628,
     294,   356,   930,    -1,    24,   365,   628,   294,   356,   930,
      -1,    66,    -1,    -1,   323,    97,    -1,    -1,    24,    21,
     936,   605,   323,   311,   930,    -1,    24,   119,   628,   323,
     311,   930,    -1,    24,   152,   649,   323,   311,   930,    -1,
      24,   346,   836,   323,   311,   930,    -1,    24,   317,   928,
     323,   311,   930,    -1,    24,   387,   928,   323,   311,   930,
      -1,    24,   365,   628,   323,   311,   930,    -1,    24,    21,
     936,   605,   265,   356,   940,    -1,    24,    78,   628,   265,
     356,   940,    -1,    24,    98,   931,   265,   356,   940,    -1,
      24,   119,   628,   265,   356,   940,    -1,    24,   152,   649,
     265,   356,   940,    -1,    24,   558,   197,   930,   265,   356,
     940,    -1,    24,   198,   247,   549,   265,   356,   940,    -1,
      24,   254,   695,   694,   265,   356,   940,    -1,    24,   254,
      61,   628,   376,   932,   265,   356,   940,    -1,    24,   254,
     140,   628,   376,   932,   265,   356,   940,    -1,    24,   311,
     930,   265,   356,   940,    -1,    24,   365,   628,   265,   356,
     940,    -1,    24,   348,   930,   265,   356,   940,    -1,    24,
     352,   313,   113,   628,   265,   356,   940,    -1,    24,   352,
     313,    72,   628,   265,   356,   940,    -1,    24,   147,    97,
     396,   930,   265,   356,   940,    -1,    24,   320,   930,   265,
     356,   940,    -1,    24,    98,   931,   712,    -1,    24,   311,
     930,   712,    -1,    24,   346,   836,   712,    -1,    24,   346,
     836,    24,   707,   942,   712,    -1,    24,   317,   928,   712,
      -1,    24,   387,   928,   712,    -1,    24,   152,   649,   712,
      -1,    24,    21,   936,   605,   712,    -1,    24,   198,   247,
     938,   712,    -1,    24,   365,   628,   712,    -1,   315,   196,
     356,   939,    -1,    81,   670,   309,   930,    31,   252,   718,
     356,   928,   840,   117,   719,   714,    -1,   239,    -1,   716,
      -1,   426,   715,   427,    -1,   715,   429,   717,    -1,   717,
      -1,   793,    -1,   771,    -1,   782,    -1,   776,    -1,   721,
      -1,   716,    -1,    -1,   316,    -1,   374,    -1,   109,    -1,
     183,    -1,   184,    -1,    23,    -1,    -1,   121,   309,   930,
     252,   928,   480,    -1,   121,   309,   165,   135,   930,   252,
     928,   480,    -1,   240,   942,   722,    -1,   430,   939,    -1,
      -1,   208,   942,    -1,   372,   942,    -1,   372,   419,    -1,
      14,   726,    -1,    40,   726,   729,    -1,   333,   358,   729,
      -1,    69,   726,    -1,   127,   726,    -1,   306,   726,    -1,
     310,   942,    -1,   293,   310,   942,    -1,   293,   942,    -1,
     306,   726,   356,   310,   942,    -1,   306,   726,   356,   942,
      -1,   276,   358,   939,    -1,    69,   277,   939,    -1,   306,
     277,   939,    -1,   395,    -1,   358,    -1,    -1,   193,   205,
     463,    -1,   285,   253,    -1,   285,   397,    -1,   727,    -1,
     728,   430,   727,    -1,   728,   727,    -1,   728,    -1,    -1,
      81,   503,   387,   928,   521,    31,   793,   731,    -1,    81,
     257,   296,   503,   387,   928,   521,    31,   793,   731,    -1,
     393,    59,   255,    -1,   393,    51,    59,   255,    -1,   393,
     210,    59,   255,    -1,    -1,   209,   935,    -1,    81,    98,
     931,   437,   734,    -1,   734,   735,    -1,    -1,   348,   736,
     930,    -1,   348,   736,   104,    -1,   213,   736,   939,    -1,
     213,   736,   104,    -1,   350,   736,   930,    -1,   350,   736,
     104,    -1,   125,   736,   939,    -1,   125,   736,   938,    -1,
     125,   736,   104,    -1,   200,   736,   939,    -1,   200,   736,
     104,    -1,   201,   736,   939,    -1,   201,   736,   104,    -1,
      73,   207,   736,   941,    -1,   265,   736,   930,    -1,   265,
     736,   104,    -1,   413,    -1,    -1,    24,    98,   931,   437,
     739,    -1,    24,    98,   931,   323,   348,   930,    -1,    24,
      98,   931,   469,    -1,   739,   740,    -1,    -1,    73,   207,
     736,   941,    -1,   121,    98,   931,    -1,   121,    98,   165,
     135,   931,    -1,    81,   119,   628,   744,   844,   512,    -1,
      24,   119,   628,   479,    -1,    24,   119,   628,   121,   238,
     243,    -1,    24,   119,   628,   323,   238,   243,    -1,    24,
     119,   628,    18,   519,    -1,    24,   119,   628,   121,    74,
     930,   480,    -1,    31,    -1,    -1,    24,   352,   313,   113,
     628,   601,    -1,    24,   352,   313,    72,   628,    18,   216,
     145,   929,   393,   627,    -1,    24,   352,   313,    72,   628,
      24,   216,   145,   929,   393,   627,    -1,    24,   352,   313,
      72,   628,    24,   216,   296,   628,   393,   628,    -1,    24,
     352,   313,    72,   628,    24,   216,   145,   929,   296,   628,
     393,   628,    -1,    24,   352,   313,    72,   628,   121,   216,
     145,   929,    -1,    24,   352,   313,    72,   628,   121,   216,
     165,   135,   145,   929,    -1,    81,   614,    78,   628,   145,
     939,   356,   939,   150,   628,    -1,    63,   755,   928,   749,
      -1,    63,   755,    -1,    63,   755,   934,   252,   928,    -1,
     376,   934,    -1,    -1,   377,   756,   757,   755,    -1,   377,
     756,   757,   755,   928,    -1,   377,   756,   757,   755,   753,
      -1,   377,   426,   751,   427,    -1,   377,   426,   751,   427,
     928,   758,    -1,   752,    -1,   751,   430,   752,    -1,   754,
      -1,   385,    -1,   149,    -1,   151,    -1,   754,   755,    -1,
     754,   755,   928,   758,    -1,    27,    -1,    26,    -1,   385,
      -1,    -1,   151,    -1,    -1,   149,    -1,    -1,   426,   929,
     427,    -1,    -1,   136,   760,    -1,   136,   754,   755,   760,
      -1,   136,   385,   760,    -1,   136,   426,   761,   427,   760,
      -1,   793,    -1,   771,    -1,   782,    -1,   776,    -1,   789,
      -1,   537,    -1,   768,    -1,   762,    -1,   761,   430,   762,
      -1,   763,   764,    -1,   942,    -1,   754,    -1,   385,    -1,
     464,    -1,   467,    -1,   549,    -1,    -1,   276,   930,   766,
      31,   767,    -1,   426,   899,   427,    -1,    -1,   793,    -1,
     771,    -1,   782,    -1,   776,    -1,   134,   930,   769,    -1,
      81,   503,   346,   538,    31,   134,   930,   769,    -1,   426,
     896,   427,    -1,    -1,   100,   930,    -1,   100,   276,   930,
      -1,   100,    22,    -1,   100,   276,    22,    -1,   183,   189,
     928,   772,   775,    -1,   793,    -1,   426,   773,   427,   793,
      -1,   104,   381,    -1,   774,    -1,   773,   430,   774,    -1,
     942,   920,    -1,   301,   925,    -1,    -1,   109,   150,   838,
     777,   841,   775,    -1,   376,   829,    -1,    -1,   214,   803,
     837,   779,   781,    -1,   170,   780,   221,    -1,    -1,    16,
     325,    -1,   307,   325,    -1,   307,   133,    -1,   325,   374,
     133,    -1,   325,    -1,   325,   307,   133,    -1,   133,    -1,
      16,   133,    -1,   242,    -1,    -1,   374,   838,   323,   783,
     828,   841,   775,    -1,   784,    -1,   783,   430,   784,    -1,
     785,    -1,   786,    -1,   787,   413,   922,    -1,   426,   788,
     427,   413,   924,    -1,   942,   920,    -1,   787,    -1,   788,
     430,   787,    -1,   103,   790,   791,    95,   792,   145,   793,
      -1,   930,    -1,    -1,   791,   230,   312,    -1,   791,   312,
      -1,   791,    43,    -1,   791,   182,    -1,    -1,   393,   162,
      -1,   394,   162,    -1,   795,    -1,   794,    -1,   426,   795,
     427,    -1,   426,   794,   427,    -1,   797,    -1,   796,   807,
      -1,   796,   806,   822,   811,    -1,   796,   806,   810,   823,
      -1,   798,   796,    -1,   798,   796,   807,    -1,   798,   796,
     806,   822,   811,    -1,   798,   796,   806,   810,   823,    -1,
     797,    -1,   794,    -1,   316,   805,   925,   801,   828,   840,
     820,   821,   879,    -1,   827,    -1,   346,   836,    -1,   796,
     369,   804,   796,    -1,   796,   187,   804,   796,    -1,   796,
     130,   804,   796,    -1,   393,   799,    -1,   393,   289,   799,
      -1,   800,    -1,   799,   430,   800,    -1,   930,   758,    31,
     794,    -1,   189,   802,    -1,    -1,   351,   803,   928,    -1,
     349,   803,   928,    -1,   210,   351,   803,   928,    -1,   210,
     349,   803,   928,    -1,   154,   351,   803,   928,    -1,   154,
     349,   803,   928,    -1,   346,   928,    -1,   928,    -1,   346,
      -1,    -1,    22,    -1,   116,    -1,    -1,   116,    -1,   116,
     252,   426,   896,   427,    -1,    22,    -1,    -1,   807,    -1,
      -1,   258,    47,   808,    -1,   809,    -1,   808,   430,   809,
      -1,   868,   376,   894,   668,    -1,   868,   667,   668,    -1,
     812,   813,    -1,   813,   812,    -1,   812,    -1,   813,    -1,
     810,    -1,    -1,   207,   814,    -1,   207,   814,   430,   815,
      -1,   141,   819,   816,   818,   253,    -1,   250,   815,    -1,
     250,   817,   818,    -1,   868,    -1,    22,    -1,   868,    -1,
     941,    -1,   426,   868,   427,    -1,    -1,   870,    -1,   307,
      -1,   308,    -1,   142,    -1,   229,    -1,   158,    47,   896,
      -1,    -1,   160,   868,    -1,    -1,   824,    -1,   145,   285,
     253,    -1,   822,    -1,    -1,   825,    -1,   824,   825,    -1,
     145,   374,   826,   781,    -1,   145,   325,   826,   781,    -1,
     248,   927,    -1,    -1,   381,   924,    -1,   827,   430,   924,
      -1,   150,   829,    -1,    -1,   830,    -1,   829,   430,   830,
      -1,   836,    -1,   836,   832,    -1,   839,    -1,   839,   832,
      -1,   839,    31,   426,   842,   427,    -1,   839,    31,   942,
     426,   842,   427,    -1,   839,   942,   426,   842,   427,    -1,
     794,    -1,   794,   832,    -1,   831,    -1,   426,   831,   427,
     832,    -1,   426,   831,   427,    -1,   830,    85,   194,   830,
      -1,   830,   833,   194,   830,   835,    -1,   830,   194,   830,
     835,    -1,   830,   227,   833,   194,   830,    -1,   830,   227,
     194,   830,    -1,    31,   942,   426,   929,   427,    -1,    31,
     942,    -1,   942,   426,   929,   427,    -1,   942,    -1,   151,
     834,    -1,   204,   834,    -1,   304,   834,    -1,   179,    -1,
     260,    -1,    -1,   376,   426,   929,   427,    -1,   252,   868,
      -1,   928,    -1,   928,   419,    -1,   253,   928,    -1,   253,
     426,   928,   427,    -1,   836,    -1,   837,   430,   836,    -1,
     836,    -1,   836,   942,    -1,   836,    31,   942,    -1,   871,
      -1,   390,   868,    -1,    -1,   390,   868,    -1,   390,    87,
     248,   930,    -1,    -1,   843,    -1,   842,   430,   843,    -1,
     942,   844,    -1,   846,   845,    -1,   324,   846,   845,    -1,
     846,    30,   424,   938,   425,    -1,   324,   846,    30,   424,
     938,   425,    -1,   846,    30,    -1,   324,   846,    30,    -1,
     845,   424,   425,    -1,   845,   424,   938,   425,    -1,    -1,
     848,    -1,   850,    -1,   852,    -1,   856,    -1,   863,    -1,
     864,   866,    -1,   864,   426,   938,   427,   866,    -1,   850,
      -1,   853,    -1,   857,    -1,   863,    -1,   943,   849,    -1,
     943,   629,   849,    -1,   426,   896,   427,    -1,    -1,   185,
      -1,   186,    -1,   329,    -1,    42,    -1,   286,    -1,   143,
     851,    -1,   120,   274,    -1,   102,   849,    -1,   101,   849,
      -1,   246,   849,    -1,    45,    -1,   426,   938,   427,    -1,
      -1,   854,    -1,   855,    -1,   854,    -1,   855,    -1,    44,
     861,   426,   896,   427,    -1,    44,   861,    -1,   858,    -1,
     859,    -1,   858,    -1,   859,    -1,   860,   426,   938,   427,
     862,    -1,   860,   862,    -1,    57,   861,    -1,    56,   861,
      -1,   382,    -1,   226,    57,   861,    -1,   226,    56,   861,
      -1,   228,   861,    -1,   384,    -1,    -1,    57,   323,   942,
      -1,    -1,   355,   426,   938,   427,   865,    -1,   355,   865,
      -1,   354,   426,   938,   427,   865,    -1,   354,   865,    -1,
     188,    -1,   412,   409,    -1,   394,   354,   409,    -1,    -1,
     407,    -1,   222,    -1,    99,    -1,   163,    -1,   219,    -1,
     867,    -1,   407,   356,   222,    -1,    99,   356,   163,    -1,
      99,   356,   219,    -1,    99,   356,   867,    -1,   163,   356,
     219,    -1,   163,   356,   867,    -1,   219,   356,   867,    -1,
      -1,   314,    -1,   314,   426,   938,   427,    -1,   870,    -1,
     868,    11,   844,    -1,   868,    36,   354,   409,   868,    -1,
     417,   868,    -1,   418,   868,    -1,   868,   417,   868,    -1,
     868,   418,   868,    -1,   868,   419,   868,    -1,   868,   420,
     868,    -1,   868,   421,   868,    -1,   868,   422,   868,    -1,
     868,   414,   868,    -1,   868,   415,   868,    -1,   868,   413,
     868,    -1,   868,   893,   868,    -1,   893,   868,    -1,   868,
     893,    -1,   868,    28,   868,    -1,   868,   257,   868,    -1,
     238,   868,    -1,   868,   206,   868,    -1,   868,   206,   868,
     129,   868,    -1,   868,   238,   206,   868,    -1,   868,   238,
     206,   868,   129,   868,    -1,   868,   166,   868,    -1,   868,
     166,   868,   129,   868,    -1,   868,   238,   166,   868,    -1,
     868,   238,   166,   868,   129,   868,    -1,   868,   327,   356,
     868,    -1,   868,   327,   356,   868,   129,   868,    -1,   868,
     238,   327,   356,   868,    -1,   868,   238,   327,   356,   868,
     129,   868,    -1,   868,   191,   243,    -1,   868,   192,    -1,
     868,   191,   238,   243,    -1,   868,   241,    -1,   889,   262,
     889,    -1,   868,   191,   362,    -1,   868,   191,   238,   362,
      -1,   868,   191,   139,    -1,   868,   191,   238,   139,    -1,
     868,   191,   371,    -1,   868,   191,   238,   371,    -1,   868,
     191,   116,   150,   868,    -1,   868,   191,   238,   116,   150,
     868,    -1,   868,   191,   248,   426,   899,   427,    -1,   868,
     191,   238,   248,   426,   899,   427,    -1,   868,    41,   921,
     869,    28,   869,    -1,   868,   238,    41,   921,   869,    28,
     869,    -1,   868,    41,   343,   869,    28,   869,    -1,   868,
     238,    41,   343,   869,    28,   869,    -1,   868,   170,   911,
      -1,   868,   238,   170,   911,    -1,   868,   895,   890,   794,
      -1,   868,   895,   890,   426,   868,   427,    -1,   370,   794,
      -1,   868,   191,   118,    -1,   868,   191,   238,   118,    -1,
     870,    -1,   869,    11,   844,    -1,   417,   869,    -1,   418,
     869,    -1,   869,   417,   869,    -1,   869,   418,   869,    -1,
     869,   419,   869,    -1,   869,   420,   869,    -1,   869,   421,
     869,    -1,   869,   422,   869,    -1,   869,   414,   869,    -1,
     869,   415,   869,    -1,   869,   413,   869,    -1,   869,   893,
     869,    -1,   893,   869,    -1,   869,   893,    -1,   869,   191,
     116,   150,   869,    -1,   869,   191,   238,   116,   150,   869,
      -1,   869,   191,   248,   426,   899,   427,    -1,   869,   191,
     238,   248,   426,   899,   427,    -1,   869,   191,   118,    -1,
     869,   191,   238,   118,    -1,   917,    -1,   937,    -1,    10,
     920,    -1,   426,   868,   427,   920,    -1,   912,    -1,   871,
      -1,   794,    -1,   135,   794,    -1,    30,   794,    -1,    30,
     900,    -1,   889,    -1,   936,   426,   427,   882,    -1,   936,
     426,   897,   427,   882,    -1,   936,   426,   383,   898,   427,
     882,    -1,   936,   426,   897,   430,   383,   898,   427,   882,
      -1,   936,   426,   897,   807,   427,   882,    -1,   936,   426,
      22,   897,   806,   427,   882,    -1,   936,   426,   116,   897,
     806,   427,   882,    -1,   936,   426,   419,   427,   882,    -1,
      89,    -1,    92,    -1,    92,   426,   938,   427,    -1,    93,
      -1,    93,   426,   938,   427,    -1,   211,    -1,   211,   426,
     938,   427,    -1,   212,    -1,   212,   426,   938,   427,    -1,
      90,    -1,    94,    -1,   322,    -1,   375,    -1,    88,    -1,
      91,    -1,    53,   426,   868,    31,   844,   427,    -1,   138,
     426,   902,   427,    -1,   263,   426,   904,   427,    -1,   272,
     426,   906,   427,    -1,   341,   426,   907,   427,    -1,   359,
     426,   868,    31,   844,   427,    -1,   361,   426,    46,   910,
     427,    -1,   361,   426,   202,   910,   427,    -1,   361,   426,
     357,   910,   427,    -1,   361,   426,   910,   427,    -1,   244,
     426,   868,   430,   868,   427,    -1,    64,   426,   896,   427,
      -1,   157,   426,   896,   427,    -1,   203,   426,   896,   427,
      -1,   400,   426,   896,   427,    -1,   401,   426,   224,   944,
     427,    -1,   401,   426,   224,   944,   430,   874,   427,    -1,
     401,   426,   224,   944,   430,   896,   427,    -1,   401,   426,
     224,   944,   430,   874,   430,   896,   427,    -1,   402,   426,
     875,   427,    -1,   403,   426,   877,   868,   878,   427,    -1,
     404,   426,   224,   944,   427,    -1,   404,   426,   224,   944,
     430,   868,   427,    -1,   405,   426,   868,   430,   872,   873,
     427,    -1,   406,   426,   877,   868,    31,   846,   427,    -1,
     386,   868,    -1,   386,   230,   380,    -1,   430,   332,   408,
      -1,   430,   332,   230,    -1,   430,   332,   230,   380,    -1,
      -1,   399,   426,   875,   427,    -1,   876,    -1,   875,   430,
     876,    -1,   868,    31,   944,    -1,   868,    -1,   118,    -1,
      76,    -1,   275,   391,    -1,   340,   391,    -1,    -1,   392,
     880,    -1,    -1,   881,    -1,   880,   430,   881,    -1,   942,
      31,   883,    -1,   261,   883,    -1,   261,   942,    -1,    -1,
     426,   884,   885,   806,   886,   427,    -1,   942,    -1,    -1,
     268,    47,   896,    -1,    -1,   284,   887,    -1,   308,   887,
      -1,    -1,   888,    -1,    41,   888,    28,   888,    -1,   366,
     273,    -1,   366,   144,    -1,    87,   307,    -1,   868,   273,
      -1,   868,   144,    -1,   307,   426,   896,   427,    -1,   307,
     426,   427,    -1,   426,   896,   430,   868,   427,    -1,    29,
      -1,   330,    -1,    22,    -1,     8,    -1,   892,    -1,   417,
      -1,   418,    -1,   419,    -1,   420,    -1,   421,    -1,   422,
      -1,   414,    -1,   415,    -1,   413,    -1,     8,    -1,   254,
     426,   695,   427,    -1,   891,    -1,   254,   426,   695,   427,
      -1,   891,    -1,   254,   426,   695,   427,    -1,   206,    -1,
     238,   206,    -1,   166,    -1,   238,   166,    -1,   868,    -1,
     896,   430,   868,    -1,   898,    -1,   897,   430,   898,    -1,
     868,    -1,   677,    13,   868,    -1,   844,    -1,   899,   430,
     844,    -1,   424,   896,   425,    -1,   424,   901,   425,    -1,
     424,   425,    -1,   900,    -1,   901,   430,   900,    -1,   903,
     150,   868,    -1,    -1,     3,    -1,   407,    -1,   222,    -1,
      99,    -1,   163,    -1,   219,    -1,   314,    -1,   939,    -1,
     868,   905,   908,   909,    -1,   868,   905,   908,    -1,   270,
     868,    -1,   869,   170,   869,    -1,    -1,   868,   908,   909,
      -1,   868,   909,   908,    -1,   868,   908,    -1,   868,   909,
      -1,   896,    -1,    -1,   150,   868,    -1,   145,   868,    -1,
     868,   150,   896,    -1,   150,   896,    -1,   896,    -1,   794,
      -1,   426,   896,   427,    -1,    52,   916,   913,   915,   127,
      -1,   914,    -1,   913,   914,    -1,   389,   868,   353,   868,
      -1,   123,   868,    -1,    -1,   868,    -1,    -1,   942,    -1,
     942,   919,    -1,   428,   933,    -1,   428,   419,    -1,   424,
     868,   425,    -1,   424,   868,   431,   868,   425,    -1,   918,
      -1,   919,   918,    -1,    -1,   920,   918,    -1,    35,    -1,
      -1,   868,    -1,   104,    -1,   922,    -1,   923,   430,   922,
      -1,   426,   923,   427,    -1,   926,    -1,   925,   430,   926,
      -1,   868,    31,   944,    -1,   868,     3,    -1,   868,    -1,
     419,    -1,   928,    -1,   927,   430,   928,    -1,   942,    -1,
     942,   919,    -1,   930,    -1,   929,   430,   930,    -1,   942,
      -1,   942,    -1,   942,    -1,   944,    -1,   942,    -1,   939,
      -1,   943,    -1,   942,   919,    -1,   938,    -1,     4,    -1,
     939,    -1,     6,    -1,     7,    -1,   936,   939,    -1,   936,
     426,   897,   427,   939,    -1,   847,   939,    -1,   864,   939,
     866,    -1,   864,   426,   938,   427,   939,   866,    -1,   362,
      -1,   139,    -1,   243,    -1,     9,    -1,     5,    -1,   942,
      -1,   938,    -1,   417,   938,    -1,   418,   938,    -1,     3,
      -1,   945,    -1,   946,    -1,     3,    -1,   945,    -1,   947,
      -1,     3,    -1,   945,    -1,   946,    -1,   947,    -1,   948,
      -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    23,    -1,    24,
      -1,    25,    -1,    33,    -1,    34,    -1,    36,    -1,    38,
      -1,    39,    -1,    40,    -1,    47,    -1,    48,    -1,    49,
      -1,    50,    -1,    51,    -1,    54,    -1,    55,    -1,    58,
      -1,    60,    -1,    61,    -1,    62,    -1,    63,    -1,    67,
      -1,    68,    -1,    69,    -1,    70,    -1,    72,    -1,    73,
      -1,    75,    -1,    76,    -1,    77,    -1,    78,    -1,    79,
      -1,    80,    -1,    82,    -1,    83,    -1,    84,    -1,    86,
      -1,    87,    -1,    95,    -1,    96,    -1,    97,    -1,    98,
      -1,    99,    -1,   100,    -1,   103,    -1,   105,    -1,   107,
      -1,   108,    -1,   109,    -1,   110,    -1,   111,    -1,   113,
      -1,   114,    -1,   115,    -1,   118,    -1,   119,    -1,   120,
      -1,   121,    -1,   122,    -1,   124,    -1,   125,    -1,   126,
      -1,   128,    -1,   129,    -1,   131,    -1,   132,    -1,   133,
      -1,   134,    -1,   136,    -1,   137,    -1,   140,    -1,   142,
      -1,   144,    -1,   146,    -1,   148,    -1,   152,    -1,   153,
      -1,   154,    -1,   156,    -1,   159,    -1,   161,    -1,   162,
      -1,   163,    -1,   164,    -1,   165,    -1,   167,    -1,   168,
      -1,   169,    -1,   171,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   176,    -1,   178,    -1,   181,    -1,   182,
      -1,   183,    -1,   184,    -1,   190,    -1,   193,    -1,   195,
      -1,   196,    -1,   197,    -1,   198,    -1,   199,    -1,   200,
      -1,   201,    -1,   205,    -1,   208,    -1,   209,    -1,   210,
      -1,   213,    -1,   214,    -1,   215,    -1,   216,    -1,   217,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,
      -1,   223,    -1,   224,    -1,   225,    -1,   229,    -1,   230,
      -1,   231,    -1,   232,    -1,   233,    -1,   234,    -1,   235,
      -1,   237,    -1,   239,    -1,   240,    -1,   242,    -1,   245,
      -1,   247,    -1,   248,    -1,   251,    -1,   254,    -1,   255,
      -1,   256,    -1,   264,    -1,   265,    -1,   266,    -1,   267,
      -1,   268,    -1,   269,    -1,   271,    -1,   273,    -1,   276,
      -1,   277,    -1,   275,    -1,   279,    -1,   280,    -1,   281,
      -1,   282,    -1,   283,    -1,   284,    -1,   285,    -1,   287,
      -1,   288,    -1,   289,    -1,   291,    -1,   292,    -1,   293,
      -1,   294,    -1,   295,    -1,   296,    -1,   297,    -1,   298,
      -1,   299,    -1,   300,    -1,   302,    -1,   303,    -1,   305,
      -1,   306,    -1,   308,    -1,   309,    -1,   310,    -1,   311,
      -1,   312,    -1,   313,    -1,   314,    -1,   315,    -1,   317,
      -1,   318,    -1,   319,    -1,   320,    -1,   321,    -1,   323,
      -1,   325,    -1,   326,    -1,   328,    -1,   331,    -1,   332,
      -1,   333,    -1,   334,    -1,   335,    -1,   336,    -1,   337,
      -1,   338,    -1,   339,    -1,   340,    -1,   342,    -1,   344,
      -1,   345,    -1,   347,    -1,   348,    -1,   349,    -1,   350,
      -1,   351,    -1,   352,    -1,   358,    -1,   360,    -1,   363,
      -1,   364,    -1,   365,    -1,   366,    -1,   367,    -1,   368,
      -1,   371,    -1,   372,    -1,   373,    -1,   374,    -1,   377,
      -1,   378,    -1,   379,    -1,   380,    -1,   384,    -1,   386,
      -1,   387,    -1,   388,    -1,   391,    -1,   394,    -1,   395,
      -1,   396,    -1,   397,    -1,   398,    -1,   407,    -1,   408,
      -1,   409,    -1,    41,    -1,    42,    -1,    44,    -1,    45,
      -1,    56,    -1,    57,    -1,    64,    -1,   101,    -1,   102,
      -1,   135,    -1,   138,    -1,   143,    -1,   157,    -1,   180,
      -1,   185,    -1,   186,    -1,   188,    -1,   203,    -1,   226,
      -1,   228,    -1,   236,    -1,   244,    -1,   246,    -1,   259,
      -1,   263,    -1,   272,    -1,   274,    -1,   286,    -1,   307,
      -1,   324,    -1,   329,    -1,   341,    -1,   354,    -1,   355,
      -1,   359,    -1,   361,    -1,   381,    -1,   382,    -1,   399,
      -1,   400,    -1,   401,    -1,   402,    -1,   403,    -1,   404,
      -1,   405,    -1,   406,    -1,    37,    -1,    43,    -1,    71,
      -1,    85,    -1,    91,    -1,   149,    -1,   151,    -1,   166,
      -1,   179,    -1,   191,    -1,   192,    -1,   194,    -1,   204,
      -1,   206,    -1,   227,    -1,   241,    -1,   260,    -1,   261,
      -1,   262,    -1,   304,    -1,   327,    -1,   385,    -1,    22,
      -1,    26,    -1,    27,    -1,    28,    -1,    29,    -1,    30,
      -1,    31,    -1,    32,    -1,    35,    -1,    46,    -1,    52,
      -1,    53,    -1,    59,    -1,    65,    -1,    66,    -1,    74,
      -1,    81,    -1,    88,    -1,    89,    -1,    90,    -1,    92,
      -1,    93,    -1,    94,    -1,   104,    -1,   106,    -1,   112,
      -1,   116,    -1,   117,    -1,   123,    -1,   127,    -1,   130,
      -1,   139,    -1,   141,    -1,   145,    -1,   147,    -1,   150,
      -1,   155,    -1,   158,    -1,   160,    -1,   170,    -1,   177,
      -1,   187,    -1,   189,    -1,   202,    -1,   207,    -1,   211,
      -1,   212,    -1,   238,    -1,   243,    -1,   249,    -1,   250,
      -1,   252,    -1,   253,    -1,   257,    -1,   258,    -1,   270,
      -1,   278,    -1,   290,    -1,   301,    -1,   316,    -1,   322,
      -1,   330,    -1,   343,    -1,   346,    -1,   353,    -1,   356,
      -1,   357,    -1,   362,    -1,   369,    -1,   370,    -1,   375,
      -1,   376,    -1,   383,    -1,   389,    -1,   390,    -1,   392,
      -1,   393,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   625,   625,   632,   639,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   753,   763,
     774,   775,   784,   785,   789,   790,   794,   799,   803,   808,
     813,   817,   821,   825,   829,   833,   837,   841,   845,   850,
     854,   858,   862,   866,   871,   878,   880,   884,   888,   892,
     896,   910,   928,   939,   940,   944,   962,   974,   995,  1002,
    1021,  1028,  1045,  1063,  1074,  1075,  1087,  1094,  1111,  1123,
    1135,  1136,  1140,  1141,  1149,  1150,  1151,  1152,  1153,  1154,
    1168,  1174,  1180,  1189,  1197,  1205,  1212,  1219,  1227,  1238,
    1246,  1254,  1262,  1270,  1281,  1289,  1297,  1304,  1314,  1315,
    1322,  1323,  1326,  1328,  1330,  1334,  1335,  1336,  1337,  1341,
    1342,  1343,  1344,  1356,  1360,  1364,  1379,  1402,  1403,  1404,
    1408,  1409,  1410,  1414,  1415,  1419,  1426,  1433,  1440,  1447,
    1457,  1458,  1463,  1469,  1475,  1481,  1487,  1497,  1507,  1508,
    1512,  1513,  1521,  1536,  1542,  1548,  1554,  1572,  1580,  1588,
    1596,  1607,  1608,  1613,  1621,  1629,  1638,  1646,  1654,  1663,
    1672,  1681,  1690,  1700,  1713,  1723,  1731,  1741,  1751,  1758,
    1765,  1772,  1779,  1787,  1795,  1803,  1811,  1819,  1826,  1833,
    1841,  1848,  1855,  1863,  1871,  1879,  1887,  1895,  1903,  1911,
    1919,  1927,  1937,  1938,  1942,  1943,  1944,  1948,  1949,  1953,
    1956,  1957,  1961,  1962,  1967,  1971,  1975,  1980,  1995,  2001,
    2028,  2050,  2064,  2065,  2074,  2075,  2076,  2079,  2080,  2085,
    2086,  2090,  2094,  2098,  2102,  2106,  2110,  2114,  2118,  2122,
    2126,  2130,  2139,  2143,  2147,  2151,  2155,  2159,  2163,  2164,
    2169,  2173,  2180,  2187,  2188,  2189,  2190,  2191,  2192,  2196,
    2200,  2208,  2209,  2220,  2234,  2258,  2259,  2260,  2261,  2262,
    2263,  2264,  2268,  2269,  2273,  2274,  2278,  2282,  2289,  2293,
    2300,  2301,  2302,  2306,  2307,  2310,  2321,  2332,  2333,  2337,
    2345,  2346,  2365,  2372,  2379,  2389,  2399,  2408,  2417,  2446,
    2453,  2460,  2467,  2486,  2496,  2497,  2498,  2502,  2503,  2504,
    2505,  2506,  2507,  2516,  2524,  2528,  2542,  2555,  2568,  2584,
    2604,  2605,  2609,  2610,  2613,  2619,  2623,  2631,  2636,  2642,
    2643,  2647,  2652,  2659,  2660,  2670,  2672,  2674,  2676,  2679,
    2682,  2685,  2689,  2690,  2691,  2692,  2693,  2696,  2697,  2702,
    2703,  2704,  2705,  2708,  2709,  2710,  2711,  2714,  2715,  2718,
    2719,  2729,  2754,  2766,  2767,  2771,  2772,  2776,  2792,  2793,
    2794,  2807,  2819,  2828,  2829,  2832,  2833,  2836,  2840,  2844,
    2848,  2852,  2856,  2860,  2864,  2868,  2872,  2876,  2880,  2886,
    2887,  2891,  2892,  2897,  2900,  2901,  2913,  2925,  2940,  2941,
    2949,  2950,  2954,  2955,  2959,  2960,  2964,  2965,  2969,  2977,
    2988,  2989,  2999,  3009,  3010,  3023,  3030,  3046,  3063,  3071,
    3088,  3097,  3105,  3116,  3117,  3121,  3125,  3133,  3137,  3141,
    3148,  3152,  3157,  3162,  3169,  3176,  3181,  3191,  3205,  3206,
    3211,  3212,  3216,  3217,  3227,  3235,  3252,  3261,  3269,  3285,
    3297,  3298,  3299,  3309,  3317,  3334,  3353,  3373,  3397,  3398,
    3402,  3404,  3426,  3428,  3430,  3432,  3434,  3439,  3444,  3454,
    3455,  3459,  3460,  3464,  3465,  3469,  3470,  3471,  3475,  3481,
    3482,  3483,  3484,  3485,  3489,  3490,  3494,  3496,  3505,  3512,
    3522,  3526,  3527,  3531,  3532,  3537,  3547,  3569,  3588,  3611,
    3621,  3632,  3642,  3652,  3663,  3699,  3706,  3715,  3724,  3733,
    3744,  3747,  3748,  3751,  3755,  3762,  3763,  3764,  3765,  3766,
    3769,  3770,  3773,  3776,  3777,  3785,  3792,  3793,  3796,  3798,
    3815,  3830,  3831,  3835,  3844,  3853,  3862,  3872,  3881,  3882,
    3885,  3886,  3889,  3903,  3908,  3918,  3927,  3939,  3940,  3944,
    3952,  3964,  3973,  3985,  3994,  4015,  4025,  4043,  4052,  4064,
    4065,  4066,  4067,  4068,  4069,  4070,  4071,  4072,  4073,  4074,
    4075,  4079,  4080,  4083,  4084,  4087,  4089,  4102,  4113,  4114,
    4115,  4140,  4149,  4158,  4167,  4176,  4185,  4194,  4204,  4213,
    4222,  4231,  4240,  4249,  4258,  4266,  4274,  4282,  4293,  4294,
    4295,  4296,  4297,  4298,  4299,  4300,  4301,  4302,  4303,  4304,
    4308,  4309,  4319,  4325,  4333,  4341,  4349,  4357,  4365,  4373,
    4381,  4389,  4397,  4405,  4413,  4421,  4429,  4437,  4445,  4453,
    4463,  4464,  4467,  4468,  4478,  4494,  4508,  4534,  4536,  4538,
    4540,  4547,  4556,  4557,  4560,  4567,  4574,  4581,  4595,  4603,
    4611,  4619,  4627,  4635,  4643,  4651,  4659,  4667,  4675,  4683,
    4691,  4699,  4711,  4712,  4715,  4725,  4739,  4740,  4744,  4745,
    4750,  4766,  4779,  4789,  4801,  4802,  4805,  4806,  4816,  4826,
    4827,  4831,  4835,  4839,  4850,  4863,  4877,  4894,  4895,  4896,
    4908,  4927,  4928,  4932,  4933,  4937,  4938,  4942,  4943,  4946,
    4947,  4955,  4965,  4975,  4987,  4988,  4989,  4992,  4993,  4994,
    4997,  4998,  4999,  5015,  5027,  5040,  5055,  5056,  5059,  5060,
    5064,  5065,  5073,  5074,  5078,  5079,  5094,  5103,  5112,  5121,
    5130,  5142,  5143,  5144,  5145,  5146,  5152,  5156,  5171,  5172,
    5178,  5188,  5192,  5197,  5207,  5208,  5215,  5219,  5223,  5227,
    5231,  5235,  5239,  5243,  5247,  5251,  5255,  5259,  5263,  5271,
    5275,  5279,  5283,  5289,  5290,  5297,  5298,  5301,  5313,  5317,
    5332,  5343,  5344,  5349,  5350,  5365,  5375,  5388,  5398,  5411,
    5421,  5434,  5442,  5444,  5446,  5451,  5453,  5466,  5475,  5476,
    5480,  5484,  5496,  5507,  5518,  5531,  5532,  5533,  5537,  5548,
    5549,  5563,  5571,  5581,  5594,  5595,  5598,  5599,  5609,  5618,
    5626,  5634,  5643,  5651,  5659,  5668,  5677,  5685,  5694,  5703,
    5712,  5721,  5730,  5739,  5747,  5755,  5763,  5772,  5781,  5789,
    5797,  5805,  5813,  5823,  5824,  5827,  5828,  5838,  5847,  5855,
    5864,  5872,  5880,  5888,  5904,  5913,  5921,  5929,  5937,  5946,
    5954,  5962,  5971,  5980,  5989,  5997,  6005,  6013,  6021,  6029,
    6037,  6053,  6061,  6069,  6077,  6086,  6094,  6102,  6111,  6120,
    6128,  6138,  6150,  6167,  6168,  6169,  6174,  6180,  6189,  6190,
    6191,  6192,  6193,  6197,  6198,  6201,  6202,  6203,  6204,  6208,
    6209,  6210,  6215,  6225,  6246,  6256,  6257,  6260,  6269,  6275,
    6294,  6301,  6308,  6315,  6322,  6329,  6336,  6344,  6352,  6360,
    6368,  6376,  6383,  6390,  6399,  6400,  6401,  6405,  6408,  6411,
    6418,  6420,  6422,  6427,  6429,  6441,  6452,  6466,  6472,  6478,
    6484,  6494,  6510,  6520,  6521,  6525,  6529,  6533,  6537,  6541,
    6545,  6549,  6553,  6557,  6561,  6565,  6569,  6573,  6577,  6581,
    6585,  6595,  6596,  6607,  6614,  6625,  6636,  6637,  6641,  6655,
    6662,  6679,  6691,  6700,  6708,  6716,  6725,  6736,  6737,  6748,
    6758,  6768,  6778,  6788,  6798,  6806,  6827,  6850,  6858,  6867,
    6878,  6879,  6891,  6905,  6919,  6931,  6943,  6960,  6961,  6965,
    6966,  6967,  6968,  6972,  6984,  6999,  7000,  7004,  7005,  7008,
    7009,  7012,  7013,  7017,  7018,  7031,  7038,  7048,  7055,  7065,
    7066,  7067,  7068,  7069,  7070,  7071,  7075,  7079,  7086,  7093,
    7094,  7095,  7099,  7100,  7101,  7102,  7112,  7122,  7123,  7127,
    7128,  7129,  7130,  7140,  7148,  7165,  7166,  7176,  7182,  7188,
    7194,  7210,  7219,  7225,  7231,  7240,  7242,  7247,  7258,  7259,
    7270,  7283,  7284,  7295,  7306,  7307,  7310,  7311,  7312,  7313,
    7314,  7315,  7316,  7317,  7320,  7321,  7332,  7349,  7350,  7354,
    7355,  7359,  7367,  7395,  7406,  7407,  7417,  7428,  7431,  7432,
    7433,  7434,  7435,  7438,  7439,  7440,  7488,  7489,  7493,  7494,
    7508,  7509,  7516,  7524,  7532,  7540,  7548,  7556,  7567,  7568,
    7595,  7610,  7611,  7630,  7634,  7638,  7653,  7660,  7670,  7671,
    7674,  7686,  7696,  7704,  7709,  7714,  7719,  7724,  7729,  7734,
    7739,  7746,  7747,  7750,  7751,  7752,  7759,  7760,  7761,  7762,
    7766,  7767,  7771,  7775,  7776,  7779,  7788,  7801,  7802,  7803,
    7804,  7808,  7809,  7813,  7815,  7825,  7830,  7833,  7838,  7839,
    7847,  7857,  7858,  7859,  7867,  7871,  7872,  7875,  7876,  7881,
    7882,  7886,  7887,  7891,  7892,  7896,  7897,  7901,  7902,  7906,
    7914,  7925,  7926,  7931,  7937,  7955,  7956,  7960,  7961,  7971,
    7975,  7980,  7987,  7995,  8002,  8012,  8022,  8050,  8057,  8061,
    8087,  8091,  8103,  8116,  8130,  8141,  8156,  8162,  8167,  8173,
    8180,  8181,  8182,  8183,  8187,  8188,  8200,  8201,  8206,  8213,
    8220,  8227,  8238,  8239,  8252,  8256,  8263,  8273,  8278,  8279,
    8284,  8285,  8293,  8298,  8302,  8308,  8329,  8334,  8341,  8346,
    8352,  8357,  8366,  8368,  8371,  8375,  8376,  8377,  8378,  8379,
    8380,  8385,  8415,  8416,  8417,  8418,  8429,  8435,  8443,  8444,
    8450,  8455,  8460,  8465,  8470,  8475,  8480,  8485,  8491,  8497,
    8503,  8510,  8532,  8541,  8545,  8553,  8557,  8565,  8577,  8598,
    8602,  8608,  8612,  8625,  8644,  8667,  8669,  8671,  8673,  8675,
    8677,  8682,  8683,  8687,  8688,  8695,  8704,  8712,  8721,  8732,
    8740,  8741,  8742,  8746,  8748,  8750,  8752,  8754,  8756,  8758,
    8763,  8768,  8774,  8782,  8787,  8794,  8801,  8805,  8809,  8839,
    8840,  8842,  8864,  8866,  8868,  8870,  8872,  8874,  8876,  8878,
    8880,  8882,  8884,  8887,  8889,  8891,  8894,  8896,  8898,  8901,
    8903,  8916,  8918,  8931,  8933,  8946,  8948,  8962,  8975,  8988,
    9001,  9024,  9031,  9038,  9045,  9052,  9056,  9063,  9070,  9077,
    9084,  9091,  9098,  9102,  9110,  9114,  9124,  9131,  9138,  9151,
    9164,  9183,  9204,  9214,  9221,  9237,  9242,  9260,  9262,  9264,
    9266,  9268,  9270,  9272,  9274,  9276,  9278,  9280,  9282,  9284,
    9286,  9288,  9290,  9292,  9296,  9301,  9305,  9309,  9314,  9331,
    9332,  9333,  9348,  9360,  9362,  9364,  9374,  9384,  9394,  9402,
    9420,  9433,  9446,  9459,  9472,  9485,  9502,  9515,  9538,  9559,
    9569,  9582,  9599,  9612,  9622,  9635,  9645,  9658,  9671,  9684,
    9697,  9710,  9723,  9736,  9738,  9751,  9769,  9783,  9799,  9821,
    9837,  9850,  9863,  9876,  9880,  9887,  9895,  9903,  9907,  9911,
    9915,  9919,  9923,  9927,  9936,  9940,  9944,  9949,  9963,  9965,
    9969,  9971,  9973,  9976,  9979,  9982,  9983,  9986,  9994, 10004,
   10005, 10008, 10009, 10010, 10017, 10018, 10022, 10023, 10028, 10036,
   10038, 10052, 10055, 10082, 10083, 10086, 10087, 10098, 10116, 10123,
   10132, 10149, 10194, 10202, 10210, 10218, 10226, 10247, 10248, 10249,
   10252, 10253, 10254, 10257, 10258, 10261, 10262, 10263, 10264, 10265,
   10266, 10267, 10268, 10269, 10272, 10274, 10279, 10281, 10286, 10288,
   10290, 10292, 10294, 10296, 10308, 10312, 10319, 10323, 10329, 10333,
   10344, 10345, 10348, 10352, 10356, 10362, 10363, 10368, 10372, 10379,
   10380, 10381, 10382, 10383, 10384, 10385, 10386, 10396, 10400, 10407,
   10414, 10415, 10431, 10435, 10440, 10444, 10459, 10464, 10468, 10471,
   10474, 10475, 10476, 10479, 10486, 10496, 10510, 10511, 10515, 10526,
   10527, 10530, 10531, 10534, 10538, 10545, 10549, 10553, 10560, 10570,
   10571, 10575, 10576, 10579, 10580, 10591, 10592, 10601, 10602, 10610,
   10621, 10622, 10625, 10641, 10649, 10657, 10679, 10680, 10691, 10699,
   10727, 10729, 10734, 10737, 10740, 10742, 10744, 10746, 10756, 10758,
   10769, 10773, 10777, 10781, 10785, 10794, 10801, 10826, 10830, 10836,
   10853, 10857, 10861, 10867, 10868, 10869, 10871, 10872, 10873, 10889,
   10890, 10891, 10896, 10897, 10898, 10904, 10905, 10906, 10907, 10908,
   10928, 10929, 10930, 10931, 10932, 10933, 10934, 10935, 10936, 10937,
   10938, 10939, 10940, 10941, 10942, 10943, 10944, 10945, 10946, 10947,
   10948, 10949, 10950, 10951, 10952, 10953, 10954, 10955, 10956, 10957,
   10958, 10959, 10960, 10961, 10962, 10963, 10964, 10965, 10966, 10967,
   10968, 10969, 10970, 10971, 10972, 10973, 10974, 10975, 10976, 10977,
   10978, 10979, 10980, 10981, 10982, 10983, 10984, 10985, 10986, 10987,
   10988, 10989, 10990, 10991, 10992, 10993, 10994, 10995, 10996, 10997,
   10998, 10999, 11000, 11001, 11002, 11003, 11004, 11005, 11006, 11007,
   11008, 11009, 11010, 11011, 11012, 11013, 11014, 11015, 11016, 11017,
   11018, 11019, 11020, 11021, 11022, 11023, 11024, 11025, 11026, 11027,
   11028, 11029, 11030, 11031, 11032, 11033, 11034, 11035, 11036, 11037,
   11038, 11039, 11040, 11041, 11042, 11043, 11044, 11045, 11046, 11047,
   11048, 11049, 11050, 11051, 11052, 11053, 11054, 11055, 11056, 11057,
   11058, 11059, 11060, 11061, 11062, 11063, 11064, 11065, 11066, 11067,
   11068, 11069, 11070, 11071, 11072, 11073, 11074, 11075, 11076, 11077,
   11078, 11079, 11080, 11081, 11082, 11083, 11084, 11085, 11086, 11087,
   11088, 11089, 11090, 11091, 11092, 11093, 11094, 11095, 11096, 11097,
   11098, 11099, 11100, 11101, 11102, 11103, 11104, 11105, 11106, 11107,
   11108, 11109, 11110, 11111, 11112, 11113, 11114, 11115, 11116, 11117,
   11118, 11119, 11120, 11121, 11122, 11123, 11124, 11125, 11126, 11127,
   11128, 11129, 11130, 11131, 11132, 11133, 11134, 11135, 11136, 11137,
   11138, 11139, 11140, 11141, 11142, 11143, 11144, 11145, 11146, 11147,
   11148, 11149, 11150, 11151, 11152, 11153, 11154, 11155, 11156, 11157,
   11158, 11159, 11160, 11161, 11162, 11163, 11164, 11165, 11166, 11167,
   11168, 11169, 11170, 11171, 11172, 11173, 11174, 11175, 11176, 11177,
   11178, 11192, 11193, 11194, 11195, 11196, 11197, 11198, 11199, 11200,
   11201, 11202, 11203, 11204, 11205, 11206, 11207, 11208, 11209, 11210,
   11211, 11212, 11213, 11214, 11215, 11216, 11217, 11218, 11219, 11220,
   11221, 11222, 11223, 11224, 11225, 11226, 11227, 11228, 11229, 11230,
   11231, 11232, 11233, 11234, 11235, 11236, 11237, 11251, 11252, 11253,
   11254, 11255, 11256, 11257, 11258, 11259, 11260, 11261, 11262, 11263,
   11264, 11265, 11266, 11267, 11268, 11269, 11270, 11271, 11272, 11282,
   11283, 11284, 11285, 11286, 11287, 11288, 11289, 11290, 11291, 11292,
   11293, 11294, 11295, 11296, 11297, 11298, 11299, 11300, 11301, 11302,
   11303, 11304, 11305, 11306, 11307, 11308, 11309, 11310, 11311, 11312,
   11313, 11314, 11315, 11316, 11317, 11318, 11319, 11320, 11321, 11322,
   11323, 11324, 11325, 11326, 11327, 11328, 11329, 11330, 11331, 11332,
   11333, 11334, 11335, 11336, 11337, 11338, 11339, 11340, 11341, 11342,
   11343, 11344, 11345, 11346, 11347, 11348, 11349, 11350, 11351, 11352,
   11353, 11354, 11355, 11356, 11357, 11358
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE",
  "CALLED", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN",
  "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLUMN", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE",
  "CREATEUSER", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "CreateAsStmt",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "AlterSecLabelStmt", "SecLabelItem", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_item", "opt_equal", "AlterDatabaseStmt",
  "AlterDatabaseSetStmt", "alterdb_opt_list", "alterdb_opt_item",
  "DropdbStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,    61,    60,    62,   668,    43,    45,    42,
      47,    37,    94,   669,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   432,   433,   434,   434,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   436,
     437,   437,   438,   438,   439,   439,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   441,   441,   441,   441,   441,
     441,   442,   443,   444,   444,   445,   446,   447,   448,   448,
     449,   449,   450,   451,   452,   452,   453,   453,   454,   454,
     455,   455,   456,   456,   457,   457,   457,   457,   457,   457,
     458,   458,   458,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   460,   460,
     461,   461,   462,   462,   462,   463,   463,   463,   463,   464,
     464,   464,   464,   465,   465,   465,   465,   465,   465,   465,
     466,   466,   466,   467,   467,   468,   468,   468,   468,   468,
     469,   469,   470,   470,   470,   470,   470,   471,   472,   472,
     473,   473,   474,   475,   475,   475,   475,   476,   476,   476,
     476,   477,   477,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   479,   479,   480,   480,   480,   481,   481,   482,
     483,   483,   484,   484,   485,   485,   485,   485,   486,   486,
     487,   487,   488,   488,   489,   489,   489,   490,   490,   491,
     491,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   493,   493,   494,   494,   495,   495,   496,   496,
     497,   497,   498,   499,   499,   499,   499,   499,   499,   500,
     500,   501,   501,   502,   502,   503,   503,   503,   503,   503,
     503,   503,   504,   504,   505,   505,   506,   506,   507,   507,
     508,   508,   508,   509,   509,   510,   511,   512,   512,   513,
     513,   513,   514,   514,   514,   514,   514,   514,   514,   515,
     515,   515,   515,   516,   517,   517,   517,   518,   518,   518,
     518,   518,   518,   519,   519,   520,   520,   520,   520,   520,
     521,   521,   522,   522,   523,   524,   524,   524,   524,   525,
     525,   526,   526,   527,   527,   528,   528,   528,   528,   528,
     529,   530,   531,   531,   531,   531,   531,   532,   532,   533,
     533,   533,   533,   534,   534,   534,   534,   535,   535,   536,
     536,   537,   538,   539,   539,   540,   540,   541,   542,   542,
     542,   543,   544,   545,   545,   546,   546,   547,   547,   547,
     547,   547,   547,   547,   547,   547,   547,   547,   547,   548,
     548,   549,   549,   549,   550,   550,   551,   551,   552,   552,
     553,   553,   554,   554,   555,   555,   556,   556,   557,   557,
     558,   558,   559,   560,   560,   561,   561,   562,   563,   563,
     564,   564,   564,   565,   565,   566,   566,   567,   568,   568,
     569,   569,   569,   569,   570,   571,   572,   573,   574,   574,
     575,   575,   576,   576,   577,   577,   578,   578,   578,   579,
     580,   580,   580,   581,   581,   582,   583,   583,   584,   584,
     585,   585,   586,   586,   586,   586,   586,   587,   587,   588,
     588,   589,   589,   590,   590,   591,   591,   591,   592,   592,
     592,   592,   592,   592,   593,   593,   594,   594,   594,   594,
     594,   595,   595,   596,   596,   597,   597,   598,   599,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   600,   600,
     601,   602,   602,   603,   603,   604,   604,   604,   604,   604,
     605,   605,   606,   607,   607,   608,   609,   609,   610,   610,
     611,   612,   612,   613,   613,   613,   613,   613,   614,   614,
     615,   615,   616,   616,   617,   618,   618,   619,   619,   620,
     620,   621,   621,   622,   622,   623,   624,   625,   625,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   627,   627,   628,   628,   629,   629,   630,   631,   631,
     631,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     634,   634,   635,   635,   636,   636,   636,   636,   636,   636,
     636,   636,   636,   636,   636,   636,   636,   636,   636,   636,
     637,   637,   638,   638,   639,   640,   640,   641,   641,   641,
     641,   641,   642,   642,   643,   643,   643,   643,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   645,   645,   646,   646,   647,   647,   648,   648,
     649,   650,   651,   651,   652,   652,   653,   653,   654,   655,
     655,   656,   656,   656,   657,   657,   657,   658,   658,   658,
     659,   660,   660,   661,   661,   662,   662,   663,   663,   664,
     664,   665,   665,   665,   666,   666,   666,   667,   667,   667,
     668,   668,   668,   669,   669,   669,   670,   670,   671,   671,
     672,   672,   673,   673,   674,   674,   675,   675,   675,   675,
     675,   676,   676,   676,   676,   676,   677,   678,   679,   679,
     679,   680,   680,   680,   681,   681,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   682,   682,   682,   683,
     683,   683,   683,   684,   684,   685,   685,   686,   687,   687,
     688,   689,   689,   690,   690,   691,   691,   692,   692,   693,
     693,   694,   694,   694,   694,   695,   695,   696,   697,   697,
     698,   698,   699,   699,   699,   700,   700,   700,   701,   702,
     702,   703,   703,   703,   704,   704,   705,   705,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   707,   707,   708,   708,   709,   709,   709,
     709,   709,   709,   709,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   711,   711,   711,   711,   711,   711,   711,   711,   711,
     711,   712,   713,   714,   714,   714,   715,   715,   716,   716,
     716,   716,   716,   717,   717,   718,   718,   718,   718,   719,
     719,   719,   720,   720,   721,   722,   722,   723,   724,   724,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   726,   726,   726,   727,   727,   727,
     728,   728,   728,   729,   729,   730,   730,   731,   731,   731,
     731,   732,   733,   734,   734,   735,   735,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,   735,   735,   735,
     735,   736,   736,   737,   737,   738,   739,   739,   740,   741,
     741,   742,   743,   743,   743,   743,   743,   744,   744,   745,
     746,   746,   746,   746,   746,   746,   747,   748,   748,   748,
     749,   749,   750,   750,   750,   750,   750,   751,   751,   752,
     752,   752,   752,   753,   753,   754,   754,   755,   755,   756,
     756,   757,   757,   758,   758,   759,   759,   759,   759,   760,
     760,   760,   760,   760,   760,   760,   761,   761,   762,   763,
     763,   763,   764,   764,   764,   764,   765,   766,   766,   767,
     767,   767,   767,   768,   768,   769,   769,   770,   770,   770,
     770,   771,   772,   772,   772,   773,   773,   774,   775,   775,
     776,   777,   777,   778,   779,   779,   780,   780,   780,   780,
     780,   780,   780,   780,   781,   781,   782,   783,   783,   784,
     784,   785,   786,   787,   788,   788,   789,   790,   791,   791,
     791,   791,   791,   792,   792,   792,   793,   793,   794,   794,
     795,   795,   795,   795,   795,   795,   795,   795,   796,   796,
     797,   797,   797,   797,   797,   797,   798,   798,   799,   799,
     800,   801,   801,   802,   802,   802,   802,   802,   802,   802,
     802,   803,   803,   804,   804,   804,   805,   805,   805,   805,
     806,   806,   807,   808,   808,   809,   809,   810,   810,   810,
     810,   811,   811,   812,   812,   812,   813,   813,   814,   814,
     815,   816,   816,   816,   817,   818,   818,   819,   819,   820,
     820,   821,   821,   822,   822,   823,   823,   824,   824,   825,
     825,   826,   826,   827,   827,   828,   828,   829,   829,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     831,   831,   831,   831,   831,   831,   832,   832,   832,   832,
     833,   833,   833,   833,   834,   834,   835,   835,   836,   836,
     836,   836,   837,   837,   838,   838,   838,   839,   840,   840,
     841,   841,   841,   842,   842,   843,   844,   844,   844,   844,
     844,   844,   845,   845,   845,   846,   846,   846,   846,   846,
     846,   846,   847,   847,   847,   847,   848,   848,   849,   849,
     850,   850,   850,   850,   850,   850,   850,   850,   850,   850,
     850,   851,   851,   852,   852,   853,   853,   854,   855,   856,
     856,   857,   857,   858,   859,   860,   860,   860,   860,   860,
     860,   861,   861,   862,   862,   863,   863,   863,   863,   864,
     865,   865,   865,   866,   866,   866,   866,   866,   866,   866,
     866,   866,   866,   866,   866,   866,   866,   867,   867,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   872,   872,
     873,   873,   873,   873,   874,   875,   875,   876,   876,   877,
     877,   878,   878,   878,   879,   879,   880,   880,   881,   882,
     882,   882,   883,   884,   884,   885,   885,   886,   886,   886,
     887,   887,   888,   888,   888,   888,   888,   889,   889,   889,
     890,   890,   890,   891,   891,   892,   892,   892,   892,   892,
     892,   892,   892,   892,   893,   893,   894,   894,   895,   895,
     895,   895,   895,   895,   896,   896,   897,   897,   898,   898,
     899,   899,   900,   900,   900,   901,   901,   902,   902,   903,
     903,   903,   903,   903,   903,   903,   903,   904,   904,   905,
     906,   906,   907,   907,   907,   907,   907,   907,   908,   909,
     910,   910,   910,   911,   911,   912,   913,   913,   914,   915,
     915,   916,   916,   917,   917,   918,   918,   918,   918,   919,
     919,   920,   920,   921,   921,   922,   922,   923,   923,   924,
     925,   925,   926,   926,   926,   926,   927,   927,   928,   928,
     929,   929,   930,   931,   932,   933,   934,   935,   936,   936,
     937,   937,   937,   937,   937,   937,   937,   937,   937,   937,
     937,   937,   937,   938,   939,   940,   941,   941,   941,   942,
     942,   942,   943,   943,   943,   944,   944,   944,   944,   944,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     1,     2,     2,     2,     3,
       3,     5,     5,     0,     3,     5,     5,     4,     3,     5,
       3,     5,     5,     6,     1,     1,     3,     5,     6,     4,
       1,     0,     2,     0,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       5,     2,     2,     2,     2,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     3,     6,     1,     1,     1,
       1,     1,     0,     1,     1,     2,     3,     4,     3,     2,
       2,     1,     2,     3,     4,     3,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     4,     4,     4,
       4,     1,     3,     2,     3,     4,     6,     6,     6,     5,
       5,     6,     6,     4,     7,     2,     6,     4,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     3,     3,
       3,     3,     3,     4,     4,     3,     2,     3,     3,     3,
       2,     2,     3,     2,     1,     1,     0,     2,     0,     3,
       2,     0,     1,     3,     3,     1,     5,     3,     2,     2,
      10,     6,     1,     1,     1,     1,     1,     1,     3,     2,
       0,     1,     1,     3,     3,     1,     1,     3,     3,     3,
       3,     4,     1,     0,     2,     0,     3,     0,     1,     0,
       1,     3,     2,     1,     1,     1,     1,     3,     0,     1,
       3,     1,     1,    11,    10,     1,     1,     2,     2,     2,
       2,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     3,     4,     2,     0,     3,
       1,     1,     2,     1,     3,     4,     4,     2,     5,     1,
       2,     2,     2,     3,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     7,     8,     9,    11,
       3,     0,     1,     3,     1,     2,     2,     2,     0,     1,
       3,     3,     6,     4,     0,     1,     1,     2,     2,     0,
       3,     3,     2,     1,     1,     2,     2,     4,     0,     2,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     7,     5,     3,     0,     1,     3,     1,     2,     3,
       0,     5,     4,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     5,     7,
       1,     0,     6,     2,     0,     3,     5,     7,     6,     8,
       7,     6,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,     8,
       1,     1,     1,     7,     9,     8,    15,    20,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     2,     0,     1,     2,     1,     2,
       0,     2,     1,     2,     2,     6,     8,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     0,     1,     3,
      13,     1,     3,     4,     5,     4,     7,     2,     1,     0,
       2,     0,     1,     0,     6,     8,     8,     1,     3,     5,
       5,     7,     9,     7,     9,     5,     6,     6,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     8,     8,     8,     8,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     3,     2,     2,     5,
       5,     5,     1,     3,     1,     2,     3,     0,     1,     3,
       2,     6,     6,     9,     3,     0,     3,     0,     5,     2,
       0,     3,     3,     3,     7,     7,    10,     1,     1,     1,
      14,     1,     0,     1,     0,     1,     0,     2,     0,     1,
       3,     4,     4,     6,     1,     2,     0,     1,     1,     0,
       1,     1,     0,     9,    12,     7,     2,     0,     3,     2,
       1,     3,     3,     2,     1,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     4,
       5,     1,     3,     3,     1,     2,     4,     5,     1,     1,
       1,     1,     3,     3,     2,     2,     2,     2,     1,     2,
       2,     1,     1,     1,     3,     2,     0,     2,     1,     3,
       5,     1,     2,     1,     0,     5,     7,     5,     7,     5,
       7,     3,     5,     5,     5,     1,     3,     2,     1,     2,
       1,     2,    11,    10,    10,     2,     2,     0,     9,     2,
       0,     4,     4,     4,     1,     1,     1,     0,     7,     6,
       6,     6,     6,     7,     9,     9,     6,     6,     6,     6,
       6,     8,     8,     6,     6,     6,     5,     5,     8,     8,
       8,     8,     6,     1,     0,     2,     0,     7,     6,     6,
       6,     6,     6,     6,     7,     6,     6,     6,     6,     7,
       7,     7,     9,     9,     6,     6,     6,     8,     8,     8,
       6,     4,     4,     4,     7,     4,     4,     4,     5,     5,
       4,     4,    13,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     6,     8,     3,     2,     0,     2,     2,     2,
       2,     3,     3,     2,     2,     2,     2,     3,     2,     5,
       4,     3,     3,     3,     1,     1,     0,     3,     2,     2,
       1,     3,     2,     1,     0,     8,    10,     3,     4,     4,
       0,     2,     5,     2,     0,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     1,     0,     5,     6,     4,     2,     0,     4,     3,
       5,     6,     4,     6,     6,     5,     7,     1,     0,     6,
      11,    11,    11,    13,     9,    11,    10,     4,     2,     5,
       2,     0,     4,     5,     5,     4,     6,     1,     3,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     0,     1,
       0,     1,     0,     3,     0,     2,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     2,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     0,     1,
       1,     1,     1,     3,     8,     3,     0,     2,     3,     2,
       3,     5,     1,     4,     2,     1,     3,     2,     2,     0,
       6,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     7,     1,     3,     1,
       1,     3,     5,     2,     1,     3,     7,     1,     0,     3,
       2,     2,     2,     0,     2,     2,     1,     1,     3,     3,
       1,     2,     4,     4,     2,     3,     5,     5,     1,     1,
       9,     1,     2,     4,     4,     4,     2,     3,     1,     3,
       4,     2,     0,     3,     3,     4,     4,     4,     4,     2,
       1,     1,     0,     1,     1,     0,     1,     5,     1,     0,
       1,     0,     3,     1,     3,     4,     3,     2,     2,     1,
       1,     1,     0,     2,     4,     5,     2,     3,     1,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     1,     3,
       0,     2,     0,     1,     3,     1,     0,     1,     2,     4,
       4,     2,     0,     2,     3,     2,     0,     1,     3,     1,
       2,     1,     2,     5,     6,     5,     1,     2,     1,     4,
       3,     4,     5,     4,     5,     4,     5,     2,     4,     1,
       2,     2,     2,     1,     1,     0,     4,     2,     1,     2,
       2,     4,     1,     3,     1,     2,     3,     1,     2,     0,
       2,     4,     0,     1,     3,     2,     2,     3,     5,     6,
       2,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       2,     5,     1,     1,     1,     1,     2,     3,     3,     0,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       1,     3,     0,     1,     1,     1,     1,     5,     2,     1,
       1,     1,     1,     5,     2,     2,     2,     1,     3,     3,
       2,     1,     0,     3,     0,     5,     2,     5,     2,     1,
       2,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       3,     5,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     3,     3,     2,     3,
       5,     4,     6,     3,     5,     4,     6,     4,     6,     5,
       7,     3,     2,     4,     2,     3,     3,     4,     3,     4,
       3,     4,     5,     6,     6,     7,     6,     7,     6,     7,
       3,     4,     4,     6,     2,     3,     4,     1,     3,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     2,     5,     6,     6,     7,     3,     4,     1,
       1,     2,     4,     1,     1,     1,     2,     2,     2,     1,
       4,     5,     6,     8,     6,     7,     7,     5,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     4,     4,     6,     5,
       5,     5,     4,     6,     4,     4,     4,     4,     5,     7,
       7,     9,     4,     6,     5,     7,     7,     7,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     2,     2,     0,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     2,     2,     0,
       1,     4,     2,     2,     2,     2,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     4,
       1,     2,     1,     2,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       2,     0,     2,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     2,     1,     1,     1,     3,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     5,     2,     3,     6,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     108,   996,   491,  1076,  1075,   996,   232,     0,  1078,     0,
     996,   323,   797,     0,     0,     0,     0,     0,   491,   996,
       0,     0,     0,     0,     0,     0,     0,  1202,     0,     0,
       0,     0,     0,     0,     0,     0,   996,     0,  1209,     0,
       0,     0,     0,  1202,     0,     0,  1080,     0,     0,     0,
       0,     2,     4,    50,    51,    19,    18,    24,    23,    73,
      74,    40,    12,    64,    45,   105,   104,   106,    30,    26,
      58,    17,    27,    31,    47,    32,    46,    16,    44,    68,
      48,    71,    37,    62,     9,    38,    63,    10,    52,    75,
      22,    49,    72,    33,    60,    56,    41,    42,    43,    65,
      66,    67,    89,    70,   100,    29,    79,    80,    95,    81,
      96,     7,    82,    39,    11,    92,    91,    93,    59,    34,
      61,    90,    94,    13,    14,    15,    97,    69,    87,    84,
     101,    99,   107,    85,    53,     5,     6,    76,    36,     8,
      21,    20,    35,    28,   103,    25,  1078,    78,    88,    77,
      54,    83,    57,    86,   102,    55,    98,  1179,  1166,  1211,
    1178,     0,  1181,   995,   994,   980,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   490,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1699,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
     299,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,
    1961,  1962,  1963,  1964,  1727,  1728,  1729,  1730,  1731,  1732,
    1733,  1965,  1966,  1734,  1735,  1736,  1737,  1738,  1967,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1968,  1969,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1970,  1786,
    1787,  1971,  1788,  1789,  1972,  1790,  1791,  1792,  1793,  1794,
    1795,  1796,  1973,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1974,
    1813,  1814,  1815,  1816,  1975,  1976,  1977,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1978,  1826,  1827,  1828,
    1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,
    1839,  1840,  1841,  1842,  1979,  1980,  1843,  1844,  1845,  1846,
    1847,  1848,  1849,  1981,  1850,  1851,  1852,  1853,  1982,  1854,
    1983,  1855,  1856,  1857,  1858,  1859,  1860,  1984,  1985,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1986,  1868,  1987,  1871,
    1869,  1870,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1988,
    1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,
    1889,  1890,  1891,  1892,  1893,  1894,  1895,  1989,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1990,  1910,  1911,  1912,  1991,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1992,  1923,  1924,
    1925,  1926,  1927,  1928,  1929,  1930,  1931,  1993,  1994,  1932,
    1995,  1933,  1996,  1934,  1935,  1936,  1937,  1938,  1939,  1940,
    1941,  1942,  1943,  1944,  1945,  1946,  1947,  1997,  1998,  1948,
    1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  1958,  1959,  1960,
     298,  1157,  1672,  1700,  1701,  1077,  1058,   491,     0,   983,
     322,     0,     0,     0,     0,     0,     0,     0,   618,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
     346,   345,     0,     0,     0,   771,     0,     0,     0,     0,
     479,  1119,  1869,  1117,  1158,     0,   233,   236,   234,   235,
    1694,     0,   867,   868,   870,     0,     0,   880,   645,     0,
     644,     0,     0,     0,   642,     0,     0,     0,     0,   646,
     640,     0,   639,     0,     0,     0,   643,     0,   641,     0,
       0,   984,  1116,   351,     0,     0,  1094,  1078,  1085,  1095,
    1090,  1092,  1091,  1093,  1089,  1693,  1711,   713,   713,   713,
     713,   710,   711,   713,   713,   713,  1883,     0,     0,   692,
       0,   694,  1696,   713,   718,   401,   401,   401,     0,   717,
     722,   401,     0,   977,  1011,  1677,  1201,     0,   693,   976,
    1932,  1108,     0,     0,   884,     0,   885,     0,  1898,   988,
     219,  1908,  1993,  1932,   215,   188,  1715,     0,     0,   717,
       0,   985,   986,  1208,  1206,     0,  1732,  1745,  1829,   212,
    1894,  1899,  1908,  1993,  1932,  1957,   170,     0,   226,  1908,
    1993,  1932,   222,  1004,     0,  1182,  1288,  1668,     0,   979,
     978,  1294,     0,  1079,     0,  1082,     0,  1253,  1881,  1186,
    1188,  1084,  1179,     0,     1,   108,  1073,  1205,  1205,     0,
    1205,     0,  1171,  1179,  1174,  1178,     0,  1699,  2007,  2008,
    2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,
    2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,
       0,     0,  1678,  1700,  1704,     0,   653,   111,  1673,   760,
       0,     0,     0,     0,     0,  1695,     0,     0,  1573,  1736,
    1788,  1583,  1581,  1582,  1575,  1576,  1577,  1578,  1579,  1580,
       0,   865,  1574,     0,   111,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,   111,     0,     0,     0,     0,  1000,
    1003,   981,  1061,     0,  1668,     0,     0,   678,     0,   687,
     679,   684,     0,   681,     0,     0,   689,     0,   680,   682,
     683,   688,     0,     0,   685,   686,     0,     0,   992,   401,
       0,     0,     0,     0,     0,   111,  1048,     0,   350,   349,
     111,   348,   347,  1736,  1788,     0,   796,   111,     0,   163,
     519,   494,     0,     0,   583,  1833,   111,     0,     0,     0,
       0,   774,     0,     0,   478,   491,  1120,  1118,     0,  1132,
     871,   214,   213,   869,  1802,     0,   286,     0,     0,  1802,
    1039,     0,  1802,     0,  1802,   156,  1670,  1736,  1788,  1802,
       0,     0,  1802,   148,  1802,     0,  1802,   286,  1802,   495,
       0,  1802,     0,  1802,  1833,   150,     0,  1802,   286,   651,
       0,  1113,     0,  1087,  1997,  1101,  1100,     0,  1096,  1105,
    1099,     0,   713,   712,     0,   713,     0,   713,     0,   713,
       0,   713,     0,     0,     0,   713,  1697,  1698,   695,     0,
     719,     0,     0,   726,   725,   724,     0,     0,     0,   727,
       0,  1292,  1135,     0,   974,   991,     0,     0,     0,   887,
     887,   887,   987,   218,   216,     0,     0,     0,     0,     0,
       0,   993,     0,     0,  1681,  1683,  1684,  1584,  1651,     0,
    1962,  1963,  1964,  1642,     0,  1965,  1966,  1967,  1501,  1488,
    1497,  1502,  1489,  1491,  1498,  1968,  1969,  1774,  1970,  1971,
    1691,  1972,  1973,  1975,  1976,  1977,  1978,  1493,  1495,  1979,
    1980,     0,  1692,  1982,  1983,  1858,  1985,  1986,  1988,  1989,
    1499,  1991,  1992,  1993,  1994,  1995,  1996,  1690,     0,  1500,
    1998,  2000,  2001,  2002,  2003,  2004,  2005,  2006,     0,     0,
    1665,     0,  1475,     0,  1322,  1323,  1345,  1346,  1324,  1351,
    1352,  1364,  1325,     0,  1664,  1389,  1474,  1479,     0,  1473,
    1469,  1192,  1660,     0,  1470,  1680,  1682,  1643,   181,   228,
       0,   229,  1666,  1908,   171,   211,   183,   210,   184,   182,
       0,  1734,   172,     0,   179,     0,     0,     0,     0,   225,
     223,     0,   982,     0,  1290,  1289,     0,     0,  1649,  1669,
     660,     0,  1295,     0,  1071,  1072,  1070,     0,  1067,  1069,
    1081,  1078,  1656,  1655,  1657,     0,  1187,     0,     0,     0,
    1169,  1168,     3,  1084,  1203,  1204,     0,     0,     0,     0,
       0,     0,     0,     0,  1246,  1219,  1220,  1222,  1243,  1247,
       0,  1175,  1254,     0,     0,  1679,     0,     0,     0,   654,
       0,     0,     0,     0,   110,  1037,   221,  1035,   941,     0,
       0,     0,     0,     0,  1042,     0,     0,     0,     0,   829,
       0,     0,     0,     0,     0,     0,   830,   828,   831,   838,
     851,   854,   947,     0,   750,   154,   155,     0,     0,     0,
     914,     0,     0,   914,     0,     0,     0,     0,     0,     0,
       0,   238,   241,   471,     0,     0,  1696,   473,     0,     0,
       0,     0,     0,     0,     0,   115,     0,     0,     0,   942,
       0,   458,   470,     0,     0,     0,     0,     0,   467,     0,
     111,   239,   452,   455,   945,     0,     0,     0,   528,   527,
     914,   914,     0,   237,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,     0,     0,
       0,   115,   147,     0,     0,   240,   946,     0,     0,   998,
     999,     0,  1002,     0,  1057,     0,     0,     0,     0,     0,
       0,  1736,  1788,     0,     0,     0,     0,     0,     0,   325,
     305,   306,   111,   304,     0,     0,   580,     0,  1702,  1333,
    1362,  1340,  1362,  1362,  1329,  1329,  1342,  1330,  1331,  1369,
       0,  1362,  1329,  1334,     0,  1332,  1372,  1372,  1357,     0,
    1314,  1315,  1316,  1317,  1343,  1344,  1318,  1349,  1350,  1319,
    1386,  1329,  1703,     0,  1014,  1047,     0,     0,   113,   619,
       0,     0,   581,     0,   113,     0,   159,     0,   523,     0,
       0,     0,     0,     0,     0,   539,   538,     0,     0,   582,
       0,   113,   454,     0,   444,   401,     0,   773,   776,     0,
       0,     0,  1161,  1163,  1162,     0,  1160,     0,  1302,     0,
     286,   284,   285,   578,   879,     0,     0,     0,     0,   286,
       0,     0,  1802,     0,  1802,     0,     0,   286,   286,     0,
       0,     0,     0,   524,     0,   650,   648,   647,   649,     0,
       0,     0,     0,     0,  1802,   286,     0,     0,   638,  1594,
       0,     0,     0,     0,   200,   202,   201,   199,  1102,  1103,
    1104,  1098,  1086,     0,   703,     0,   707,     0,   698,     0,
     704,     0,   699,   696,   697,     0,   702,     0,     0,   402,
     404,     0,     0,  1759,     0,  1793,  1821,  1822,  1899,  1904,
       0,  1927,     0,   728,   755,   723,     0,     0,  1129,  1122,
       0,     0,  1145,   975,  1600,     0,     0,     0,   886,   883,
     882,   881,   217,   189,     0,     0,     0,   757,  1898,   990,
       0,  1471,     0,  1477,  1478,  1361,  1348,  1641,     0,     0,
    1356,  1355,     0,     0,     0,     0,  1338,  1337,  1336,  1476,
    1608,     0,  1335,     0,     0,     0,     0,  1362,  1362,  1360,
    1408,     0,  1339,     0,     0,  1621,     0,  1627,     0,     0,
       0,  1368,     0,  1366,     0,     0,  1444,     0,     0,     0,
       0,     0,     0,     0,  1392,  1393,  1475,  1594,     0,  1687,
       0,     0,  1354,     0,  1386,  1663,  1584,     0,     0,     0,
       0,  1654,  1592,     0,     0,  1422,  1590,     0,  1424,     0,
       0,     0,  1583,  1581,  1582,  1575,  1576,  1577,  1578,  1579,
    1580,  1588,  1405,     0,     0,  1404,     0,     0,  1256,     0,
    1685,  1644,   230,   231,   227,     0,     0,   186,   185,     0,
     204,   208,   209,   178,   207,     0,   203,  1540,  1539,   187,
     177,   175,   173,   190,   192,   193,   194,   176,   174,   224,
       0,     0,  1705,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    1646,  1645,  1675,  1706,  1707,  1708,  1709,  1650,     0,     0,
     286,  1296,     0,  1256,  1147,  1149,  1150,     0,  1651,  1065,
       0,  1062,  1659,     0,  1189,     0,     0,  1074,  1185,  1184,
    1212,  1213,   789,  1183,  1237,  1238,  1233,     0,  1252,  1252,
    1229,  1223,  1228,  1226,     0,  1230,  1389,  1245,  1173,  1217,
    1218,  1221,  1172,     0,  1248,  1246,  1222,     0,     0,     0,
       0,     0,   948,     0,     0,   655,     0,     0,     0,     0,
    1927,   220,  1033,     0,     0,     0,     0,   759,   758,     0,
       0,   778,     0,     0,     0,  1045,   394,     0,   283,     0,
       0,     0,     0,     0,     0,     0,   836,     0,     0,     0,
       0,   837,   834,   835,  1899,   853,     0,   852,   850,   811,
     813,   812,     0,   815,   799,     0,   800,     0,     0,   810,
     818,   816,     0,     0,     0,  1782,   243,   255,     0,   913,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     276,     0,     0,     0,     0,   281,     0,     0,     0,   280,
       0,   472,     0,   949,     0,     0,     0,     0,     0,   866,
       0,     0,   142,   145,     0,     0,   457,   469,     0,   461,
     462,   459,   463,   464,     0,     0,     0,     0,     0,     0,
     456,     0,     0,   521,   520,   526,     0,     0,     0,     0,
       0,     0,   907,   906,     0,     0,     0,     0,     0,     0,
       0,     0,   530,   531,     0,   532,     0,   146,     0,     0,
       0,     0,     0,     0,   198,   997,  1001,  1060,  1676,  1059,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   310,
    1702,     0,   603,   579,     0,  1314,     0,  1310,  1306,  1375,
    1376,  1377,  1374,  1387,  1373,     0,  1320,  1378,  1329,  1326,
       0,  1012,   368,   487,   152,     0,     0,     0,   591,   594,
       0,   109,   163,   351,     0,   162,   164,   166,   167,   168,
     165,   169,   518,   522,     0,   493,     0,     0,     0,     0,
       0,   543,   542,   546,   544,     0,   540,     0,     0,     0,
     141,   451,   453,     0,     0,   353,   432,     0,     0,     0,
     775,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
    1266,  1131,  1257,  1268,  1259,  1261,  1297,     0,  1668,     0,
    1129,     0,   857,     0,  1040,  1802,   286,     0,   855,   157,
    1671,     0,     0,     0,     0,     0,   859,   635,   149,     0,
     286,   286,   496,     0,   286,   151,     0,     0,     0,   488,
     286,   652,  1115,     0,   444,  1088,  1097,   700,   709,   708,
     706,   705,   701,     0,   720,     0,   400,     0,     0,     0,
     734,     0,     0,   733,   748,   735,     0,   737,   730,   729,
     738,     0,     0,   757,  1124,     0,  1125,  1651,     0,  1121,
       0,  1142,     0,  1140,     0,  1293,  1144,  1133,  1107,     0,
    1106,  1110,  1112,  1111,  1109,     0,     0,     0,   717,     0,
       0,   286,   989,     0,  1652,  1604,     0,  1605,     0,     0,
       0,  1640,  1636,     0,     0,     0,     0,     0,  1609,  1612,
    1613,  1614,  1611,  1615,  1610,     0,     0,  1616,     0,     0,
       0,     0,     0,  1359,  1358,     0,     0,     0,     0,     0,
       0,     0,  1447,  1479,     0,     0,  1568,     0,  1594,  1626,
       0,     0,  1370,     0,     0,     0,     0,     0,     0,     0,
    1594,  1632,     0,     0,     0,  1538,     0,  1535,     0,     0,
       0,     0,  1651,     0,     0,     0,     0,  1688,  1390,  1406,
    1662,     0,  1653,     0,     0,  1413,     0,  1633,  1440,     0,
    1445,  1428,     0,  1421,     0,  1426,  1430,  1409,  1654,  1593,
       0,  1591,     0,     0,  1407,     0,  1402,  1400,  1401,  1394,
    1395,  1396,  1397,  1398,  1399,  1403,  1572,  1570,  1571,     0,
       0,     0,  1425,  1795,  1829,     0,  1202,  1202,  1191,  1200,
    1661,     0,  1299,     0,     0,     0,     0,  1551,     0,  1598,
       0,  1596,  1678,  1667,     0,     0,  1386,     0,  1291,  1647,
       0,   658,   659,   657,  1154,     0,     0,  1302,     0,  1153,
    1084,  1068,  1064,  1063,  1658,  1083,  1190,     0,   787,   788,
       0,   792,     0,     0,  1231,  1244,     0,  1145,  1145,     0,
    1235,  1236,  1227,  1177,  1176,   601,   600,     0,     0,     0,
     925,   889,   656,   926,   890,     0,  1034,     0,  1036,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   286,  1043,   927,   282,  1044,   918,     0,     0,
       0,   501,   502,     0,   832,   833,   928,   891,     0,   919,
     814,  1329,   798,     0,     0,   809,     0,   808,  1329,  1329,
     892,   153,   244,   368,   916,   262,   275,   270,   271,   269,
    1802,   286,  1802,   286,     0,     0,     0,     0,   272,   267,
     268,   264,   277,   278,   900,     0,   292,   295,   279,   258,
       0,   263,   259,     0,   242,     0,     0,  1674,     0,     0,
     861,     0,     0,   144,   903,     0,   124,   126,   128,     0,
     122,   130,   125,   127,   129,   123,   131,   121,     0,   120,
       0,     0,     0,   114,   934,   896,   460,   465,   898,   468,
     921,   466,  1714,  1775,  1909,     0,   508,   510,     0,   515,
     940,   916,   897,     0,   920,   936,   905,     0,     0,     0,
       0,     0,     0,     0,  1049,     0,     0,     0,   935,   912,
     923,     0,   904,   899,   922,     0,     0,   196,   195,   197,
       0,     0,     0,     0,     0,     0,     0,     0,   691,   667,
     690,     0,     0,     0,     0,     0,     0,     0,   661,   324,
     302,   303,     0,     0,   301,   307,     0,   602,     0,     0,
    1311,  1307,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1327,     0,     0,  1032,  1032,  1032,  1032,  1032,  1032,
    1032,  1013,  1041,   486,   504,     0,     0,     0,     0,   135,
     112,     0,   624,   590,     0,     0,   401,   158,     0,     0,
       0,   492,   589,   587,   586,   588,     0,     0,     0,   607,
       0,  1303,     0,     0,     0,   450,   355,     0,     0,   352,
     356,   360,   361,   362,     0,   445,   447,     0,     0,   436,
       0,     0,     0,   803,     0,   821,   804,     0,     0,     0,
     841,   846,   842,   824,     0,   476,  1164,  1165,     0,  1179,
       0,  1268,     0,  1267,  1279,     0,     0,  1285,  1283,     0,
    1285,     0,  1285,     0,  1260,     0,  1262,  1279,     0,  1669,
    1755,  1300,  1130,   286,     0,     0,   498,   286,     0,   286,
       0,   286,   286,     0,   972,   525,     0,   575,     0,     0,
     286,   637,  1595,     0,   721,   403,     0,     0,     0,     0,
     732,     0,   474,   736,     0,   747,   742,   744,     0,   751,
       0,     0,  1127,  1128,  1143,  1136,  1138,  1137,     0,     0,
    1134,  1601,   636,     0,     0,   286,     0,   752,  1207,  1602,
    1603,     0,     0,     0,     0,  1637,     0,     0,  1514,  1490,
    1492,  1328,  1504,     0,  1341,  1515,  1516,  1494,  1496,     0,
    1585,     0,     0,  1505,  1449,  1450,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1462,
    1461,  1506,  1567,     0,     0,  1624,  1625,  1507,  1371,  1372,
    1372,     0,     0,  1631,     0,     0,     0,  1512,  1517,     0,
       0,  1522,     0,  1543,     0,     0,     0,  1472,  1595,  1363,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,  1446,
    1429,  1423,     0,  1427,  1431,     0,     0,     0,     0,  1415,
    1441,  1411,     0,     0,  1417,     0,  1442,  1202,  1202,  1202,
    1202,  1199,     0,     0,  1255,     0,  1240,  1211,  1211,     0,
    1551,     0,  1480,     0,  1551,     0,     0,   180,     0,   205,
     191,     0,     0,     0,  1148,  1129,  1151,  1066,  1214,     0,
    1586,   792,   790,   791,  1216,     0,     0,  1251,  1250,  1249,
    1224,   924,   888,   917,   951,  1032,   762,   763,     0,   761,
       0,     0,     0,   393,   777,     0,     0,     0,     0,  1046,
     485,     0,   484,   480,   500,   826,     0,  1329,   801,   806,
     807,     0,   365,     0,     0,     0,   245,     0,     0,   257,
       0,   253,   273,   265,   274,   266,   289,     0,     0,     0,
     260,   261,   930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   931,     0,     0,   117,   116,     0,   134,     0,
     512,   513,   511,   507,     0,   514,   516,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     929,   893,   662,     0,     0,   663,   671,     0,     0,   664,
       0,     0,     0,     0,     0,     0,   673,   327,     0,   330,
     338,   311,   315,  1048,  1048,     0,   316,  1048,   312,  1048,
     309,  1858,  1575,  1576,   598,   605,   595,   597,   599,   596,
       0,   604,   570,     0,     0,     0,  1312,     0,  1380,  1381,
    1382,  1383,  1384,  1385,     0,  1379,  1386,     0,  1032,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     379,     0,     0,   373,     0,     0,   846,   367,   370,   371,
       0,   497,   137,     0,     0,   138,   136,     0,   592,   593,
       0,   351,     0,     0,   545,   548,   541,     0,   606,   608,
     584,     0,  1305,   504,  1116,     0,   441,     0,   432,   386,
     428,     0,   443,     0,   430,   429,   431,     0,   438,  1010,
       0,   778,   802,     0,     0,     0,   839,   843,   840,     0,
       0,   817,     0,   825,   795,   967,   968,   965,   966,     0,
       0,  1156,  1270,  1277,     0,  1258,     0,  1284,  1280,     0,
    1281,     0,     0,  1282,     0,     0,  1277,     0,     0,     0,
     858,     0,   286,   856,     0,   631,     0,   633,   860,   286,
     286,   533,     0,   489,   447,     0,     0,     0,   731,   749,
       0,   745,     0,     0,   714,   754,  1123,  1126,  1141,  1139,
     757,     0,   715,   756,  1606,  1347,     0,  1639,  1635,     0,
    1607,     0,  1619,  1618,  1448,  1620,     0,  1467,     0,     0,
    1459,  1457,  1458,  1451,  1452,  1453,  1454,  1455,  1456,  1460,
    1629,  1628,  1622,  1623,  1367,  1365,     0,  1509,  1510,  1511,
    1630,  1518,     0,  1537,  1536,     0,     0,     0,  1524,     0,
       0,  1533,     0,  1569,  1353,  1386,  1391,     0,     0,  1414,
    1634,  1432,     0,     0,     0,  1410,     0,     0,     0,     0,
    1419,  1585,     0,     0,     0,     0,     0,     0,  1194,  1193,
    1298,     0,  1242,     0,     0,  1210,     0,  1551,  1487,  1554,
    1549,  1550,  1599,  1481,  1686,     0,  1597,  1551,     0,  1648,
       0,  1155,  1146,     0,  1215,  1232,  1225,     0,   768,   769,
     767,     0,     0,     0,   570,     0,     0,   409,     0,   786,
     786,     0,     0,   846,   939,   481,   827,     0,   819,     0,
     250,   915,     0,     0,     0,   249,     0,   286,   286,   293,
     294,   297,     0,     0,     0,     0,     0,   625,   611,     0,
       0,   626,   627,     0,     0,   863,   864,   862,   132,   118,
     119,   133,   509,   901,     0,     0,     0,     0,     0,   938,
     911,   937,   909,   908,   910,   902,   535,     0,   665,     0,
       0,   666,   677,   675,   674,   676,   668,   328,   111,     0,
     308,     0,   336,     0,   333,   334,   332,   335,     0,     0,
       0,     0,     0,     0,   572,     0,     0,   577,   566,   568,
       0,     0,     0,  1308,  1313,  1388,  1321,   565,     0,  1023,
    1022,  1021,  1025,  1024,  1027,  1026,  1018,  1017,  1030,  1029,
    1016,  1015,  1020,  1019,     0,     0,   377,   381,   382,   380,
     372,   846,   401,   440,     0,   140,   139,     0,     0,     0,
       0,   550,   554,   585,     0,  1304,   529,  1114,   448,     0,
       0,   358,   363,   364,     0,   436,   383,     0,   432,   357,
     446,     0,     0,   442,     0,  1005,     0,     0,   805,   822,
     823,     0,     0,   846,   845,     0,   483,  1269,     0,     0,
    1271,     0,     0,  1273,  1275,     0,     0,     0,     0,     0,
    1672,  1551,  1301,   286,   499,   286,   286,   973,   576,     0,
     741,   740,   739,   475,     0,   743,   286,     0,  1638,  1503,
    1513,  1617,     0,     0,  1468,     0,     0,  1508,  1999,     0,
       0,  1541,  1542,  1523,     0,  1844,  1528,     0,     0,     0,
    1689,  1438,  1436,  1433,     0,  1434,     0,     0,  1416,  1412,
       0,  1418,  1443,  1198,  1197,  1196,  1195,     0,     0,  1545,
    1551,  1551,  1482,  1556,  1553,     0,  1484,  1386,  1152,     0,
    1038,     0,     0,     0,   395,     0,   846,     0,     0,     0,
     784,   789,   789,     0,   846,   440,   820,   246,   247,   248,
     251,   288,   256,   252,     0,   932,   894,     0,     0,   617,
       0,     0,     0,     0,   933,   895,     0,     0,     0,  1054,
       0,     0,   669,   670,   310,     0,   331,   341,   342,     0,
     339,   313,   318,     0,   320,   319,   314,   317,   574,   573,
     571,   567,   569,  1309,     0,   877,   877,     0,   570,  1028,
       0,     0,   369,   440,   408,     0,   374,     0,   505,     0,
    1010,   353,   504,   549,     0,     0,     0,   609,   449,   354,
       0,     0,   438,     0,     0,     0,   436,     0,   433,     0,
     437,     0,     0,     0,     0,     0,   844,     0,   848,     0,
     816,   793,  1299,     0,   487,     0,  1278,  1287,     0,  1274,
    1272,  1263,     0,  1265,   878,   632,   634,   534,   746,   753,
     286,  1463,     0,     0,     0,     0,  1519,     0,  1520,  1525,
    1529,     0,  1526,  1527,  1435,  1439,  1437,  1420,  1239,  1241,
       0,  1180,  1485,  1486,     0,  1211,  1551,   206,  1587,   747,
       0,   286,   786,   440,   410,  1858,   411,   785,   792,   792,
       0,   440,   570,     0,   254,   296,     0,     0,   623,   612,
       0,     0,   628,     0,     0,     0,     0,     0,   672,   300,
     326,   337,     0,   321,   877,     0,   874,   873,   564,     0,
     376,   375,     0,   419,     0,   503,     0,   621,  1006,   517,
     551,   552,   547,     0,     0,   359,   368,   344,   392,   391,
     388,   387,   389,   390,   385,   384,     0,   438,   434,   435,
       0,  1007,     0,  1056,     0,   779,   847,     0,     0,     0,
     482,   477,  1276,     0,  1264,   716,  1464,     0,  1465,     0,
       0,  1531,  1530,  1544,  1546,     0,     0,  1559,  1483,   764,
       0,   765,   789,   414,     0,   782,   781,   401,   570,   396,
     287,     0,   615,   622,   613,   623,     0,     0,  1050,     0,
    1051,  1052,  1055,   340,   872,   876,   875,     0,   405,   406,
     407,     0,   378,   415,   416,     0,   506,     0,     0,     0,
       0,   366,   427,   343,  1008,  1009,   291,     0,   846,   849,
     971,  1286,  1466,  1534,  1521,  1532,     0,     0,  1555,     0,
       0,     0,     0,   792,     0,   570,     0,   408,   397,     0,
     614,   630,   629,     0,     0,     0,     0,     0,   417,     0,
     418,   439,   620,     0,   553,     0,     0,   438,   780,   794,
     970,   969,     0,  1547,  1548,  1961,  1755,  1937,     0,  1557,
    1560,  1558,  1552,   286,   783,     0,   398,   412,   419,     0,
    1053,   554,   424,     0,   423,     0,   421,   420,   610,   557,
     290,  1299,   953,   964,   952,   954,   962,   959,   961,   960,
     958,     0,  1564,  1563,  1562,  1566,  1565,   766,     0,   570,
     616,     0,   422,   426,   425,   559,   561,   562,     0,   555,
     558,   560,   563,   770,     0,   963,   957,  1179,  1166,     0,
     413,   399,     0,   536,     0,   955,   964,  1561,     0,   556,
     956,     0,   557,     0,   537
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    50,    51,    52,    53,  1125,  1934,  1832,  2499,  2500,
      54,    55,  1186,    56,    57,    58,    59,    60,    61,    62,
    1158,    63,    64,   818,  1316,  1945,    65,  1741,   657,  1582,
    1583,  1885,  1584,  1573,  1046,  1585,  1126,  1149,    67,    68,
    1040,  1564,    69,    70,    71,  1171,  1172,  2816,  1353,  3604,
    1819,  3777,  2355,  2356,    72,    73,  2462,  1262,  2464,  2465,
    2900,   501,  1908,  3248,  3249,  2888,  2889,  3256,  3479,  3480,
      74,  1313,  2528,  2978,  2529,  3320,  2530,  3321,  2531,  3322,
    2492,  2947,  2948,  2949,  2532,  3326,  3654,  2533,  1756,   913,
    1418,  1419,  3633,  3176,  3177,  3755,  3722,  3723,  3724,  3806,
    3328,  2539,  2988,  3333,  3506,   576,  1333,  1976,  2534,  2535,
    2976,    76,    77,  1971,  1202,  1203,  1838,  2904,  2613,    78,
     835,  2802,  3544,  2493,  2494,    79,   189,    80,  1320,    81,
      82,    83,    84,  2951,  3507,  1208,  2405,  2406,  2407,  2408,
    2855,    85,  1318,  1209,  1954,    86,    87,    88,  1874,    89,
      90,    91,  1327,  1965,  1966,  3312,  3514,  3642,  3516,  3838,
    3839,  3498,  3267,  3268,  3269,    92,    93,    94,    95,  1312,
    1937,  1938,  2905,  1114,  1266,  1911,  1912,  2967,  2968,    96,
    3207,  3208,   528,  3728,  3704,    97,    98,  3211,  3212,    99,
     100,   101,   102,   103,   570,   878,   879,  2329,   104,  1680,
     105,   797,  2449,   106,   599,   893,   894,   107,   108,   608,
    2088,   610,  1432,  2615,  2616,  3054,  2053,   732,   109,   110,
    2063,  2091,   111,  1129,  1747,  1748,  3171,   112,   529,  1338,
    1979,  2298,  3664,  3178,  3441,  2261,  2774,   113,   530,  1154,
    1785,  1982,  2544,  2545,  1787,  2228,  3000,  1789,  2546,  2551,
    2552,  2553,  2996,  3004,  3538,  3539,   114,  1151,  1778,   115,
     116,   117,  1181,   750,   118,   542,   543,   119,  3626,   120,
     848,   121,   627,  1449,   122,  1800,  2817,   123,   124,   125,
    1128,   126,  3814,  3844,  3845,  3846,  3009,  3782,   127,  3816,
     924,   129,   130,   131,   165,   769,   770,   771,   132,  3335,
     133,   134,  1931,  2491,  2930,   135,   136,  1742,  2288,   137,
     138,   139,  1306,   140,   141,   142,   143,  1244,   144,  1077,
    1078,   145,   146,   496,   675,  1081,  1089,   147,   578,   887,
     888,   889,  1401,   148,   927,  2080,   579,   881,   150,   580,
    1438,  2065,  2066,  2069,   581,  1348,   153,  1442,  2074,  2077,
     582,  1683,  1684,  1685,  1686,  1687,  2245,   583,   601,   838,
    1987,   584,  1012,   158,   159,   160,   161,   679,   680,  1558,
    2218,   617,  1096,   645,   691,  3145,  1700,  1701,  1721,  1722,
    1105,  1106,  1711,  1713,  2263,  1714,  2272,  1706,  3142,  3419,
    1717,  1718,  1108,  1109,  2267,   162,  2222,  1991,  1992,  1993,
    2563,  2573,  3018,  3353,  1994,   922,   672,  1995,  2746,  2000,
    2520,  2521,  1790,  1918,  1290,  1013,  1291,  1929,  1014,  1482,
    1293,  1015,  1016,  1017,  1296,  1018,  1019,  1020,  1021,  1466,
    1522,  1022,  1023,  1501,  1926,  1927,  1389,  2131,  1025,  1026,
    3111,  3398,  3389,  2156,  2157,  1579,  3107,  3581,  3683,  3684,
    3153,  3150,  3423,  3585,  3751,  3789,  3790,  1027,  2209,  1551,
     752,  1028,  2907,  1553,  2151,  2230,  2231,  1728,  1464,  2098,
    2115,  2116,  2128,  2662,  2135,  2140,  2685,  2686,  2152,  2178,
    1029,  2101,  2102,  2646,  1468,  1030,  1068,  1069,  1461,  2174,
    1084,  1085,   677,  1031,  1032,  1433,   666,  3349,   856,   727,
    2366,  1671,   773,   614,  1033,  1034,  1035,  1036,  2617,  1177,
     492,   722,  2409,   493,   494,   724,  1676
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3430
static const int yypact[] =
{
   11924,   986,  7389, -3430, -3430,   986, -3430, 42187,   483,   698,
     794,   128,  9688, 42594, 49513,   727,   436,   267, 11227,   986,
   49513,  1418, 33233, 38524,   796, 49513,  1021,   742, 33233, 49513,
   49920,   961,   780, 50327, 43001, 36489,   984, 49513,   292, 50734,
   43408,   877, 43815,   742, 30404, 43815,    86,   832, 51141,   944,
    1348,   940, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430,   483, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430,   167, -3430,   631,
     239,  1271,   928, -3430, -3430, -3430, 34454, 49513, 49513,  1255,
   49513,  1416, 34454, 49513, 49513,  1321, 27488, -3430, 49513, 49513,
   49513, 49513, 43815, 49513,  1243, 49513, 49513, 51548, 49513,  1394,
     608, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, 49513,  8303,  1021, -3430,
   -3430, 49513,  1262, 34454, 49513,  1172,  1295, 49513, -3430, 49513,
    1570,  1091, 49513,  1377, 27908,  1379, 49513, 49513, 49513, 49513,
   -3430, -3430,  1370, 49513, 49513, -3430, 51955,    12,  1629,  1559,
     114, -3430, 44222, -3430, -3430, 43815, -3430, -3430, -3430, -3430,
   -3430, 44629,   267, -3430, -3430, 34861, 49513,  1552, -3430, 52362,
   -3430,  1645, 35268, 52769, -3430, 28328,  1759, 53176, 53583, -3430,
   -3430, 53990, -3430, 54397,  1511, 54804, -3430, 55211, -3430,  1616,
   55618, -3430,  1426,   124,  1632, 24590, -3430,   483, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430,   287,   221,   190,   162,
     218, -3430, -3430,   163,   166,   189,   287,  1827,  1827, -3430,
   49513, -3430, -3430,   221,    -5,  1430,  1430,  1430,  1608,   820,
   -3430,  1430, 49513, -3430, -3430, -3430, -3430, 43815, -3430,  1435,
    1021,  1460,  1854, 49513, -3430, 49513, -3430, 49513, 49513, -3430,
   -3430,  1902,  1534,  1756,  1522, -3430,  1705,  1710,  1709,    96,
    1021,  1615, -3430, -3430,  1724, 16176,  1021, 45036, 56025,   149,
   44629,  1021, 45443,  1573,   608,  1717, -3430,    75, -3430,  1946,
    1582,  1804,  1522,   608, 25416, -3430,  1567,  1164, 43815, -3430,
   -3430, 56432,  1680, -3430,   156,  1860, 16600, -3430, 49513,  1586,
   -3430,  1612,  1626,  1649, -3430, 11924, 49513,  1011,  1011,  1996,
    1011,   222,   654, -3430,  1452, -3430,   832,   183, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
    1658,  1164, -3430,   196, -3430,  1165,  1664,  1247, -3430, -3430,
     745,  1702,  2711,  1676,   252, -3430,  3021,   302, -3430, 49513,
   49513, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
    1678, -3430, -3430,  1689,    49,  1266,  4388,   653,  1918,  1315,
     171,  1864,  1171,  1961,  1130,  1987, 49513,  1916,   487, -3430,
     590, -3430,  1746,  1883,   734, 34454,  1723, -3430, 49513, -3430,
   -3430, -3430, 34454, -3430,  1896, 28748, -3430, 49513, -3430, -3430,
   -3430, -3430,  1840, 49513, -3430, -3430,  1960, 49513, -3430,  1430,
     391,  1732,  2100, 62086, 49513,  1770,  2133,  1775, -3430, -3430,
    1770, -3430, -3430, 49513, 49513,  1772,   642,  1770,  2135,  2151,
    1838,  1928,   669,  1419,   139,  2057,  1770, 49513, 49513, 49513,
   49513,  2139, 34454, 49513, -3430,  1933, -3430, -3430,  1316,  1846,
   -3430, -3430, -3430, -3430,  2091,  1658,   288,  2099,  1812,  2111,
   -3430,  1866,  2121,  1676,  2122,  1845, -3430, 56839, 57246,  2142,
    1678, 49513,  2152,  1845,  2157,  2016,  2158,   288,  2159, -3430,
     703,  2160,  2045,  2163,  1287,  1845, 45850,  2164,   141, -3430,
   18296, -3430,  1954, -3430,   832, -3430, -3430,  1216, -3430, 32826,
   -3430,  1632,   221, -3430, 49513,   221, 49513,   221, 49513,   221,
   49513,   221, 49513, 49513, 49513,   221, -3430, -3430, -3430, 49513,
    1875, 49513, 49513, -3430, -3430, -3430, 38931, 49513, 39338, -3430,
     946, -3430,    65,  1021, -3430, -3430, 62086,  2272, 49513,  2162,
    2162,  2162, -3430, -3430, -3430,  2101, 49513,  2166,  2168, 38931,
   49513, -3430, 57653,  1878, -3430, -3430, -3430, -3430, -3430,  1333,
    2300,   245,  2304, 18296,  1888,   175,   175,  1889, -3430, -3430,
   -3430,   208,  1890,  1891, -3430,   212,   212,  2046,  1895,  1898,
   -3430,   219,  1900,  2317,  2322,   225,  1903,  1904,  1905,   325,
     175, 18296, -3430,  1906,   212,  1907,  1908,  1910,  2323,  1913,
   -3430,  2333,  1914,   231,   236,  1915,  1917, -3430,  1895, -3430,
     153,  1919,  1920,  1921,  1923,  1924,  1925,  1927, 18296, 18296,
   -3430, 15328, -3430,  1021, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430,   116, -3430,   228,  4035, -3430, -3430,  2080, 18296, -3430,
   -3430,    67, -3430,   233, -3430, -3430, -3430,  1164, -3430, -3430,
    1075,  1926, -3430,   778, -3430, -3430, -3430, -3430, -3430, -3430,
   40152,  2313, -3430,   314,   590,   289,  2268, 32012, 32419, -3430,
   -3430,  2153, -3430, 49513, -3430, -3430, 18296, 29997, -3430,  1164,
     115, 49513, -3430, 25829, -3430, -3430, -3430,  1309, -3430, -3430,
   -3430,   483, -3430, 11202, -3430,  1349,  1586, 49513, 49513,  2326,
   -3430, -3430, -3430,  1612, -3430, -3430,  1271,  1271, 18296,  1271,
     768,   565, 17024, 18296,  2214,  2110,  1209,  1188,  2216, -3430,
     222,   654, -3430, 31218,  1429,  1164,  2007,  2008, 33640,  1938,
    2017,  2018,  2179, 58060, -3430, -3430, -3430, -3430, -3430,  1207,
     206,   728,  2021,   706, -3430, 49513,  2130,   302,  2068, -3430,
    2028,  2030,  2144,   302,  1233, 58467, -3430, -3430, -3430, -3430,
   -3430,  2274, -3430, 14112, -3430, -3430, -3430,  2032,  2022, 35675,
    2325,  2140,   639,  1117,   170, 49513,  2221,  2042,  2044,  1975,
    1132,  1972, -3430, -3430,  1500,  2147,  2089, -3430,  2029,  2037,
   60887,  2149, 29168,  2319,  2063, -3430,   594,  2066,  2067, -3430,
     302, -3430,  2377,   302,   302,  1242,  2378,  2070,   306,  1489,
    1770,  1972,  1027, -3430, -3430,  2002,  2073,   240, -3430,  2174,
    2325,   150,  1494,  1972, -3430,  2076,  2077,  1975,  1975, 49513,
   49513, 49513, 49513, 49513,  2081,  2084,  2125, -3430, 40559,  2085,
   56025, -3430, -3430,  2094,  1497,  1972, -3430,  1265,  1210, -3430,
   -3430,   608, -3430, 49513, -3430, 49513,  1658, 62086,  2193,  1676,
     302, 49513, 49513,  1678,   959,   781,  2195, 49513,  2260,  2059,
   -3430, -3430,  1770, -3430, 31615,  1772, -3430,  2034, -3430, -3430,
    2071, -3430,  2071,  2071,  2036,  2036,  2038, -3430, -3430, -3430,
     325,  2071,  2036, -3430, 62878, -3430,  1221,  1237, -3430,  2423,
    2426, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
    1085,  1392, -3430,  2443, -3430, -3430, 62086, 49513, -3430,  2365,
    2103, 33640, -3430,  2090, -3430, 49513,  1099,  1021,  2095, 49513,
    2267, 49513, 49513, 49513, 49513, -3430, -3430,   755,    72, -3430,
   40559, -3430,  1027,  2452,    23,  1430,  2339, -3430, 49513,  2060,
    2461,  2302, -3430,   784, -3430,  2185, -3430, 22938,  2112, 34454,
     288, -3430, -3430, -3430, -3430, 62086, 49513, 58874, 34454,   288,
   49513, 49513,  2366,  2124,  2369,  2129, 29168,   288,   148, 49513,
   49513, 49513, 49513, -3430, 49513, -3430, -3430, -3430, -3430, 49513,
   49513, 49513, 40559,  2371,  2372,   288, 49513, 49513, -3430, 11202,
    1395, 49513,  1632, 39745, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, 49513, -3430, 49513, -3430, 49513, -3430, 49513,
   -3430, 49513, -3430, -3430, -3430, 49513, -3430, 49513,  1408, -3430,
   -3430,  1421,   106, 49513,   230, 34454, 49513,  2261, 49513, 49513,
   49513, 49513,  2155,  1926,   975, -3430,  2128, 25003,  2211, -3430,
     213, 43815,  2273, -3430, -3430,  1423,   566,   841, -3430, -3430,
   -3430, -3430, -3430, -3430, 39338, 38524,  2368,    66, 49513, -3430,
   18296,  1164, 15752, -3430, -3430, -3430,  2093, 11202,  2127, 18296,
   -3430, -3430, 18296,  1827,  1827, 18296, -3430, -3430, -3430, -3430,
     929,  1827, -3430, 18296, 18296,  1827,  1827,  2071,  2071, -3430,
    5468, 18296, -3430, 29168, 18296, 20840, 13282, 18296,  2169,  2113,
    1827, -3430,  1827, -3430, 18296, 14904, -3430, 18296,  2296, 18296,
     289,  2301, 18296,   289,  2513,  2513,  1540,  3710,  2096, -3430,
    2205,  1827, -3430,  1827,  1182, -3430,   186, 62086, 18296, 33640,
    2175,   176, 18296,  2104,  1461, -3430, 18296,   656, -3430,  2105,
   18296,  2176, 18296, 18296, 18296, 18296, 18296, 18296, 18296, 18296,
   18296, -3430, 21688,   354,    18,   797, 46257, 16176,  2383, 12857,
   -3430,   246, -3430, -3430, -3430, 49513,  2313, -3430, -3430,  2177,
   -3430, -3430, -3430, -3430, -3430,   237, -3430, -3430, -3430, -3430,
   -3430, -3430,  2106, -3430, -3430, -3430, -3430, -3430,  2106, -3430,
    2107,  1760, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,  2373,  2379,
     288, -3430, 49513,   113, -3430, -3430, -3430,  2131, -3430, 49513,
     156, 40966, -3430, 16600, -3430,  1439,  1895, -3430,  2355, -3430,
    2116, -3430,  7587,  2355, -3430, -3430,   291,  2294,  2305,  2305,
   -3430,  2119, 11202, -3430,  1442, 11202,  1462, -3430, -3430, -3430,
   -3430, -3430, -3430,    26, -3430,  2214,  1188,  2134,  1473,  2198,
    2199,  2245, -3430, 49513, 49513, -3430, 33640, 49513, 49513,  2201,
   49513, -3430,  2487,   740, 38524,  2251, 36896, -3430, -3430,  2137,
   49513,  2188,  2375,  2376,  2141, -3430, -3430, 49513, -3430,  2334,
   49513, 18296,  2335, 49513,   884,  2336, -3430,   227, 49513, 49513,
    2314, -3430, -3430, -3430, 44629, -3430,   256, -3430, -3430,  2309,
   -3430, -3430, 62878, -3430, -3430,  1527, -3430, 62482, 59281, -3430,
   -3430,   825, 49513, 49513, 49513,   952, -3430, -3430, 62086, -3430,
   49513, 49513, 49513, 41373, 59677, 60084,  1046,  1054, 49513, 41780,
   -3430, 49513, 49513, 49513, 33640, -3430, 49513,    77,   679, -3430,
    3273, -3430,  2225, -3430, 49513, 49513,  2150,  1528,  2228, -3430,
   49513, 49513,  3779, -3430, 49513, 49513, -3430, -3430,   302, -3430,
   -3430, -3430, -3430, -3430, 49513, 49513,   302, 49513,   302,  1168,
   -3430, 34047, 49513, -3430, -3430, -3430, 49513, 49513, 49513, 49513,
   49513, 49513, -3430, -3430,   863,   589,  2291,  2292,  2293, 49513,
   49513, 49513, -3430, -3430,  2271, -3430, 49513,  3779, 49513, 49513,
    2232,  2236,   132,  2315, -3430, -3430, -3430, -3430, -3430, -3430,
    2403,  2568, 49513,  2411,  2413,  2230,  2233,  2419,   249, 49513,
   49513, 49513, 49513, 49513, 49513,  2421,   249,  2363,   107,  2189,
    2204,  1532, -3430, -3430, 18296,  2593, 62086,  2206,  2207,  2269,
    2276,  2277, -3430,  2202,  2278,  1827, -3430, -3430,  1433, -3430,
     755,  1478, -3430,    56,  5942,  2484, 49513,  1550, -3430,  2226,
   49513,  5942, -3430,   983, 38524, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430,  2490, -3430,  1021,  1772,  1772,  1772,
    1772, -3430, -3430, -3430,  2390,  1338, -3430,  2222, 49513,  2320,
    5942, -3430,  1027,  1190, 49513, 36082,  1381,  2616,  1021,  2397,
   -3430, 14508,  2991,  2398, 44629,  2489,  2491,  2507, -3430, 22525,
   46664,  2229,  1328, -3430, 46664, 47071, -3430,  2234,  1164, 18720,
    2211,  1658, -3430,  2623, -3430,  2520,   288,  1676, -3430,  1845,
   -3430, 49513, 49513, 49513, 49513,  1678, -3430, -3430,  1845,  2404,
     288,   288, -3430,  2409,   288,  1845,  2343,  2521, 44629, -3430,
     141, -3430, -3430, 18296,  2242, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430,  1563, -3430, 49513, -3430,  2501,  2502,  2504,
    1845,  2279, 49513,  2246, -3430,  1845,   302,  1845,  1926,  1926,
    1845, 47478,  2658,  2523, -3430,  1565, -3430, -3430, 16176, -3430,
     146, -3430,   544,    38,  2459, -3430, -3430, -3430, -3430, 62086,
   -3430, -3430, -3430, -3430, -3430, 49513,   118,  2430,  2254, 47478,
    2638,   288, -3430,  1569, -3430, -3430,  1194, -3430,  1246, 18296,
   18296,   278, -3430,  9402,  1577,  2259,  2263,  1588, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430,  2282,  2537, -3430,  2284,  1594,
    1604,  2287,  2288, -3430, -3430,  3476,  2289,  9790,  2290, 20840,
   20840,   900, -3430, -3430, 20840,  2297, -3430,  1606,  8152,  2258,
    2299,  2295, -3430,  2306,  2307, 10120, 17448, 18296, 17448, 17448,
   10612,  2258,  2310,  1610, 33640, 10672,  1617, -3430, 18296, 33640,
    3507, 18296, -3430, 18296, 49513,  2311,  2316, -3430, -3430,  5468,
   -3430,  2318, -3430, 20840, 20840,  3169, 15328, -3430, -3430,  2553,
   -3430, -3430,  1912, -3430,  2280, -3430, -3430,  3813,   193, 18296,
    2104, 18296,  2349, 29168,  4166, 18296,  3266,  2841,  2841,   351,
     351,   238,   238,   238,  1124,   797, -3430, -3430, -3430,  2321,
    1913, 18296, -3430,  1544,  1557, 49513,  1777,  1979, -3430, -3430,
   -3430, 22938,  2328, 18296, 18296, 18296,  2327,  2458,  2715, 11202,
       9, -3430,  2718, -3430,   608,  1827,  1182, 32826, -3430, -3430,
   18296, -3430, -3430, -3430, -3430,  1618, 25829,  2112, 16600,  1164,
    1612, -3430, -3430, -3430, -3430, -3430, -3430, 18296, -3430, -3430,
     543,  1376, 18296,  1442, -3430, -3430, 49513,  2273,  2273, 18296,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, 49513, 49513, 49513,
   -3430, -3430, -3430, -3430, -3430,  1021, -3430,  2529, -3430, 49513,
   49513,  2488, 49513,  2493,  2492, 18296,   138, 49513,  2329,  2330,
    2331, 49513,   288, -3430, -3430, 11202, -3430, -3430,  2367,  2386,
   49513,  2174, -3430,  2571, -3430, -3430, -3430, -3430,  2510, -3430,
   -3430,  1392, -3430, 59281, 62482, -3430, 62482, -3430,  1392,  1267,
   -3430,  1845, -3430, -3430,   736, -3430, -3430, -3430, -3430, -3430,
    2624,   288,  2626,   288, 49513, 49513, 49513, 49513, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430,  1622, -3430,  1121, -3430, -3430,
    2566, -3430, -3430,  2569, -3430, 49513,  1278, -3430,   901, 62086,
   -3430, 61283, 49513, -3430, -3430,  2559, -3430, -3430, -3430,  2498,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,   410, -3430,
    2500, 49513,  2408, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, 33640, 33640, 33640,  1627, -3430, -3430,  1021, -3430,
   -3430,   767, -3430,  2427, -3430, -3430, -3430,  2570,  2572,  2573,
    2428,  2429,  2431,  2434, -3430,  2436,  2437,  2438, -3430, -3430,
   -3430, 49513, -3430, -3430, -3430, 49513, 49513, -3430, -3430, -3430,
     249, 62086,  2591,   249,   249, 49513, 49513,   249, -3430, -3430,
   -3430,  2614,  2615,  2617,  2618,  2619,  2620,   249, -3430, -3430,
   -3430, -3430,   391, 33640, -3430,  1824, 27068, -3430,  2804,  4534,
    2388,  2207,  2387,  1827,   147,  1093,    84,  2499,  1827,  2594,
    2391, -3430,  1515,  2613,  2420,  2420,  2420,  2420,  2420,  2420,
    2420, -3430,  1434, -3430,  2565, 49513,   151, 49513,  1827, -3430,
   -3430,  2457, -3430, -3430, 33640, 27068,  1430,  1099,  2530,   685,
    2742, -3430, -3430, -3430, -3430, -3430, 49513, 49513,   755,  1021,
    1639, -3430, 62086, 49513, 49513,  2448,  2416, 49513,  2418,  2417,
   -3430, -3430, -3430, -3430,  1643, -3430, 62086,    25,  2592,  2598,
     944,  2495, 49513, -3430,  1644,   122, -3430,  1021, 44629, 60491,
   -3430,  2855, -3430, -3430,   720,  2687, -3430, -3430,   944, 13698,
    1328,  2435, 49513, -3430,  2432, 22938,  2660,  2595, -3430, 22938,
    2595,  1456,  2595,  2662, -3430, 26242, -3430,  2440, 12857,  1386,
    2609, 11202, -3430,   288, 62086, 49513, -3430,   288,  2485,   288,
    2494,   288,   288, 49513, -3430, -3430, 49513, -3430, 49513, 40559,
     288, -3430, 11202, 49513, -3430, -3430,  2556,  2557,  2558, 49513,
    1845, 34454, -3430,  2450, 49513,  1048, -3430, -3430,  2628, -3430,
     944, 49513,  1164,  2455, -3430, -3430, -3430, -3430,  2731,  2745,
   -3430, -3430, -3430, 49513, 38931,   214, 49513, -3430, -3430, -3430,
   -3430,  2464,  1650, 10940, 18296, -3430,  2762, 62086, -3430, -3430,
   -3430, -3430, -3430, 18296, -3430, -3430, -3430, -3430, -3430, 18296,
   -3430, 18296,  2741, -3430,  2881,  2881, 62086, 20840,  1123,  1907,
   20840, 20840, 20840, 20840, 20840, 20840, 20840, 20840, 20840, 22112,
     553, -3430, -3430, 18296, 18296,  2748,  2741, -3430, -3430,   996,
     996, 62086,  2467,  2258,  2469,  2470, 18296, -3430, -3430,  1655,
   33640, -3430, 18296,  9350,  1656,  2516, 11009,  1164,  4586, -3430,
    2842,  1021, 18296,  1055,  2053, 18296,  1661, 18296,  2755, -3430,
   -3430, -3430,  2483, -3430, -3430, 62086, 18296, 20840, 20840,  5013,
   -3430,  5031, 18296,  2486,  6189, 15328, -3430,   742,   742,   742,
     742, -3430, 49513, 49513,  2229, 18296,  2752,    32,    32,  2503,
    2458, 26655, -3430, 18296,   229, 17872,  2506,   590,  2511, -3430,
   -3430,  7520,  2512, 49513, -3430,  2211, -3430, -3430, -3430,  2508,
   -3430,  1376, -3430, -3430, -3430,  4844,  2659,  1926, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430,  2420,  1845,  1845,   129,  1845,
    2766,   129,  5141, -3430, -3430, 23351, 49513, 49513,  1667, -3430,
   -3430, 49513, -3430,  1664, -3430, -3430,  2733,  1293, -3430, -3430,
   -3430,  2550,  1434,   625,  1975,   775, -3430,  2551, 49513, -3430,
   49513, -3430, -3430, -3430, -3430, -3430, -3430, 33640, 27068, 33640,
   -3430, -3430, -3430,  2561,  2564,   697,   646,  2581,  2583,  2514,
    2515,  2517, -3430,   287,  1021, -3430, -3430,  1021,  1845,  1021,
   -3430, -3430, -3430, -3430, 34047, -3430, -3430, -3430, 49513,  2781,
     610,  1383, 49513, 49513, 49513, 49513, 49513, 49513, 49513,  2174,
   -3430, -3430, -3430,  2518,   249, -3430, -3430,  2737,  2749, -3430,
     249,   249,   249,   249,   249,   249, -3430,   210,  1669, -3430,
   24177, -3430, -3430,  2133,  2133,  1113, -3430,  2133, -3430,  2133,
   -3430,  2508,  1827,  1500, -3430, -3430, -3430, -3430, -3430, -3430,
    2204, -3430,  1102,  1827,  1447,  2522, -3430,  2524, -3430, -3430,
   -3430, -3430, -3430, -3430,  2525, -3430,  1182, 49513,  2420, -3430,
    1410,   917,   977,  1176, 47885, 48292, 48699,  2528, 49513, 20840,
   -3430,  1105,   587, -3430,  2756, 49513,  2567, -3430, -3430, -3430,
    2531, -3430,  1845, 49513, 49513,  1845, -3430, 62086, -3430, -3430,
    2912,   124, 49513,  2554,  2532,  2813, -3430,  2539,  2541, -3430,
   -3430, 49513, -3430,  2565,  1426,   593, -3430, 37303,  1381, -3430,
    2797, 36082, -3430, 49513, -3430, -3430, -3430,  2908,  2630,  2586,
    1021,  2188, -3430, 59281, 18296, 18296, -3430,  2552, -3430,  2560,
    3191, -3430,  1772, -3430, -3430, -3430, -3430, -3430, -3430,  2627,
   49513, -3430, 46664,  2580, 49513,  1328, 22938, -3430, -3430,   633,
   -3430, 22938,  2786, -3430, 22938, 49513,  2584, 49513,   496, 49513,
   -3430,  2585,   288, -3430, 49513, -3430, 49513, -3430, -3430,   288,
     288, -3430,  2664, -3430, -3430, 49513, 49513, 49513,  1845, -3430,
     302, -3430,  2830, 47478, -3430, -3430, -3430, -3430, -3430, -3430,
      66,  2844, -3430, -3430, -3430, -3430, 18296, 11202, -3430,  2587,
   11202,  5727, 11202,  2748, -3430,  2410,  2845, -3430,   988,  2589,
    2410,  2582,  2582,   358,   358,   251,   251,   251,  2881,   553,
   11202, 11202, -3430, -3430, -3430, -3430,  2590, -3430, -3430, -3430,
    2258, -3430, 19144, -3430, -3430,  2600,  2607,  2601, -3430, 18296,
   19568,  2578, 62878, -3430, -3430,  1182,  2513, 20840, 20840,  2224,
   -3430,   724, 18296, 62086,  1673,  2224,  2357,  2382, 18296, 18296,
    7781,   373, 18296,  6001, 49513, 49513, 49513, 49513, -3430, -3430,
   11202,  2971,  2860, 18296,  2602, -3430,  2603,  2458, -3430, 61679,
   -3430, -3430, 11202, -3430, -3430, 18296, -3430,  2458,  1021, -3430,
     832, -3430, -3430, 29168, -3430, -3430, -3430,   287, -3430, -3430,
   -3430,  2669, 38524,  2877,  1102, 18296,  1683, -3430,  2642, 49106,
   12431,  1688,  1700,  2567, -3430,  1938, -3430,  2666, -3430,  2793,
   -3430, -3430,  2794,   287, 49513, -3430, 62086,   288,   288, -3430,
   -3430,  2625, 49513, 49513,  1827,  1827, 62086,  2611, -3430,  1827,
    1827,  2621, -3430, 49513, 49513, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, 49513, 49513, 49513, 49513,  2909, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430,  2852, -3430,   249,
     249, -3430, -3430, -3430, -3430, -3430, -3430, -3430,  1770,  2935,
   -3430, 33640, -3430, 37710, -3430, -3430, -3430, -3430,  1021,  1021,
    2805, 30811,  1021,  1021, -3430,  1187,  2943, -3430,  2878,   708,
    2629,  1305,  2904, -3430, -3430, -3430, -3430,  2907,   287, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, 18296,   752,  2410, -3430, -3430, -3430,
   -3430,  2567,  1430,  2682, 33640,  1845,  1845,  2683,   944,    29,
   49513,  2940,  2674, -3430,  1021, -3430, -3430, -3430, -3430,  2967,
    1701, -3430, -3430, -3430,  2672,  2598,   875,  2643,  1381, -3430,
   -3430,   750, 49513, -3430,   957, -3430,  2918,  2644, -3430, 11202,
   11202,  1021, 63274,  2855, -3430, 49513,  2894, -3430, 49513,  1706,
   -3430, 18296,  2647, -3430, -3430, 22938,   633,  1714, 49513,  1715,
   62086,  2458, -3430,   288, -3430,   288,   288, -3430, -3430, 49513,
    1845,  1845,  1845, -3430,  2821, -3430,   288, 47478, 11202, -3430,
   -3430, -3430, 20840,  2927, -3430,  2652, 62086, -3430,  2654,  1720,
    1738, -3430, -3430, -3430,  6334,  2701, 11202,  2751,  2661,  2665,
   -3430,   751,   751,   724,  1757, -3430, 20840, 20840,  2224,  2224,
   18296,  2224, -3430, -3430, -3430, -3430, -3430, 18296, 18296,  2693,
    2458,  2458, -3430,  2818, -3430,  2684, -3430,  1182, -3430,  2686,
   -3430, 47478,  2835, 47478, -3430,  6610,  2567, 23351, 29588, 49513,
   -3430,   785,   785,  2799,  2567,  2682, -3430, -3430, -3430, -3430,
   -3430,  2717, -3430, -3430, 27068, -3430, -3430, 23764, 29168, -3430,
     697,  2675,  2688,   646, -3430, -3430,  1061,   731,  2698,  1845,
    2964,   249, -3430, -3430,  2189,  1021, -3430, -3430, -3430,  1762,
   -3430, -3430, -3430, 49513, -3430,  2532, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, 34454,  3084,  3084, 49513,  1102, -3430,
    6830,  2876, -3430,  2682,  2903,  2948, -3430,  1767, -3430, 49513,
    2586, 36082,  2565, -3430,    50,  2697,  2990, -3430, -3430, -3430,
   37303,  2869,  2630,   699,   699, 49513,  2598,  2819, -3430,  2822,
   -3430,  3067,  2874,  3072, 49513, 23351, -3430, 62482, -3430,  1781,
   -3430, -3430,  2328, 49513,    56,  1788, -3430, 11202, 49513, -3430,
   -3430, -3430,  1793, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
     214,   559, 20840, 62086,  1797, 18296, -3430, 18296, -3430, -3430,
   -3430,    58, -3430, -3430, -3430,   751,   751,  2224,  2258, 11202,
   49513, -3430, -3430, -3430,  3085,  2875,  2458, -3430, -3430,  1048,
     129,   214, 49106,  2682, -3430,  2708, -3430, -3430,  1376,  1376,
   49513,  2682,  1102, 18296, -3430, -3430, 62086,  1676,     6, -3430,
   62086, 62086, -3430, 49513, 49513, 49513, 49513, 49513, -3430, -3430,
   -3430, -3430, 37710,  2532,  3084,   258, -3430, -3430, -3430,  2992,
   -3430, -3430,   142,  2884,  2790, -3430, 33640,  3001, -3430, -3430,
   -3430, -3430, -3430, 18296,  2861, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430,  1809,  2630, -3430, -3430,
    2891, -3430,  2892, -3430,  1813, -3430, -3430,  3191, 63274,  3031,
   -3430, -3430, -3430,  1818, -3430, -3430,   559,  1820, -3430,  1828,
    1837,  2770, -3430,  2721, -3430,  3121, 18296,  1083, -3430, -3430,
    3004, -3430,   785,  2765, 29168, -3430, -3430,  1430,  1102, -3430,
   11202,  1842, -3430, -3430, -3430,  2868,  1843,  1852,  2728,  2767,
    2728, -3430,  1845, -3430, -3430, -3430, -3430,  3040, -3430, -3430,
   -3430,   178, -3430,  2913,  2914, 49513, -3430, 49513,  3133,  6897,
   34454,  1434, -3430, -3430, -3430, -3430,  2774, 23351,  2855, -3430,
     741, -3430, -3430, -3430, -3430, -3430, 49513,  2743,  2258, 19992,
   19992,  2744, 47478,  1376,  2746,  1102,  2747,  2903, -3430, 34454,
   -3430, -3430, -3430, 49513,  2866,   181,   181,  3066, -3430,  2802,
   -3430, -3430, -3430,   697, -3430,  2753,  1975,  2630, -3430, -3430,
   -3430, -3430,  1248, -3430, -3430, 21264,  2882,   157,  8501, -3430,
   -3430, -3430, -3430,   214, -3430, 18296, -3430, -3430,  2884,  1676,
   -3430,  2674, -3430,  3164, -3430,   185, -3430, -3430,  2611, 38117,
   -3430,  2328, -3430,  1280, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430,  3154, -3430, -3430, -3430, -3430, -3430, -3430,  7103,  1102,
   -3430,  3050, -3430, -3430, -3430, -3430, -3430, -3430,  1859, -3430,
   -3430, -3430, -3430, -3430,  1492, -3430, -3430,  1504,  1649, 20416,
   -3430, -3430,  2910, -3430, 38117, -3430,  1280, -3430, 34454, -3430,
   -3430,  2759, 38117,  1861, -3430
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3430, -3430, -3430,  2505, -3430,  -673,  -291,  1962,  -410, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430, -3430, -3430,  1249, -3430, -3430,   100,  1513,  2143,
     958, -3430,  -864, -3430, -3430,  -528,   134,  -570, -3430, -3430,
   -3430, -3430, -3430, -3430, -3430,   869,  1380,  2472,    35, -3430,
   -1157, -3430, -3430,   370, -3430, -3430, -3430,   737,  -271, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430,   -45, -3430, -3430,  -415,
   -1273,    51, -3430, -3430, -3430, -3430,   232,  -312, -1013, -3430,
   -2259, -3430,   -84, -3430, -3430, -3430,  -310, -1093,   916,  -592,
    -880,  1170,  -541, -3430,  -220, -3430,  -580,  -505,  -500,  -542,
   -3430, -2794, -3067, -3214, -2694,   135, -3430, -3430, -3430,   244,
   -3430, -1234, -3430, -3430,  1909, -1071, -3430,  -683, -3430, -3430,
   -3430, -2860, -3430,  1464,  -309, -3430,   108, -3430, -3430, -3430,
   -3430, -3430, -3430, -2821, -3430, -1164, -3430,   380, -2303,   833,
   -3430, -3430, -3430,  1934, -3430, -3430, -3430, -3430, -1253, -3430,
   -3430, -1233, -3430,  1307,   721, -3430, -3430, -3430,  -563,  -620,
    -609, -3430, -3029,   -23,   -11, -3430, -3430, -3430, -3430,  -772,
   -3430,   760, -2390,  -690, -3430, -3430,   798, -3430, -3430, -3430,
    -508,  -193,  1964, -3430,  -436, -3430, -3430, -3430,  -188, -3430,
   -3430, -3430, -3430, -3430, -3430, -1352,  -119,  -691, -3430, -3430,
   -3430, -3430, -1654, -3430,  3242,  1556,   707, -1230, -3430,   -28,
      61,  2358,  -883, -2021,   226,  -311, -3430, -1389, -3430, -3430,
   -3430, -1949, -3430, -3430, -3430, -3430, -2663, -1223, -3430, -3430,
   -3430,   290, -3430, -3280, -2994, -2705, -2644, -3430, -3430,  -843,
   -3430, -3430, -3430, -1047,  1495, -1123, -3430, -1698,   294, -2879,
    -568, -2473, -3430, -2786,  -388, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430,  -840,  -490, -3430, -3430,  2740, -3430, -3172, -3430,
   -3430, -3430, -3430,   982, -3430,   271, -3430, -3430, -3430, -3430,
    -653, -3430, -3430, -3430,  -497,  -566, -3430, -3430, -3430,   136,
   -3430, -3430, -3430, -3430,  1646,  -728,  -581,  2632, -1219,  -218,
   -3430, -3430, -3430, -3430, -2311, -3430, -3430, -3430, -3430, -3430,
   -3430, -3430,  -995, -3430, -3430, -3430, -3430, -3430, -3430, -3430,
    1611,  1605,    71,   -30, -3430, -3430,  -983, -3430,  -451, -3430,
    1911, -3430, -3430, -3430, -3430, -3430,   140,   326, -3430,     2,
   -3430, -3430,   682, -1867,     3, -3430, -3430, -3430, -3430,  -343,
       4, -3430,  1064, -3430, -3430, -1569, -3430,   143,   158, -3430,
   -3430,     1,     0,   -44,   -19,   -10, -3430,  2634,  2231, -3430,
   -3430,   -17,  1250, -3430,  -685,  -141, -3430,  1056,  -477,  1590,
    2215,  2212, -3430,  1057, -3430, -3430,  1060, -3430, -3430, -3430,
    -471,  1599, -3430,  2217,  1620, -3430,  1651,  1106, -1904,  1344,
   -1876,   766,  -562,   -18,    62,  2673,  2807, -3430, -3282,  1096,
   -2840,   369,  -679,  1431, -1227, -3430, -3430,  -896,  4847, -3430,
   -3430, -3430,  6638,  7551, -3430, -3430,  7948,  8145, -3430,  -787,
     635,  8283,  -703,  -935, -1471,  -646,  7438, -1832,  -799, -1276,
   -3430, -3430, -3430,  -217,   645,   188, -3430, -3430, -3430,  -397,
   -2151,  -396, -3430, -3430, -3430,  -398, -3429,    22, -3430,  -170,
   -3430,  8790,  1094, -3430,  -750, -2020, -2100,  -898, -1354, -3430,
   -3430, -3430, -3430, -3430, -3430, -3430, -2282, -2504,  -462,  1163,
   -3430, -3430,  1256, -3430, -3430, -3430,  -974,  -682, -1539,  1174,
   -1546, -3430,  -665,  1288,  1801,  -624,  -147,  -495,  4862,  -432,
   -1731,  -970,  -913, -3430,  -126, -3430,    16,    -9,  -123,    -6,
    2930,  5704,  -980,  6117, -1038, -1020, -2346
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2012
static const yytype_int16 yytable[] =
{
     157,   156,   151,   152,   154,   683,   751,   638,   544,  1110,
    1359,   502,  1815,   840,   914,   915,   603,   615,   692,   919,
    1367,   157,   603,  1041,   815,  1398,   668,   736,  1445,  1674,
    1788,  1112,  1421,   756,  2030,  1119,  2054,  1755,   602,  1115,
     720,   765,  1242,  1946,   602,  1855,   733,  1675,   725,   682,
     734,   730,  1329,  2167,  1175,   754,  1456,  1915,   855,  1503,
    1862,  1863,   863,   527,   764,   860,  1797,   762,  2635,  1476,
    1477,  1996,   875,  1054,  2812,   805,  2752,  1969,  3003,  1152,
    1674,  1185,  1947,  1948,   609,  2560,  1949,  1672,  1492,  2325,
    2327,  1231,   577,  1950,  2368,  1677,   639,  1951,  1675,  2850,
    1300,  2852,  1189,  1204,   665,  1214,  1786,   671,  2097,  1227,
    1697,  1265,  1236,  2244,  2619,  2959,   686,   850,  2574,  2576,
    2909,  3343,  1048,   883,  1289,  2749,   569,  3164,  3173,  2026,
    1390,  1850,  1304,  2582,    66,    75,   128,  1308,  1672,   656,
     149,  1677,   694,   155,  1314,  3434,  1796,  2254,  1735,  2249,
    3346,   695,  3316,  1331,   540,  1350,   585,  1127, -1357,  2909,
    3303,   693, -1789, -1823,  1150,   490, -1843, -1167,  1470,  1471,
    1328,   500,   534,  1520,  2931,  2932,  2933,  2934,  2935,  2936,
   -1362,  3092,     3,     4,  3325,  3357,  3442,  3359, -1702, -1872,
   -1724,  1351,  1678,  1489,  1232,  1806, -1702,  1749,  1351,   585,
    1967, -1703,  2437,  2747,  2748,  2502,  1400,  1259, -1573, -1703,
   -1357,  2172,   895, -2011,  1104, -1573,  1799, -1329, -1792,  1183,
    1107, -2011,  2090,  1300, -1342,  1056,  2994,   585,  2172,  2070,
   -1369,  3802, -1362,   540,   540,  1440, -1372,   673,   540, -1170,
     899, -1372,   540,  1219,   758,   540,   940,  1444, -1167,  1527,
   -1362, -1679,  2458,  1045,   540,  3665,  1556,  2460,  3522,  2047,
    3669,  1518,  2666,  2221,  1351,  1749,   832,   689,  2633,  1751,
    1155,  1974,   540,  1674,  1530,   910,  2984,  1974,   511,  2624,
    1750,  2589,  3168,  2591,  1220,  1752,  2308,  3765,  3681,  3833,
     689,  1675,  3715,  3718,  3703,  1253,   585,  2664,  2665, -1842,
     585,  3823,  2680,  2921,  1716,  1074,  1173,  1075,  3647,  2953,
    -111,   585,   591,   591,   643,  -111,   591,  1570,  1173,   540,
   -1170,  -329, -1167,   585,  3627,  2210,  1242,  2051,  2359,   827,
    1887,  1939,   592,   592,   513,  2314,   592,  1751,  1351,   591,
     591,  2713,  2714,  1184,   751,  2628,  2071,  -143,  1385,   772,
    1575,  1708,  1503,  1752,   799,  1561,  3821,  3640,   828,   592,
     592,  1399,  1527,  1100,  1772,  1577,  1368,  1101,   591,  2666,
    1574,   591,  -143,  1156,  1586,  1586,  2206,   801,  1476,  1477,
    3073,  1487,  1488,  2207,  3641,   751,  1492,  1530,   592,   810,
     806,   592,  2360,   817, -1170, -1589,   540,  3445,  1923,   829,
    1709,  2644, -1589,   826,  3093,   824,  1893,  1578,   644,  3719,
    1300,  3803,  2629,  1897,  1679,   540,  1753,  2315,  1571,   845,
    3857,   911,  1434,   833,  2048,  1980,   853,  3716,  3834,  1102,
    3824,  1057,  1180,  1447,  1444,  2310,  2754,  1221,  3200,  2755,
    1402,  1352,  1124,  3733,  2211,  1457,  1773,  3169,  1352,  1975,
    1300,  1814,  3714,  2049,  1766,  3511,  2954,  3778,   536,  3657,
    1771,  1732,  3143,  2461,   541,   920,  3682,  1807, -1167,  3629,
    3720,  2625,  1103,   520,  3167,   521,  3170,  1300,   834,  1808,
     931,  3804,  2909,  1853,  1753,  1470,  1471,  2094,  1058,   798,
    2751,  1674,  2448,  1913,  1489,  1441,  1361,  1557,  1968,  2438,
    1042,  1827,  1279,   936,  3805, -1842,  1857,  1836,  1754,  1675,
    1839,  1840,   674,  1886,  1352,  3503, -1573,  1064,  3552,  2173,
    2072,  1222,  1568,  1823,  1572,  1846,   918,  1848,  2622,  3843,
    1809,   683,   841,   544,  3526,  2995,  2727,  2043,  2073,  1093,
   -1170,  1076,  1521,  2246,  1300,  1441,  1157,   891,   918,  2170,
    2052,   738,  3766,  1111,    49,  1915,  1890,  3541,  3028,  1465,
   -1167,  1300, -1842,  3811,  2666,  1311,  2794,  1894,  1891,  3381,
    2666,  1387,  2916,  3699,   157,   682,  1754, -1842,  1361, -1357,
     892,  1300,   897,  1777,   901,  1444,  3247,  1677,  1352,  1909,
     905, -1789, -1823,  1695, -1167, -1843, -1167,   671,  3692,  3148,
    2312, -1362,   602,  1300,   602,   796,   602,   597,   598, -1702,
    1928,   925,   602,   906,   907,   751,  1833,  3278, -1872, -1724,
    1178,  1179, -1703,  2707,   882,  1498,  2809,  1932,  2810,  1465,
    1498,   941, -1170,  1725, -2011,   597,   598,  1038,  1475,  1726,
    1047,   841,  1049,  1499,  3053,  1481,   886, -1792,  1499,  1246,
    3593, -1369,  1300,  2845,  1523,  3156,  1249,  1500,  3601,  1559,
    1550,  3015,  1502,  2235,  2324,  3019, -1170,  2100, -1170,  3758,
    1066, -1362, -1679,  2678,  1067,    15,  2003,  2626,  1258,   921,
    1332,  1334,  1335,  3670,  2208,   157,   156,   151,   152,   154,
    3318,  3639,  1829,  3299,  1309,  1310,  2132,  2188,  1674,  1124,
    2123,  2124,  2766, -1589,   597,   598,  1339,   537,   597,   598,
    2093,  1336,  2096,  1996,  2877,  2878,  1675,  2262,  2566,   597,
    1174,  3648,  2104,  -111,  -111,  2107,  3796,  1260,  1261,  1758,
     921,   597,  1174,  2119,  2120,  1527,  3598,  3599,  1363,  1365,
    1239,  1321,  2361,  1977,  2668,  1079,  2137,  2139,  1044,    24,
   -2012,  3602,  1052,  1176,   689,  3225,  1672,  2153,   908,   947,
    1530,   687,  2666,  1130,  3780,  2759,  2282,  3649,  2906,  1042,
    1547,  1548,  1549,  1550,  3650,  1375,  1674,  2675,  2676,  2677,
    2678,  2332,  1322,   767,  2567,   538,  2872,   539,  3738,  2875,
    2876,  1263,  1042,  2879,  1675, -1210,   511,  2769,  3209, -1210,
    3851,   767,  1757,  2886,  3651,  2058,  2059,  2906,  1527,  3631,
    1761,  2937,  2568,  1674,  3264,  1050,  1376,  2258,   688,    66,
      75,   128,  2189,  3319,  1300,   149,  2190,  2569,   155,  3005,
    3300,  1675,  1758,  1530,  2357,  3075,  1566,  2570,  3080,  3081,
    3082,  3083,  3084,  3085,  3086,  3087,  3088,  3089,  2168,  3204,
    1707,  3001,   513,  1900,  2422, -1329,  2939,  2813,  1788,  3527,
    2571, -1210,  2191,  3189,  1961,  2009,  1131,   841,   495,  2627,
    3003,  3528,  3191,  3652,  2018,   768,  2015,   535,   623,  1761,
     841,  2417,    38,  2423,  1240,  3351,  2025,  2418,  2813,   689,
    1708,   157,    34,   768,  1901,  3126,  3127,  2259,  3162,  3693,
    3210,  1850,  1373,  3006, -1210,   602,  3226,  3698,   947,  1205,
    1704,  2666,    42,  1388,  1443, -2012,  1590,  1230,  1206,  2835,
     157,  1439,   540,  3361,  2004,  3781,  2755,  3690,  2050, -1329,
    2362,  2055,  2108,  2057,   540,  1323,  2060,  2572,  1962,  1709,
      45,  2035,  2668,  1341,  1762,  1996,  3266,    47,  1802,  1463,
     497,  3205,  3779,   624,  3695,  3696,   741,   742,   743,    48,
     744,   745,   746,   747,   748,   749,  1759,   683,  1479,  1377,
    2673,  2674,  2675,  2676,  2677,  2678,  2673,  2674,  2675,  2676,
    2677,  2678,   540,  2192,  2419,   612, -1676,  3753,  1534,  1535,
    3501,   520,    49,   521,  2363,  2943,  3422,  1705,  1506,  1803,
     690,  3508,   827,  2126,  1519,  2669,  3426,  3523,  3531,  3352,
    1132,  1516,   751,  3192,  1524,  1311,  3532,  1763,  1810,  1324,
    1241,  3282,  2836,  1941,  1560,  3529,   540,  3614,  2109,  -351,
    2944,  2962,  2481,  1094,  2814,  3206,  3007,  3653,  1538,  1207,
    1970,   841,  2945,  3156,  1576,  2289,  3524,  1902,   841,   841,
    1436,  1691,  1404,  1378,  1406,  3425,  1408,   506,  1410,  2815,
    1412,  1413,  1414,   947,  3605,  2814,  2666,  1416,  1133,   602,
    2667,   498,   829,   602,   602,  1190,  1868,  1698,  1699,  1300,
    1703,  3284,  1122,  3117,  1300,  1300,   695,   695,   616,   695,
    2815,  2668,  2110,  2424,  3008,  1300,   693,   693,  1889,   693,
    1864,  1865,  1866,  1867,  3383,  1875,  3384,  3296,  2909,  3794,
    3193,  3376,  3350,  3194,  2308,  2290,  1674,  3354,  1963,  2333,
    3356,  1674,  2946,  1191,  3615,   625,   626,  1095,  2420,  1964,
    2906,  1903,  1895,  1896,  1675,  1527,  3347,   511,  1905,  1675,
    1205,  1545,  1546,  1547,  1548,  1549,  1550,  2804,  2111,  2309,
    1898,  2112,   163,   602,  2669,  2396,  -772,  2421,  1066,   602,
    1530,  1361,  1067,  2399,  2587,  2401,  2837,  3533,  2673,  2674,
    2675,  2676,  2677,  2678,  2699,  2592,   917,  1985,  1986,  2704,
    1943,   540,  1562,  1799,  1919,  2512,  2513,  2514,  2515,   164,
     907,  1804,  1942,   513,  3161,  2838,   751,  2085,  1854,  1192,
    1788,  1814,  1957,  1958,  1959,  1960,   602,  1875,  3264,   602,
     602,  1899,  3297,  1300,  1545,  1546,  1547,  1548,  1549,  1550,
    3238,  1997,  3049,  2001,  2020,   622,  3241,  3242,  3243,  3244,
    3245,  3246,  2007,  2024,  1946,   663,  3385,  2472, -1329,  3076,
    2508,  3077,  1563,  2113,  2034,  1193,  2668,  1194,  1920, -1329,
     918,  1475, -1329,  1118,  1944, -1329,  2918,  1849,   676,  1875,
      38,   640,    38,  2310,  1841,  3003,   602,  2767,  2031,  3582,
    3583,  1361,  3298,  1947,  1948,  2094,  2808,  1949,  1300,  3265,
    3286,  1919,  1042,  1042,  1950,  3401,  3402,  3064,  1951,  1996,
      42,  1196,    42,  1996,  3488,   896,   898,   900,  2331,   733,
     902,   903,   904,  3365,  1921,  3366,  2284,  1922,  1952,  2669,
     909,  2583,  2919,  2670,  2671,  2672,  2579,  2673,  2674,  2675,
    2676,  2677,  2678,   751,  2524,    47,  1198,    47,  2297,  1100,
    2132,  2132,   520,  3726,   521,  2132,  2114,    48,  1841,    48,
    3266,  1772,   163,   523,   163,  1920,  3042,  1990,   684,  2642,
    1100,  3260,  1743,   525,  3489,  2344,  3560,    15,   696,  1342,
    1200,  3078,  1744,  2346,  1674,  1674,  1674,  3749,  2062,   685,
      49,  3079,  1437,  2612,  2132,  2132,  1300,  1745,  -778,   164,
    2985,   164,  1675,  1675,  1675,  2002,  1842,  3731,  1843,    15,
    1498,  3750,   157,   683,  2008,  1102,  3261,  2693,  2373,  1923,
    2631,  1921,  2016,  2017,  1922,  1361,  2345,  1923,  1499,  2219,
    3589,  1343,  3591,  2566,  2347,   540,  1102,  1811,  2233,   585,
    2029,  2798,  2393,  1773,  1229,  1674,  2716,  2087,    34,  1739,
    1116,    24,  1382,  2481,  1805,  3688,  1224,   682,  1103,  1325,
     808,  3052,   809,  1675,     3,     4,   157,  2084,  2081,  2082,
    2083,  3549,  1383,  1230,  3613,  3276,  2555,  3494,  1326,  1117,
    1842,  1518,  1843,    24,   886,  1225,  1674,  2393,  2670,  2671,
    2672,  2117,  2673,  2674,  2675,  2676,  2677,  2678,  3053,  2567,
    1816,  1856,  1858,  2890,  1675,  3495,  1122,  3812,    29,  2105,
    2106,  1361,  1924,  2937,  1226,  1882,  1923,  2118,  1344,   573,
    2600,  2121,  2122,  2075,  1821,  1883,    38,  2568,  2938,   585,
    1746,  1925,  1120,   731,  3279,  2086,  2143,  2133,  2144,  3179,
      29,    14,  2569,  1124,  1939,  1817,  1818,    15,  3227,  1884,
    1880,  1187,  2570,  2177,  2828,   729,    42,  2165,  2939,  2166,
    2940,  1121,  2250,  2833,  2253,    34,  1345,   634,  3228,  2829,
    3561,  2483,    20,   662,  1586,  2571,   760,  2610,  1814,  1881,
    1188,  2037,  1122,  2038,    38,  2039,  2236,  2040,   737,  2041,
    1123,    47,  2834,  2042,  3575,  3576,  2212,  2179,   600,  2180,
    1215,  1122,   687,    48,   600,  3472,  3473,    38,  1066,  1924,
    2517,   766,  1067, -1211,    42,  2518,    38, -1211,   803,  1403,
    2181,    24,  1405,  2484,  1407,  1677,  1409,  2567,  1411,  1216,
    2280,  2941,  1415,  1217,  2283,  1498,    49,    42,   800,  2639,
    1300,  1300,    45,  1300,  2033,  1201,    42,  1213,  1346,    47,
    2807,  1498,  2572,  1499,  1235,  2568,  2964,  2304,  1218,   688,
    1124,    48,  2777,  1392,  3400,  2316,  1393,  1500,  2094,  1499,
    3021,   190,    47,  2757,    45,   804,   499,  3190,  3195, -1211,
    2570,    47,  1674,  1502,  2352,   571,  1300,   807,  1300,  2330,
   -1179,  2640,  2942,    48,  3813,   816,  2641,  2943,  2485,  2486,
    1675, -1179,   641,   822,  2692, -1179,  2694,  2695,  2811,  2353,
    2839,  2487,  2841,  1475,  1729,  1736,  2256,    49,  2158,  2182,
    2264,  2161, -1211,  2733,  2183,  3236,    49,   830,  2374,  2184,
     689,  2394,  2944,   573,  3187,  2243,  2291,   847,  2294,  1475,
    3103,  1736,   602,  1730,  2945,  2397,   811, -1179,   812,  2410,
    3676,  3793,   831,  2094,    38,    14,  1689,  2415,  1300,  1690,
    1996,    15,   851,  2488,  1122,  1996,  2428, -1179,  1996,  2270,
    2271,  3061,  1731,  2432,  3094,  3095,  2906,  1462,  2857,    49,
    2572,  1079,  2873,  1300,    42,  1049,    20,  2927,  1526, -1234,
   -1234,  1527,  2518,  2442,  2537,  2538,  1692, -1928,  3637,  1693,
    2451,  2452,  2453,  2454,  2455,  2456,  2772,  2773,  1528,  1674,
   -1179,  1674,    45,  2506,  2786,  2787,  1530,  2789, -1179,    47,
    1847,  1531,  1300,   574,  2946,  1859,   861,  1675,  1879,  1675,
    1066,    48, -1679,   876,  1067,    24,  1674,  3618,  1475,  1300,
    1118,   690,  2032,  2185,   870,  2033,  2489,  3124,  2490,  2920,
    2922,  2923,  2186,  1300,  1675,  2044,   585,  1816,  2045,  3666,
    3271,  3272,  1816,  2972,   575,  1816,  1300,  2357,  2046,  3201,
    2078,  2045,   880,  2079,   602,  2526,   912,  2333, -1928,  1475,
     916,  1736,   602,  1997,   602,   923,  2255,  2891,  2132,  1361,
    1788,  2132,  2132,  2132,  2132,  2132,  2132,  2132,  2132,  2132,
    2132,  1300,  1817,  1818,  3323,  3399,   926,  1817,  1818,  2450,
    1817,  1818,  2588,  2737,  2590,  2738,  2848,  2450,  3258,  3259,
    2276,   928,  3262,  2079,  3263,  3031,  2739, -1928,  2740, -1179,
    2892,  2481,  1450,  1451,  2960,  1814,  3181,  3182, -1928,  3855,
    1814,  3856, -1928,  1814,  2778,  2779,  1532, -1928,  2132,  2132,
    1533,  1090, -1928, -1167,  2893, -1928,  1159, -1928,  1097,   933,
    1099,  2480,  1210,   934,  1300,   683,  3100,  2511,    38,   935,
     936,  1534,  1535,  2894,  2322,  2370,  3587,  2323,  2371,  2467,
     937,   939,  2468,  1300, -1928,   938,  1536,  1090,  3069,  2541,
    2895,   942,  1055,   157,  2525,   841,   943,  2503,    42, -1930,
    2504,  1161,  1053,  1059, -1928,  2896,  1065,  3074,  1300,  2559,
    2604,  1060,  2620,  2045,  2509,  2621,  2638,  1061,  1537,  2033,
    2952,  1538,  2955,  1073,  2648,  1159,    45,  2033,  3020,  1080,
    3023,  1160,  3096,    47,  1539,  2651,  1087,  1540,  2033,   841,
    2998,  2655,  1300,   751,  2033,    48,  3254, -1928,  2718,  1242,
    2719,  2656,  1162,  2682,  2033, -1928,  2033,  2698,  1088,  1163,
    2033,  2586,  1164,  1098,  2701,  2762,  1444,  2702,  2763,  2826,
    1161,  2720,  2827,  1090,  2853,  2594,  2595,  2854,    49,  2597,
   -1930,   947,  3144,  3146,  2666,  2601,  2970,  2897,  2741,  2971,
    2982,  2992,   602,  2983,  2993,  2898,  1091,  3065, -1928,  1996,
    2033,  3118,  3101,  3108,  1113,  3102,  3109,  1541,  3120,  2756,
    2770,  2033,  1118,  1165,  3183,  1997,  3250,  2045,  1135,  3251,
    3405,  1162,  1153,  2079,  1180,  3624,  1228,  2899,  1163, -1930,
    3436,  1164,  3185,  3437,  3048,  3443,  1223,  1182,  2045,  1042,
   -1930,  1238,  1243,   616, -1930,  1300,  2637,  3444,  3519, -1930,
    2045,  3520,   683,  3546, -1930,  1245,  1361, -1930,  3060, -1930,
    2132,  3551,  3553,  1250,  2971,  2971, -1928,  3566,  1166,  1247,
    3567,  2133,  2133,  1255,  2781,  2721,  2133,  1257,  1264,  1267,
    2722,  3179,  1165,  1124,  1305,  3568, -1930, -1928,  2033, -1928,
   -1928,  1307,  1315,  1542,  1543,  1544,  1516,  1545,  1546,  1547,
    1548,  1549,  1550,  1167,  3574,  2239, -1930,  2079,  -160,  3621,
    2177,  2240,  3622,  1319,  3635,  2133,  2133,  3636,  1311,  2742,
    2743, -1928,  1330,  1317, -1928, -1928, -1928,  3257,  3667,  2736,
    1337,  3668,  1211,  1674,   177,  3672,  1169,  1166,  1361,  3537,
    3674,  1990,  1347,  2971,  3678,  3404,  1349,  2079,   841, -1930,
    3344,  1675,  1526,  1122,  1354,  1527,  3732, -1930,  1355,  1565,
    3736,  1212,  2832,  3737,  2668,  3741,  1356,  3742,  1361,  2842,
    2079,  2758,  1167,   602,  1300,  3743,  1358,  1360,  2702,  3179,
    1530,  3708,  1357,  3710,  3744,  1531,  1674,  2033,  1371,  3759,
    3761,  2890,  2079,  2079,  2723,  1361,  2784,  1366,  3307,  3762,
   -1930,  1233,  2079,  2724,  1675,  1169,  3853,  1369,  3864,  3854,
    1300,  3854,  1370,  1372,  1374,  1379,  2770,  1380,  1381,  1386,
    1391,  1417,  1122,  1446,  1460, -1333,  1452,  2669,  1448, -1340,
    1234,  1454,  2870,  1455,  1469,  1472,  1473,  1474,  2132,  2132,
    1478,    49, -1330,  1136,  1480,   616,  1483, -1331, -1334,  1484,
    1485,  1486,  1491,  1493,  1494,  2770,  1495,  2799, -1332,  1496,
    1497,  1504,  1554,  1505,  1569,  1507,  1508,  1509, -1930,  1510,
    1511,  1512,  3390,  1513,  1137,  1580,  1565,  1696,  1589,  1101,
    1103,  1723,  3255,  1733,  1734,   947,  1736,  3373,  2666, -1930,
    2965, -1930, -1930,  1737,  1738,  1739,  2819,  1760,  2821,  2846,
    2979,  3485,  1765,  1767,  1768,  3406,  1769,  1770,  1792,  3477,
     947,  1799,  1801,  2666,  1533,  2991,  1811,  1793,  1812,  2856,
    1813,  1814,  1820, -1930,  1122,  1824, -1930, -1930, -1930,  1300,
    3407,  1138,  1822,  1825,  1828,  1534,  1535,  1830,   947,  1831,
    1300,  2666,  1834,  1835,  1837,  1844,  1845,  3323,  1851,  1852,
    1205,  2450,  1860,  1861,  2450,  2450,  1871,  1869,  2450,  1997,
    1870,  1876,  1139,  1997,  1444,  1892,  3039,  1904,  2450,  3040,
    1878,  1906,  1907,  1263,  1916,  1465,  1917,  2908,  3305,  3306,
    1914,  3179,  1475,  1930,  1481,  1538,  2670,  2671,  2672,   508,
    2673,  2674,  2675,  2676,  2677,  2678,  1875,  1940,  1539,  1936,
    1956,  1207,   602,  1973,  1978,   733,  1981,  1042,  3564,  2915,
    2917,  3051,  1983,  1300,  2924,  3428,  2908,  1988,  1115,  1984,
    2012,  2011,  1999,  1300,  2013,  2014,  2027,  2028,  2056,  2064,
    2969,  2061,  2068,  3063,  2956,  2076,  2100,  3451,  2089,  2099,
    2154,   602,  2142,  2141,  1527,  2159,  2163,  3459,  2164,  2171,
    2176,  2193,  2195,  2221,  2238,  2234,  2237,  2241,  2997,   841,
     157,  2989,   688,  2242,  2248,  3537,  2257,  2265,  2668,  2269,
    3370,  3371,  3372,  2266,  2277,  2278,  2279,  2285,   157,  3011,
    2287,  2275,  2292,  2295,  2297,  1990,  2318,  2301,  2320,  1990,
    2299,  2300,    34,  2668,  1775,  3474,  1142,  2303,  2306,  2313,
    2369,  2365,  1143,  2132,  2372,  2425,  2426,  2427,  2435,  1776,
     947,  2431,  2436,  2666,  2440,  3138,  3139,  1230,  1674,  2441,
    2439,  2668,  2443,  3623,  2444,  1146,  2445,  2132,  2132,  2446,
    2447,  2669,  2457,  1147,  2459,  2463,  1675,  2466,  3030,  3810,
     157,  3056,  3033,  2470,  3035,  2475,  3037,  3038,  2478,  2501,
    2473,  2474,  2476,  2477,  2479,  3043,  2669,  2510,  2516,  2505,
    2523,  1545,  1546,  1547,  1548,  1549,  1550,  2540,  2519,  2542,
    2554,  2556,  2558,  2557,  2584,  2585,  2593,  1300,  2770,  2565,
    2578,  2596,  1148,  2598,  2669,  3677,  2599,  3578,  2603,  1997,
    3062,  2606,  2607,  3429,  2608,  2609,  2611,  2618,  3184,  2090,
    2630,  2972,  2634,  1300,   918,  2636,  2649,  2653,  2033,  2133,
    2650,   683,  2133,  2133,  2133,  2133,  2133,  2133,  2133,  2133,
    2133,  2133,  3115,  2717,  2688,  2732,  2725,  1444,  3701,  2652,
    3504,  2654,  3706,  3707,  2657,  2658,  2660,  2663,  2745,  2751,
    3134,  3135,  3136,  3137,  2681,  3478,  2687,  2712,  2753,  3466,
    3467,  -816,  3469,  2689,  2690,  1516,  2785,  2697,  2710,  3229,
    2788,  3231,  2801,  2711,  2791,  3154,  2800,  2735,  2790,  2133,
    2133,  1300,  2805,  2806,  2750,  2795,  2796,  2797,  3477,  2818,
    1136,  2820,  2830,  2132,  3702,  2831,  2843,  2844,  3705,  2847,
    2670,  2671,  2672,  2668,  2673,  2674,  2675,  2676,  2677,  2678,
    3277,  2849,  2874,  2858,  2862,  2863,  2859,  2864,  2860,  2861,
    2865,  1137,  2866,  2867,  2868,  2670,  2671,  2672,  3302,  2673,
    2674,  2675,  2676,  2677,  2678,  2880,  2881,  2910,  2882,  2883,
    2884,  2885,  2913,  1923,  2914,  3309,  2925,  3680,  2926,  2908,
    2928,  2950,  2957,  2670,  2671,  2672,  2961,  2673,  2674,  2675,
    2676,  2677,  2678,  2929,  1300,  3219,  2669,  3218,  3220,  2963,
    3221,  2975,  2977,  2986,   602,  2980,  3010,  2981,  1138,  1526,
    2987,  2990,  1527,  3545,  3016,  3017,  3024,  3029,  3014,   602,
    1300,  3034,  3012,  3545,  3058,  2450,  3027,  3045,  3046,  3047,
    3036,  2450,  2450,  2450,  2450,  2450,  2450,  1530,  3059,  1139,
    3050,   841,  1531,  3055,  1444,  1557,  2547,  2756,  1462,  3068,
    1997,  2684,  2666,  2683,  3097,  1997,  3098,  3099,  1997,  1520,
    3687,  3656,  3110,  1300,  1136,  3122,   602,  1300,  1300,  3123,
    3141,  3172,  3166,  3131,  3186,  3188,  3196,  3202,   906,   907,
    3203,  3281,  3283,  3285,  3287,  3160,  3224,  1444,  3239,  3270,
    3147,  1444,  1444,  3157,  3163,  1137,  3748,  3213,  3158,  3214,
    3240,  3215,  3216,  3308,  3217,  3237,  3280,  3273,  3596,  3274,
    3310,  3301,  3275,   611,  3294,   613,  3830,  3304,  3311,   619,
    3002,  2133,  2045,   629,   635,   611,  3313,   642,  3608,   635,
     635,  3314,   667,  3327,   670,   667,  1140,  3331,  3332,  3334,
    3355,  3336,  3341,  3345,  3369,  3374,  3342,  3413,  3414,  3415,
    3416,  3391,  1138,   751,  3377,  3382, -2012, -2012,  3392,  2673,
    2674,  2675,  2676,  2677,  2678,  1141,  3348,  1532,  3397,    34,
    3358,  1533,  3363,  1142,  3379,  3386,  1990,  3387,  3417,  1143,
    3418,  1990,  2547,  1139,  1990,  3431,  1144,  3433,  3393,  3420,
    3421,  3446,  1534,  1535,  1145,  3438,  3447,  3448,  3454,  1159,
    1136,  3460,  1146,  3471,  3470,  1160,  3475,  1536,  3483,  3490,
    1147,  3463,  2548,  3673,  3493,  3265,  3496,  3497,  3505,  3509,
    3440,  3440,  3513,  3515,  3518,  3521,   602,  3364,  3534,  3525,
    3535,  1137,  3543,  3548,  3367,  3368,  3558,  3562,  3563,  3455,
    3565,  3570,  1538,  3571,  1161,  3580,  3584,  3590,  3572,  3600,
    3464,  3616,  3573,  3603,  3478,  1539,   721,   726,   728,  1148,
     726,  3610,   721,   735,   667,  3757,   753,  3468,   735,  3617,
     667,  3586,   667,  3588,  3611,  3625,   726,   735,   667,  3300,
    3632,  3634,  3712,  3643,  3644,  3646,  3660,  3658,  1138,  3661,
    3659,  3662,  3686,   689,  3694,  1162,  3721,  3717,  3725,  2133,
    2133,  3727,  1163,  3730,  3432,  1164,  3734,  3735,  3740,  3427,
    3745,  3746,  3747,    34,  3752,  3754,  3703,  1142,  1387,  1139,
    3763,  3430,  3764,  1143,  3773,  3767,  3769,  3776,  1541,  3149,
    1776,  3792,  3795,  3801,  3797,  3765,  3766,  1526,  1230,  3809,
    1527,  3832,  3849,   602,  3852,  3862,  1146,  3449,  2548,  3822,
    1092,  2507,  3858,  1877,  1147,  2760,  1165,  3199,  3542,  2887,
    2364,  1588,  1134,  3619,  3756,  1530,  3476,  3713,  3645,   602,
    1531,  3502,  2793,  3329,  3655,  2605,  3798,  3594,  3829,  3770,
    3457,  3458,  2547,  3768,  3807,  3461,  3462,  3330,  2311,  1997,
    2450,  2450,  3452,  3453,  3222,  3671,  2851,  2482,  3831,  2966,
    1136,  1972,  3863,  1148,   841,  3859,  3492,  2550,  3002,  3481,
    3482,  1166,  1953,  3486,  3487, -2012, -2012,  3491,  1545,  1546,
    1547,  1548,  1549,  1550,  2958,  3808,  2911,  3609,   751,  3760,
     618,  1137,  3499,  1935,  1526,  3612,  1435,  1527,  3689,  3375,
    3739,  3337,   843,  2326,  2770,  3815,  1167,  3338,   751,    34,
    3860,  1159,  3638,  2549,   602,  1062,  2252,  1160,  2715,  1143,
    3317,  2251,  1530,  3057,  2036,  3517,  1776,  1531,   157,  3510,
    2764,  1997,  1086,  2768,  1230,  1168,  2274,  1719,  1694,  1169,
    3597,  1720,  1146,  2776,  2273,  1724,  2780,  2744,  1138,  2268,
    1147,  3607,  3536,  2561,  2247, -2012,  1161,  3022,  3550,  1533,
    3315,  1070,   839,  2765,  1170,  3114,  2471,  3104,  3679,  3783,
    3628,  3784,  3791,  2730,  2771,  1990,  2623,  2645,  2220,  1139,
    1534,  1535,  2728,     0,     0,     0,     0,     0,   733,     0,
       0,     0,     0,     0,     0, -2012,     0,     0,  1042,  1148,
       0,     0,     0,  2550,     0,     0,     0,  1162,  2548,     0,
       0,     0,     0,     0,  1163,     0,     0,  1164,  3554,     0,
    3555,  3556,     0,     0,  2133,     0,     0,     0,     0,  1997,
    1538,  3559,     0,     0,     0,  3663,     0,     0,     0,     0,
       0,     0,     0,  1539,     0,     0,   774,     0,  2133,  2133,
       0,   667,  1532,   721,     0,     0,  1533,   728,     0,   726,
       0,     0,   735,     0,   753,  2908,   735,   819,  1165,     0,
       0,     0,     0,  3697,   726,     0,   735,  1534,  1535,     0,
       0,     0,  2450,     0,     0,   667,  3620,     0,     0,     0,
     602,   842,  1536,  3440,     0,   721,     0,     0,     0,   728,
       0,     0,   721,     0,  1526,   753,     0,  1527,     0,    34,
       0,     0,     0,  1142,     0,  3709, -2012,  3711,     0,  1143,
     726,     0,     0,  1166,  1528,   890,  1776,  1538,     0,     0,
       0,     0,  1530,     0,  1230,  1526,     0,  1531,  1527,     0,
    1539,     0,  1146,     0,   751,     0,     0,     0,     0,     0,
    1147,     0,     0,     0,     0,  1528,     0,     0,  1167,     0,
       0,     0,   667,  1530,     0,     0,     0,   667,  1531,     0,
       0,     0,     0,     0,     0,     0,     0,   667,   932,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1169,     0,     0,     0,  1037,     0,   667,   635,  1148,
     842,     0,   635,  2550,  2133,     0,  1545,  1546,  1547,  1548,
    1549,  1550,     0,  1541,   667,  3675,  1170,     0,   667,     0,
       0,  1072,     0,     0,  3775,     0,  1037,     0,  3772,     0,
       0,  1997,     0,   841,     0,     0,   667,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3691,     0,     0,     0,
       0,     0,     0,  3799,     0,     0,     0,     0,     0,     0,
       0,     0,  1532,     0,  3800,     0,  1533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1534,  1535,   726,
     726,     0,     0,  1532,     0,     0,     0,  1533,     0,  1542,
    1543,  1544,  1536,  1545,  1546,  1547,  1548,  1549,  1550,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1534,  1535,
       0,     0,     0,     0,     0,   721,     0,     0,     0,     0,
       0,     0,   721,  1536,  1537,   753,     0,  1538,  1526,     0,
       0,  1527,     0,     0,     0,     0,     0,   726,     0,     0,
    1539,     0,  3861,  1540,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,   726,   726,  1537,  1530,     0,  1538,     0,
       0,  1531,     0,     0,     0,     0,     0,   667,   667,   667,
     726,  1539,   721,     0,  1540,     0,     0,     0,     0,  3848,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   157,  3820,  3817,  3818,  3819,   726,   726,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3841,     0,     0,  1541,     0,     0,   842,     0,     0,     0,
    1037,     0,     0,  3847,  3820,  3817,  3818,  3819,     0,   842,
       0,  1526,     0,     0,  1527,  3840,     0,     0,  3827,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
       0,  1420,  1420,     0,     0,  3841,   667,     0,   611,  1530,
       0,     0,  2375,  3841,  1531,     0,   157,  3820,  3817,  3818,
    3819,  2376,  2377,  2378,     0,     0,  1453,     0,     0,   667,
    3840,     0,  1459,     0,     0,     0,  1532,     0,  3840,     0,
    1533,     0,     0,  1037,     0,     0,     0,     0,     0,  1542,
    1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,
       0,  1534,  1535,     0,     0,  2379,  2659,     0,     0,     0,
       0,  1037,     0,     0,     0,     0,  1536,     0,     0,     0,
    1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,     0,     0,     0,     0,     0,  2705,  1037,  1037,
       0,  1037,  2726,     0,     0,     0,     0,     0,  1537,     0,
       0,  1538,     0,     0,  2380,     0,     0,     0,  1037,     0,
       0,     0,     0,     0,  1539,     0,     0,  1540,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2012,
     842,     0,     0,  1533,     0,     0,     0,   842,   842,     0,
       0,     0,     0,   667,  2381,     0,  1037,     0,     0,     0,
       0,  1681,     0,  1688,  1534,  1535,     0,     0,     0,     0,
    2382,  2383,  2384,  2385,  2386,     0,  2387,     0,     0, -2012,
       0,     0,     0,     0,     0,     0,     0,     0,  1037,     0,
       0,     0,  1037,  1037,     0,     0,     0,  1541,  1525,     0,
       0,     0,     0,  1526,     0,     0,  1527,     0,  2388,     0,
       0,     0,     0,   635,  1538,     0,     0,     0,     0,     0,
       0,     0,     0,  1528,     0,     0,  1529,  1539,     0,     0,
       0,  1530,     0,     0,     0,   635,  1531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1798,
       0,     0,     0,     0,     0,   667,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,     0,     0,     0,     0,     0,     0,     0,
       0,  2389,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,  2162,     0,     0,
   -2012,     0,     0,     0,     0,     0,     0,  2390,     0,   726,
     726,   726,   726,   667,  2391,     0,     0,  2392,   735,     0,
     635,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1888,  1526,   667,     0,  1527,     0,     0,
       0,   726,   726,     0,     0,     0,     0,   726,     0,     0,
       0,     0,     0,     0,  1528,     0,     0,     0,     0,     0,
       0,  1532,  1530,     0,     0,  1533,     0,  1531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1534,  1535,     0,     0,
    1545,  1546,  1547,  1548,  1549,  1550,     0,     0,     0,     0,
       0,  1536,     0,     0,     0,   735,     0,     0,     0,     0,
       0,   726,   726,   726,   726,     0,     0,     0,     0,     0,
     735,     0,     0,     0,     0,     0,     0,     0,  1888,     0,
       0,     0,     0,  1537,     0,     0,  1538,  1998,     0,   721,
       0,     0,     0,     0,     0,     0,   728,     0,   721,  1539,
       0,     0,  1540,     0,     0,     0,   753,     0,     0,     0,
       0,   667,     0,     0,     0,     0,     0,     0,     0,     0,
     667,     0,   735,     0,     0,     0,   726,   726,     0,     0,
       0,   667,     0,   890,     0,     0,     0,     0,     0,     0,
       0,     0,  1532,     0,     0,     0,  1533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1420,     0,     0,
       0,     0,     0,     0,     0,   721,     0,  1534,  1535,   667,
     667,     0,  1541,     0,     0,     0,     0,  2067,     0,     0,
       0,   667,  1536,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   611,   611,     0,     0,  2092,     0,
    1037,     0,  1037,     0,     0,     0,     0,     0,     0,  1037,
       0,     0,  1037,     0,  1537,  1037,  1159,  1538,     0,     0,
       0,     0,  1160,  1037,  1037,     0,     0,     0,     0,     0,
    1539,  1037,     0,   753,  1037,  1037,  1037,  1037,     0,     0,
       0,     0,     0,     0,  1037,  1037,  1190,  1037,     0,  1037,
       0,     0,  1037,     0,     0,     0,     0,     0,  1542,  1543,
    1544,  1161,  1545,  1546,  1547,  1548,  1549,  1550,  1037,     0,
       0,     0,  1037,     0,     0,     0,  1037,     0,     0,     0,
    1037,     0,  1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,
    1037,     0,  1037,     0,  1191,     0,   667,  1037,     0,  1037,
       0,     0,     0,  1541,     0,   667,     0,     0,     0,     0,
       0,     0,  1162,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,  1164,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1526,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1192,     0,  1528,  1165,     0,     0,     0,     0,     0,     0,
    1530,     0,     0,     0,     0,  1531,     0,     0,     0,  1542,
    1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,
       0,     0,     0,     0,  1526,     0,     0,  1527,     0,     0,
       0,     0,     0,     0,     0,     0,  1193,     0,  1194,     0,
       0,     0,  1688,     0,  1528,     0,     0,     0,  1195,   667,
       0,   667,  1530,  1037,     0,     0,     0,  1531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1196,  1167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   735,     0,     0,     0,   735,   728,     0,
       0,     0,     0,     0,   611,     0,   611,     0,     0,     0,
       0,     0,  1197,     0,     0,     0,  1169,  1198,     0,     0,
     735,  1037,     0,     0,     0,     0,     0,     0,   735,     0,
    1532,     0,     0,  1122,  1533,     0,     0,     0,     0,     0,
       0,  1199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1200,   735,     0,  1798,  1534,  1535,     0,     0,     0,
    2334,     0,     0,     0,     0,  2343,     0,     0,     0,     0,
    1536,   667,   735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1532,     0,  2367,  2367,  1533,     0,     0,     0,
     728,   735,     0,     0,   735,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,   726,  1538,     0,  1534,  1535,     0,
       0,     0,   735,     0,     0,     0,  2411,     0,  1539,     0,
     735,  1540,  1536,     0,     0,     0,     0,     0,     0,   735,
       0,     0,     0,     0,     0,     0,   735,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   726,     0,  1537,     0,     0,  1538,     0,   726,
     726,   726,   726,   726,   726,     0,     0,     0,     0,     0,
    1539,     0,     0,  1540,  1037,     0,     0,     0,     0,     0,
       0,     0,  1526,     0,     0,  1527,     0,     0,     0,     0,
       0,  1541,     0,     0,     0,     0,  2367,     0,     0,   491,
     667,     0,  1528,     0,   611,   533,   491,     0,     0,     0,
    1530,     0,   572,     0,   491,  1531,     0,     0,     0,     0,
     491,     0,   621,     0,     0,     0,     0,     0,  2522,     0,
       0,     0,     0,     0,   726,  2536,     0,     0,     0,     0,
     681,     0,     0,  1541,   842,     0,     0,     0,     0,  1998,
    2564,     0,     0,     0,  2564,  2577,     0,     0,     0,  1037,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   726,  2367,   726,  2367,     0,     0,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,     0,   842,     0,
       0,  2912,     0,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   735,     0,     0,     0,     0,     0,     0,  1037,  1542,
    1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,
    1532,     0,     0,  3113,  1533,     0,     0,     0,     0,   735,
       0,  1526,     0,     0,  1527,     0,     0,     0,     0,  1037,
    1037,     0,     0,     0,     0,  1534,  1535,     0,     0,  1526,
       0,   755,  1527,   757,     0,   759,     0,   761,     0,  1530,
    1536,     0,     0,     0,  1531,     0,     0,     0,     0,  1037,
    1037,     0,     0,     0,  1037,     0,     0,  1530,     0,     0,
       0,     0,  1531,     0,     0,     0,  1037,  1037,  1037,  1037,
       0,     0,  1537,     0,     0,  1538,     0,     0,  1037,     0,
       0,  1037,     0,  1037,  2709,     0,     0,     0,  1539,     0,
       0,  1540,     0,  1037,  1037,     0,  1037,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1037,
       0,  1037,     0,   753,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1037,  3128,     0,     0,   667,     0,     0,     0,  1526,
       0,  1998,  1527,  1037,  1037,  1037,     0,     0,     0,     0,
    3129,     0,     0,     0,     0,     0,     0,   842,     0,  1528,
    1037,  1541,     0,     0,     0,     0,  1688,  1530,  1037, -2012,
       0,     0,  1531,  1533,     0,     0,     0,  1037,     0,     0,
       0,     0,  1037,     0,     0,     0,   667, -2012,     0,  1037,
       0,  1533,     0,     0,  1534,  1535,     0,   735,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2012,
       0,     0,  1534,  1535,     0,  1037,     0,  2367,     0,     0,
       0,  1420,     0,     0,     0,     0,     0, -2012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1538,     0,     0,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,  1539,     0,     0,
       0,  3165,  1538,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1539,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,     0,     0,     0,     0,
       0,     0,   735,     0,     0,     0,     0,  1532,     0,     0,
       0,  1533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1534,  1535,     0,     0,     0,     0,     0,     0,
   -2012,     0,     0,     0,     0,     0,     0,  1536,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2012,     0,
       0,     0,     0,     0,     0,   735,   802,     0,     0,     0,
       0,     0,     0,     0,     0,  2367,  2367,     0,     0,  1537,
     820,   821,  1538,     0,     0,   823,     0,     0,     0,     0,
       0,     0,     0,     0,   837,  1539,     0,     0,  1540,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   846,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     865,     0,     0,   867,     0,   869,     0,   872,     0,     0,
    1545,  1546,  1547,  1548,  1549,  1550,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1420,   667,  1545,  1546,
    1547,  1548,  1549,  1550,     0,     0,     0,   667,     0,     0,
       0,     0,   491,     0,     0,     0,     0,     0,  1541,     0,
       0,     0,   667,     0,     0,     0,  1526,     0,   842,  1527,
       0,     0,     0,     0,     0,   929,     0,   930,     0,  2564,
       0,     0,  3013,     0,     0,  1998,     0,     0,     0,  1998,
       0,     0,     0,     0,  1530,  3026,     0,     0,  1037,  1531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   667,     0,     0,   667,     0,     0,   735,
       0,     0,     0,  3044,     0,     0,     0,     0,     0,     0,
     681,   721,     0,     0,   735,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,  1542,  1543,  1544,     0,  1545,  1546,
    1547,  1548,  1549,  1550,   667,     0,   735,     0,  3174,     0,
       0,     0,     0,     0,  1037,     0,     0,     0,     0,     0,
       0,     0,     0,  1037,     0,     0,     0,     0,     0,  1037,
       0,  1037,     0,     0,     0,     0,     0,  1037,     0,     0,
    1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,  1037,
       0,     0,     0,  1037,  1037,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1037,     0,  1237,     0,
       0,     0,  1037,     0,  1532,     0,     0,     0,  1533,     0,
    1248,     0,  1037,     0,     0,  1037,     0,  1037,     0,  1254,
    1292,     0,     0,     0,     0,  1256,  1037,  1037,  1037,  1534,
    1535,     0,  1037,     0,     0,  1037,  1303,     0,     0,     0,
       0,     0,   667,   667,  1536,  1037,     0,     0,     0,     0,
       0,  3151,     0,  1037,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,  1688,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1537,     0,     0,  1538,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1539,     0,     0,  3180,  1420,  1420,     0,     0,
       0,   735,     0,     0,     0,  1526,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3198,     0,     0,     0,     0,  1528,   491,     0,   491,     0,
     491,     0,   491,  1530,   491,   491,   491,     0,  1531,     0,
       0,   491,     0,  1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   735,     0,   735,  1541,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     842,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   667,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1037,
       0,     0,     0,     0,     0,   667,     0,     0,     0,     0,
       0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,
    1550,     0,   667,  1532,     0,     0,     0,  1533,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,  3324,     0,     0,
       0,  1798,     0,  3044,     0,     0,     0,     0,  1534,  1535,
       0,     0,     0,     0,  1037,  1037,     0,     0,     0,     0,
       0,     0,     0,  1536,     0,     0,     0,     0,     0,     0,
       0,     0,  2564,     0,     0,     0,  1998,     0,     0,   681,
       0,  1998,     0,     0,  1998,  2522,     0,  3360,     0,     0,
    1292,  2495,     0,     0,  2367,  1537,  2367,     0,  1538,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1539,     0,   735,  1540,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1037,  1764,     0,     0,
    1292,     0,     0,     0,     0,     0,     0,     0,     0,  1526,
       0,     0,  1527,     0,     0,  2375,     0,     0,     0,     0,
       0,     0,     0,     0,  2376,  2377,  2378,  1292,     0,  1528,
       0,     0,  1037,     0,     0,     0,     0,  1530,     0,  1037,
    1037,     0,  1531,     0,     0,     0,     0,  1037,  1037,     0,
       0,     0,  1037,     0,  1541,     0,     0,     0,  1037,  1037,
       0,     0,  1037,     0,   667,   667,   667,   667,  2379,     0,
       0,     0,     0,  1037,     0,     0,     0,     0,     0,  3424,
       0,     0,     0,     0,     0,  1037,     0,     0,     0,     0,
       0,     0,     0,   753,  1292,     0,     0,     0,     0,     0,
       0,     0,   611,     0,     0,  1037,     0,     0,     0,   726,
     726,  1292,  2496,     0,     0,     0,     0,  2380,     0,     0,
       0,     0,     0,     0,  3450,     0,     0,     0,     0,     0,
       0,  1292,   735,     0,     0,     0,     0,     0,     0,     0,
    1542,  1543,  1544,   735,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,     0,  1292,  3380,     0,   726,  2381,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1532,     0,  1933,
       0,  1533,     0,  2382,  2383,  2384,  2385,  2386,     0,  2387,
       0,  1955,     0,   842,     0,     0,     0,     0,     0,     0,
       0,  1420,  1534,  1535,     0,     0,     0,  1526,     0,     0,
    1527,     0,  1292,     0,     0,     0,     0,  1536,     0,     0,
       0,  2388,     0,     0,     0,     0,     0,     0,     0,  2006,
       0,     0,     0,  2010,  1037,  1530,     0,     0,     0,     0,
    1531,     0,  2019,     0,  2021,     0,  2022,     0,     0,  1537,
       0,  2023,  1538,     0,     0,     0,     0,  2497,     0,     0,
       0,     0,     0,     0,     0,  1539,     0,     0,  1540,     0,
       0,     0,     0,     0,     0,   491,     0,   491,     0,   491,
       0,   491,     0,   491,     0,   667,     0,   491,     0,     0,
       0,  1037,     0,   723,  2389,  1998,  2498,     0,  3360,   723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,     0,     0,
    2390,     0,  1037,     0,     0,     0,     0,  2391,  3132,     0,
    2392,     0,     0,     0,     0,     0,     0,     0,  1541,     0,
       0,     0,     0,     0,     0,     0,  1037,  1037,     0,     0,
    1037,     0,  1526,     0,     0,  1527,     0,  1037,  1037,     0,
       0,     0,     0,     0,     0, -2012,     0,     0,     0,  1533,
       0,   735,  1528,   735,     0,     0,     0,  3180,   753,   726,
    1530,     0,     0,     0,  1292,  1531,     0,     0,     0,     0,
    1534,  1535,     0,     0,     0,     0,     0,   721,   753,     0,
       0,     0,     0,     0,     0, -2012,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1420,  1542,  1543,  1544,     0,  1545,  1546,
    1547,  1548,  1549,  1550,   721,     0,     0,   667,  3412,     0,
    1538,     0,     0,     0,     0,     0,     0,     0,     0,  2367,
       0,  1798,     0,  1539,     0,     0,     0,     0,     0,     0,
    3324,     0,     0,     0,     0,   667,     0,     0,     0,     0,
       0,     0,     0,     0,   726,  3180,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1037,     0,     0,  1037,     0,  1037,     0,     0,
    1532,     0,     0,     0,  1533,     0,     0,  1301,     0,     0,
    3685,     0,     0,     0,     0,     0, -2012,     0,     0,     0,
       0,     0,   726,     0,     0,  1534,  1535,     0,     0,     0,
     667,     0,     0,  1037,     0,     0,     0,     0,     0,     0,
    1536,     0,     0,   726,   726,   726,   726,     0,     0,     0,
       0,     0,   842,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1537,  1037,     0,  1538,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1539,     0,
       0,  1540,     0,     0,     0,     0,  2281,     0,     0,     0,
       0,     0,  2286,     0,     0,     0,  1545,  1546,  1547,  1548,
    1549,  1550,  2296,     0,     0,     0,  1037,     0,  1526,  2302,
     723,  1527,     0,     0,   753,  2307,     0,     0,     0,  1292,
    1301,  2317,     0,     0,  1292,  1292,  2319,     0,  1528,     0,
       0,     0,     0,     0,     0,  1292,  1530,     0,     0,     0,
       0,  1531,     0,     0,     0,     0,     0,   726,     0,     0,
     721,  1541,   723,  2335,  2336,  2339,  2341,  3180,     0,   723,
    2348,  2351,     0,     0,     0,  2354,  3685,     0,  2358,  1037,
    1037,     0,   735,     0,     0,     0,     0,     0,     0,   721,
       0,     0,     0,   726,     0,     0,     0,  2395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2398,     0,  2400,
       0,     0,     0,     0,     0,  1037,     0,     0,     0,  2412,
    2413,  2414,     0,  2416,     0,  1037,     0,     0,     0,     0,
       0,     0,  2429,  2430,     0,     0,     0,     0,     0,  3842,
    2433,  2434,     0,     0,     0,     0,     0,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,     0,     0,     0,
       0,  3569,   723,  1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1532,     0,     0,  1037,
    1533,     0,     0,     0,  3842,     0,     0,     0,   721,     0,
       0,     0,  3842,   723,     0,     0,     0,     0,     0,     0,
       0,  1534,  1535,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1536,  1301,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1292,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1526,     0,
       0,  1527,     0,     0,     0,     0,     0,     0,  1537,     0,
       0,  1538,     0,     0,     0,     0,     0,  1791,  1528,     0,
       0,     0,     0,     0,  1539,     0,  1530,  1540,     0,     0,
       0,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1301,     0,     0,     0,     0,     0,
       0,     0,   723,     0,     0,     0,     0,     0,     0,   723,
       0,     0,     0,     0,     0,  1526,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1302,     0,     0,     0,     0,  1528,  1292,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,     0,  1541,  1531,     0,
       0,     0,     0,     0,     0,     0,     0,  2632,     0,   723,
       0,  1301,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1301,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1301,     0,
       0,     0,     0,     0,     0,     0,  1532,   723,     0,     0,
    1533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1534,  1535,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,  1536,  3592,     0,     0,
       0,     0,     0,  1302,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1301,
       0,     0,     0,  1532,     0,     0,     0,  1533,  1537,     0,
     723,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,     0,     0,  1540,  1534,  1535,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
       0,     0,     0,  1536,     0,     0,     0,     0,     0,     0,
       0,  1526,     0,     0,  1527,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   723,   723,     0,   723,     0,
       0,  1528,     0,     0,     0,  1537,     0,     0,  1538,  1530,
    2782,  2783,     0,     0,  1531,   723,     0,     0,     0,     0,
       0,  1539,     0,     0,  1540,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1292,  1292,  2803,  1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   723,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2822,  2823,  2824,  2825,
       0,     0,     0,     0,     0,   723,  1292,     0,  1292,   723,
     723,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
    1302,  1301,     0,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,  3630,     0,     0,
       0,     0,     0,  2232,     0,     0,     0,     0,     0,  1532,
    1302,     0,     0,  1533,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1292,     0,
       0,     0,     0,  2869,  1534,  1535,     0,  1302,  2871,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1536,
    1542,  1543,  1544,  1292,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,     0,     0,  3774,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1537,     0,     0,  1538,     0,     0,     0,     0,     0,
       0,     0,  1292,     0,     0,     0,     0,  1539,     0,     0,
    1540,     0,     0,     0,  1302,     0,     0,     0,     0,  1292,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1302,     0,  1292,     0,  2973,  2974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1292,     0,     0,     0,
       0,  1302,     0,     0,     0,     0,     0,     0,     0,     0,
     166,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1302,     0,     0,     0,     0,  1673,     0,
    1541,  1292,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1294,     0,     0,     0,     0,     0,  3032,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3041,     0,     0,     0,   723,     0,   723,   167,     0,     0,
       0,     0,  1302,     0,     0,   723,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2321,   168,     0,     0,
       0,  1791,  2328,   169,  1292,     0,     0,     0,     0,     0,
       0,     0,  1301,     0,     0,     0,     0,     0,   170,     0,
       0,     0,     0,  1292,     0,     0,  1542,  1543,  1544,     0,
    1545,  1546,  1547,  1548,  1549,  1550,     0,     0,  1526,     0,
    3850,  1527,     0,     0,     0,     0,   171,     0,  1292,     0,
       0,   172,   723,     0,     0,     0,     0,   173,  1528,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,  1531,   174,     0,  1294,     0,     0,     0,     0,     0,
       0,     0,  1292,     0,     0,     0,     0,   723,     0,   723,
       0,     0,     0,     0,     0,     0,   723,   175,     0,   723,
       0,     0,   723,     0,     0,  1526,     0,     0,  1527,     0,
     723,   723,     0,     0,     0,     0,     0,     0,   723,     0,
       0,   723,   723,   723,   723,  1528,     0,     0,     0,  2258,
    1301,   723,   723,  1530,   723,     0,   723,     0,  1531,   723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   176,  1302,   723,  1673,     0,     0,   723,
       0,     0,     0,   723,     0,     0,     0,   723,     0,   723,
     723,   723,   723,   723,   723,   723,   723,   723,     0,   723,
     177,     0,     0,     0,   723,  1292,   723,     0,     0,     0,
    3197,     0,     0,     0,     0,  1791,  1532,     0,     0,     0,
    1533,     0,     0,     0,   178,     0,     0,     0,     0,  2259,
     179,     0,     0,     0,     0,     0,   180,     0,     0,   181,
       0,  1534,  1535,     0,     0,     0,     0,     0,     0,     0,
    3223,     0,     0,     0,     0,  3230,  1536,  3232,  3233,  3234,
    3235,     0,     0,     0,     0,   182,     0,   183,     0,     0,
       0,   184,     0,     0,     0,     0,     0,     0,     0,   185,
       0,  1294,     0,  1532,   186,     0,     0,  1533,  1537,     0,
       0,  1538,     0,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,     0,   188,  1540,  1534,  1535,
       0,     0,     0,  1301,     0,     0,     0,     0,     0,  1526,
       0,  1294,  1527,  1536,     0,     0,  3289,  3291,  3293,     0,
    3295,     0,     0,     0,  1292,     0,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,  1530,  1294,     0,
       0,     0,  1531,     0,     0,  1537,     0,     0,  1538,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1292,  1539,     0,     0,  1540,     0,     0,  1541,     0,     0,
       0,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2803,     0,     0,     0,     0,     0,   723,     0,
       0,     0,     0,     0,     0,  1294,     0,     0,     0,     0,
       0,  3362,     0,     0,     0,     0,     0,     0,     0,  1302,
       0,     0,  1294,     0,  1302,  1302,     0,     0,     0,     0,
    3410,     0,     0,     0,  1541,  1302,     0,     0,     0,     0,
       0,     0,  1294,     0,     0,     0,     0,  2232,  2232,  2232,
       0,  1673,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,  1294,  3159,     0, -2012,     0,     0,
       0,  1533,     0,     0,     0,     0,     0,     0,     0,  1292,
       0,     0,     0,  2260,     0,     0,     0,     0,  1673,     0,
    1292,     0,  1534,  1535,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2012,     0,     0,
       0,     0,     0,  1294,     0,     0,     0,     0,     0,     0,
    1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1538,     0,     0,     0,     0,  1791,  2328,     0,
    2328,   723,     0,  1302,     0,  1539,     0,     0,     0,     0,
       0,     0,     0,  1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3456,     0,     0,     0,     0,
       0,     0,     0,  1301,     0,  1301,  3465,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,     0,     0,     0,   723,     0, -2012,     0,
       0,     0,     0,     0,  1083,     0,   723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1301,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,  1527,     0,  1294,     0,     0,     0,     0,
    2328,     0,  3512,     0,     0,     0,     0,     0,     0,     0,
    1528,     0,     0,     0,     0,   723,     0,     0,  1530,     0,
       0,     0,     0,  1531,  3530,     0,  1302,     0,  1545,  1546,
    1547,  1548,  1549,  1550,     0,     0,     0,  1292,     0,  2328,
       0,     0,     0,     0,     0,     0,   723,   723,     0,     0,
       0,     0,     0,     0,     0,     0,  1301,     0,     0,     0,
       0,  3557,     0,  1292,     0,     0,     0,     0,     0,     0,
    1301,     0,     0,     0,     0,     0,   723,   723,     0,     0,
       0,   723,     0,  2328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   723,   723,   723,   723,     0,     0,     0,
       0,  1673,     0,     0,     0,   723,  1673,     0,   723,     0,
     723,     0,  2232,     0,     0,     0,     0,     0,  1301,     0,
     723,   723,     0,   723,     0,     0,     0,  2683,     0,     0,
       0,  1292,  2684,     0,     0,     0,   723,     0,   723,     0,
       0,     0,   723,     0,     0,     0,     0,     0,  1532,     0,
       0,     0,  1533,     0,   775,     0,     0,     0,   723,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
     723,   723,   723,  1534,  1535,     0,     0,     0,     0,     0,
       0,  1301,     0,     0,  1295,     0,   776,   723,  1536,     0,
       0,     0,     0,     0,     0,   723,     0,     0,     0,   777,
    1301,     0,     0,     0,   723,     0,     0,   778,     0,   723,
       0,   779,     0,     0,  1292,     0,   723,     0,     0,     0,
    1537,  1467,     0,  1538,     0,  1301,     0,     0,     0,     0,
       0,   780,     0,     0,     0,  2803,  1539,     0,     0,  1540,
    1292,     0,   723,     0,     0,     0,     0,     0,     0,  1490,
    1294,     0,   781,     0,     0,  1294,  1294,     0,     0,  1301,
       0,     0,     0,     0,     0,     0,  1294,     0,     0,     0,
    1302,  1302,     0,  1302,     0,     0,  1514,  1515,     0,  1517,
       0,     0,     0,  1292,     0,   782,     0,  1292,  1292,  2232,
       0,     0,     0,     0,     0,     0,  1555,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   783,  1295,     0,  1541,
       0,     0,     0,     0,     0,     0,  1302,     0,  1302,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   784,     0,     0,  1591,     0,     0,     0,     0,  1526,
       0,     0,  1527,     0,     0,     0,     0,     0,     0,  1673,
    1673,  1673,     0,     0,     0,     0,     0,     0,     0,  1528,
       0,     0,  2328,     0,     0,     0,  1702,  1530,     0,     0,
    1712,  1715,  1531,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1294,     0,     0,   785,  1302,     0,
       0,     0,     0,     0,     0,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,     0,     0,     0,     0,
    1673,     0,     0,  1302,   177,     0,     0,  3771,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   786,     0,
       0,     0,   787,     0,   788,     0,     0,     0,     0,  1294,
     789,  1673,  1302,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1302,
       0,     0,     0,     0,     0,  3825,     0,     0,     0,   790,
       0,   791,     0,  1302,     0,   792,     0,     0,     0,     0,
       0,  1301,     0,   793,  1295,     0,  1302,  1532,   794,     0,
       0,  1533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   723,     0,     0,     0,   723,     0,     0,     0,
     795,     0,  1534,  1535,     0,   723,     0,  1791,     0,     0,
       0,  1302,     0,     0,  1295,     0,     0,  1536,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1294,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
       0,  1295,     0,     0,     0,     0,     0,     0,     0,  1537,
       0,     0,  1538,     0,     0,     0,     0,     0,     0,     0,
       0,  1297,     0,     0,     0,  1539,     0,     0,  1540,     0,
       0,   723,     0,     0,  1302,     0,     0,     0,     0,     0,
     723,     0,     0,     0,  3826,     0,   723,     0,   723,     0,
       0,     0,     0,  1302,   723,     0,     0,   723,   723,   723,
     723,   723,   723,   723,   723,   723,   723,     0,  1295,     0,
     723,   723,     0,     0,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,   723,     0,  1295,  1301,  1673,     0,   723,
       0,     0,     0,     0,     0,     0,     0,  1301,  1541,   723,
       0,     0,   723,     0,   723,  1295,     0,     0,     0,     0,
       0,     0,  1302,   723,   723,   723,     0,  2232,     0,   723,
       0,     0,   723,     0,     0,     0,     0,  1295,     0,  2232,
       0,     0,   723,     0,     0,     0,     0,     0,     0,     0,
     723,     0,   723,     0,  1297,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1301,     0,     0,     0,     0,     0,  1295,  2103,     0,     0,
    1301,     0,   723,     0,  1542,  1543,  1544,     0,  1545,  1546,
    1547,  1548,  1549,  1550,     0,     0,     0,     0,     0,  2125,
       0,     0,  2127,     0,     0,  2138,     0,     0,     0,     0,
       0,     0,  2145,  2150,  1673,  1302,  1673,  2155,  1298,     0,
    2160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1294,  1294,     0,  1294,     0,  2169,     0,     0,     0,
    2175,  1673,     0,     0,  2187,     0,     0,     0,  2194,     0,
    2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,     0,
    2205,     0,     0,     0,     0,  1024,     0,  2229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1294,     0,  1294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3540,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   723,     0,     0,     0,
       0,  1297,     0,     0,  1301,     0,     0,     0,     0,     0,
       0,  1298,     0,     0,  1302,     0,     0,     0,  1295,  1294,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
    1301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1297,     0,     0,  1294,     0,     0,     0,     0,     0,
    1302,   723,   723,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1297,     0,
       0,  1083,     0,   723,     0,     0,     0,     0,   723,     0,
       0,   723,     0,  1294,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,     0,
    1294,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1294,     0,     0,     0,     0,     0,
       0,     0,     0,   723,     0,     0,     0,  1294,     0,     0,
       0,     0,     0,     0,     0,  1297,     0,     0,     0,  2305,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
       0,     0,  1297,     0,     0,     0,     0,     0,     0,   723,
       0,     0,  1294,     0,     0,     0,   723,   723,     0,  1302,
       0,     0,  1297,     0,   723,   723,     0,     0,     0,   723,
    1302,  2328,     0,     0,     0,   723,   723,     0,     0,   723,
       0,     0,     0,     0,  1297,     0,     0,     0,  1298,     0,
     723,     0,     0,     0,     0,     0,     0,  1301,     0,     0,
       0,     0,   723,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1294,     0,     0,     0,     0,
       0,     0,   723,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,  1297,  1294,     0,     0,     0,     0,     0,
    1301,     0,     0,  1302,  1301,  1301,     0,     0,     0,     0,
       0,     0,     0,  1302,     0,  1298,     0,     0,     0,  1294,
       0,     0,     0,  1295,     0,     0,     0,     0,  1295,  1295,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1295,
       0,     0,  2469,     0,     0,     0,     0,     0,  1526,     0,
       0,  1527,     0,  1294,     0,     0,     0,     0,  1673,     0,
       0,     0,  3540,     0,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,  1531,  1298,     0,     0,     0,  1299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1298,
    1526,   723,     0,  1527,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,     0,     0,     0,     0,     0,  1298,
    1528,     0,     0,  2647,     0,     0,  1299,  2581,  1530,     0,
       0,     0,     0,  1531,     0,     0,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,     0,     0,     0,  1302,
       0,     0,     0,  1299,     0,     0,  1294,  1295,   723,     0,
       0,  2602,   723,     0,     0,  1297,     0,  1302,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   723,
    1298,     0,     0,  1302,     0,     0,  1024,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1532,     0,     0,     0,
    1533,     0,     0,   723,   723,     0,     0,   723,     0,     0,
    1299,     0,  1295,     0,   723,   723,     0,     0,  2643,     0,
       0,  1534,  1535,     0,     0,     0,     0,  1299,     0,     0,
       0,     0,     0,     0,   723,     0,  1536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1299,  1532,     0,
       0,  1302,  1533,     0,   723,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2150,     0,  2150,  2150,  1537,  1299,
       0,  1538,     0,  1534,  1535,  1294,  2703,     0,     0,  2706,
       0,  2708,     0,     0,  1539,     0,     0,  1540,  1536,     0,
       0,   723,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3105,     0,  2729,     0,  2731,
    1295,  1294,     0,  2734,     0,     0,     0,     0,  1299,     0,
    1537,     0,     0,  1538,     0,     0,     0,     0,     0,     0,
       0,     0,   723,     0,  1302,     0,  1539,     0,     0,  1540,
       0,  2229,  2229,  2229,     0,     0,     0,     0,     0,     0,
       0,     0,  1298,     0,     0,     0,     0,  1541,  2761,   723,
    1302,     0,   723,     0,   723,     0,  1083,     0,     0,     0,
    3106,     0,     0,     0,     0,  1702,     0,     0,     0,     0,
    2775,     0,     0,     0,     0,     0,     0,  1715,     0,   503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     723,   504,     0,  1302,     0,     0,     0,  1302,  1302,  1541,
    1297,     0,     0,  2792,     0,  1297,  1297,     0,     0,     0,
       0,   505,     0,     0,     0,     0,  1297,     0,     0,     0,
    1294,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
     723,  1294,   506,  1542,  1543,  1544,  -619,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1302,   507,     0,     0,     0,
       0,     0,   508,     0,     0,     0,     0,     0,  1526,     0,
       0,  1527,     0,   723,     0,     0,     0,   509,     0,     0,
    1299,     0,     0,     0,  1552,  1542,  1543,  1544,  1528,  1545,
    1546,  1547,  1548,  1549,  1550,     0,  1530,     0,     0,     0,
       0,  1531,     0,     0,  1294,   510,     0,     0,     0,     0,
       0,     0,   511,     0,  1294,     0,   512,   723,     0,     0,
       0,     0,     0,     0,   723,     0,     0,     0,     0,     0,
       0,  -772,     0,     0,  1297,     0,   723,   723,     0,     0,
       0,     0,     0,  1552,  1295,  1295,   723,  1295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   513,     0,
       0,     0,   723,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   723,     0,     0,     0,     0,     0,     0,     0,
    1295,     0,  1295,     0,     0,     0,     0,  1298,     0,  1297,
       0,     0,  1298,  1298,     0,     0,     0,     0,     0,     0,
       0,     0,   514,  1298,     0,   515,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1532,     0,     0,     0,
    1533,     0,     0,     0,     0,     0,   723,     0,     0,     0,
       0,     0,     0,     0,     0,   723,     0,     0,     0,     0,
       0,  1534,  1535,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1295,   516,     0,     0,  1536,     0,  1294,   517,
       0,     0,     0,     0,     0,  -351,     0,     0,   518,     0,
       0,     0,     0,     0,     0,     0,  2229,  1295,     0,     0,
       0,     0,     0,     0,  1294,     0,     0,  1297,  1537,     0,
       0,  1538,     0,     0,  -351,     0,   519,   520,     0,   521,
     522,     0,     0,     0,  1539,     0,     0,  1540,   523,     0,
       0,     0,     0,   524,     0,     0,  1295,     0,   525,     0,
    2661,  1298,     0,   526,     0,  1299,     0,     0,     0,     0,
    1299,  1299,     0,  1295,     0,  -351,     0,     0,     0,     0,
       0,  1299,  3067,     0,     0,     0,     0,  1295,     0,     0,
       0,  3070,  1294,     0,     0,     0,     0,  3071,     0,  3072,
    1295,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,  3090,  3091,     0,     0,     0,  1298,     0,  1526,     0,
       0,  1527,     0,     0,     0,  1295,     0,     0,     0,     0,
    2155,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
    3116,  2691,     0,  3119,     0,  3121,  1530,     0,     0,     0,
       0,  1531,     0,     0,  3125,     0,     0,     0,     0,     0,
    3130,     0,     0,  3133,     0,  1294,     0,     0,     0,  1552,
       0,     0,     0,  3140,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,  2229,     0,     0,     0,     0,  1295,  1299,
       0,  1294,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,  1295,     0,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1295,     0,  1294,     0,     0,     0,  1294,  1294,
       0,     0,     0,     0,     0,     0,     0,  1552,     0,     0,
       0,     0,     0,     0,  1299,     0,     0,     0,     0,     0,
       0,  1297,  1297,     0,  1297,     0,  1295,     0,     0,     0,
    1552,     0,     0,     0,     0,  2134,  1532,     0,     0,     0,
    1533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,  1552,     0,  1552,     0,     0,
       0,  1534,  1535,     0,     0,     0,     0,  1297,     0,  1297,
       0,     0,     0,     0,     0,     0,  1536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1537,     0,
       0,  1538,  1299,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,     0,     0,  1540,     0,  1295,
       0,  1552,     0,     0,     0,     0,     0,     0,     0,  1297,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1297,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3339,  3340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,     0,     0,  1297,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1298,  1298,
    1297,  1298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1297,     0,     0,     0,     0,     0,
       0,     0,  1552,     0,     0,     0,     0,  1297,     0,     0,
       0,     0,  1552,     0,  3378,  1552,     0,     0,  1295,     0,
       0,     0,     0,     0,  1298,     0,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1297,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,  1295,     0,     0,  3394,  3396,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3403,     0,     0,     0,     0,     0,  3408,  3409,     0,     0,
    3411,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2229,     0,     0,     0,     0,  1298,     0,     0,     0,
       0,     0,     0,  2229,     0,  1297,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,  1299,     0,  1299,
       0,  1298,     0,  3435,  1297,     0,     0,     0,     0,     0,
    1526,     0,     0,  1527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1297,
    1528,     0,     0,     0,     0,     0,     0,     0,  1530,     0,
    1298,     0,  1299,  1531,  1299,     0,     0,     0,     0,     0,
       0,     0,     0,  1295,     0,     0,     0,  1298,     0,     0,
       0,     0,     0,  1297,  1295,     0,     0,     0,     0,     0,
    1526,  1298,     0,  1527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,     0,     0,
    1528,     0,     0,  2700,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,  1531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1299,     0,     0,     0,     0,  1298,
       0,     0,  3500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1295,     0,  1299,
       0,     0,     0,     0,     0,     0,     0,  1295,     0,     0,
       0,     0,  2696,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1297,     0,  1532,     0,
       0,     0,  1533,     0,     0,     0,     0,     0,  1299,  3547,
       0,     0,  1298,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1534,  1535,  1299,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,     0,     0,  1536,  1299,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1299,     0,     0,     0,  1298,     0,  1532,     0,
       0,     0,  1533,     0,     0,     0,     0,     0,  3577,     0,
    1537,     0,     0,  1538,     0,     0,  3579,     0,     0,     0,
       0,     0,     0,  1534,  1535,     0,  1539,  1299,     0,  1540,
    1298,     0,     0,     0,     0,     0,     0,     0,  1536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1297,     0,     0,     0,     0,
    1537,  1295,     0,  1538,     0,  1552,     0,  1552,     0,  2134,
    2134,  2679,     0,     0,  2134,     0,  1539,     0,  1552,  1540,
    1299,     0,     0,     0,     0,  1552,     0,  1295,     0,  1541,
    1552,  1297,     0,     0,     0,  1552,     0,     0,  1526,  1299,
    1552,  1527,     0,     0,     0,     0,     0,     0,     0,  1552,
       0,     0,     0,  2134,  2134,  1552,     0,     0,  1528,     0,
       0,     0,     0,  1298,  1299,     0,  1530,  1552,     0,     0,
       0,  1531,     0,     0,  1552,     0,  1552,  1552,  1552,  1552,
    1552,  1552,  1552,  1552,  1552,  1552,     0,     0,     0,  1541,
       0,     0,     0,  2155,     0,  1295,     0,     0,  1299,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,  1552,
    1527,     0,     0,     0,     0,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,     0,  1528,     0,     0,
    3112,  3700,     0,     0,     0,  1530,     0,     0,     0,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1297,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1297,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3729,     0,     0,     0,  1542,  1543,  1544,  1295,  1545,
    1546,  1547,  1548,  1549,  1550,  1552,     0,     0,     0,     0,
       0,     0,  1298,     0,     0,     0,  1532,     0,     0,     0,
    1533,  1299,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1534,  1535,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,  1297,     0,  1536,     0,     0,     0,
       0,     0,     0,     0,  1297,     0,     0,  1295,     0,     0,
       0,  1295,  1295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1532,     0,     0,  1537,  1533,
       0,  1538,     0,     0,     0,     0,     0,  3788,  3788,     0,
       0,     0,     0,     0,  1539,     0,     0,  1540,     0,     0,
    1534,  1535,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,  1527,     0,  1536,     0,     0,     0,     0,
       0,     0,     0,  3788,     0,     0,     0,     0,     0,     0,
    1528,     0,     0,  3828,     0,     0,     0,     0,  1530,     0,
    1299,     0,     0,  1531,     0,     0,     0,  1537,   545,     0,
    1538,     0,     0,     0,     0,     0,     0,  1298,     0,  1552,
     546,     0,     0,  1539,     0,     0,  1540,  1541,  1298,     0,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
     547,     0,     0,     0,     0,     0,     0,  3788,     0,     0,
       0,     0,     0,  3066,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   548,     0,     0,  1297,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   549,     0,     0,     0,     0,
       0,     0,     0,     0,  1297,     0,  1541,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,   550,     0,     0,     0,
       0,  1298,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,     0,  1532,     0,
       0,  1552,  1533,     0,   551,     0,     0,     0,     0,   552,
       0,     0,     0,     0,     0,   553,     0,     0,     0,     0,
       0,     0,  1552,  1534,  1535,  1299,     0,     0,     0,     0,
     554,     0,  1297,     0,     0,     0,  1299,     0,  1536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,
    1549,  1550,     0,  1552,     0,     0,     0,     0,     0,     0,
    1537,     0,     0,  1538,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2679,  2679,  1539,  2134,     0,  1540,
    2134,  2134,  2134,  2134,  2134,  2134,  2134,  2134,  2134,  2134,
    2679,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
       0,   555,     0,     0,     0,  1297,     0,     0,     0,  1299,
       0,   556,     0,  1552,     0,     0,  1552,     0,  1552,     0,
       0,     0,     0,  2679,  2679,  1298,     0,     0,   177,     0,
       0,  1297,     0,     0,     0,     0,     0,  2134,  2134,  1552,
       0,  1552,     0,     0,  1552,     0,     0,     0,     0,  1541,
       0,  1298,   557,     0,     0,     0,   558,     0,   559,     0,
       0,     0,     0,     0,   560,     0,     0,   561,     0,     0,
       0,  1552,     0,     0,  1297,     0,     0,     0,  1297,  1297,
       0,     0,     0,     0,     0,  1552,     0,     0,     0,     0,
       0,     0,     0,   562,     0,   563,     0,     0,     0,   564,
       0,     0,  1552,     0,     0,     0,     0,   565,     0,     0,
       0,     0,   566,     0,     0,     0,     0,     0,     0,  1298,
       0,     0,   567,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   568,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1299,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1298,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2134,
       0,     0,     0,     0,     0,     0,     0,  1299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,  1298,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1552,     0,     0,
    1552,  1552,  1552,     0,     0,  2679,     0,     0,     0,     0,
    2679,  2679,  2679,  2679,  2679,  2679,  2679,  2679,  2679,  2679,
    1552,  1552,     0,     0,     0,     0,     0,     0,     0,  1299,
       0,     0,     0,  1299,  1299,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1552,  2134,  2134,  1552,
       0,  1552,     0,     0,     0,  1552,  2679,  2679,     0,     0,
    1552,     0,     0,  1552,     0,     0,     0,     0,     0,     0,
    1552,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,  1552,     0,     0,     0,     0,     0,     2,     0,
       3,     4,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     7,     8,     0,     0,
       0,     9,     0,    10,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,     0,    12,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,     0,     0,    14,     0,     0,
       0,     0,     0,    15,     0,     0,     0,     0,     0,    16,
       0,    17,     0,     0,     0,    18,     0,     0,     0,     0,
       0,    19,     0,     0,     0,     0,     0,     0,    20,     0,
      21,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,     0,     0,     0,  2679,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
    1552,     0,    25,    26,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,     0,  1552,     0,
       0,     0,  2134,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,     0,  1552,     0,     0,     0,
       0,  2679,  2679,  1552,     0,     0,  2134,  2134,  1552,  1552,
      30,  1552,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,    32,     0,    33,     0,     0,
       0,     0,    34,     0,     0,  1552,     0,    35,     0,     0,
      36,     0,     0,     0,    37,     0,     0,     0,     0,     0,
      38,     0,     0,     0,     0,     0,     0,    39,     0,     0,
      40,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    43,     0,     0,
    1552,     0,     0,     0,     0,     0,    44,     0,    45,     0,
       0,    46,     0,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1552,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      49,  2679,  2134,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2679,  2679,  1552,     0,  1552,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,  2679,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
    1552,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,  1552,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,  1552,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,  1552,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,  3439,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1066,     0,     0,     0,  1067,
     697,   944,   540,   945,   946,   947,   585,   948,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,  2223,
     201,   202,   203,     0,     0,     0,     0,   949,     0,     0,
     204,   205,     0,   206,   698,   207,   208,   209,   210,   950,
     699,   951,   952,     0,   214,   215,   216,   217,   218,   953,
     954,   219,   220,   955,   956,   223,     0,   224,   225,   226,
     227,   957,     0,     0,   229,   230,   231,   232,   700,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   701,   244,   245,   958,   959,   960,   961,   962,
     963,   964,   246,   247,   248,   249,   250,   251,   965,   966,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,  2224,     0,   264,   265,   967,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   968,   279,   280,   969,   970,   282,     0,   283,
     971,   285,     0,   286,     0,   287,   703,     0,   704,   288,
     289,   290,     0,   291,   972,     0,   293,     0,   294,   295,
     296,   297,   298,   705,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   706,   309,   310,   311,
     312,   313,   973,   974,     0,   975,     0,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,     0,
     976,   710,   327,   711,     0,   328,   329,   330,   977,   978,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   979,   712,   980,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   981,   355,   356,   713,   357,
     982,   983,   359,   984,   361,   362,     0,     0,   363,     0,
       0,   985,   365,   366,     0,     0,   367,   714,   715,   716,
     986,   369,   370,   371,   372,   373,   374,     0,   375,   987,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   988,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,   717,   405,   406,   989,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,   990,
     421,   422,   423,   424,   718,   425,   991,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   992,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   993,   994,     0,     0,   449,   995,   451,   996,   997,
     453,   454,   455,   456,   457,   458,     0,   998,   459,   460,
     461,   462,   999,     0,   463,   464,   465,   466,   467,  1000,
    2225,   469,   719,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,     0,
       0,     0,     0,     0,  1008,  1009,  2226,     0,     0,     0,
       0,     0,     0,  1011,  2227,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,   191,     0,     0,     0,     0,     0,     0,  1011,  2136,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,  2562,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243, -1266,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0, -1266,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308, -1266,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318, -1266,   319,   320,   321,   322,   323,   324,   325,
       0,   326, -1266,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344, -1266,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404, -1266,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1090,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,     0,  1269,   699,  1270,  1271,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,  1272,  1273,
     223,     0,   224,   225,   226,   227,     0,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
       0,     0,     0,   702,     0,     0,     0,   246,   247,   248,
     249,   250,   251,  1274,  1275,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,     0,   279,   280,
       0,     0,   282,     0,   283,  1276,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,     0,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,  1779,   302,   303,   304,   305,   306,   307,     0,
     308,   706,  1780,   310,   311,   312,   313,  1277,  1278,     0,
    1279,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,     0,   710,   327,   711,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1280,   712,
    1281,   346,   347,   348,   349,   350,   351,   352,     0,   354,
       0,   355,   356,   713,   357,     0,     0,   359,  1282,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,  1781,   714,   715,   716,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,   377,     0,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1283,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,     0,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,  1782,   423,   424,   718,
     425,  1285,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,  1286,  1287,     0,     0,
     449,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,     0,  1288,  1783,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,  1268,     0,     0,     0,     0,     0,     0,     0,   487,
     488,   489,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,  1784,
       0,   204,   205,     0,   206,   698,   207,   208,   209,     0,
    1269,   699,  1270,  1271,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,  1272,  1273,   223,     0,   224,   225,
     226,   227,     0,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,     0,     0,     0,   702,
       0,     0,     0,   246,   247,   248,   249,   250,   251,  1274,
    1275,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,     0,   279,   280,     0,     0,   282,     0,
     283,  1276,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,     0,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,  1779,   302,
     303,   304,   305,   306,   307,     0,   308,   706,  1780,   310,
     311,   312,   313,  1277,  1278,     0,  1279,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,     0,   710,   327,   711,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1280,   712,  1281,   346,   347,   348,
     349,   350,   351,   352,     0,   354,     0,   355,   356,   713,
     357,     0,     0,   359,  1282,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,  1781,   714,   715,
     716,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,   377,     0,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1283,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,     0,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,  1782,   423,   424,   718,   425,  1285,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,  1286,  1287,     0,     0,   449,     0,   451,     0,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,     0,
    1288,  1783,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   697,   944,   540,
     945,   946,   947,   585,   948,   487,   488,   489,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,  2543,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
    2146,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,  2147,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,  2148,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,  2149,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,    38,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,    42,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   884,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,    48,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,     0,     0,     0,     0,     0,  1462,  2095,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,   456,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,  1010,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,  1082,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   981,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,  1710,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,  2147,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,   210,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,  3155,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,     0,     0,     0,     0,     0,     0,     0,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,   456,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,  2580,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   981,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
     998,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  1008,  1009,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
     711,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   981,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,   718,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
     456,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,  3388,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,  3395,   348,
     349,   350,   351,   352,   353,   354,   981,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,  3785,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,  3786,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,   711,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     981,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,   718,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,  3787,   457,
     458,     0,   998,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,  1008,
    1009,     0,     0,     0,     0,     0,     0,     0,  1011,   697,
     944,   540,   945,   946,   947,   585,   948,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,   949,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,   210,   950,   699,
     951,   952,     0,   214,   215,   216,   217,   218,   953,   954,
     219,   220,   955,   956,   223,     0,   224,   225,   226,   227,
     957,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,  3786,   958,   959,   960,   961,   962,   963,
     964,   246,   247,   248,   249,   250,   251,   965,   966,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   968,   279,   280,   969,   970,   282,     0,   283,   971,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,   972,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,   309,   310,   311,   312,
     313,   973,   974,     0,   975,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,   976,
     710,   327,   711,     0,   328,   329,   330,   977,   978,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   979,   712,   980,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   981,   355,   356,   713,   357,   982,
     983,   359,   984,   361,   362,     0,     0,   363,     0,     0,
     985,   365,   366,     0,     0,   367,   714,   715,   716,   986,
     369,   370,   371,   372,   373,   374,     0,   375,   987,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   988,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,   989,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,   990,   421,
     422,   423,   424,   718,   425,   991,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   992,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     993,   994,     0,     0,   449,   995,   451,   996,   997,   453,
     454,   455,  3787,   457,   458,     0,   998,   459,   460,   461,
     462,   999,     0,   463,   464,   465,   466,   467,  1000,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,   487,   488,   489,     0,     0,     0,     0,
       0,     0,     0,  1008,  1009,     0,     0,     0,     0,     0,
       0,     0,  1011,   697,   944,   540,   945,   946,   947,   585,
     948,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
     949,     0,     0,   204,   205,     0,   206,   698,   207,   208,
     209,   210,   950,   699,   951,   952,     0,   214,   215,   216,
     217,   218,   953,   954,   219,   220,   955,   956,   223,     0,
     224,   225,   226,   227,   957,     0,     0,   229,   230,   231,
     232,   700,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   701,   244,   245,   958,   959,
     960,   961,   962,   963,   964,   246,   247,   248,   249,   250,
     251,   965,   966,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     967,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   968,   279,   280,   969,   970,
     282,     0,   283,   971,   285,     0,   286,     0,   287,   703,
       0,   704,   288,   289,   290,     0,   291,   972,     0,   293,
       0,   294,   295,   296,   297,   298,   705,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   706,
     309,   310,   311,   312,   313,   973,   974,     0,   975,     0,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,     0,   976,   710,   327,   711,     0,   328,   329,
     330,   977,   978,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   979,   712,   980,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   713,   357,   982,   983,   359,   984,   361,   362,     0,
       0,   363,     0,     0,   985,   365,   366,     0,     0,   367,
     714,   715,   716,   986,   369,   370,   371,   372,   373,   374,
       0,   375,   987,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   988,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,   717,   405,   406,   989,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,   990,   421,   422,   423,   424,   718,   425,   991,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   992,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   993,   994,     0,     0,   449,   995,
     451,   996,   997,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,   999,     0,   463,   464,   465,
     466,   467,  1000,     0,   469,   719,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,   489,
       0,     0,     0,     0,     0,     0,     0,  2129,  2130,     0,
       0,     0,     0,     0,     0,     0,  1011,   697,   944,   540,
     945,   946,   947,   585,   948,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,   949,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209, -2012,   950,   699,   951,   952,
       0,   214,   215,   216,   217,   218,   953,   954,   219,   220,
     955,   956,   223,     0,   224,   225,   226,   227,   957,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,  3786,   958,   959,   960,   961,   962,   963,   964,   246,
     247,   248,   249,   250,   251,   965,   966,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   967,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   968,
     279,   280,   969,   970,   282,     0,   283,   971,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   972,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   973,
     974,     0,   975,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   976,   710,   327,
       0,     0,   328,   329,   330,   977,   978,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     979,   712,   980,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,   713,   357,   982,   983,   359,
     984,   361,   362,     0,     0,   363,     0,     0,   985,   365,
     366,     0,     0,   367,   714,   715,   716,   986,   369,   370,
     371,   372,   373,   374,     0,   375,   987,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     988,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   989,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,   990,   421,   422,   423,
     424,     0,   425,   991,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   992,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   993,   994,
       0,     0,   449,   995,   451,   996,   997,   453,   454,   455,
    3787,   457,   458,     0,   998,   459,   460,   461,   462,   999,
       0,   463,   464,   465,   466,   467,  1000,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,   487,   488,   489,     0,     0,     0,     0,     0,     0,
       0,  1008,  1009,     0,     0,     0,     0,     0,     0,     0,
    1011,   697,   944,   540,   945,   946,   947,   585,   948,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,   949,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,     0,
     950,   699,   951,   952,     0,   214,   215,   216,   217,   218,
     953,   954,   219,   220,   955,   956,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   965,
     966,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,     0,     0,   274,
     275,   276,   277,   968,   279,   280,   969,   970,   282,     0,
     283,   971,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   973,   974,     0,   975,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,     0,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   979,   712,   980,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,   713,
     357,   982,   983,   359,   984,   361,   362,     0,     0,   363,
       0,     0,   985,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   988,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   989,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,     0,   425,   991,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   993,   994,     0,     0,   449,   995,   451,   996,
     997,   453,   454,   455,   456,   457,   458,     0,   998,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
    1000,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,     0,  1008,  1009,     0,     0,     0,
       0,     0,     0,     0,  1011,   697,   944,   540,   945,   946,
     947,   585,   948,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,   949,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,     0,   950,   699,   951,   952,     0,   214,
     215,   216,   217,   218,   953,   954,   219,   220,   955,   956,
     223,     0,   224,   225,   226,   227,   957,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
     958,   959,   960,   961,   962,   963,   964,   246,   247,   248,
     249,   250,   251,   965,   966,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,     0,     0,   274,   275,   276,   277,   968,   279,   280,
     969,   970,   282,     0,   283,   971,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,   972,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,   309,   310,   311,   312,   313,   973,   974,     0,
     975,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,   976,   710,   327,     0,     0,
     328,   329,   330,   977,   978,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   979,   712,
     980,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,   713,   357,   982,   983,   359,   984,   361,
     362,     0,     0,   363,     0,     0,   985,   365,   366,     0,
       0,   367,   714,   715,   716,   986,   369,   370,   371,   372,
     373,   374,     0,   375,   987,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   988,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,   989,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,   990,   421,   422,   423,   424,     0,
     425,   991,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   992,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   993,   994,     0,     0,
     449,   995,   451,   996,   997,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,   999,     0,   463,
     464,   465,   466,   467,  1000,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,
     488,   489,     0,     0,     0,     0,     0,     0,   697,  2129,
    2130,     0,     0,     0,     0,     0,     0,     0,  1011,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,   698,   207,   208,   209,   210,   211,   699,   212,
     213,     0,   214,   215,   216,   217,   218,     0,   954,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   957,
       0,     0,   229,   230,   231,   232,   700,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     701,   244,   245,   958,   959,   960,   961,   962,   963,   964,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   969,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,   703,     0,   704,   288,   289,   290,
       0,   291,   972,     0,   293,     0,   294,   295,   296,   297,
     298,   705,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   706,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   707,   708,   318,   709,
     319,   320,   321,   322,   323,   324,   325,     0,   976,   710,
     327,   711,     0,   328,   329,   330,   977,   978,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   712,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,   713,   357,     0,   983,
     359,   360,   361,   362,     0,     0,   363,     0,   664,   364,
     365,   366,     0,     0,   367,   714,   715,   716,   986,   369,
     370,   371,   372,   373,   374,     0,   375,   987,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,   717,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    38,   416,   417,   418,   419,   420,   990,   421,   422,
     423,   424,   718,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   992,   438,     0,   439,
     440,    42,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   995,   451,   996,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
     999,     0,   463,   464,   465,   466,   884,   468,     0,   469,
     719,   470,   471,   472,     0,     0,   473,     0,    48,   474,
     475,   476,   477,   478,   479,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,   487,   488,   489,     0,     0,     0,     0,     0,
       0,   697,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1989,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     211,   699,   212,   213,     0,   214,   215,   216,   217,   218,
       0,   954,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   957,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,   958,   959,   960,   961,
     962,   963,   964,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   969,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   972,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   976,   710,   327,   711,     0,   328,   329,   330,   977,
     978,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   712,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,   713,
     357,     0,   983,   359,   360,   361,   362,     0,     0,   363,
       0,   664,   364,   365,   366,     0,     0,   367,   714,   715,
     716,   986,   369,   370,   371,   372,   373,   374,     0,   375,
     987,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
     990,   421,   422,   423,   424,   718,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   992,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   995,   451,   996,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,   999,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,   487,   488,   489,     0,     0,
       0,     0,     0,     0,   697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1989,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   698,   207,
     208,   209,   210,   211,   699,   212,   213,     0,   214,   215,
     216,   217,   218,     0,   954,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   957,     0,     0,   229,   230,
     231,   232,   700,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   701,   244,   245,   958,
     959,   960,   961,   962,   963,   964,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   969,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
     703,     0,   704,   288,   289,   290,     0,   291,   972,     0,
     293,     0,   294,   295,   296,   297,   298,   705,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     706,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   707,   708,   318,   709,   319,   320,   321,   322,
     323,   324,   325,     0,   976,   710,   327,   711,     0,   328,
     329,   330,   977,   978,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   712,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,   713,   357,     0,   983,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   714,   715,   716,   986,   369,   370,   371,   372,   373,
     374,     0,   375,   987,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,   717,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,   990,   421,   422,   423,   424,   718,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   992,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     995,   451,   996,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,   999,     0,   463,   464,
     465,   466,   467,   468,     0,   469,   719,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,  1001,  1002,  1003,  1004,  1005,  1006,  1007,   487,   488,
     489,     0,     0,     0,     0,     0,     0,   697,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3175,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   211,   699,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,     0,     0,     0,   702,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   326,   710,   327,
     711,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   712,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,   713,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,   714,   715,   716,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   718,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,     0,     0,     0,     0,     0,
     191,  1173,   540,     0,     0,     0,   585,     0,     0,     0,
    3606,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,  1394,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,  1395,     0,   363,  1396,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,  1397,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,     0,     0,
       0,     0,     0,   191,   597,  1174,  3252,     0,     0,     0,
       0,     0,     0,  3253,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     3,     4,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    38,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,    42,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   884,   468,     0,   469,   885,   470,   471,   472,     0,
       0,   473,     0,    48,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,     0,     0,     0,     0,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    38,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,    42,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   884,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,    48,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,     0,     0,     0,     0,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,     0,     0,     0,
       0,     0,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1063,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
       0,     0,     0,     0,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1682,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,     0,     0,     0,     0,     0,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3025,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,     0,     0,     0,
       0,  1268,  1173,   540,     0,     0,   738,   585,     0,     0,
       0,  3149,   192,   193,   194,   195,   196,   197,   198,   199,
    1593,   201,   202,   203,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,   204,   205,  1601,   206,   698,   207,   208,   209,     0,
    1269,   699,  1270,  1271,  1602,   214,   215,   216,   217,   218,
    1603,  1604,   219,   220,  1272,  1273,   223,  1605,   224,   225,
     226,   227,     0,  1606,  1607,   229,   230,   231,   232,   700,
     233,   234,  1608,   235,   236,   237,   238,   239,   240,  1609,
     241,   242,   243,   701,   244,   245,  1610,  1611,  1612,   702,
    1613,  1614,  1615,   246,   247,   248,   249,   250,   251,  1274,
    1275,   254,  1616,   255,  1617,   256,   257,   258,   259,   260,
    1618,   261,   262,   263,  1619,  1620,   264,   265,   967,   267,
     268,  1621,   269,   270,   271,  1622,   272,   273,  1623,   274,
     275,   276,   277,     0,   279,   280,     0,  1624,   282,  1625,
     283,  1276,   285,  1626,   286,  1627,   287,   703,  1628,   704,
     288,   289,   290,  1629,   291,     0,  1630,   293,  1631,   294,
     295,   296,   297,   298,   705,   299,   300,   301,  1632,   302,
     303,   304,   305,   306,   307,  1633,   308,   706,     0,   310,
     311,   312,   313,  1277,  1278,  1634,  1279,  1635,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
    1636,     0,   710,   327,   711,  1637,   328,   329,   330,  1638,
    1639,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1280,   712,  1281,   346,   347,   348,
     349,   350,   351,   352,     0,   354,  1640,   355,   356,   713,
     357,  1641,     0,   359,  1282,   361,   362,  1642,  1643,   363,
    1644,  1645,  2901,   365,   366,  1646,  1647,     0,   714,   715,
     716,     0,   369,   370,   371,   372,   373,   374,  1648,   375,
       0,   377,     0,   379,   380,   381,  1649,   382,   383,   384,
     385,   386,   387,   388,  1283,   390,   391,   392,  1650,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,  1651,
     403,   404,   717,   405,   406,     0,   408,   409,   410,   411,
     412,   413,   414,   415,  1652,   416,   417,   418,   419,   420,
    1653,   421,  1782,   423,   424,   718,   425,  1285,  1654,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,  1655,   439,   440,  1656,   441,   442,   443,   444,   445,
     446,  1657,  1286,  1287,  1658,  1659,   449,     0,   451,     0,
    1660,   453,   454,   455,   456,   457,   458,  1661,  1662,   459,
     460,   461,   462,  1663,  1664,   463,   464,   465,   466,     0,
    1288,  1665,   469,   719,   470,   471,   472,  1666,  1667,   473,
    1668,  1669,   474,   475,   476,   477,   478,     0,     0,     0,
       0,     0,     0,     0,     0,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,  2902,  2903,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   739,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   740,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   813,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   814,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   857,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   858,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   859,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,  1251,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,  1252,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
       0,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   191,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,  3595,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
    1592,   741,   742,   743,     0,   744,   745,   746,   747,   748,
     749,   192,   193,   194,   195,   196,   197,   198,   199,  1593,
     201,   202,   203,  1594,  1595,  1596,  1597,  1598,  1599,  1600,
     204,   205,  1601,   206,   698,   207,   208,   209,   210,   211,
     699,   212,   213,  1602,   214,   215,   216,   217,   218,  1603,
    1604,   219,   220,   221,   222,   223,  1605,   224,   225,   226,
     227,   228,  1606,  1607,   229,   230,   231,   232,   700,   233,
     234,  1608,   235,   236,   237,   238,   239,   240,  1609,   241,
     242,   243,   701,   244,   245,  1610,  1611,  1612,   702,  1613,
    1614,  1615,   246,   247,   248,   249,   250,   251,   252,   253,
     254,  1616,   255,  1617,   256,   257,   258,   259,   260,  1618,
     261,   262,   263,  1619,  1620,   264,   265,   266,   267,   268,
    1621,   269,   270,   271,  1622,   272,   273,  1623,   274,   275,
     276,   277,   278,   279,   280,   281,  1624,   282,  1625,   283,
     284,   285,  1626,   286,  1627,   287,   703,  1628,   704,   288,
     289,   290,  1629,   291,   292,  1630,   293,  1631,   294,   295,
     296,   297,   298,   705,   299,   300,   301,  1632,   302,   303,
     304,   305,   306,   307,  1633,   308,   706,   309,   310,   311,
     312,   313,   314,   315,  1634,   316,  1635,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,  1636,
     326,   710,   327,   711,  1637,   328,   329,   330,  1638,  1639,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   712,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,  1640,   355,   356,   713,   357,
    1641,   358,   359,   360,   361,   362,  1642,  1643,   363,  1644,
    1645,   364,   365,   366,  1646,  1647,   367,   714,   715,   716,
     368,   369,   370,   371,   372,   373,   374,  1648,   375,   376,
     377,   378,   379,   380,   381,  1649,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,  1650,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,  1651,   403,
     404,   717,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,  1652,   416,   417,   418,   419,   420,  1653,
     421,   422,   423,   424,   718,   425,   426,  1654,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
    1655,   439,   440,  1656,   441,   442,   443,   444,   445,   446,
    1657,   447,   448,  1658,  1659,   449,   450,   451,   452,  1660,
     453,   454,   455,   456,   457,   458,  1661,  1662,   459,   460,
     461,   462,  1663,  1664,   463,   464,   465,   466,   467,   468,
    1665,   469,   719,   470,   471,   472,  1666,  1667,   473,  1668,
    1669,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,  1670,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,   669,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,  1268,     0,     0,     0,     0,     0,     0,     0,     0,
    3484,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,     0,
    1269,   699,  1270,  1271,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,  1272,  1273,   223,     0,   224,   225,
     226,   227,     0,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,     0,     0,     0,   702,
       0,     0,     0,   246,   247,   248,   249,   250,   251,  1274,
    1275,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,     0,   279,   280,     0,     0,   282,     0,
     283,  1276,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,     0,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,     0,   310,
     311,   312,   313,  1277,  1278,     0,  1279,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,     0,   710,   327,   711,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1280,   712,  1281,   346,   347,   348,
     349,   350,   351,   352,     0,   354,     0,   355,   356,   713,
     357,     0,     0,   359,  1282,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,     0,   714,   715,
     716,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,   377,     0,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1283,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,     0,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,  1284,   423,   424,   718,   425,  1285,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,  1286,  1287,     0,     0,   449,     0,   451,     0,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,     0,
    1288,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,     0,  1910,     0,
       0,     0,     0,     0,     0,   487,   488,   489,     0,   192,
     193,   194,   195,   196,   197,   198,   199,  1727,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,   698,   207,   208,   209,     0,  1269,   699,  1270,
    1271,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,  1272,  1273,   223,     0,   224,   225,   226,   227,     0,
       0,     0,   229,   230,   231,   232,   700,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     701,   244,   245,     0,     0,     0,   702,     0,     0,     0,
     246,   247,   248,   249,   250,   251,  1274,  1275,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   967,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
       0,   279,   280,     0,     0,   282,     0,   283,  1276,   285,
       0,   286,     0,   287,   703,     0,   704,   288,   289,   290,
       0,   291,     0,     0,   293,     0,   294,   295,   296,   297,
     298,   705,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   706,     0,   310,   311,   312,   313,
    1277,  1278,     0,  1279,     0,   317,   707,   708,   318,   709,
     319,   320,   321,   322,   323,   324,   325,     0,     0,   710,
     327,   711,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1280,   712,  1281,   346,   347,   348,   349,   350,   351,
     352,     0,   354,     0,   355,   356,   713,   357,     0,     0,
     359,  1282,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,     0,   714,   715,   716,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,   377,     0,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1283,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,   717,
     405,   406,     0,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,  1284,
     423,   424,   718,   425,  1285,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,  1286,
    1287,     0,     0,   449,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,     0,  1288,     0,   469,
     719,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,     0,   191,  1173,   540,     0,     0,
       0,   585,   487,   488,   489,     0,   192,   193,   194,   195,
     196,   197,   198,   199,  1727,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,  1581,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,  1394,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,  1395,     0,   363,  1396,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,  1397,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,  1173,   540,     0,     0,     0,   585,   597,
    1174,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,  1587,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,  1394,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,  1395,     0,
     363,  1396,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,  1397,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
    1173,   540,     0,     0,     0,   585,   597,  1174,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,  1394,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,  1395,     0,   363,  1396,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,  1397,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,   585,   597,  1174,     0,     0,   192,   586,   194,
     195,   196,   197,   198,   199,   587,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   588,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   589,   284,   285,     0,   286,
       0,   590,     0,   591,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   592,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   593,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   594,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   595,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   596,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,  1592,     0,     0,     0,     0,     0,     0,
     597,   598,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,  1593,   201,   202,   203,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,   204,   205,  1601,   206,   698,   207,   208,
     209,   210,   211,   699,   212,   213,  1602,   214,   215,   216,
     217,   218,  1603,  1604,   219,   220,   221,   222,   223,  1605,
     224,   225,   226,   227,   228,  1606,  1607,   229,   230,   231,
     232,   700,   233,   234,  1608,   235,   236,   237,   238,   239,
     240,  1609,   241,   242,   243,   701,   244,   245,  1610,  1611,
    1612,   702,  1613,  1614,  1615,   246,   247,   248,   249,   250,
     251,   252,   253,   254,  1616,   255,  1617,   256,   257,   258,
     259,   260,  1618,   261,   262,   263,  1619,  1620,   264,   265,
     266,   267,   268,  1621,   269,   270,   271,  1622,   272,   273,
    1623,   274,   275,   276,   277,   278,   279,   280,   281,  1624,
     282,  1625,   283,   284,   285,  1626,   286,  1627,   287,   703,
    1628,   704,   288,   289,   290,  1629,   291,   292,  1630,   293,
    1631,   294,   295,   296,   297,   298,   705,   299,   300,   301,
    1632,   302,   303,   304,   305,   306,   307,  1633,   308,   706,
     309,   310,   311,   312,   313,   314,   315,  1634,   316,  1635,
     317,   707,   708,   318,   709,   319,   320,   321,   322,   323,
     324,   325,  1636,   326,   710,   327,   711,  1637,   328,   329,
     330,  1638,  1639,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   712,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,  1640,   355,
     356,   713,   357,  1641,   358,   359,   360,   361,   362,  1642,
    1643,   363,  1644,  1645,   364,   365,   366,  1646,  1647,   367,
     714,   715,   716,   368,   369,   370,   371,   372,   373,   374,
    1648,   375,   376,   377,   378,   379,   380,   381,  1649,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
    1650,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,  1651,   403,   404,   717,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,  1652,   416,   417,   418,
     419,   420,  1653,   421,   422,   423,   424,   718,   425,   426,
    1654,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,  1655,   439,   440,  1656,   441,   442,   443,
     444,   445,   446,  1657,   447,   448,  1658,  1659,   449,   450,
     451,   452,  1660,   453,   454,   455,   456,   457,   458,  1661,
    1662,   459,   460,   461,   462,  1663,  1664,   463,   464,   465,
     466,   467,   468,  1665,   469,   719,   470,   471,   472,  1666,
    1667,   473,  1668,  1669,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
    1592,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,  2402,   197,   198,   199,  1593,
     201,   202,   203,  1594,  1595,  1596,  1597,  1598,  1599,  1600,
     204,   205,  1601,   206,   698,   207,   208,   209,   210,   211,
     699,   212,   213,  1602,   214,   215,   216,   217,   218,  1603,
    1604,   219,   220,   221,   222,   223,  1605,   224,   225,   226,
     227,   228,  1606,  1607,   229,   230,   231,   232,   700,   233,
     234,  1608,   235,   236,   237,   238,   239,   240,  1609,   241,
     242,   243,   701,   244,   245,  1610,  1611,  1612,   702,  1613,
    1614,  1615,   246,   247,   248,   249,   250,   251,   252,   253,
     254,  1616,   255,  1617,   256,   257,   258,   259,   260,  1618,
     261,   262,   263,  1619,  1620,   264,   265,   266,  2403,   268,
    1621,   269,   270,   271,  1622,   272,   273,  1623,   274,   275,
     276,   277,   278,   279,   280,   281,  1624,   282,  1625,   283,
     284,   285,  1626,   286,  1627,   287,   703,  1628,   704,   288,
     289,   290,  1629,   291,   292,  1630,   293,  1631,   294,   295,
     296,   297,   298,   705,   299,   300,   301,  1632,   302,   303,
     304,   305,   306,   307,  1633,   308,   706,   309,   310,   311,
     312,   313,   314,   315,  1634,   316,  1635,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,  1636,
     326,   710,   327,   711,  1637,   328,   329,   330,  1638,  1639,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   712,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,  1640,   355,   356,   713,   357,
    1641,   358,   359,   360,   361,   362,  1642,  1643,   363,  1644,
    1645,   364,   365,   366,  1646,  1647,   367,   714,   715,   716,
     368,   369,   370,   371,   372,   373,   374,  1648,   375,   376,
     377,   378,   379,   380,   381,  1649,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,  1650,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,  1651,   403,
     404,   717,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,  1652,   416,   417,   418,   419,   420,  1653,
    2404,   422,   423,   424,   718,   425,   426,  1654,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
    1655,   439,   440,  1656,   441,   442,   443,   444,   445,   446,
    1657,   447,   448,  1658,  1659,   449,   450,   451,   452,  1660,
     453,   454,   455,   456,   457,   458,  1661,  1662,   459,   460,
     461,   462,  1663,  1664,   463,   464,   465,   466,   467,   468,
    1665,   469,   719,   470,   471,   472,  1666,  1667,   473,  1668,
    1669,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   697,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,   210,   211,   699,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,     0,     0,     0,   702,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,   326,   710,   327,
     711,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   712,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,   713,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,   714,   715,   716,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   718,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   698,   207,
     208,   209,   210,   211,   699,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   700,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   701,   244,   245,     0,
       0,     0,   702,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
     703,     0,   704,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   844,   705,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     706,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   707,   708,   318,   709,   319,   320,   321,   322,
     323,   324,   325,     0,   326,   710,   327,   711,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   712,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,   713,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   714,   715,   716,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,   717,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   718,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,   719,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   697,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,   210,
     211,   699,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,     0,     0,     0,   702,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   852,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,   326,   710,   327,   711,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   712,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,   713,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,   714,   715,
     716,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   718,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,  1749,   224,   225,   226,   227,   228,
       0,  1794,   229,   230,   231,   232,     0,   233,   234,  1750,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,  1795,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,  1752,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,  1753,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,  1754,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,  1749,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,  1750,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,  1795,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,  1752,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,  2527,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
    1753,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,  1754,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   636,   198,
     199,   604,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
     605,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,   637,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   606,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   607,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,   604,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,   605,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,  2293,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   606,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   607,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,  1749,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,  1750,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,  1795,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
    1752,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,  1753,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,  1754,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,   540,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,  1394,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,  1395,
       0,   363,  1396,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,  1397,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,  3835,   540,  3836,  3837,     0,   585,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,   604,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,   605,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   606,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     607,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,  1422,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,  1423,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,  1424,   287,
       0,     0,     0,  1425,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,  1426,  1427,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,  1428,   412,   413,   414,   415,     0,  1429,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,  1430,   441,  1431,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,   605,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   606,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   607,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     3,     4,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     885,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,   540,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,  1567,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,  1872,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,  1873,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     3,     4,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,  2337,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,  2338,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,  2349,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,  2350,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,   531,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     532,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,   630,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   631,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   632,   448,     0,     0,   633,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
     658,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   659,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   660,   448,     0,     0,   661,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,   664,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,   836,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,   540,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,  1039,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
    1050,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   646,   220,   221,
     222,  1051,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   649,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   650,   406,
     407,   408,   409,   410,   651,   412,   413,   414,   415,     0,
     416,   417,   418,   419,  1043,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   653,   448,     0,
       0,   654,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   655,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,   540,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,  1384,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,  2213,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,  2214,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,  2215,   441,   442,  2216,   444,  2217,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,  2562,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,  2575,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,  2614,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,  3288,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,  3290,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,  3292,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,  3439,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   620,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   628,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   646,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   647,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   648,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   649,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   650,
     406,   407,   408,   409,   410,   651,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   652,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   653,   448,
       0,     0,   654,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   655,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     678,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   763,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   825,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,     0,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   849,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   854,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   862,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   864,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   866,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,     0,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   868,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   871,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   873,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   874,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,     0,   469,     0,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   877,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,   447,   448,     0,     0,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,     0,   469,     0,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   646,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     649,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,     0,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
     650,   406,   407,   408,   409,   410,   651,   412,   413,   414,
     415,     0,   416,   417,   418,   419,  1043,     0,   421,   422,
     423,   424,     0,   425,   426,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,   653,
     448,     0,     0,   654,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,     0,   459,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,     0,   469,
       0,   470,   471,   472,     0,     0,   473,     0,     0,   474,
     475,   476,   477,   655,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,  1071,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,     0,     0,     0,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,     0,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,     0,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,     0,   469,     0,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,  1362,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,  1364,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,     0,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,     0,
     469,     0,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,   405,   406,
     407,   408,   409,  1458,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
       0,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,     0,   469,     0,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   646,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   649,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,     0,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   650,   406,   407,   408,   409,
     410,   651,   412,   413,   414,   415,     0,   416,   417,   418,
     419,  1043,     0,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,  1740,   443,
     444,   445,   446,     0,   653,   448,     0,     0,   654,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
       0,   459,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,     0,   469,     0,   470,   471,   472,     0,
       0,   473,     0,     0,   474,   475,   476,   477,   655,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   646,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   649,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   650,   406,   407,   408,   409,   410,  1774,   412,
     413,   414,   415,     0,   416,   417,   418,   419,  1043,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   653,   448,     0,     0,   654,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   655,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,  2005,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,  1268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   698,   207,
     208,   209,     0,  1269,   699,  1270,  1271,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,  1272,  1273,   223,
       0,   224,   225,   226,   227,     0,     0,     0,   229,   230,
     231,   232,   700,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   701,   244,   245,     0,
       0,     0,   702,     0,     0,     0,   246,   247,   248,   249,
     250,   251,  1274,  1275,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   967,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,     0,   279,   280,     0,
       0,   282,     0,   283,  1276,   285,     0,   286,     0,   287,
     703,     0,   704,   288,   289,   290,     0,   291,     0,     0,
     293,     0,   294,   295,   296,   297,   298,   705,   299,   300,
     301,  1779,   302,   303,   304,   305,   306,   307,     0,   308,
     706,  1780,   310,   311,   312,   313,  1277,  1278,     0,  1279,
       0,   317,   707,   708,   318,   709,   319,   320,   321,   322,
     323,   324,   325,     0,     0,   710,   327,   711,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1280,   712,  1281,
     346,   347,   348,   349,   350,   351,   352,     0,   354,     0,
     355,   356,   713,   357,     0,     0,   359,  1282,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
    1781,   714,   715,   716,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,   377,     0,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1283,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,   717,   405,   406,     0,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,  1782,   423,   424,   718,   425,
    1285,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,  1286,  1287,     0,     0,   449,
       0,   451,     0,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,     0,  1288,  1783,   469,   719,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
     191,     0,     0,     0,     0,     0,     0,     0,   487,   488,
     489,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,  2340,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,     0,     0,     0,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
       0,   469,     0,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,  2342,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,     0,   469,     0,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,  1268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   698,   207,
     208,   209,     0,  1269,   699,  1270,  1271,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,  1272,  1273,   223,
       0,   224,   225,   226,   227,     0,     0,     0,   229,   230,
     231,   232,   700,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   701,   244,   245,     0,
       0,     0,   702,     0,     0,     0,   246,   247,   248,   249,
     250,   251,  1274,  1275,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   967,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,     0,   279,   280,     0,
       0,   282,     0,   283,  1276,   285,     0,   286,     0,   287,
     703,     0,   704,   288,   289,   290,     0,   291,     0,     0,
     293,     0,   294,   295,   296,   297,   298,   705,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     706,     0,   310,   311,   312,   313,  1277,  1278,     0,  1279,
       0,   317,   707,   708,   318,   709,   319,   320,   321,   322,
     323,   324,   325,     0,     0,   710,   327,   711,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1280,   712,  1281,
     346,   347,   348,   349,   350,   351,   352,     0,   354,     0,
     355,   356,   713,   357,  1770,     0,   359,  1282,   361,   362,
       0,     0,   363,     0,     0,   364,   365,   366,     0,     0,
       0,   714,   715,   716,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,   377,     0,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1283,   390,   391,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,     0,   403,   404,   717,   405,   406,     0,   408,
     409,   410,   411,   412,   413,   414,   415,     0,   416,   417,
     418,   419,   420,     0,   421,  1782,   423,   424,   718,   425,
    1285,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,     0,   439,   440,  2999,   441,   442,
     443,   444,   445,   446,     0,  1286,  1287,     0,     0,   449,
       0,   451,     0,     0,   453,   454,   455,   456,   457,   458,
       0,     0,   459,   460,   461,   462,     0,     0,   463,   464,
     465,   466,     0,  1288,     0,   469,   719,   470,   471,   472,
       0,     0,   473,     0,     0,   474,   475,   476,   477,   478,
    1268,     0,     0,     0,     0,     0,     0,     0,   487,   488,
     489,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   698,   207,   208,   209,     0,  1269,
     699,  1270,  1271,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,  1272,  1273,   223,     0,   224,   225,   226,
     227,     0,     0,     0,   229,   230,   231,   232,   700,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   701,   244,   245,     0,     0,     0,   702,     0,
       0,     0,   246,   247,   248,   249,   250,   251,  1274,  1275,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   967,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,     0,   279,   280,     0,     0,   282,     0,   283,
    1276,   285,     0,   286,     0,   287,   703,     0,   704,   288,
     289,   290,     0,   291,     0,     0,   293,     0,   294,   295,
     296,   297,   298,   705,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   706,     0,   310,   311,
     312,   313,  1277,  1278,     0,  1279,     0,   317,   707,   708,
     318,   709,   319,   320,   321,   322,   323,   324,   325,     0,
       0,   710,   327,   711,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1280,   712,  1281,   346,   347,   348,   349,
     350,   351,   352,  1826,   354,     0,   355,   356,   713,   357,
       0,     0,   359,  1282,   361,   362,     0,     0,   363,     0,
       0,   364,   365,   366,     0,     0,     0,   714,   715,   716,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
     377,     0,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1283,   390,   391,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,   717,   405,   406,     0,   408,   409,   410,   411,   412,
     413,   414,   415,     0,   416,   417,   418,   419,   420,     0,
     421,  1284,   423,   424,   718,   425,  1285,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,  1286,  1287,     0,     0,   449,     0,   451,     0,     0,
     453,   454,   455,   456,   457,   458,     0,     0,   459,   460,
     461,   462,     0,     0,   463,   464,   465,   466,     0,  1288,
       0,   469,   719,   470,   471,   472,     0,     0,   473,     0,
       0,   474,   475,   476,   477,   478,  1268,     0,     0,     0,
       0,     0,     0,     0,   487,   488,   489,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     698,   207,   208,   209,     0,  1269,   699,  1270,  1271,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,  1272,
    1273,   223,     0,   224,   225,   226,   227,     0,     0,     0,
     229,   230,   231,   232,   700,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   701,   244,
     245,     0,     0,     0,   702,     0,     0,     0,   246,   247,
     248,   249,   250,   251,  1274,  1275,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   967,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,     0,   279,
     280,     0,     0,   282,     0,   283,  1276,   285,     0,   286,
       0,   287,   703,     0,   704,   288,   289,   290,     0,   291,
       0,     0,   293,     0,   294,   295,   296,   297,   298,   705,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   706,     0,   310,   311,   312,   313,  1277,  1278,
       0,  1279,     0,   317,   707,   708,   318,   709,   319,   320,
     321,   322,   323,   324,   325,     0,     0,   710,   327,   711,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1280,
     712,  1281,   346,   347,   348,   349,   350,   351,   352,  2840,
     354,     0,   355,   356,   713,   357,     0,     0,   359,  1282,
     361,   362,     0,     0,   363,     0,     0,   364,   365,   366,
       0,     0,     0,   714,   715,   716,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,   377,     0,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1283,
     390,   391,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,     0,   403,   404,   717,   405,   406,
       0,   408,   409,   410,   411,   412,   413,   414,   415,     0,
     416,   417,   418,   419,   420,     0,   421,  1284,   423,   424,
     718,   425,  1285,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,  1286,  1287,     0,
       0,   449,     0,   451,     0,     0,   453,   454,   455,   456,
     457,   458,     0,     0,   459,   460,   461,   462,     0,     0,
     463,   464,   465,   466,     0,  1288,     0,   469,   719,   470,
     471,   472,     0,     0,   473,     0,     0,   474,   475,   476,
     477,   478,   191,     0,     0,     0,     0,     0,     0,     0,
     487,   488,   489,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,     0,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,     0,
       0,     0,   368,   369,   370,   371,   372,     0,   374,     0,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   405,   406,   407,     0,   409,   410,
     411,   412,   413,   414,   415,     0,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,     0,   425,   426,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,     0,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,     0,
     459,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,     0,   469,     0,   470,   471,   472,     0,     0,
     473,     0,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,  1268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,   698,   207,   208,   209,     0,  1269,   699,
    1270,  1271,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,  1272,  1273,   223,     0,   224,   225,   226,   227,
       0,     0,     0,   229,   230,   231,   232,   700,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   701,   244,   245,     0,     0,     0,   702,     0,     0,
       0,   246,   247,   248,   249,   250,   251,  1274,  1275,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   967,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,     0,   279,   280,     0,     0,   282,     0,   283,  1276,
     285,     0,   286,     0,   287,   703,     0,   704,   288,   289,
     290,     0,   291,     0,     0,   293,     0,   294,   295,   296,
     297,   298,   705,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   706,     0,   310,   311,   312,
     313,  1277,  1278,     0,  1279,     0,   317,   707,   708,   318,
     709,   319,   320,   321,   322,   323,   324,   325,     0,     0,
     710,   327,   711,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,  1280,   712,  1281,   346,   347,   348,   349,   350,
     351,   352,     0,   354,     0,   355,   356,   713,   357,     0,
       0,   359,  1282,   361,   362,     0,     0,   363,     0,     0,
     364,   365,   366,     0,     0,     0,   714,   715,   716,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,   377,
       0,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1283,   390,   391,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,     0,   403,   404,
     717,   405,   406,     0,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   416,   417,   418,   419,   420,     0,   421,
    1284,   423,   424,   718,   425,  1285,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
    1286,  1287,     0,     0,   449,     0,   451,     0,     0,   453,
     454,   455,   456,   457,   458,     0,     0,   459,   460,   461,
     462,     0,     0,   463,   464,   465,   466,     0,  1288,     0,
     469,   719,   470,   471,   472,     0,     0,   473,     0,     0,
     474,   475,   476,   477,   478,  1268,     0,     0,     0,     0,
       0,     0,     0,   487,   488,   489,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,   698,
     207,   208,   209,     0,  1269,   699,  1270,  1271,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,  1272,  1273,
     223,     0,   224,   225,   226,   227,     0,     0,     0,   229,
     230,   231,   232,   700,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   701,   244,   245,
       0,     0,     0,   702,     0,     0,     0,   246,   247,   248,
     249,   250,   251,  1274,  1275,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   967,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,     0,   279,   280,
       0,     0,   282,     0,   283,  1276,   285,     0,   286,     0,
     287,   703,     0,   704,   288,   289,   290,     0,   291,     0,
       0,   293,     0,   294,   295,   296,   297,   298,   705,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   706,     0,   310,   311,   312,   313,  1277,  1278,     0,
    1279,     0,   317,   707,   708,   318,   709,   319,   320,   321,
     322,   323,   324,   325,     0,     0,   710,   327,   711,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1280,   712,
    1281,   346,   347,   348,   349,   350,   351,   352,     0,   354,
       0,   355,   356,   713,   357,     0,     0,   359,  1282,   361,
     362,     0,     0,   363,     0,     0,   364,   365,   366,     0,
       0,     0,   714,   715,   716,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,   377,     0,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1283,   390,
     391,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,     0,   403,   404,   717,   405,   406,     0,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   416,
     417,   418,   419,   420,     0,   421,  1782,   423,   424,   718,
     425,  1285,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,  1286,  1287,     0,     0,
     449,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,     0,   459,   460,   461,   462,     0,     0,   463,
     464,   465,   466,     0,  1288,     0,   469,   719,   470,   471,
     472,     0,     0,   473,     0,     0,   474,   475,   476,   477,
     478,  1268,     0,     0,     0,     0,     0,     0,     0,   487,
     488,   489,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,   698,   207,   208,   209,     0,
    1269,   699,  1270,  1271,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,  1272,  1273,   223,     0,   224,   225,
     226,   227,     0,     0,     0,   229,   230,   231,   232,   700,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   701,   244,   245,     0,     0,     0,   702,
       0,     0,     0,   246,   247,   248,   249,   250,   251,  1274,
    1275,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   967,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,     0,   279,   280,     0,     0,   282,     0,
     283,  1276,   285,     0,   286,     0,   287,   703,     0,   704,
     288,   289,   290,     0,   291,     0,     0,   293,     0,   294,
     295,   296,   297,   298,   705,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   706,     0,   310,
     311,   312,   313,  1277,  1278,     0,  1279,     0,   317,   707,
     708,   318,   709,   319,   320,   321,   322,   323,   324,   325,
       0,     0,   710,   327,   711,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1280,   712,  1281,   346,   347,   348,
     349,   350,   351,   352,     0,   354,     0,   355,   356,   713,
     357,     0,     0,   359,  1282,   361,   362,     0,     0,   363,
       0,     0,   364,   365,   366,     0,     0,     0,   714,   715,
     716,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,   377,     0,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1283,   390,   391,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,     0,
     403,   404,   717,   405,   406,     0,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   416,   417,   418,   419,   420,
       0,   421,     0,   423,   424,   718,   425,  1285,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,  1286,  1287,     0,     0,   449,     0,   451,     0,
       0,   453,   454,   455,   456,   457,   458,     0,     0,   459,
     460,   461,   462,     0,     0,   463,   464,   465,   466,     0,
    1288,     0,   469,   719,   470,   471,   472,     0,     0,   473,
       0,     0,   474,   475,   476,   477,   478,  1268,     0,     0,
       0,     0,     0,     0,     0,   487,   488,   489,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   698,   207,   208,   209,     0,     0,   699,     0,     0,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
       0,     0,   223,     0,   224,   225,   226,   227,     0,     0,
       0,   229,   230,   231,   232,   700,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   701,
     244,   245,     0,     0,     0,   702,     0,     0,     0,   246,
     247,   248,   249,   250,   251,     0,     0,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,     0,
     279,   280,     0,     0,   282,     0,   283,     0,   285,     0,
     286,     0,   287,   703,     0,   704,   288,   289,   290,     0,
     291,     0,     0,   293,     0,   294,   295,   296,   297,   298,
     705,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   706,     0,   310,   311,   312,   313,     0,
       0,     0,     0,     0,   317,   707,   708,   318,   709,   319,
     320,   321,   322,   323,   324,   325,     0,     0,   710,   327,
     711,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   712,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   354,     0,   355,   356,   713,   357,     0,     0,   359,
       0,   361,   362,     0,     0,   363,     0,     0,   364,   365,
     366,     0,     0,     0,   714,   715,   716,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   377,     0,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   390,   391,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   403,   404,   717,   405,
     406,     0,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   416,   417,   418,   419,   420,     0,   421,     0,   423,
     424,   718,   425,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,     0,     0,
       0,     0,   449,     0,   451,     0,     0,   453,   454,   455,
     456,   457,   458,     0,     0,   459,   460,   461,   462,     0,
       0,   463,   464,   465,   466,     0,     0,     0,   469,   719,
     470,   471,   472,     0,     0,   473,     0,     0,   474,   475,
     476,   477,   478,     0,     0,     0,     0,     0,     0,     0,
       0,   487,   488,   489
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,    49,   176,    35,    17,   694,
     853,    11,  1169,   541,   606,   607,    22,    26,   159,   611,
     860,    21,    28,   647,   514,   889,    43,   174,   926,  1067,
    1153,   696,   912,   180,  1386,   726,  1425,  1130,    22,   721,
     166,   188,   770,  1316,    28,  1209,   172,  1067,   167,    49,
     173,   170,   824,  1524,   737,   178,   939,  1284,   553,   994,
    1217,  1218,   557,    12,   187,   555,  1159,   186,  2089,   965,
     966,  1347,   567,   654,  2333,   507,  2227,  1330,  2551,   732,
    1118,   754,  1316,  1316,    23,  1989,  1316,  1067,   984,  1787,
    1788,   764,    21,  1316,  1825,  1069,    35,  1316,  1118,  2402,
     803,  2404,   755,   756,    42,   758,  1153,    45,  1462,   762,
    1093,   801,   765,  1682,  2063,  2505,   146,   549,  1994,  1995,
    2466,  3000,   650,   574,   803,  2225,    18,  2771,  2791,  1382,
     880,  1202,   805,  2000,     0,     0,     0,   810,  1118,    39,
       0,  1115,   161,     0,   817,  3174,  1159,  1693,  1118,  1688,
    3010,   161,  2973,   826,     5,   845,     9,   727,     5,  2505,
    2946,   161,     0,     0,   732,     7,     0,     0,   955,   956,
      31,    43,    14,    57,  2485,  2486,  2487,  2488,  2489,  2490,
       5,  2685,    26,    27,  2978,  3025,  3180,  3027,     5,     0,
       0,    50,    77,   980,   764,    25,    13,    59,    50,     9,
     128,     5,    70,  2223,  2224,  1936,   889,   799,    22,    13,
      57,    35,    22,     5,   691,    29,    66,     5,     0,   170,
     691,    13,   156,   926,     5,   150,   104,     9,    35,    16,
       5,    50,    57,     5,     5,   170,     5,   151,     5,     0,
      22,     5,     5,    72,   182,     5,   150,   926,    81,    11,
       5,     5,  1906,   104,     5,  3535,   189,   150,  3325,   153,
    3542,  1011,    11,   150,    50,    59,   152,   258,   150,   131,
      18,   248,     5,  1311,    36,   280,   251,   248,   154,   133,
      74,  2012,   153,  2014,   113,   147,   230,   109,   230,   104,
     258,  1311,    34,   151,   288,   785,     9,  2129,  2130,   150,
       9,   144,  2134,   219,  1103,   149,     4,   151,  3522,   158,
       4,     9,   150,   150,    22,     9,   150,     3,     4,     5,
      81,   111,   155,     9,  3496,   307,  1054,    97,   251,   317,
    1243,  1311,   170,   170,   210,   108,   170,   131,    50,   150,
     150,  2173,  2174,   294,   514,   307,   133,   298,   876,   496,
    1053,   325,  1287,   147,   501,  1037,  3785,   307,   346,   170,
     170,   889,    11,   141,   108,    76,   861,   145,   150,    11,
    1053,   150,   323,   121,  1057,  1058,    22,   503,  1274,  1275,
    2662,    56,    57,    29,   334,   555,  1282,    36,   170,   512,
     509,   170,   315,   516,   155,    22,     5,  3183,   314,   387,
     374,   123,    29,   526,  2686,   524,  1249,   118,   116,   267,
    1113,   230,   374,  1253,   299,     5,   278,   190,   104,   545,
    3849,   426,   917,   309,   318,  1338,   552,   169,   243,   207,
     273,   356,   426,   928,  1113,   379,   427,   266,  2828,   430,
     891,   300,   393,  3657,   426,   940,   190,   318,   300,   426,
    1153,   426,  3624,   347,  1137,   426,   305,  3737,    22,  3526,
    1143,  1114,   430,   356,   197,   612,   408,   297,   301,  3498,
     328,   325,   250,   349,  2785,   351,   347,  1180,   364,   309,
     627,   300,  2828,   243,   278,  1272,  1273,  1461,   413,   498,
     261,  1529,   243,  1265,  1281,   430,   430,   430,   426,   367,
     647,  1180,   188,   428,   323,   356,   356,  1190,   370,  1529,
    1193,  1194,   426,  1241,   300,  3301,   330,   664,  3358,   343,
     307,   350,  1050,  1176,   210,  1198,   430,  1200,  2067,  3811,
     360,   575,   541,   542,  3328,   413,   343,  1417,   325,   686,
     301,   385,   426,   430,  1247,   430,   294,   577,   430,  1529,
     320,     8,   374,   694,   426,  1782,  1246,  3343,  2578,   384,
     393,  1264,   413,  3777,    11,   426,  2297,  1250,  1247,  3073,
      11,   430,   425,  3602,   574,   575,   370,   428,   430,   426,
     586,  1284,   588,  1151,   590,  1264,   376,  1561,   300,  1262,
     596,   429,   429,  1088,   427,   429,   429,   535,  3592,  2750,
    1764,   426,   586,  1306,   588,   497,   590,   417,   418,   426,
    1301,   620,   596,   597,   598,   785,  1186,  2928,   429,   429,
     739,   740,   426,  2162,   573,   394,  2324,  1306,  2326,   384,
     394,   640,   393,  1110,   426,   417,   418,   646,   426,  1110,
     649,   650,   651,   412,   430,   426,   575,   429,   412,   775,
    3436,   426,  1355,   243,   426,  2755,   782,   426,  3444,   426,
     422,  2565,   426,   426,  1787,  2569,   427,   389,   429,  3698,
     424,   426,   426,   422,   428,   109,  1355,   133,   797,   617,
     827,   828,   829,  3543,   330,   685,   685,   685,   685,   685,
      97,  3512,  1182,   106,   813,   814,  1495,    41,  1736,   393,
    1487,  1488,  2248,   330,   417,   418,   832,   271,   417,   418,
    1460,   830,  1462,  1989,  2445,  2446,  1736,   426,    85,   417,
     418,    22,  1472,   417,   418,  1475,  3755,   336,   337,   104,
     668,   417,   418,  1483,  1484,    11,  3441,  3442,   857,   858,
     253,    72,    63,  1335,   191,   674,  1496,  1497,   648,   183,
     191,  3445,   652,   737,   258,   145,  1736,  1507,   600,     8,
      36,   130,    11,    18,    23,  2236,  1736,    68,  2466,   916,
     419,   420,   421,   422,    75,    72,  1814,   419,   420,   421,
     422,  1794,   113,   193,   151,   349,  2440,   351,  3667,  2443,
    2444,   800,   939,  2447,  1814,   141,   154,   254,   152,   145,
    3829,   193,    74,  2457,   105,  1429,  1430,  2505,    11,  3503,
     104,    59,   179,  1851,   106,    37,   113,    32,   187,   685,
     685,   685,   166,   230,  1527,   685,   170,   194,   685,   109,
     243,  1851,   104,    36,  1814,  2667,    58,   204,  2670,  2671,
    2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,  1527,   152,
     285,  2549,   210,    72,   265,    30,   104,   121,  1981,   109,
     227,   207,   206,   238,   109,  1360,   121,   876,   385,   325,
    3343,   121,    97,   174,  1369,   285,  1366,   150,    98,   104,
     889,    18,   316,   294,   397,   252,  1381,    24,   121,   258,
     325,   891,   298,   285,   113,  2727,  2728,   112,  2765,  3593,
     254,  1972,   867,   183,   250,   889,   296,  3601,     8,   256,
     142,    11,   346,   878,   923,   191,  1063,   323,   265,    18,
     920,   920,     5,   427,  1356,   184,   430,  3590,  1423,   104,
     251,  1426,     3,  1428,     5,   266,  1431,   304,   183,   374,
     374,  1392,   191,   835,   238,  2221,   238,   381,   309,   949,
     252,   254,  3738,   173,  3598,  3599,   413,   414,   415,   393,
     417,   418,   419,   420,   421,   422,   238,  1011,   968,   266,
     417,   418,   419,   420,   421,   422,   417,   418,   419,   420,
     421,   422,     5,   327,   121,   189,   252,  3692,   191,   192,
     238,   349,   426,   351,   315,   243,  3147,   229,   998,   360,
     369,  3304,   317,  1493,  1013,   254,  3157,   132,    51,   376,
     265,  1011,  1182,   238,  1023,   426,    59,   311,  1165,   350,
     430,   104,   121,  1314,  1033,   275,     5,   296,    99,   387,
     278,   346,  1928,    22,   298,   338,   316,   338,   241,   386,
    1331,  1050,   290,  3143,  1053,   305,   171,   266,  1057,  1058,
     104,  1081,   894,   350,   896,  3155,   898,    74,   900,   323,
     902,   903,   904,     8,  3454,   298,    11,   909,   323,  1053,
     170,   277,   387,  1057,  1058,    48,  1223,  1096,  1097,  1782,
    1099,   104,   315,    28,  1787,  1788,  1096,  1097,   346,  1099,
     323,   191,   163,  1865,   374,  1798,  1096,  1097,  1245,  1099,
    1219,  1220,  1221,  1222,   116,  1228,   118,  2939,  3454,  3753,
     335,  3060,  3016,   338,   230,   375,  2154,  3021,   363,  1798,
    3024,  2159,   370,    96,   393,   345,   346,   116,   265,   374,
    2828,   350,  1251,  1252,  2154,    11,  3012,   154,  1257,  2159,
     256,   417,   418,   419,   420,   421,   422,  2311,   219,   265,
     191,   222,   358,  1137,   254,  1838,   173,   294,   424,  1143,
      36,   430,   428,  1846,  2007,  1848,   265,   210,   417,   418,
     419,   420,   421,   422,  2154,  2015,   356,   393,   394,  2159,
      81,     5,   107,    66,    99,  1957,  1958,  1959,  1960,   395,
    1174,    74,  1315,   210,  2763,   294,  1366,   356,  1207,   172,
    2323,   426,  1321,  1322,  1323,  1324,  1190,  1330,   106,  1193,
    1194,   252,   107,  1916,   417,   418,   419,   420,   421,   422,
    2874,  1347,  2611,  1349,  1371,   264,  2880,  2881,  2882,  2883,
    2884,  2885,  1358,  1380,  2507,   358,   248,  1916,   413,   116,
     257,   118,   167,   314,  1391,   218,   191,   220,   163,   424,
     430,   426,   427,   428,   155,   430,   163,   230,   426,  1382,
     316,   277,   316,   379,    96,  3738,  1250,  2250,  1387,  3420,
    3421,   430,   167,  2507,  2507,  2249,  2323,  2507,  1981,   177,
     104,    99,  1429,  1430,  2507,  3117,  3118,  2641,  2507,  2565,
     346,   264,   346,  2569,   107,   588,   589,   590,  1793,  1425,
     593,   594,   595,  3034,   219,  3036,  1738,   222,  1317,   254,
     603,  2001,   219,   413,   414,   415,  1998,   417,   418,   419,
     420,   421,   422,  1493,   134,   381,   299,   381,   376,   141,
    2129,  2130,   349,  3636,   351,  2134,   407,   393,    96,   393,
     238,   108,   358,   360,   358,   163,  2599,  1347,     0,  2099,
     141,   238,   145,   370,   167,   309,  3377,   109,   430,    43,
     333,   238,   155,   309,  2402,  2403,  2404,   284,   393,   429,
     426,   248,   426,  2056,  2173,  2174,  2079,   170,   426,   395,
    2537,   395,  2402,  2403,  2404,  1350,   218,  3646,   220,   109,
     394,   308,  1392,  1437,  1359,   207,   283,  2147,  1830,   314,
    2079,   219,  1367,  1368,   222,   430,   360,   314,   412,  1556,
    3431,    95,  3433,    85,   360,     5,   207,   175,  1565,     9,
    1385,  2301,  1832,   190,   294,  2463,  2176,  1455,   298,   196,
     265,   183,   145,  2329,  1163,  3586,   265,  1437,   250,    20,
     349,   393,   351,  2463,    26,    27,  1446,  1446,  1446,  1446,
    1446,  3355,   165,   323,   393,  2926,  1984,   152,    39,   294,
     218,  2211,   220,   183,  1393,   294,  2504,  1877,   413,   414,
     415,  1480,   417,   418,   419,   420,   421,   422,   430,   151,
     348,  1210,  1211,  2463,  2504,   180,   315,   239,   240,  1473,
    1474,   430,   407,    59,   323,   285,   314,  1481,   182,    81,
    2028,  1485,  1486,  1441,     4,   295,   316,   179,    74,     9,
     303,   426,   265,    97,   104,  1454,  1500,  1495,  1502,  2795,
     240,   103,   194,   393,  2504,   393,   394,   109,   145,   319,
     265,   265,   204,  1533,   413,   280,   346,  1521,   104,  1523,
     106,   294,  1689,   265,  1691,   298,   230,    34,   165,   428,
    3382,    73,   134,    40,  2237,   227,   313,  2052,   426,   294,
     294,  1403,   315,  1405,   316,  1407,  1575,  1409,   247,  1411,
     323,   381,   294,  1415,  3406,  3407,  1554,   116,    22,   118,
     265,   315,   130,   393,    28,  3239,  3240,   316,   424,   407,
     252,   197,   428,   141,   346,   257,   316,   145,   426,   892,
     139,   183,   895,   125,   897,  2579,   899,   151,   901,   294,
    1733,   177,   905,   298,  1737,   394,   426,   346,   356,   425,
    2323,  2324,   374,  2326,   430,   756,   346,   758,   312,   381,
    2321,   394,   304,   412,   765,   179,  2516,  1760,   323,   187,
     393,   393,  2266,   427,  3115,  1768,   430,   426,  2622,   412,
     194,     5,   381,  2234,   374,   360,    10,  2814,  2815,   207,
     204,   381,  2700,   426,  1811,    19,  2369,    97,  2371,  1792,
     130,   425,   238,   393,   426,   296,   430,   243,   200,   201,
    2700,   141,    36,   313,  2146,   145,  2148,  2149,   421,  1812,
    2369,   213,  2371,   426,   265,   428,  1696,   426,  1510,   238,
    1706,  1513,   250,  2193,   243,  2869,   426,    78,  1831,   248,
     258,  1834,   278,    81,   421,  1680,  1744,   165,  1746,   426,
    2700,   428,  1706,   294,   290,  1844,   349,   187,   351,  1852,
    3562,  3752,   173,  2707,   316,   103,   427,  1860,  2441,   430,
    3016,   109,    97,   265,   315,  3021,  1869,   207,  3024,   307,
     308,  2634,   323,  1876,  2689,  2690,  3454,   424,  2411,   426,
     304,  1690,  2441,  2466,   346,  1774,   134,   252,     8,   307,
     308,    11,   257,  1892,   393,   394,   427,     0,  3509,   430,
    1899,  1900,  1901,  1902,  1903,  1904,   410,   411,    28,  2827,
     250,  2829,   374,  1940,  2289,  2290,    36,  2292,   258,   381,
     311,    41,  2505,   385,   370,   311,    47,  2827,   311,  2829,
     424,   393,   426,   197,   428,   183,  2854,  3471,   426,  2522,
     428,   369,   427,   362,   313,   430,   348,  2725,   350,  2475,
    2476,  2477,   371,  2536,  2854,   427,     9,   348,   430,  3537,
     393,   394,   348,  2522,   426,   348,  2549,  2827,   427,  2829,
     427,   430,   426,   430,  1838,  1974,   426,  2536,    81,   426,
     252,   428,  1846,  1989,  1848,   430,   427,    43,  2667,   430,
    2993,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,
    2679,  2584,   393,   394,  2977,  3112,   426,   393,   394,  1898,
     393,   394,  2011,   349,  2013,   351,  2391,  1906,  2893,  2894,
     427,    47,  2897,   430,  2899,  2584,   349,   130,   351,   369,
      86,  2807,   930,   931,  2506,   426,  2796,  2797,   141,   427,
     426,   429,   145,   426,  2267,  2268,   166,   150,  2727,  2728,
     170,   427,   155,   429,   110,   158,    18,   160,   688,    37,
     690,  1925,    24,   409,  2647,  1989,  2696,  1956,   316,   193,
     428,   191,   192,   129,   427,   427,  3427,   430,   430,   427,
     255,   252,   430,  2666,   187,   255,   206,   427,  2647,  1978,
     146,   356,   255,  1973,  1973,  1984,   252,   427,   346,     0,
     430,    63,   409,    37,   207,   161,   419,  2666,  2691,  1989,
     427,   409,   427,   430,  1943,   430,   427,   193,   238,   430,
    2495,   241,  2497,   323,   427,    18,   374,   430,  2570,   149,
    2572,    24,  2691,   381,   254,   427,   430,   257,   430,  2028,
    2548,   427,  2725,  2193,   430,   393,  2890,   250,   116,  2757,
     118,   427,   114,   427,   430,   258,   430,   427,   426,   121,
     430,  2006,   124,    47,   427,   427,  2725,   430,   430,   427,
      63,   139,   430,   427,   427,  2020,  2021,   430,   426,  2024,
      81,     8,  2747,  2748,    11,  2030,   427,   243,  2215,   430,
     427,   427,  2056,   430,   430,   251,   427,   427,   301,  3355,
     430,    28,   427,   427,   426,   430,   430,   327,   427,  2230,
    2260,   430,   428,   175,   427,  2221,   427,   430,   396,   430,
     427,   114,   426,   430,   426,  3494,   145,   283,   121,   130,
     427,   124,  2803,   430,  2609,   427,   252,   428,   430,  2266,
     141,   205,   376,   346,   145,  2828,  2091,   427,   427,   150,
     430,   430,  2176,   427,   155,   252,   430,   158,  2633,   160,
    2939,   427,   427,   247,   430,   430,   369,   427,   230,   426,
     430,  2129,  2130,   313,  2277,   243,  2134,   197,   426,    59,
     248,  3437,   175,   393,    31,   427,   187,   390,   430,   392,
     393,   396,    37,   413,   414,   415,  2176,   417,   418,   419,
     420,   421,   422,   265,   427,   425,   207,   430,    37,   427,
    2190,   431,   430,   265,   427,  2173,  2174,   430,   426,  2216,
    2217,   424,   145,   365,   427,   428,   429,  2890,   427,  2209,
      71,   430,   294,  3251,   281,   427,   298,   230,   430,  3342,
     427,  2221,   376,   430,   427,  3123,   135,   430,  2237,   250,
    3002,  3251,     8,   315,   135,    11,   427,   258,   426,   430,
     427,   323,  2365,   430,   191,   427,   135,   427,   430,  2372,
     430,  2235,   265,  2237,  2957,   427,   135,   135,   430,  3535,
      36,  3613,   396,  3615,   427,    41,  3304,   430,   252,   427,
     427,  3251,   430,   430,   362,   430,  2285,   135,  2957,   427,
     301,   294,   430,   371,  3304,   298,   427,   135,   427,   430,
    2993,   430,   135,   135,   135,   135,  2466,   252,   135,   135,
     346,   426,   315,    31,   426,     5,   205,   254,   146,     5,
     323,   145,  2435,   145,   426,   426,   426,   426,  3117,  3118,
     274,   426,     5,    49,   426,   346,   426,     5,     5,   426,
     426,   426,   426,   426,   426,  2505,   426,  2302,     5,   426,
     426,   426,   262,   426,    31,   426,   426,   426,   369,   426,
     426,   426,  3102,   426,    80,    87,   430,    31,   205,   145,
     250,   145,  2890,   356,   356,     8,   428,  3050,    11,   390,
    2517,   392,   393,   356,   356,   196,  2341,   356,  2343,  2388,
    2527,  3261,   252,   315,   356,    28,   356,   243,   356,  3253,
       8,    66,   252,    11,   170,  2542,   175,   375,   356,  2408,
     356,   426,   430,   424,   315,   376,   427,   428,   429,  3112,
      28,   137,   265,   376,   265,   191,   192,    98,     8,   356,
    3123,    11,   356,   356,    47,    47,   356,  3520,   426,   356,
     256,  2440,   356,   356,  2443,  2444,   311,   356,  2447,  2565,
     356,   356,   168,  2569,  3123,   252,  2593,   252,  2457,  2596,
     356,   191,   393,  2462,    31,   384,    30,  2466,  2953,  2954,
     426,  3737,   426,    20,   426,   241,   413,   414,   415,   104,
     417,   418,   419,   420,   421,   422,  2599,   387,   254,   376,
     213,   386,  2466,    31,   145,  2611,   426,  2634,  3386,  2473,
    2474,  2614,    31,  3196,  2478,  3160,  2505,   312,  3180,   197,
     376,   135,   390,  3206,   135,   376,   135,   135,   247,   381,
    2519,   356,   301,  2636,  2498,   242,   389,  3196,   150,   426,
     224,  2505,   409,   354,    11,   224,   430,  3206,   323,   354,
     426,   426,   356,   150,   427,   358,   430,   164,  2547,  2548,
    2540,  2540,   187,   164,   413,  3668,   430,   253,   191,   430,
    3045,  3046,  3047,   248,   356,   356,   311,   356,  2558,  2558,
      73,   427,   311,   426,   376,  2565,   252,   426,   259,  2569,
     195,   195,   298,   191,   300,  3248,   302,   243,   243,   243,
     430,   356,   308,  3382,   356,   294,   294,   294,   356,   315,
       8,   320,   356,    11,   191,  2742,  2743,   323,  3636,    31,
     285,   191,   191,  3483,   191,   331,   376,  3406,  3407,   376,
     191,   254,   191,   339,   251,   426,  3636,   413,  2583,  3776,
    2620,  2620,  2587,    30,  2589,   356,  2591,  2592,   426,   145,
     424,   424,   356,   356,   356,  2600,   254,   147,   248,   413,
     320,   417,   418,   419,   420,   421,   422,    31,   426,   252,
     252,   162,   145,   162,    31,   135,   252,  3360,  2828,   430,
     426,   252,   388,   320,   254,  3563,   145,  3417,   426,  2795,
    2635,   170,   170,  3163,   170,   396,   430,    19,  2801,   156,
     221,  3360,   252,  3386,   430,    47,   427,   150,   430,  2667,
     427,  2735,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,
    2678,  2679,  2711,   150,   409,   356,   426,  3386,  3606,   427,
    3302,   427,  3610,  3611,   427,   427,   427,   427,   390,   261,
    2737,  2738,  2739,  2740,   427,  3253,   427,   409,    13,  3224,
    3225,    13,  3227,   427,   427,  2735,   207,   427,   427,  2862,
     252,  2864,   356,   427,   252,  2754,   379,   426,   255,  2727,
    2728,  3454,   181,   243,   427,   426,   426,   426,  3622,   135,
      49,   135,   196,  3562,  3607,   196,   207,   269,  3608,   269,
     413,   414,   415,   191,   417,   418,   419,   420,   421,   422,
    2927,   373,   191,   356,   356,   356,   216,   356,   216,   216,
     356,    80,   356,   356,   356,   413,   414,   415,  2945,   417,
     418,   419,   420,   421,   422,   191,   191,     3,   191,   191,
     191,   191,   424,   314,   427,  2962,   222,  3567,   427,  2828,
     207,   256,   365,   413,   414,   415,   296,   417,   418,   419,
     420,   421,   422,   413,  3537,  2844,   254,  2843,  2847,    97,
    2849,   393,   426,   251,  2828,   427,   159,   430,   137,     8,
     252,   356,    11,  3348,   194,   260,   194,   248,   426,  2843,
    3563,   376,   427,  3358,   133,  2874,   426,   311,   311,   311,
     376,  2880,  2881,  2882,  2883,  2884,  2885,    36,   133,   168,
     430,  2890,    41,   255,  3563,   430,    31,  3028,   424,   127,
    3016,   150,    11,   145,   427,  3021,   427,   427,  3024,    57,
    3585,  3525,   386,  3606,    49,   150,  2890,  3610,  3611,   426,
     158,   145,   253,   427,   181,   365,   365,   356,  2902,  2903,
     356,  2930,  2931,  2932,  2933,   413,   145,  3606,   191,  2913,
     427,  3610,  3611,   427,   426,    80,  3686,   356,   427,   356,
     191,   427,   427,    31,   427,   427,  2930,   425,  3438,   425,
     396,   195,   427,    23,   426,    25,  3799,   426,   145,    29,
     393,  2939,   430,    33,    34,    35,   427,    37,  3458,    39,
      40,   430,    42,   176,    44,    45,   265,    69,   348,   393,
     194,  2990,   430,   356,   320,   155,   426,  3134,  3135,  3136,
    3137,   391,   137,  3163,   150,   150,   414,   415,   391,   417,
     418,   419,   420,   421,   422,   294,   426,   166,   430,   298,
     426,   170,   427,   302,   427,   426,  3016,   427,    47,   308,
     160,  3021,    31,   168,  3024,   356,   315,   150,   427,   427,
     427,   365,   191,   192,   323,   393,   243,   243,   413,    18,
      49,   430,   331,   191,   135,    24,   111,   206,   243,   106,
     339,   430,   197,  3548,   425,   177,   152,   150,   376,   376,
    3179,  3180,   122,   389,    97,   393,  3050,  3032,   150,   426,
     426,    80,   178,   426,  3039,  3040,   255,   150,   426,  3202,
     426,   380,   241,   332,    63,   392,   268,   252,   427,   290,
    3213,   393,   427,   376,  3622,   254,   166,   167,   168,   388,
     170,   426,   172,   173,   174,  3697,   176,  3226,   178,   145,
     180,   427,   182,   427,   426,    31,   186,   187,   188,   243,
     217,   173,  3617,   426,   134,   256,    59,   308,   137,   255,
     308,    59,    47,   258,   426,   114,   252,   145,   348,  3117,
    3118,   140,   121,   282,  3172,   124,   255,   255,   117,  3158,
     380,   430,    31,   298,   150,   390,   288,   302,   430,   168,
     393,  3167,   122,   308,    31,   252,   252,   393,   327,   426,
     315,   427,   426,   307,   427,   109,   374,     8,   323,   426,
      11,    17,    28,  3167,   134,   426,   331,  3193,   197,   307,
     685,  1942,   282,  1231,   339,  2237,   175,  2827,  3345,  2462,
    1820,  1058,   730,  3474,  3694,    36,  3251,  3622,  3520,  3193,
      41,  3295,  2296,  2981,  3524,  2045,  3757,  3437,  3798,  3724,
    3204,  3205,    31,  3723,  3766,  3209,  3210,  2983,  1764,  3355,
    3239,  3240,  3197,  3198,  2854,  3544,  2403,  1930,  3801,  2518,
      49,  1332,  3862,   388,  3253,  3854,  3269,   392,   393,  3258,
    3259,   230,  1318,  3262,  3263,   414,   415,  3268,   417,   418,
     419,   420,   421,   422,  2504,  3773,  2468,  3460,  3438,  3705,
      28,    80,  3278,  1309,     8,  3463,   918,    11,  3589,  3053,
    3668,  2991,   542,  1788,  3454,  3782,   265,  2993,  3458,   298,
    3856,    18,  3510,   302,  3278,   663,  1691,    24,   129,   308,
    2974,  1690,    36,  2621,  1393,  3314,   315,    41,  3308,  3308,
    2246,  3437,   678,  2257,   323,   294,  1726,  1105,  1087,   298,
    3439,  1106,   331,  2263,  1725,  1108,  2269,  2221,   137,  1709,
     339,  3457,  3341,  1989,  1683,   166,    63,  2571,  3356,   170,
    2971,   668,   535,  2247,   323,  2710,  1915,  2702,  3565,  3746,
    3497,  3747,  3750,  2190,  2260,  3355,  2068,  2101,  1557,   168,
     191,   192,  2188,    -1,    -1,    -1,    -1,    -1,  3494,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,  3525,   388,
      -1,    -1,    -1,   392,    -1,    -1,    -1,   114,   197,    -1,
      -1,    -1,    -1,    -1,   121,    -1,    -1,   124,  3363,    -1,
    3365,  3366,    -1,    -1,  3382,    -1,    -1,    -1,    -1,  3535,
     241,  3376,    -1,    -1,    -1,  3534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,   496,    -1,  3406,  3407,
      -1,   501,   166,   503,    -1,    -1,   170,   507,    -1,   509,
      -1,    -1,   512,    -1,   514,  3454,   516,   517,   175,    -1,
      -1,    -1,    -1,  3600,   524,    -1,   526,   191,   192,    -1,
      -1,    -1,  3471,    -1,    -1,   535,  3475,    -1,    -1,    -1,
    3454,   541,   206,  3592,    -1,   545,    -1,    -1,    -1,   549,
      -1,    -1,   552,    -1,     8,   555,    -1,    11,    -1,   298,
      -1,    -1,    -1,   302,    -1,  3614,   327,  3616,    -1,   308,
     570,    -1,    -1,   230,    28,   575,   315,   241,    -1,    -1,
      -1,    -1,    36,    -1,   323,     8,    -1,    41,    11,    -1,
     254,    -1,   331,    -1,  3694,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,    -1,    28,    -1,    -1,   265,    -1,
      -1,    -1,   612,    36,    -1,    -1,    -1,   617,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   627,   628,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   298,    -1,    -1,    -1,   645,    -1,   647,   648,   388,
     650,    -1,   652,   392,  3562,    -1,   417,   418,   419,   420,
     421,   422,    -1,   327,   664,  3560,   323,    -1,   668,    -1,
      -1,   671,    -1,    -1,  3730,    -1,   676,    -1,  3727,    -1,
      -1,  3737,    -1,  3622,    -1,    -1,   686,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3591,    -1,    -1,    -1,
      -1,    -1,    -1,  3759,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,  3763,    -1,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,   739,
     740,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,   413,
     414,   415,   206,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,   775,    -1,    -1,    -1,    -1,
      -1,    -1,   782,   206,   238,   785,    -1,   241,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,   797,    -1,    -1,
     254,    -1,  3858,   257,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,   813,   814,   238,    36,    -1,   241,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,   827,   828,   829,
     830,   254,   832,    -1,   257,    -1,    -1,    -1,    -1,  3813,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3782,  3782,  3782,  3782,  3782,   857,   858,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3809,    -1,    -1,   327,    -1,    -1,   876,    -1,    -1,    -1,
     880,    -1,    -1,  3813,  3813,  3813,  3813,  3813,    -1,   889,
      -1,     8,    -1,    -1,    11,  3809,    -1,    -1,  3793,    -1,
      -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,
      -1,   911,   912,    -1,    -1,  3854,   916,    -1,   918,    36,
      -1,    -1,    73,  3862,    41,    -1,  3856,  3856,  3856,  3856,
    3856,    82,    83,    84,    -1,    -1,   936,    -1,    -1,   939,
    3854,    -1,   942,    -1,    -1,    -1,   166,    -1,  3862,    -1,
     170,    -1,    -1,   953,    -1,    -1,    -1,    -1,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,   191,   192,    -1,    -1,   126,   430,    -1,    -1,    -1,
      -1,   981,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,  1008,  1009,
      -1,  1011,   129,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,   241,    -1,    -1,   175,    -1,    -1,    -1,  1028,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
    1050,    -1,    -1,   170,    -1,    -1,    -1,  1057,  1058,    -1,
      -1,    -1,    -1,  1063,   215,    -1,  1066,    -1,    -1,    -1,
      -1,  1071,    -1,  1073,   191,   192,    -1,    -1,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,    -1,    -1,   206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1098,    -1,
      -1,    -1,  1102,  1103,    -1,    -1,    -1,   327,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,   269,    -1,
      -1,    -1,    -1,  1123,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    31,   254,    -1,    -1,
      -1,    36,    -1,    -1,    -1,  1145,    41,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1159,
      -1,    -1,    -1,    -1,    -1,  1165,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   342,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,   427,    -1,    -1,
     327,    -1,    -1,    -1,    -1,    -1,    -1,   368,    -1,  1219,
    1220,  1221,  1222,  1223,   375,    -1,    -1,   378,  1228,    -1,
    1230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1243,     8,  1245,    -1,    11,    -1,    -1,
      -1,  1251,  1252,    -1,    -1,    -1,    -1,  1257,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    36,    -1,    -1,   170,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,
      -1,   206,    -1,    -1,    -1,  1315,    -1,    -1,    -1,    -1,
      -1,  1321,  1322,  1323,  1324,    -1,    -1,    -1,    -1,    -1,
    1330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1338,    -1,
      -1,    -1,    -1,   238,    -1,    -1,   241,  1347,    -1,  1349,
      -1,    -1,    -1,    -1,    -1,    -1,  1356,    -1,  1358,   254,
      -1,    -1,   257,    -1,    -1,    -1,  1366,    -1,    -1,    -1,
      -1,  1371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1380,    -1,  1382,    -1,    -1,    -1,  1386,  1387,    -1,    -1,
      -1,  1391,    -1,  1393,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1425,    -1,   191,   192,  1429,
    1430,    -1,   327,    -1,    -1,    -1,    -1,  1437,    -1,    -1,
      -1,  1441,   206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1454,  1455,    -1,    -1,  1458,    -1,
    1460,    -1,  1462,    -1,    -1,    -1,    -1,    -1,    -1,  1469,
      -1,    -1,  1472,    -1,   238,  1475,    18,   241,    -1,    -1,
      -1,    -1,    24,  1483,  1484,    -1,    -1,    -1,    -1,    -1,
     254,  1491,    -1,  1493,  1494,  1495,  1496,  1497,    -1,    -1,
      -1,    -1,    -1,    -1,  1504,  1505,    48,  1507,    -1,  1509,
      -1,    -1,  1512,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    63,   417,   418,   419,   420,   421,   422,  1528,    -1,
      -1,    -1,  1532,    -1,    -1,    -1,  1536,    -1,    -1,    -1,
    1540,    -1,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,    -1,  1552,    -1,    96,    -1,  1556,  1557,    -1,  1559,
      -1,    -1,    -1,   327,    -1,  1565,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,
      -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,    -1,    28,   175,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,   220,    -1,
      -1,    -1,  1682,    -1,    28,    -1,    -1,    -1,   230,  1689,
      -1,  1691,    36,  1693,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1733,    -1,    -1,    -1,  1737,  1738,    -1,
      -1,    -1,    -1,    -1,  1744,    -1,  1746,    -1,    -1,    -1,
      -1,    -1,   294,    -1,    -1,    -1,   298,   299,    -1,    -1,
    1760,  1761,    -1,    -1,    -1,    -1,    -1,    -1,  1768,    -1,
     166,    -1,    -1,   315,   170,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   333,  1792,    -1,  1794,   191,   192,    -1,    -1,    -1,
    1800,    -1,    -1,    -1,    -1,  1805,    -1,    -1,    -1,    -1,
     206,  1811,  1812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,  1824,  1825,   170,    -1,    -1,    -1,
    1830,  1831,    -1,    -1,  1834,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,  1844,   241,    -1,   191,   192,    -1,
      -1,    -1,  1852,    -1,    -1,    -1,  1856,    -1,   254,    -1,
    1860,   257,   206,    -1,    -1,    -1,    -1,    -1,    -1,  1869,
      -1,    -1,    -1,    -1,    -1,    -1,  1876,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1892,    -1,   238,    -1,    -1,   241,    -1,  1899,
    1900,  1901,  1902,  1903,  1904,    -1,    -1,    -1,    -1,    -1,
     254,    -1,    -1,   257,  1914,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,   327,    -1,    -1,    -1,    -1,  1936,    -1,    -1,     7,
    1940,    -1,    28,    -1,  1944,    13,    14,    -1,    -1,    -1,
      36,    -1,    20,    -1,    22,    41,    -1,    -1,    -1,    -1,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,  1968,    -1,
      -1,    -1,    -1,    -1,  1974,  1975,    -1,    -1,    -1,    -1,
      48,    -1,    -1,   327,  1984,    -1,    -1,    -1,    -1,  1989,
    1990,    -1,    -1,    -1,  1994,  1995,    -1,    -1,    -1,  1999,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2011,  2012,  2013,  2014,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,  2028,    -1,
      -1,   427,    -1,  2033,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2061,    -1,    -1,    -1,    -1,    -1,    -1,  2068,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
     166,    -1,    -1,   427,   170,    -1,    -1,    -1,    -1,  2089,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,  2099,
    2100,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,     8,
      -1,   179,    11,   181,    -1,   183,    -1,   185,    -1,    36,
     206,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,  2129,
    2130,    -1,    -1,    -1,  2134,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,  2146,  2147,  2148,  2149,
      -1,    -1,   238,    -1,    -1,   241,    -1,    -1,  2158,    -1,
      -1,  2161,    -1,  2163,  2164,    -1,    -1,    -1,   254,    -1,
      -1,   257,    -1,  2173,  2174,    -1,  2176,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2189,
      -1,  2191,    -1,  2193,    -1,  2195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2211,   129,    -1,    -1,  2215,    -1,    -1,    -1,     8,
      -1,  2221,    11,  2223,  2224,  2225,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,  2237,    -1,    28,
    2240,   327,    -1,    -1,    -1,    -1,  2246,    36,  2248,   166,
      -1,    -1,    41,   170,    -1,    -1,    -1,  2257,    -1,    -1,
      -1,    -1,  2262,    -1,    -1,    -1,  2266,   166,    -1,  2269,
      -1,   170,    -1,    -1,   191,   192,    -1,  2277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
      -1,    -1,   191,   192,    -1,  2295,    -1,  2297,    -1,    -1,
      -1,  2301,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   254,    -1,    -1,
      -1,   427,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2365,    -1,    -1,    -1,    -1,
      -1,    -1,  2372,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
     327,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,    -1,  2435,   504,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2445,  2446,    -1,    -1,   238,
     518,   519,   241,    -1,    -1,   523,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   532,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,   561,    -1,   563,    -1,   565,    -1,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2516,  2517,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,  2527,    -1,    -1,
      -1,    -1,   600,    -1,    -1,    -1,    -1,    -1,   327,    -1,
      -1,    -1,  2542,    -1,    -1,    -1,     8,    -1,  2548,    11,
      -1,    -1,    -1,    -1,    -1,   623,    -1,   625,    -1,  2559,
      -1,    -1,  2562,    -1,    -1,  2565,    -1,    -1,    -1,  2569,
      -1,    -1,    -1,    -1,    36,  2575,    -1,    -1,  2578,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2593,    -1,    -1,  2596,    -1,    -1,  2599,
      -1,    -1,    -1,  2603,    -1,    -1,    -1,    -1,    -1,    -1,
     678,  2611,    -1,    -1,  2614,    -1,    -1,    -1,    -1,    -1,
      -1,  2621,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  2634,    -1,  2636,    -1,   427,    -1,
      -1,    -1,    -1,    -1,  2644,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2653,    -1,    -1,    -1,    -1,    -1,  2659,
      -1,  2661,    -1,    -1,    -1,    -1,    -1,  2667,    -1,    -1,
    2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,
      -1,    -1,    -1,  2683,  2684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2696,    -1,   766,    -1,
      -1,    -1,  2702,    -1,   166,    -1,    -1,    -1,   170,    -1,
     778,    -1,  2712,    -1,    -1,  2715,    -1,  2717,    -1,   787,
     803,    -1,    -1,    -1,    -1,   793,  2726,  2727,  2728,   191,
     192,    -1,  2732,    -1,    -1,  2735,   804,    -1,    -1,    -1,
      -1,    -1,  2742,  2743,   206,  2745,    -1,    -1,    -1,    -1,
      -1,  2751,    -1,  2753,    -1,  2755,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2763,    -1,   833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,  2795,  2796,  2797,    -1,    -1,
      -1,  2801,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2820,    -1,    -1,    -1,    -1,    28,   894,    -1,   896,    -1,
     898,    -1,   900,    36,   902,   903,   904,    -1,    41,    -1,
      -1,   909,    -1,   926,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2862,    -1,  2864,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2927,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2939,
      -1,    -1,    -1,    -1,    -1,  2945,    -1,    -1,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,  2962,   166,    -1,    -1,    -1,   170,    -1,    -1,
      -1,  2971,    -1,    -1,    -1,    -1,    -1,  2977,    -1,    -1,
      -1,  2981,    -1,  2983,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,  2994,  2995,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3012,    -1,    -1,    -1,  3016,    -1,    -1,  1087,
      -1,  3021,    -1,    -1,  3024,  3025,    -1,  3027,    -1,    -1,
    1113,    19,    -1,    -1,  3034,   238,  3036,    -1,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   254,    -1,  3053,   257,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3066,  1135,    -1,    -1,
    1153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    83,    84,  1180,    -1,    28,
      -1,    -1,  3102,    -1,    -1,    -1,    -1,    36,    -1,  3109,
    3110,    -1,    41,    -1,    -1,    -1,    -1,  3117,  3118,    -1,
      -1,    -1,  3122,    -1,   327,    -1,    -1,    -1,  3128,  3129,
      -1,    -1,  3132,    -1,  3134,  3135,  3136,  3137,   126,    -1,
      -1,    -1,    -1,  3143,    -1,    -1,    -1,    -1,    -1,  3149,
      -1,    -1,    -1,    -1,    -1,  3155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3163,  1247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3172,    -1,    -1,  3175,    -1,    -1,    -1,  3179,
    3180,  1264,   170,    -1,    -1,    -1,    -1,   175,    -1,    -1,
      -1,    -1,    -1,    -1,  3194,    -1,    -1,    -1,    -1,    -1,
      -1,  1284,  3202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     413,   414,   415,  3213,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,  1306,   427,    -1,  3226,   215,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,  1307,
      -1,   170,    -1,   231,   232,   233,   234,   235,    -1,   237,
      -1,  1319,    -1,  3253,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3261,   191,   192,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,  1355,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,
      -1,    -1,    -1,  1361,  3294,    36,    -1,    -1,    -1,    -1,
      41,    -1,  1370,    -1,  1372,    -1,  1374,    -1,    -1,   238,
      -1,  1379,   241,    -1,    -1,    -1,    -1,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,    -1,    -1,  1403,    -1,  1405,    -1,  1407,
      -1,  1409,    -1,  1411,    -1,  3345,    -1,  1415,    -1,    -1,
      -1,  3351,    -1,   166,   342,  3355,   344,    -1,  3358,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3377,    -1,    -1,
     368,    -1,  3382,    -1,    -1,    -1,    -1,   375,   129,    -1,
     378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3406,  3407,    -1,    -1,
    3410,    -1,     8,    -1,    -1,    11,    -1,  3417,  3418,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,  3431,    28,  3433,    -1,    -1,    -1,  3437,  3438,  3439,
      36,    -1,    -1,    -1,  1527,    41,    -1,    -1,    -1,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,  3457,  3458,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3483,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  3494,    -1,    -1,  3497,   427,    -1,
     241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3509,
      -1,  3511,    -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,
    3520,    -1,    -1,    -1,    -1,  3525,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3534,  3535,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3562,    -1,    -1,  3565,    -1,  3567,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   803,    -1,    -1,
    3580,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,
      -1,    -1,  3592,    -1,    -1,   191,   192,    -1,    -1,    -1,
    3600,    -1,    -1,  3603,    -1,    -1,    -1,    -1,    -1,    -1,
     206,    -1,    -1,  3613,  3614,  3615,  3616,    -1,    -1,    -1,
      -1,    -1,  3622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,  3643,    -1,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,    -1,
      -1,   257,    -1,    -1,    -1,    -1,  1734,    -1,    -1,    -1,
      -1,    -1,  1740,    -1,    -1,    -1,   417,   418,   419,   420,
     421,   422,  1750,    -1,    -1,    -1,  3686,    -1,     8,  1757,
     503,    11,    -1,    -1,  3694,  1763,    -1,    -1,    -1,  1782,
     926,  1769,    -1,    -1,  1787,  1788,  1774,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,  1798,    36,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,  3727,    -1,    -1,
    3730,   327,   545,  1801,  1802,  1803,  1804,  3737,    -1,   552,
    1808,  1809,    -1,    -1,    -1,  1813,  3746,    -1,  1816,  3749,
    3750,    -1,  3752,    -1,    -1,    -1,    -1,    -1,    -1,  3759,
      -1,    -1,    -1,  3763,    -1,    -1,    -1,  1835,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1845,    -1,  1847,
      -1,    -1,    -1,    -1,    -1,  3785,    -1,    -1,    -1,  1857,
    1858,  1859,    -1,  1861,    -1,  3795,    -1,    -1,    -1,    -1,
      -1,    -1,  1870,  1871,    -1,    -1,    -1,    -1,    -1,  3809,
    1878,  1879,    -1,    -1,    -1,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    -1,    -1,
      -1,   427,   645,  1916,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,  3849,
     170,    -1,    -1,    -1,  3854,    -1,    -1,    -1,  3858,    -1,
      -1,    -1,  3862,   676,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,  1113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1981,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,   241,    -1,    -1,    -1,    -1,    -1,  1153,    28,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    36,   257,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   775,    -1,    -1,    -1,    -1,    -1,    -1,   782,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     803,    -1,    -1,    -1,    -1,    28,  2079,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,   327,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2085,    -1,   832,
      -1,  1247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,   880,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,   206,   427,    -1,    -1,
      -1,    -1,    -1,   926,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1355,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,   238,    -1,
     953,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,   257,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   981,    -1,
      -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1008,  1009,    -1,  1011,    -1,
      -1,    28,    -1,    -1,    -1,   238,    -1,    -1,   241,    36,
    2278,  2279,    -1,    -1,    41,  1028,    -1,    -1,    -1,    -1,
      -1,   254,    -1,    -1,   257,    -1,    -1,   327,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2323,  2324,  2310,  2326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1066,  1067,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2344,  2345,  2346,  2347,
      -1,    -1,    -1,    -1,    -1,  1098,  2369,    -1,  2371,  1102,
    1103,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,
    1113,  1527,    -1,    -1,    -1,  1118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,   427,    -1,    -1,
      -1,    -1,    -1,  1559,    -1,    -1,    -1,    -1,    -1,   166,
    1153,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2441,    -1,
      -1,    -1,    -1,  2431,   191,   192,    -1,  1180,  2436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     413,   414,   415,  2466,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   238,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2505,    -1,    -1,    -1,    -1,   254,    -1,    -1,
     257,    -1,    -1,    -1,  1247,    -1,    -1,    -1,    -1,  2522,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1264,    -1,  2536,    -1,  2523,  2524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2549,    -1,    -1,    -1,
      -1,  1284,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1306,    -1,    -1,    -1,    -1,  1311,    -1,
     327,  2584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   803,    -1,    -1,    -1,    -1,    -1,  2585,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2598,    -1,    -1,    -1,  1347,    -1,  1349,    78,    -1,    -1,
      -1,    -1,  1355,    -1,    -1,  1358,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1782,    98,    -1,    -1,
      -1,  1787,  1788,   104,  2647,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1798,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,  2666,    -1,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,     8,    -1,
     427,    11,    -1,    -1,    -1,    -1,   147,    -1,  2691,    -1,
      -1,   152,  1425,    -1,    -1,    -1,    -1,   158,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    41,   173,    -1,   926,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2725,    -1,    -1,    -1,    -1,  1460,    -1,  1462,
      -1,    -1,    -1,    -1,    -1,    -1,  1469,   198,    -1,  1472,
      -1,    -1,  1475,    -1,    -1,     8,    -1,    -1,    11,    -1,
    1483,  1484,    -1,    -1,    -1,    -1,    -1,    -1,  1491,    -1,
      -1,  1494,  1495,  1496,  1497,    28,    -1,    -1,    -1,    32,
    1916,  1504,  1505,    36,  1507,    -1,  1509,    -1,    41,  1512,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,  1527,  1528,  1529,    -1,    -1,  1532,
      -1,    -1,    -1,  1536,    -1,    -1,    -1,  1540,    -1,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,    -1,  1552,
     281,    -1,    -1,    -1,  1557,  2828,  1559,    -1,    -1,    -1,
    2818,    -1,    -1,    -1,    -1,  1981,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,   305,    -1,    -1,    -1,    -1,   112,
     311,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2858,    -1,    -1,    -1,    -1,  2863,   206,  2865,  2866,  2867,
    2868,    -1,    -1,    -1,    -1,   346,    -1,   348,    -1,    -1,
      -1,   352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,
      -1,  1113,    -1,   166,   365,    -1,    -1,   170,   238,    -1,
      -1,   241,    -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,   387,   257,   191,   192,
      -1,    -1,    -1,  2079,    -1,    -1,    -1,    -1,    -1,     8,
      -1,  1153,    11,   206,    -1,    -1,  2934,  2935,  2936,    -1,
    2938,    -1,    -1,    -1,  2957,    -1,    -1,    -1,    -1,    -1,
    1693,    -1,    -1,    -1,    -1,    -1,    -1,    36,  1180,    -1,
      -1,    -1,    41,    -1,    -1,   238,    -1,    -1,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2993,   254,    -1,    -1,   257,    -1,    -1,   327,    -1,    -1,
      -1,    -1,    -1,  1736,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3010,    -1,    -1,    -1,    -1,    -1,  1761,    -1,
      -1,    -1,    -1,    -1,    -1,  1247,    -1,    -1,    -1,    -1,
      -1,  3029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1782,
      -1,    -1,  1264,    -1,  1787,  1788,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,   327,  1798,    -1,    -1,    -1,    -1,
      -1,    -1,  1284,    -1,    -1,    -1,    -1,  2223,  2224,  2225,
      -1,  1814,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,  1306,   425,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3112,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,  1851,    -1,
    3123,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,  1355,    -1,    -1,    -1,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,  2323,  2324,    -1,
    2326,  1914,    -1,  1916,    -1,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3206,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2369,    -1,  2371,  3214,    -1,    -1,    -1,
      -1,    -1,    -1,   645,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1981,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1989,    -1,   327,    -1,
      -1,    -1,    -1,    -1,   676,    -1,  1999,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2441,    -1,    -1,    -1,    -1,
    2033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,  1527,    -1,    -1,    -1,    -1,
    2466,    -1,  3310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,  2068,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    41,  3332,    -1,  2079,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,  3360,    -1,  2505,
      -1,    -1,    -1,    -1,    -1,    -1,  2099,  2100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2522,    -1,    -1,    -1,
      -1,  3369,    -1,  3386,    -1,    -1,    -1,    -1,    -1,    -1,
    2536,    -1,    -1,    -1,    -1,    -1,  2129,  2130,    -1,    -1,
      -1,  2134,    -1,  2549,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2146,  2147,  2148,  2149,    -1,    -1,    -1,
      -1,  2154,    -1,    -1,    -1,  2158,  2159,    -1,  2161,    -1,
    2163,    -1,  2578,    -1,    -1,    -1,    -1,    -1,  2584,    -1,
    2173,  2174,    -1,  2176,    -1,    -1,    -1,   145,    -1,    -1,
      -1,  3454,   150,    -1,    -1,    -1,  2189,    -1,  2191,    -1,
      -1,    -1,  2195,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,    21,    -1,    -1,    -1,  2211,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2221,    -1,
    2223,  2224,  2225,   191,   192,    -1,    -1,    -1,    -1,    -1,
      -1,  2647,    -1,    -1,   803,    -1,    53,  2240,   206,    -1,
      -1,    -1,    -1,    -1,    -1,  2248,    -1,    -1,    -1,    66,
    2666,    -1,    -1,    -1,  2257,    -1,    -1,    74,    -1,  2262,
      -1,    78,    -1,    -1,  3537,    -1,  2269,    -1,    -1,    -1,
     238,   953,    -1,   241,    -1,  2691,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,  3543,   254,    -1,    -1,   257,
    3563,    -1,  2295,    -1,    -1,    -1,    -1,    -1,    -1,   981,
    1782,    -1,   119,    -1,    -1,  1787,  1788,    -1,    -1,  2725,
      -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,
    2323,  2324,    -1,  2326,    -1,    -1,  1008,  1009,    -1,  1011,
      -1,    -1,    -1,  3606,    -1,   152,    -1,  3610,  3611,  2755,
      -1,    -1,    -1,    -1,    -1,    -1,  1028,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   926,    -1,   327,
      -1,    -1,    -1,    -1,    -1,    -1,  2369,    -1,  2371,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   198,    -1,    -1,  1066,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,  2402,
    2403,  2404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,  2828,    -1,    -1,    -1,  1098,    36,    -1,    -1,
    1102,  1103,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1916,    -1,    -1,   254,  2441,    -1,
      -1,    -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,    -1,
    2463,    -1,    -1,  2466,   281,    -1,    -1,  3725,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   305,    -1,
      -1,    -1,   309,    -1,   311,    -1,    -1,    -1,    -1,  1981,
     317,  2504,  2505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2522,
      -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,   346,
      -1,   348,    -1,  2536,    -1,   352,    -1,    -1,    -1,    -1,
      -1,  2957,    -1,   360,  1113,    -1,  2549,   166,   365,    -1,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2565,    -1,    -1,    -1,  2569,    -1,    -1,    -1,
     387,    -1,   191,   192,    -1,  2578,    -1,  2993,    -1,    -1,
      -1,  2584,    -1,    -1,  1153,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2079,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2611,    -1,
      -1,  1180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   803,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,
      -1,  2644,    -1,    -1,  2647,    -1,    -1,    -1,    -1,    -1,
    2653,    -1,    -1,    -1,   273,    -1,  2659,    -1,  2661,    -1,
      -1,    -1,    -1,  2666,  2667,    -1,    -1,  2670,  2671,  2672,
    2673,  2674,  2675,  2676,  2677,  2678,  2679,    -1,  1247,    -1,
    2683,  2684,    -1,    -1,    -1,    -1,    -1,    -1,  2691,    -1,
      -1,    -1,    -1,  2696,    -1,  1264,  3112,  2700,    -1,  2702,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3123,   327,  2712,
      -1,    -1,  2715,    -1,  2717,  1284,    -1,    -1,    -1,    -1,
      -1,    -1,  2725,  2726,  2727,  2728,    -1,  3143,    -1,  2732,
      -1,    -1,  2735,    -1,    -1,    -1,    -1,  1306,    -1,  3155,
      -1,    -1,  2745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2753,    -1,  2755,    -1,   926,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3196,    -1,    -1,    -1,    -1,    -1,  1355,  1469,    -1,    -1,
    3206,    -1,  2795,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,    -1,  1491,
      -1,    -1,  1494,    -1,    -1,  1497,    -1,    -1,    -1,    -1,
      -1,    -1,  1504,  1505,  2827,  2828,  2829,  1509,   803,    -1,
    1512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2323,  2324,    -1,  2326,    -1,  1528,    -1,    -1,    -1,
    1532,  2854,    -1,    -1,  1536,    -1,    -1,    -1,  1540,    -1,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,    -1,
    1552,    -1,    -1,    -1,    -1,  1557,    -1,  1559,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2369,    -1,  2371,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3342,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2939,    -1,    -1,    -1,
      -1,  1113,    -1,    -1,  3360,    -1,    -1,    -1,    -1,    -1,
      -1,   926,    -1,    -1,  2957,    -1,    -1,    -1,  1527,  2441,
      -1,    -1,    -1,    -1,    -1,    -1,   803,    -1,    -1,    -1,
    3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1153,    -1,    -1,  2466,    -1,    -1,    -1,    -1,    -1,
    2993,  2994,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1180,    -1,
      -1,  1693,    -1,  3016,    -1,    -1,    -1,    -1,  3021,    -1,
      -1,  3024,    -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3454,    -1,
    2522,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3066,    -1,    -1,    -1,  2549,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1247,    -1,    -1,    -1,  1761,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   926,
      -1,    -1,  1264,    -1,    -1,    -1,    -1,    -1,    -1,  3102,
      -1,    -1,  2584,    -1,    -1,    -1,  3109,  3110,    -1,  3112,
      -1,    -1,  1284,    -1,  3117,  3118,    -1,    -1,    -1,  3122,
    3123,  3537,    -1,    -1,    -1,  3128,  3129,    -1,    -1,  3132,
      -1,    -1,    -1,    -1,  1306,    -1,    -1,    -1,  1113,    -1,
    3143,    -1,    -1,    -1,    -1,    -1,    -1,  3563,    -1,    -1,
      -1,    -1,  3155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2647,    -1,    -1,    -1,    -1,
      -1,    -1,  3175,    -1,    -1,    -1,    -1,    -1,  1153,    -1,
      -1,    -1,    -1,  1355,  2666,    -1,    -1,    -1,    -1,    -1,
    3606,    -1,    -1,  3196,  3610,  3611,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3206,    -1,  1180,    -1,    -1,    -1,  2691,
      -1,    -1,    -1,  1782,    -1,    -1,    -1,    -1,  1787,  1788,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1798,
      -1,    -1,  1914,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,  2725,    -1,    -1,    -1,    -1,  3251,    -1,
      -1,    -1,  3668,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    41,  1247,    -1,    -1,    -1,  1113,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1264,
       8,  3294,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1284,
      28,    -1,    -1,    31,    -1,    -1,  1153,  1999,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3342,
      -1,    -1,    -1,  1180,    -1,    -1,  2828,  1916,  3351,    -1,
      -1,  2033,  3355,    -1,    -1,  1527,    -1,  3360,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3382,
    1355,    -1,    -1,  3386,    -1,    -1,  2068,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,  3406,  3407,    -1,    -1,  3410,    -1,    -1,
    1247,    -1,  1981,    -1,  3417,  3418,    -1,    -1,  2100,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,  1264,    -1,    -1,
      -1,    -1,    -1,    -1,  3437,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1284,   166,    -1,
      -1,  3454,   170,    -1,  3457,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2146,    -1,  2148,  2149,   238,  1306,
      -1,   241,    -1,   191,   192,  2957,  2158,    -1,    -1,  2161,
      -1,  2163,    -1,    -1,   254,    -1,    -1,   257,   206,    -1,
      -1,  3494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   275,    -1,  2189,    -1,  2191,
    2079,  2993,    -1,  2195,    -1,    -1,    -1,    -1,  1355,    -1,
     238,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3535,    -1,  3537,    -1,   254,    -1,    -1,   257,
      -1,  2223,  2224,  2225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1527,    -1,    -1,    -1,    -1,   327,  2240,  3562,
    3563,    -1,  3565,    -1,  3567,    -1,  2248,    -1,    -1,    -1,
     340,    -1,    -1,    -1,    -1,  2257,    -1,    -1,    -1,    -1,
    2262,    -1,    -1,    -1,    -1,    -1,    -1,  2269,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3603,    33,    -1,  3606,    -1,    -1,    -1,  3610,  3611,   327,
    1782,    -1,    -1,  2295,    -1,  1787,  1788,    -1,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,
    3112,    -1,    -1,  3636,    -1,    -1,    -1,    -1,    -1,    -1,
    3643,  3123,    74,   413,   414,   415,    78,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3668,    98,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,  3686,    -1,    -1,    -1,   119,    -1,    -1,
    1527,    -1,    -1,    -1,  1024,   413,   414,   415,    28,   417,
     418,   419,   420,   421,   422,    -1,    36,    -1,    -1,    -1,
      -1,    41,    -1,    -1,  3196,   147,    -1,    -1,    -1,    -1,
      -1,    -1,   154,    -1,  3206,    -1,   158,  3730,    -1,    -1,
      -1,    -1,    -1,    -1,  3737,    -1,    -1,    -1,    -1,    -1,
      -1,   173,    -1,    -1,  1916,    -1,  3749,  3750,    -1,    -1,
      -1,    -1,    -1,  1083,  2323,  2324,  3759,  2326,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,
      -1,    -1,  3785,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2369,    -1,  2371,    -1,    -1,    -1,    -1,  1782,    -1,  1981,
      -1,    -1,  1787,  1788,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,  1798,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,  3849,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3858,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2441,   305,    -1,    -1,   206,    -1,  3360,   311,
      -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2578,  2466,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,    -1,  2079,   238,    -1,
      -1,   241,    -1,    -1,   346,    -1,   348,   349,    -1,   351,
     352,    -1,    -1,    -1,   254,    -1,    -1,   257,   360,    -1,
      -1,    -1,    -1,   365,    -1,    -1,  2505,    -1,   370,    -1,
     270,  1916,    -1,   375,    -1,  1782,    -1,    -1,    -1,    -1,
    1787,  1788,    -1,  2522,    -1,   387,    -1,    -1,    -1,    -1,
      -1,  1798,  2644,    -1,    -1,    -1,    -1,  2536,    -1,    -1,
      -1,  2653,  3454,    -1,    -1,    -1,    -1,  2659,    -1,  2661,
    2549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,
      -1,  2683,  2684,    -1,    -1,    -1,  1981,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,  2584,    -1,    -1,    -1,    -1,
    2702,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
    2712,    31,    -1,  2715,    -1,  2717,    36,    -1,    -1,    -1,
      -1,    41,    -1,    -1,  2726,    -1,    -1,    -1,    -1,    -1,
    2732,    -1,    -1,  2735,    -1,  3537,    -1,    -1,    -1,  1389,
      -1,    -1,    -1,  2745,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2753,    -1,  2755,    -1,    -1,    -1,    -1,  2647,  1916,
      -1,  3563,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,  2666,    -1,    -1,
      -1,    -1,    -1,    -1,  2079,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2691,    -1,  3606,    -1,    -1,    -1,  3610,  3611,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1467,    -1,    -1,
      -1,    -1,    -1,    -1,  1981,    -1,    -1,    -1,    -1,    -1,
      -1,  2323,  2324,    -1,  2326,    -1,  2725,    -1,    -1,    -1,
    1490,    -1,    -1,    -1,    -1,  1495,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1514,  1515,    -1,  1517,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,  2369,    -1,  2371,
      -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1555,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,   241,  2079,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,  2828,
      -1,  1591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2441,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2466,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2994,  2995,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,
      -1,    -1,    -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2323,  2324,
    2522,  2326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1702,    -1,    -1,    -1,    -1,  2549,    -1,    -1,
      -1,    -1,  1712,    -1,  3066,  1715,    -1,    -1,  2957,    -1,
      -1,    -1,    -1,    -1,  2369,    -1,  2371,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2584,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,  2993,    -1,    -1,  3109,  3110,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3122,    -1,    -1,    -1,    -1,    -1,  3128,  3129,    -1,    -1,
    3132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3143,    -1,    -1,    -1,    -1,  2441,    -1,    -1,    -1,
      -1,    -1,    -1,  3155,    -1,  2647,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2323,  2324,    -1,  2326,
      -1,  2466,    -1,  3175,  2666,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2691,
      28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
    2505,    -1,  2369,    41,  2371,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3112,    -1,    -1,    -1,  2522,    -1,    -1,
      -1,    -1,    -1,  2725,  3123,    -1,    -1,    -1,    -1,    -1,
       8,  2536,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2549,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2441,    -1,    -1,    -1,    -1,  2584,
      -1,    -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3196,    -1,  2466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3206,    -1,    -1,
      -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2828,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,  2505,  3351,
      -1,    -1,  2647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,  2522,    -1,    -1,    -1,    -1,
      -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,   206,  2536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2549,    -1,    -1,    -1,  2691,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,  3410,    -1,
     238,    -1,    -1,   241,    -1,    -1,  3418,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,    -1,   254,  2584,    -1,   257,
    2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2957,    -1,    -1,    -1,    -1,
     238,  3360,    -1,   241,    -1,  2125,    -1,  2127,    -1,  2129,
    2130,  2131,    -1,    -1,  2134,    -1,   254,    -1,  2138,   257,
    2647,    -1,    -1,    -1,    -1,  2145,    -1,  3386,    -1,   327,
    2150,  2993,    -1,    -1,    -1,  2155,    -1,    -1,     8,  2666,
    2160,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2169,
      -1,    -1,    -1,  2173,  2174,  2175,    -1,    -1,    28,    -1,
      -1,    -1,    -1,  2828,  2691,    -1,    36,  2187,    -1,    -1,
      -1,    41,    -1,    -1,  2194,    -1,  2196,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,    -1,    -1,    -1,   327,
      -1,    -1,    -1,  3565,    -1,  3454,    -1,    -1,  2725,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,  2229,
      11,    -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,    28,    -1,    -1,
      31,  3603,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3643,    -1,    -1,    -1,   413,   414,   415,  3537,   417,
     418,   419,   420,   421,   422,  2305,    -1,    -1,    -1,    -1,
      -1,    -1,  2957,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,  2828,    -1,    -1,  3563,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,  2993,    -1,
      -1,    -1,    -1,    -1,  3196,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3206,    -1,    -1,  3606,    -1,    -1,
      -1,  3610,  3611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,   238,   170,
      -1,   241,    -1,    -1,    -1,    -1,    -1,  3749,  3750,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3785,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,  3795,    -1,    -1,    -1,    -1,    36,    -1,
    2957,    -1,    -1,    41,    -1,    -1,    -1,   238,    21,    -1,
     241,    -1,    -1,    -1,    -1,    -1,    -1,  3112,    -1,  2469,
      33,    -1,    -1,   254,    -1,    -1,   257,   327,  3123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,    -1,    -1,
      53,    -1,    -1,    -1,    -1,    -1,    -1,  3849,    -1,    -1,
      -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,  3360,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,   327,    -1,    -1,    -1,
      -1,  3196,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
      -1,  3206,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,  2581,   170,    -1,   147,    -1,    -1,    -1,    -1,   152,
      -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,
      -1,    -1,  2602,   191,   192,  3112,    -1,    -1,    -1,    -1,
     173,    -1,  3454,    -1,    -1,    -1,  3123,    -1,   206,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,  2643,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2664,  2665,   254,  2667,    -1,   257,
    2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,
    2680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3196,
      -1,   254,    -1,    -1,    -1,  3537,    -1,    -1,    -1,  3206,
      -1,   264,    -1,  2703,    -1,    -1,  2706,    -1,  2708,    -1,
      -1,    -1,    -1,  2713,  2714,  3360,    -1,    -1,   281,    -1,
      -1,  3563,    -1,    -1,    -1,    -1,    -1,  2727,  2728,  2729,
      -1,  2731,    -1,    -1,  2734,    -1,    -1,    -1,    -1,   327,
      -1,  3386,   305,    -1,    -1,    -1,   309,    -1,   311,    -1,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,    -1,
      -1,  2761,    -1,    -1,  3606,    -1,    -1,    -1,  3610,  3611,
      -1,    -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   346,    -1,   348,    -1,    -1,    -1,   352,
      -1,    -1,  2792,    -1,    -1,    -1,    -1,   360,    -1,    -1,
      -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,    -1,  3454,
      -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   387,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3563,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2939,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3454,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3606,    -1,    -1,    -1,  3610,  3611,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3563,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3067,    -1,    -1,
    3070,  3071,  3072,    -1,    -1,  3075,    -1,    -1,    -1,    -1,
    3080,  3081,  3082,  3083,  3084,  3085,  3086,  3087,  3088,  3089,
    3090,  3091,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3606,
      -1,    -1,    -1,  3610,  3611,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3116,  3117,  3118,  3119,
      -1,  3121,    -1,    -1,    -1,  3125,  3126,  3127,    -1,    -1,
    3130,    -1,    -1,  3133,    -1,    -1,    -1,    -1,    -1,    -1,
    3140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,  3152,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    -1,    62,    63,    -1,    -1,
      -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,   115,
      -1,   117,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
     136,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3339,
    3340,    -1,   208,   209,    -1,    -1,    -1,    -1,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,  3378,    -1,
      -1,    -1,  3382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3394,    -1,  3396,    -1,    -1,    -1,
      -1,  3401,  3402,  3403,    -1,    -1,  3406,  3407,  3408,  3409,
     276,  3411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,    -1,    -1,    -1,   291,    -1,   293,    -1,    -1,
      -1,    -1,   298,    -1,    -1,  3435,    -1,   303,    -1,    -1,
     306,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
     326,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,    -1,
    3500,    -1,    -1,    -1,    -1,    -1,   372,    -1,   374,    -1,
      -1,   377,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3547,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,  3561,  3562,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3575,  3576,  3577,    -1,  3579,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,  3676,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
    3700,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,  3729,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,  3788,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,  3828,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,   428,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,   116,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,   426,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,     3,    -1,    -1,    -1,    -1,    -1,    -1,   426,   427,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,   204,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,    -1,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
     408,   409,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,   427,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,     3,     4,     5,
       6,     7,     8,     9,    10,   407,   408,   409,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,   427,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,   424,   425,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
      -1,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,    -1,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,    -1,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,    -1,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,    -1,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,   253,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,   253,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,     3,   417,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,   426,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,    -1,   136,   137,    -1,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
       3,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     419,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,    -1,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,   419,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,    -1,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,     3,     4,     5,    -1,    -1,
      -1,     9,   407,   408,   409,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,   419,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,     4,     5,    -1,    -1,    -1,     9,   417,
     418,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
       4,     5,    -1,    -1,    -1,     9,   417,   418,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,     9,   417,   418,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,   150,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,     4,     5,     6,     7,    -1,     9,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,   253,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,   158,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,    -1,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
      -1,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
      -1,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
      -1,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,    -1,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,    -1,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
      -1,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,    -1,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,    -1,    -1,   245,   246,
     247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,    -1,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   408,   409,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,    -1,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,    -1,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,    -1,
     204,   205,   206,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,    -1,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,    -1,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,   408,   409,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,   204,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,    -1,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,    -1,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,    -1,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,    -1,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
     408,   409,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,    -1,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,    -1,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      -1,    -1,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,    -1,    -1,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,    -1,    -1,   140,    -1,   142,    -1,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,    -1,   181,   182,   183,   184,    -1,
      -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,   245,
      -1,   247,   248,    -1,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,    -1,   325,
     326,   327,   328,    -1,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,    -1,    -1,
      -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,    -1,    -1,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,   408,   409
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    40,    60,    62,    63,    67,
      69,    79,    81,   100,   103,   109,   115,   117,   121,   127,
     134,   136,   141,   155,   183,   208,   209,   214,   223,   240,
     276,   287,   291,   293,   298,   303,   306,   310,   316,   323,
     326,   333,   346,   363,   372,   374,   377,   381,   393,   426,
     433,   434,   435,   436,   442,   443,   445,   446,   447,   448,
     449,   450,   451,   453,   454,   458,   468,   470,   471,   474,
     475,   476,   486,   487,   502,   537,   543,   544,   551,   557,
     559,   561,   562,   563,   564,   573,   577,   578,   579,   581,
     582,   583,   597,   598,   599,   600,   611,   617,   618,   621,
     622,   623,   624,   625,   630,   632,   635,   639,   640,   650,
     651,   654,   659,   669,   688,   691,   692,   693,   696,   699,
     701,   703,   706,   709,   710,   711,   713,   720,   721,   723,
     724,   725,   730,   732,   733,   737,   738,   741,   742,   743,
     745,   746,   747,   748,   750,   753,   754,   759,   765,   768,
     770,   771,   776,   778,   782,   789,   793,   794,   795,   796,
     797,   798,   827,   358,   395,   726,    21,    78,    98,   104,
     119,   147,   152,   158,   173,   198,   254,   281,   305,   311,
     317,   320,   346,   348,   352,   360,   365,   375,   387,   558,
     726,     3,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    33,    34,    36,    38,    39,    40,
      41,    42,    44,    45,    47,    48,    49,    50,    51,    54,
      55,    56,    57,    58,    60,    61,    62,    63,    64,    67,
      68,    69,    70,    72,    73,    75,    76,    77,    78,    79,
      80,    82,    83,    84,    86,    87,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   105,   107,   108,   109,   110,
     111,   113,   114,   115,   118,   119,   120,   121,   122,   124,
     125,   126,   128,   129,   131,   132,   133,   134,   135,   136,
     137,   138,   140,   142,   143,   144,   146,   148,   152,   153,
     154,   156,   157,   159,   161,   162,   163,   164,   165,   167,
     168,   169,   171,   172,   173,   174,   175,   176,   178,   180,
     181,   182,   183,   184,   185,   186,   188,   190,   193,   195,
     196,   197,   198,   199,   200,   201,   203,   205,   208,   209,
     210,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   239,   240,   242,   244,   245,
     246,   247,   248,   251,   254,   255,   256,   259,   263,   264,
     265,   266,   267,   268,   269,   271,   272,   273,   274,   275,
     276,   277,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   302,   303,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   317,   318,   319,   320,
     321,   323,   324,   325,   326,   328,   329,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   344,
     345,   347,   348,   349,   350,   351,   352,   354,   355,   358,
     359,   360,   361,   363,   364,   365,   366,   367,   368,   371,
     372,   373,   374,   377,   378,   379,   380,   381,   382,   384,
     386,   387,   388,   391,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     790,   930,   942,   945,   946,   385,   755,   252,   277,   726,
      43,   493,   794,    21,    33,    53,    74,    98,   104,   119,
     147,   154,   158,   210,   254,   257,   305,   311,   320,   348,
     349,   351,   352,   360,   365,   370,   375,   503,   614,   660,
     670,    22,   276,   930,   790,   150,    22,   271,   349,   351,
       5,   197,   697,   698,   939,    21,    33,    53,    78,    98,
     119,   147,   152,   158,   173,   254,   264,   305,   309,   311,
     317,   320,   346,   348,   352,   360,   365,   375,   387,   558,
     626,   726,   930,    81,   385,   426,   537,   754,   760,   768,
     771,   776,   782,   789,   793,     9,    15,    22,    38,   142,
     148,   150,   170,   199,   229,   279,   292,   417,   418,   636,
     637,   790,   938,   941,    22,    81,   290,   316,   641,   642,
     643,   942,   189,   942,   935,   939,   346,   803,   636,   942,
     358,   930,   264,    98,   173,   345,   346,   704,   310,   942,
      22,   321,   354,   358,   460,   942,    19,   155,   641,   642,
     277,   726,   942,    22,   116,   805,    54,    75,   210,   225,
     305,   311,   321,   354,   358,   398,   459,   460,    22,   321,
     354,   358,   460,   358,   253,   836,   928,   942,   803,   419,
     942,   836,   838,   151,   426,   756,   426,   924,   289,   799,
     800,   930,   794,   795,     0,   429,   755,   130,   187,   258,
     369,   806,   807,   794,   796,   797,   430,     3,    37,    43,
      71,    85,    91,   149,   151,   166,   179,   191,   192,   194,
     204,   206,   227,   241,   260,   261,   262,   304,   327,   385,
     936,   942,   943,   945,   947,   628,   942,   931,   942,   280,
     628,    97,   649,   936,   940,   942,   928,   247,     8,    61,
     140,   413,   414,   415,   417,   418,   419,   420,   421,   422,
     695,   891,   892,   942,   940,   930,   928,   930,   836,   930,
     313,   930,   628,   216,   940,   928,   197,   193,   285,   727,
     728,   729,   928,   934,   942,    21,    53,    66,    74,    78,
      98,   119,   152,   173,   198,   254,   305,   309,   311,   317,
     346,   348,   352,   360,   365,   387,   558,   633,   939,   928,
     356,   936,   930,   426,   360,   931,   628,    97,   349,   351,
     940,   349,   351,    61,   140,   695,   296,   940,   455,   942,
     930,   930,   313,   930,   628,   216,   940,   317,   346,   387,
      78,   173,   152,   309,   364,   552,    22,   930,   791,   838,
     467,   939,   942,   698,   165,   936,   930,   165,   702,   165,
     931,    97,   165,   936,   165,   929,   930,    61,   140,   165,
     695,    47,   165,   929,   165,   930,   165,   930,   165,   930,
     313,   165,   930,   165,   216,   929,   197,   165,   627,   628,
     426,   769,   503,   760,   381,   385,   754,   761,   762,   763,
     942,   755,   941,   637,   638,    22,   638,   941,   638,    22,
     638,   941,   638,   638,   638,   941,   938,   938,   790,   638,
     280,   426,   426,   521,   521,   521,   252,   356,   430,   521,
     928,   836,   837,   430,   722,   939,   426,   766,    47,   930,
     930,   928,   942,    37,   409,   193,   428,   255,   255,   252,
     150,   939,   356,   252,     4,     6,     7,     8,    10,    30,
      42,    44,    45,    52,    53,    56,    57,    64,    88,    89,
      90,    91,    92,    93,    94,   101,   102,   120,   135,   138,
     139,   143,   157,   185,   186,   188,   203,   211,   212,   226,
     228,   238,   243,   244,   246,   254,   263,   272,   286,   307,
     322,   329,   341,   354,   355,   359,   361,   362,   370,   375,
     382,   400,   401,   402,   403,   404,   405,   406,   417,   418,
     419,   426,   794,   847,   850,   853,   854,   855,   857,   858,
     859,   860,   863,   864,   868,   870,   871,   889,   893,   912,
     917,   925,   926,   936,   937,   938,   939,   942,   939,    22,
     472,   927,   928,   321,   459,   104,   466,   939,   467,   939,
      37,    58,   459,   409,   728,   255,   150,   356,   413,    37,
     409,   193,   729,   426,   928,   419,   424,   428,   918,   919,
     837,    31,   942,   323,   149,   151,   385,   751,   752,   754,
     149,   757,   104,   868,   922,   923,   799,   430,   426,   758,
     427,   427,   435,   928,    22,   116,   804,   804,    47,   804,
     141,   145,   207,   250,   810,   812,   813,   822,   824,   825,
     806,   807,   924,   426,   605,   919,   265,   294,   428,   629,
     265,   294,   315,   323,   393,   437,   468,   469,   712,   655,
      18,   121,   265,   323,   479,   396,    49,    80,   137,   168,
     265,   294,   302,   308,   315,   323,   331,   339,   388,   469,
     682,   689,   712,   426,   671,    18,   121,   294,   452,    18,
      24,    63,   114,   121,   124,   175,   230,   265,   294,   298,
     323,   477,   478,     4,   418,   549,   938,   941,   628,   628,
     426,   694,   428,   170,   294,   437,   444,   265,   294,   712,
      48,    96,   172,   218,   220,   230,   264,   294,   299,   323,
     333,   477,   546,   547,   712,   256,   265,   386,   567,   575,
      24,   294,   323,   477,   712,   265,   294,   298,   323,    72,
     113,   266,   350,   252,   265,   294,   323,   712,   145,   294,
     323,   437,   469,   294,   323,   477,   712,   930,   205,   253,
     397,   430,   727,   376,   749,   252,   936,   426,   930,   936,
     247,    61,   140,   695,   930,   313,   930,   197,   628,   521,
     336,   337,   489,   939,   426,   605,   606,    59,     3,    42,
      44,    45,    56,    57,   101,   102,   143,   185,   186,   188,
     226,   228,   246,   286,   324,   329,   354,   355,   382,   844,
     846,   848,   850,   852,   854,   855,   856,   858,   859,   863,
     864,   943,   945,   930,   437,    31,   744,   396,   437,   628,
     628,   426,   601,   503,   437,    37,   456,   365,   574,   265,
     560,    72,   113,   266,   350,    20,    39,   584,    31,   601,
     145,   437,   928,   538,   928,   928,   628,    71,   661,   936,
     930,   558,    43,    95,   182,   230,   312,   376,   777,   135,
     605,    50,   300,   480,   135,   426,   135,   396,   135,   671,
     135,   430,   165,   628,   165,   628,   135,   694,   929,   135,
     135,   252,   135,   480,   135,    72,   113,   266,   350,   135,
     252,   135,   145,   165,   165,   467,   135,   430,   480,   868,
     896,   346,   427,   430,   139,   249,   252,   362,   464,   467,
     549,   764,   760,   638,   790,   638,   790,   638,   790,   638,
     790,   638,   790,   790,   790,   638,   790,   426,   522,   523,
     942,   522,    22,    98,   147,   152,   197,   198,   311,   317,
     346,   348,   644,   927,   929,   643,   104,   426,   772,   793,
     170,   430,   779,   939,   844,   899,    31,   929,   146,   705,
     705,   705,   205,   942,   145,   145,   644,   929,   310,   942,
     426,   920,   424,   794,   900,   384,   861,   868,   916,   426,
     861,   861,   426,   426,   426,   426,   849,   849,   274,   794,
     426,   426,   851,   426,   426,   426,   426,    56,    57,   861,
     868,   426,   849,   426,   426,   426,   426,   426,   394,   412,
     426,   865,   426,   865,   426,   426,   794,   426,   426,   426,
     426,   426,   426,   426,   868,   868,   794,   868,   896,   939,
      57,   426,   862,   426,   939,     3,     8,    11,    28,    31,
      36,    41,   166,   170,   191,   192,   206,   238,   241,   254,
     257,   327,   413,   414,   415,   417,   418,   419,   420,   421,
     422,   891,   893,   895,   262,   868,   189,   430,   801,   426,
     939,   919,   107,   167,   473,   430,    58,   104,   467,    31,
       3,   104,   210,   465,   549,   864,   939,    76,   118,   877,
      87,   104,   461,   462,   464,   467,   549,   104,   461,   205,
     928,   868,     3,    22,    26,    27,    28,    29,    30,    31,
      32,    35,    46,    52,    53,    59,    65,    66,    74,    81,
      88,    89,    90,    92,    93,    94,   104,   106,   112,   116,
     117,   123,   127,   130,   139,   141,   145,   147,   150,   155,
     158,   160,   170,   177,   187,   189,   202,   207,   211,   212,
     238,   243,   249,   250,   252,   253,   257,   258,   270,   278,
     290,   301,   316,   322,   330,   343,   346,   353,   356,   357,
     362,   369,   370,   375,   376,   383,   389,   390,   392,   393,
     419,   933,   944,   945,   946,   947,   948,   918,    77,   299,
     631,   942,   426,   783,   784,   785,   786,   787,   942,   427,
     430,   755,   427,   430,   800,   929,    31,   758,   796,   796,
     808,   809,   868,   796,   142,   229,   819,   285,   325,   374,
      22,   814,   868,   815,   817,   868,   870,   822,   823,   813,
     812,   810,   811,   145,   825,   810,   822,   419,   899,   265,
     294,   323,   712,   356,   356,   933,   428,   356,   356,   196,
     348,   459,   739,   145,   155,   170,   303,   656,   657,    59,
      74,   131,   147,   278,   370,   519,   520,    74,   104,   238,
     356,   104,   238,   311,   930,   252,   549,   315,   356,   356,
     243,   549,   108,   190,   311,   300,   315,   682,   690,   170,
     180,   259,   324,   383,   427,   672,   675,   676,   677,   679,
     844,   943,   356,   375,    66,   131,   510,   519,   942,    66,
     707,   252,   309,   360,    74,   707,    25,   297,   309,   360,
     928,   175,   356,   356,   426,   482,   348,   393,   394,   482,
     430,     4,   265,   712,   376,   376,   236,   844,   265,   695,
      98,   356,   439,   469,   356,   356,   549,    47,   548,   549,
     549,    96,   218,   220,    47,   356,   437,   311,   437,   230,
     547,   426,   356,   243,   939,   567,   707,   356,   707,   311,
     356,   356,   482,   482,   628,   628,   628,   628,   928,   356,
     356,   311,    94,   375,   580,   940,   356,   439,   356,   311,
     265,   294,   285,   295,   319,   463,   727,   934,   942,   928,
     605,   844,   252,   671,   549,   628,   628,   694,   191,   252,
      72,   113,   266,   350,   252,   628,   191,   393,   494,   437,
       3,   607,   608,   601,   426,   846,    31,    30,   845,    99,
     163,   219,   222,   314,   407,   426,   866,   867,   629,   849,
      20,   734,   844,   930,   438,   614,   376,   602,   603,   944,
     387,   438,   940,    81,   155,   457,   502,   543,   583,   639,
     659,   730,   939,   575,   576,   930,   213,   628,   628,   628,
     628,   109,   183,   363,   374,   585,   586,   128,   426,   580,
     438,   545,   546,    31,   248,   426,   539,   521,   145,   662,
     934,   426,   673,    31,   197,   393,   394,   792,   312,   426,
     794,   829,   830,   831,   836,   839,   871,   936,   942,   390,
     841,   936,   480,   844,   931,   165,   930,   936,   480,   929,
     930,   135,   376,   135,   376,   695,   480,   480,   929,   930,
     928,   930,   930,   930,   928,   929,   580,   135,   135,   480,
     627,   628,   427,   430,   928,   760,   762,   790,   790,   790,
     790,   790,   790,   522,   427,   430,   427,   153,   318,   347,
     929,    97,   320,   648,   649,   929,   247,   929,   927,   927,
     929,   356,   393,   652,   381,   773,   774,   942,   301,   775,
      16,   133,   307,   325,   780,   836,   242,   781,   427,   430,
     767,   771,   776,   782,   793,   356,   642,   641,   642,   150,
     156,   653,   942,   896,   918,   425,   896,   900,   901,   426,
     389,   913,   914,   868,   896,   938,   938,   896,     3,    99,
     163,   219,   222,   314,   407,   902,   903,   939,   938,   896,
     896,   938,   938,   861,   861,   868,   695,   868,   904,   417,
     418,   869,   870,   889,   893,   906,   427,   896,   868,   896,
     907,   354,   409,   938,   938,   868,    46,   150,   202,   357,
     868,   896,   910,   896,   224,   868,   875,   876,   877,   224,
     868,   877,   427,   430,   323,   938,   938,   866,   844,   868,
     944,   354,    35,   343,   921,   868,   426,   794,   911,   116,
     118,   139,   238,   243,   248,   362,   371,   868,    41,   166,
     170,   206,   327,   426,   868,   356,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,    22,    29,   330,   890,
     307,   426,   889,   154,   210,   346,   349,   351,   802,   928,
     926,   150,   828,    22,   116,   383,   419,   427,   677,   868,
     897,   898,   943,   928,   358,   426,   939,   430,   427,   425,
     431,   164,   164,   480,   787,   788,   430,   828,   413,   920,
     928,   752,   753,   928,   922,   427,   794,   430,    32,   112,
     376,   667,   426,   816,   941,   253,   248,   826,   826,   430,
     307,   308,   818,   823,   811,   427,   427,   356,   356,   311,
     940,   930,   933,   940,   931,   356,   930,    73,   740,   305,
     375,   641,   311,   155,   641,   426,   930,   376,   663,   195,
     195,   426,   930,   243,   940,   868,   243,   930,   230,   265,
     379,   555,   567,   243,   108,   190,   940,   930,   252,   930,
     259,   943,   427,   430,   677,   679,   676,   679,   943,   629,
     940,   929,   510,   844,   942,   930,   930,    22,   375,   930,
     165,   930,   165,   942,   309,   360,   309,   360,   930,    22,
     375,   930,   928,   940,   930,   484,   485,   944,   930,   251,
     315,    63,   251,   315,   478,   356,   932,   942,   932,   430,
     427,   430,   356,   931,   940,    73,    82,    83,    84,   126,
     175,   215,   231,   232,   233,   234,   235,   237,   269,   342,
     368,   375,   378,   440,   940,   930,   549,   628,   930,   549,
     930,   549,    18,   121,   323,   568,   569,   570,   571,   944,
     940,   942,   930,   930,   930,   940,   930,    18,    24,   121,
     265,   294,   265,   294,   601,   294,   294,   294,   940,   930,
     930,   320,   940,   930,   930,   356,   356,    70,   367,   285,
     191,    31,   628,   191,   191,   376,   376,   191,   243,   634,
     939,   628,   628,   628,   628,   628,   628,   191,   634,   251,
     150,   356,   488,   426,   490,   491,   413,   427,   430,   868,
      30,   845,   844,   424,   424,   356,   356,   356,   426,   356,
     938,   849,   585,    73,   125,   200,   201,   213,   265,   348,
     350,   735,   512,   555,   556,    19,   170,   305,   344,   440,
     441,   145,   932,   427,   430,   413,   928,   456,   257,   503,
     147,   939,   601,   601,   601,   601,   248,   252,   257,   426,
     842,   843,   942,   320,   134,   793,   628,   206,   504,   506,
     508,   510,   516,   519,   540,   541,   942,   393,   394,   533,
      31,   939,   252,   427,   674,   675,   680,    31,   197,   302,
     392,   681,   682,   683,   252,   467,   162,   162,   145,   794,
     830,   831,    31,   832,   942,   430,    85,   151,   179,   194,
     204,   227,   304,   833,   832,    31,   832,   942,   426,   919,
      87,   868,   775,   605,    31,   135,   480,   671,   628,   932,
     628,   932,   694,   252,   480,   480,   252,   480,   320,   145,
     467,   480,   868,   426,   427,   523,   170,   170,   170,   396,
     929,   430,   549,   550,   158,   645,   646,   940,    19,   653,
     427,   430,   920,   925,   133,   325,   133,   325,   307,   374,
     221,   844,   930,   150,   252,   645,    47,   480,   427,   425,
     425,   430,   896,   868,   123,   914,   915,    31,   427,   427,
     427,   427,   427,   150,   427,   427,   427,   427,   427,   430,
     427,   270,   905,   427,   869,   869,    11,   170,   191,   254,
     413,   414,   415,   417,   418,   419,   420,   421,   422,   893,
     869,   427,   427,   145,   150,   908,   909,   427,   409,   427,
     427,    31,   910,   896,   910,   910,   150,   427,   427,   944,
      31,   427,   430,   868,   944,   430,   868,   920,   868,   942,
     427,   427,   409,   869,   869,   129,   896,   150,   116,   118,
     139,   243,   248,   362,   371,   426,   129,   343,   921,   868,
     911,   868,   356,   695,   868,   426,   794,   349,   351,   349,
     351,   928,   803,   803,   829,   390,   840,   897,   897,   898,
     427,   261,   882,    13,   427,   430,   807,   728,   938,   866,
     462,   868,   427,   430,   784,   841,   922,   758,   809,   254,
     891,   894,   410,   411,   668,   868,   818,   927,   781,   781,
     815,   940,   930,   930,   939,   207,   929,   929,   252,   929,
     255,   252,   868,   520,   932,   426,   426,   426,   522,   480,
     379,   356,   553,   930,   567,   181,   243,   629,   675,   679,
     679,   421,   512,   121,   298,   323,   479,   708,   135,   480,
     135,   480,   930,   930,   930,   930,   427,   430,   413,   428,
     196,   196,   940,   265,   294,    18,   121,   265,   294,   844,
     236,   844,   940,   207,   269,   243,   939,   269,   929,   373,
     570,   571,   570,   427,   430,   572,   939,   712,   356,   216,
     216,   216,   356,   356,   356,   356,   356,   356,   356,   930,
     940,   930,   634,   844,   191,   634,   634,   932,   932,   634,
     191,   191,   191,   191,   191,   191,   634,   489,   497,   498,
     944,    43,    86,   110,   129,   146,   161,   243,   251,   283,
     492,   254,   417,   418,   549,   604,   679,   894,   939,   948,
       3,   608,   427,   424,   427,   938,   425,   938,   163,   219,
     867,   219,   867,   867,   938,   222,   427,   252,   207,   413,
     736,   736,   736,   736,   736,   736,   736,    59,    74,   104,
     106,   177,   238,   243,   278,   290,   370,   513,   514,   515,
     256,   565,   929,   158,   305,   929,   938,   365,   603,   604,
     521,   296,   346,    97,   522,   928,   586,   609,   610,   939,
     427,   430,   844,   930,   930,   393,   542,   426,   505,   928,
     427,   430,   427,   430,   251,   482,   251,   252,   534,   793,
     356,   928,   427,   430,   104,   413,   684,   939,   467,   346,
     678,   679,   393,   683,   685,   109,   183,   316,   374,   718,
     159,   793,   427,   942,   426,   830,   194,   260,   834,   830,
     834,   194,   833,   834,   194,   426,   942,   426,   897,   248,
     480,   844,   930,   480,   376,   480,   376,   480,   480,   928,
     928,   930,   580,   480,   942,   311,   311,   311,   929,   649,
     430,   940,   393,   430,   647,   255,   793,   774,   133,   133,
     929,   644,   480,   940,   900,   427,   353,   868,   127,   844,
     868,   868,   868,   908,   844,   869,   116,   118,   238,   248,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   869,
     868,   868,   909,   908,   865,   865,   844,   427,   427,   427,
     896,   427,   430,   944,   876,   275,   340,   878,   427,   430,
     386,   872,    31,   427,   862,   939,   868,    28,    28,   868,
     427,   868,   150,   426,   899,   868,   869,   869,   129,   129,
     868,   427,   129,   868,   803,   803,   803,   803,   928,   928,
     868,   158,   820,   430,   806,   807,   806,   427,   882,   426,
     883,   942,   868,   882,   939,   383,   898,   427,   427,   425,
     413,   787,   775,   426,   668,   427,   253,   736,   153,   318,
     347,   658,   145,   658,   427,   426,   525,   526,   665,   871,
     942,   522,   522,   427,   940,   629,   181,   421,   365,   238,
     482,    97,   238,   335,   338,   482,   365,   930,   942,   485,
     604,   944,   356,   356,   152,   254,   338,   612,   613,   152,
     254,   619,   620,   356,   356,   427,   427,   427,   941,   939,
     939,   939,   569,   930,   145,   145,   296,   145,   165,   940,
     930,   940,   930,   930,   930,   930,   567,   427,   634,   191,
     191,   634,   634,   634,   634,   634,   634,   376,   495,   496,
     427,   430,   419,   426,   464,   467,   499,   549,   744,   744,
     238,   283,   744,   744,   106,   177,   238,   594,   595,   596,
     938,   393,   394,   425,   425,   427,   866,   928,   736,   104,
     938,   939,   104,   939,   104,   939,   104,   939,   104,   930,
     104,   930,   104,   930,   426,   930,   869,   107,   167,   106,
     243,   195,   928,   685,   426,   929,   929,   844,    31,   928,
     396,   145,   587,   427,   430,   843,   565,   769,    97,   230,
     507,   509,   511,   519,   942,   533,   517,   176,   532,   508,
     541,    69,   348,   535,   393,   731,   939,   663,   680,   868,
     868,   430,   426,   681,   601,   356,   553,   832,   426,   929,
     830,   252,   376,   835,   830,   194,   830,   842,   426,   842,
     942,   427,   930,   427,   480,   932,   932,   480,   480,   320,
     929,   929,   929,   549,   155,   646,   653,   150,   868,   427,
     427,   909,   150,   116,   118,   248,   426,   427,   399,   874,
     896,   391,   391,   427,   868,   230,   868,   430,   873,   846,
     866,   869,   869,   868,   899,   427,    28,    28,   868,   868,
     129,   868,   427,   928,   928,   928,   928,    47,   160,   821,
     427,   427,   882,   884,   942,   898,   882,   939,   924,   695,
     941,   356,   641,   150,   594,   868,   427,   430,   393,   376,
     628,   666,   666,   427,   427,   685,   365,   243,   243,   941,
     942,   844,   480,   480,   413,   940,   930,   938,   938,   844,
     430,   938,   938,   430,   940,   930,   929,   929,   628,   929,
     135,   191,   634,   634,   437,   111,   498,   464,   467,   500,
     501,   939,   939,   243,   419,   522,   939,   939,   107,   167,
     106,   596,   595,   425,   152,   180,   152,   150,   593,   941,
     868,   238,   514,   685,   521,   376,   536,   566,   570,   376,
     793,   426,   930,   122,   588,   389,   590,   939,    97,   427,
     430,   393,   534,   132,   171,   426,   533,   109,   121,   275,
     930,    51,    59,   210,   150,   426,   939,   677,   686,   687,
     943,   685,   928,   178,   554,   929,   427,   868,   426,   830,
     835,   427,   842,   427,   480,   480,   480,   930,   255,   480,
     645,   869,   150,   426,   899,   426,   427,   430,   427,   427,
     380,   332,   427,   427,   427,   869,   869,   868,   896,   868,
     392,   879,   882,   882,   268,   885,   427,   866,   427,   645,
     252,   645,   427,   685,   526,   254,   695,   628,   667,   667,
     290,   685,   536,   376,   481,   604,   426,   936,   695,   613,
     426,   426,   620,   393,   296,   393,   393,   145,   634,   490,
     939,   427,   430,   522,   649,    31,   700,   700,   928,   594,
     427,   536,   217,   524,   173,   427,   430,   932,   731,   565,
     307,   334,   589,   426,   134,   509,   256,   535,    22,    68,
      75,   105,   174,   338,   518,   518,   927,   534,   308,   308,
      59,   255,    59,   628,   664,   665,   679,   427,   430,   840,
     553,   556,   427,   929,   427,   480,   869,   899,   427,   875,
     896,   230,   408,   880,   881,   942,    47,   806,   882,   647,
     658,   480,   666,   536,   426,   668,   668,   928,   536,   594,
     868,   899,   671,   288,   616,   694,   899,   899,   627,   628,
     627,   628,   929,   501,   700,    34,   169,   145,   151,   267,
     328,   252,   528,   529,   530,   348,   570,   140,   615,   868,
     282,   512,   427,   535,   255,   255,   427,   430,   681,   686,
     117,   427,   427,   427,   427,   380,   430,    31,   896,   284,
     308,   886,   150,   667,   390,   527,   695,   521,   594,   427,
     616,   427,   427,   393,   122,   109,   374,   252,   530,   252,
     529,   930,   628,    31,   427,   936,   393,   483,   665,   685,
      23,   184,   719,   881,   883,    41,    87,   366,   868,   887,
     888,   887,   427,   645,   668,   426,   594,   427,   524,   936,
     628,   307,    50,   230,   300,   323,   531,   531,   612,   426,
     482,   535,   239,   426,   714,   716,   721,   771,   776,   782,
     793,   888,   307,   144,   273,   144,   273,   480,   868,   528,
     671,   590,    17,   104,   243,     4,     6,     7,   591,   592,
     938,   939,   942,   840,   715,   716,   717,   794,   795,    28,
     427,   594,   134,   427,   430,   427,   429,   888,   282,   592,
     717,   936,   426,   591,   427
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (core_yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 626 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 633 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 640 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 753 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 764 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 774 "gram.y"
    {;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 775 "gram.y"
    {;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 784 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 785 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 789 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 790 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 795 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 800 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 804 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 809 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 814 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 818 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 822 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 826 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 830 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 834 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 838 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 842 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 846 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 851 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 855 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 859 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 863 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 867 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 872 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 878 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 881 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 885 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 889 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 893 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 897 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 911 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 929 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 939 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 940 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 945 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 963 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 975 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 996 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1003 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1022 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1029 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1046 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1064 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1074 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1075 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1088 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1095 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1112 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1124 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1135 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1136 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1140 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1141 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1169 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1175 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1181 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1190 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1198 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1206 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1213 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1220 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1228 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1239 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1247 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1255 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1263 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 1271 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1282 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1290 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1298 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1305 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1314 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1316 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1322 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1323 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1327 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1329 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1331 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1334 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1335 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1336 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1337 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1341 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1342 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1343 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1344 "gram.y"
    { (yyval.str) = "off"; ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1357 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1361 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1365 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1380 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1402 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1403 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1404 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1408 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1409 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1410 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1414 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1415 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1420 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1427 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1434 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1441 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1448 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1457 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1458 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1464 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1470 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1476 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1482 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1488 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1498 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1507 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1508 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1512 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1513 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1522 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1537 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1543 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1549 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1555 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1573 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1581 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1589 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1597 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1607 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1608 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1614 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1622 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1630 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1639 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1647 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1655 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1664 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1673 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1682 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1691 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1701 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1714 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1724 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1732 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1742 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1759 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1766 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1773 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1464 of yacc.c  */
#line 1780 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1788 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1796 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 1804 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 1812 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1820 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1827 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1834 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1842 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1849 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1856 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1864 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1872 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1880 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1888 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1896 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1904 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1912 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1920 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1928 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1937 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1938 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 284:

/* Line 1464 of yacc.c  */
#line 1942 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1943 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1944 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1948 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1949 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1953 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1956 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1957 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1961 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1962 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1968 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1972 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1976 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1981 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1996 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 2002 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 2030 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 2051 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 2064 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 2065 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 2074 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 2075 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 2076 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 2079 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 2080 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 2085 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 2086 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 2091 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 2095 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 2099 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 2103 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 2107 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 2111 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 2115 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 2119 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 2123 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 2127 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 2131 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 2140 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 2143 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 2148 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 2151 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 2156 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 2159 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 2163 "gram.y"
    {;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 2164 "gram.y"
    {;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 2170 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 2174 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 2181 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 2187 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 2188 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 2189 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 2190 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 2191 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 2192 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 2197 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 2201 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 2208 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 2209 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 2222 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 2236 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->istemp = (yyvsp[(2) - (10)].boolean);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 2258 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 2259 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 2260 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 2261 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 2262 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 2263 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 2264 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 2268 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 2269 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 2273 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 2274 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 2279 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 2283 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 358:

/* Line 1464 of yacc.c  */
#line 2290 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 359:

/* Line 1464 of yacc.c  */
#line 2294 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 2300 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 2301 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 2302 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 2306 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 2307 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 2311 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 2322 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->constraints = (yyvsp[(4) - (4)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 2332 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 2333 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 2338 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 2345 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 2346 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 2366 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 2373 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 2380 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 2390 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 2400 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (4)]);
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 2409 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 2418 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 2447 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 2454 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 2461 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 2468 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 2487 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 2496 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 2497 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 2502 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 2504 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 2505 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 2506 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 2517 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 2524 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 2529 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					if ((yyvsp[(5) - (5)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CHECK constraints cannot be deferred"),
								 parser_errposition((yylsp[(5) - (5)]))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 2544 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexspace = (yyvsp[(6) - (7)].str);
					n->deferrable = ((yyvsp[(7) - (7)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(7) - (7)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 2557 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexspace = (yyvsp[(7) - (8)].str);
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 2571 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					n->deferrable		= ((yyvsp[(9) - (9)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(9) - (9)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 399:

/* Line 1464 of yacc.c  */
#line 2586 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 2604 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 2605 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 2609 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 2610 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 2614 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 2620 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 2624 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 2632 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 2636 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 409:

/* Line 1464 of yacc.c  */
#line 2642 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 2644 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 2648 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 2653 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			;}
    break;

  case 413:

/* Line 1464 of yacc.c  */
#line 2659 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 414:

/* Line 1464 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 2671 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 2673 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 2675 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 2677 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 2679 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 2682 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 2685 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 2689 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 2690 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 2691 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 2693 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 427:

/* Line 1464 of yacc.c  */
#line 2696 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 428:

/* Line 1464 of yacc.c  */
#line 2697 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 2702 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 2703 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 2704 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 2705 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 2708 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 2709 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 2710 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 2711 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 2714 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 2715 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 2718 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 2719 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 2730 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 parser_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 2755 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 2766 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 2767 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 2771 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 2772 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 2777 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 2792 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 2793 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 2794 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 2808 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 2820 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 2828 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 2829 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 2832 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 2833 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 2837 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 2841 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 2845 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 2849 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 2853 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 2857 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 2861 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 2865 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 2869 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 2873 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 2877 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 2881 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 469:

/* Line 1464 of yacc.c  */
#line 2886 "gram.y"
    {;}
    break;

  case 470:

/* Line 1464 of yacc.c  */
#line 2887 "gram.y"
    {;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 2891 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 2893 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 2897 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 2900 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 2901 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 2914 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 477:

/* Line 1464 of yacc.c  */
#line 2927 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 2940 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 2941 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 2949 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 2954 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 2955 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 2959 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 2960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2964 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 2965 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 2970 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 2978 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 2988 "gram.y"
    {;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 2989 "gram.y"
    {;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 3000 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 3009 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 3010 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 3024 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 3031 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 3047 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 3064 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 499:

/* Line 1464 of yacc.c  */
#line 3072 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 500:

/* Line 1464 of yacc.c  */
#line 3089 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 3098 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 3106 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 3116 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 3117 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 3122 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 3126 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 507:

/* Line 1464 of yacc.c  */
#line 3133 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 508:

/* Line 1464 of yacc.c  */
#line 3138 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 509:

/* Line 1464 of yacc.c  */
#line 3142 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 510:

/* Line 1464 of yacc.c  */
#line 3149 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 3153 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 3158 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 3163 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 3170 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 3176 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 3181 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 3193 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 3205 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 3206 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 3211 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 3212 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 3216 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 523:

/* Line 1464 of yacc.c  */
#line 3217 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 524:

/* Line 1464 of yacc.c  */
#line 3228 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 525:

/* Line 1464 of yacc.c  */
#line 3236 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 526:

/* Line 1464 of yacc.c  */
#line 3253 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 527:

/* Line 1464 of yacc.c  */
#line 3262 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 3270 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 3286 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 3297 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 3298 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 3299 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 3310 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 3318 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 3335 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 536:

/* Line 1464 of yacc.c  */
#line 3356 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->before = (yyvsp[(4) - (15)].boolean);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 537:

/* Line 1464 of yacc.c  */
#line 3377 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (20)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (20)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 538:

/* Line 1464 of yacc.c  */
#line 3397 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 539:

/* Line 1464 of yacc.c  */
#line 3398 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 3403 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 3405 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				;}
    break;

  case 542:

/* Line 1464 of yacc.c  */
#line 3427 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); ;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 3429 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); ;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 3431 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); ;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 3433 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 3435 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); ;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 3440 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 3444 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 3454 "gram.y"
    {;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 3455 "gram.y"
    {;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 3459 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 3460 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 3464 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 3465 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 3469 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 3470 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 3471 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 3476 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 3481 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 3482 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 3483 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 3484 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 3485 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 3489 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 565:

/* Line 1464 of yacc.c  */
#line 3490 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 566:

/* Line 1464 of yacc.c  */
#line 3495 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 567:

/* Line 1464 of yacc.c  */
#line 3497 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 568:

/* Line 1464 of yacc.c  */
#line 3506 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 569:

/* Line 1464 of yacc.c  */
#line 3513 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 570:

/* Line 1464 of yacc.c  */
#line 3522 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 571:

/* Line 1464 of yacc.c  */
#line 3526 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 3527 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 573:

/* Line 1464 of yacc.c  */
#line 3531 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 3532 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 575:

/* Line 1464 of yacc.c  */
#line 3538 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 576:

/* Line 1464 of yacc.c  */
#line 3548 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 3571 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 3589 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 3612 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 3622 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 3633 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 3643 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 3653 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 3664 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											parser_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 3700 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 3707 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 3716 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 3725 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 589:

/* Line 1464 of yacc.c  */
#line 3734 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 590:

/* Line 1464 of yacc.c  */
#line 3744 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 591:

/* Line 1464 of yacc.c  */
#line 3747 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 592:

/* Line 1464 of yacc.c  */
#line 3748 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 593:

/* Line 1464 of yacc.c  */
#line 3752 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 594:

/* Line 1464 of yacc.c  */
#line 3756 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 595:

/* Line 1464 of yacc.c  */
#line 3762 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 596:

/* Line 1464 of yacc.c  */
#line 3763 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 597:

/* Line 1464 of yacc.c  */
#line 3764 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 598:

/* Line 1464 of yacc.c  */
#line 3765 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 599:

/* Line 1464 of yacc.c  */
#line 3766 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 600:

/* Line 1464 of yacc.c  */
#line 3769 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 601:

/* Line 1464 of yacc.c  */
#line 3770 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 602:

/* Line 1464 of yacc.c  */
#line 3773 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 603:

/* Line 1464 of yacc.c  */
#line 3776 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 604:

/* Line 1464 of yacc.c  */
#line 3777 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 605:

/* Line 1464 of yacc.c  */
#line 3786 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 606:

/* Line 1464 of yacc.c  */
#line 3792 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 607:

/* Line 1464 of yacc.c  */
#line 3793 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 608:

/* Line 1464 of yacc.c  */
#line 3797 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 609:

/* Line 1464 of yacc.c  */
#line 3799 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 610:

/* Line 1464 of yacc.c  */
#line 3817 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 611:

/* Line 1464 of yacc.c  */
#line 3830 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 612:

/* Line 1464 of yacc.c  */
#line 3831 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 613:

/* Line 1464 of yacc.c  */
#line 3836 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 614:

/* Line 1464 of yacc.c  */
#line 3845 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 615:

/* Line 1464 of yacc.c  */
#line 3854 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 616:

/* Line 1464 of yacc.c  */
#line 3863 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 617:

/* Line 1464 of yacc.c  */
#line 3873 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 618:

/* Line 1464 of yacc.c  */
#line 3881 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 619:

/* Line 1464 of yacc.c  */
#line 3882 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 620:

/* Line 1464 of yacc.c  */
#line 3885 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 621:

/* Line 1464 of yacc.c  */
#line 3886 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 622:

/* Line 1464 of yacc.c  */
#line 3890 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 623:

/* Line 1464 of yacc.c  */
#line 3903 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 624:

/* Line 1464 of yacc.c  */
#line 3909 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 625:

/* Line 1464 of yacc.c  */
#line 3919 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 626:

/* Line 1464 of yacc.c  */
#line 3928 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 627:

/* Line 1464 of yacc.c  */
#line 3939 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 628:

/* Line 1464 of yacc.c  */
#line 3940 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 629:

/* Line 1464 of yacc.c  */
#line 3945 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 630:

/* Line 1464 of yacc.c  */
#line 3953 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 631:

/* Line 1464 of yacc.c  */
#line 3965 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 632:

/* Line 1464 of yacc.c  */
#line 3974 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 633:

/* Line 1464 of yacc.c  */
#line 3986 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 634:

/* Line 1464 of yacc.c  */
#line 3995 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 635:

/* Line 1464 of yacc.c  */
#line 4016 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 636:

/* Line 1464 of yacc.c  */
#line 4026 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 637:

/* Line 1464 of yacc.c  */
#line 4044 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 638:

/* Line 1464 of yacc.c  */
#line 4053 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 639:

/* Line 1464 of yacc.c  */
#line 4064 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 640:

/* Line 1464 of yacc.c  */
#line 4065 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 641:

/* Line 1464 of yacc.c  */
#line 4066 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 4067 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 643:

/* Line 1464 of yacc.c  */
#line 4068 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 644:

/* Line 1464 of yacc.c  */
#line 4069 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 645:

/* Line 1464 of yacc.c  */
#line 4070 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 4071 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 647:

/* Line 1464 of yacc.c  */
#line 4072 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 648:

/* Line 1464 of yacc.c  */
#line 4073 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 649:

/* Line 1464 of yacc.c  */
#line 4074 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 650:

/* Line 1464 of yacc.c  */
#line 4075 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 651:

/* Line 1464 of yacc.c  */
#line 4079 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 652:

/* Line 1464 of yacc.c  */
#line 4080 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 653:

/* Line 1464 of yacc.c  */
#line 4083 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 654:

/* Line 1464 of yacc.c  */
#line 4084 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 4088 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 4090 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 4103 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 4113 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 4114 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 4115 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 4141 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 4150 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 4159 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 4168 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 4177 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 4186 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 4195 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 4205 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 4214 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 4223 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 4232 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 4241 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 4250 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 4259 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 675:

/* Line 1464 of yacc.c  */
#line 4267 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 676:

/* Line 1464 of yacc.c  */
#line 4275 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 677:

/* Line 1464 of yacc.c  */
#line 4283 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 678:

/* Line 1464 of yacc.c  */
#line 4293 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 679:

/* Line 1464 of yacc.c  */
#line 4294 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 680:

/* Line 1464 of yacc.c  */
#line 4295 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 681:

/* Line 1464 of yacc.c  */
#line 4296 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 682:

/* Line 1464 of yacc.c  */
#line 4297 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 683:

/* Line 1464 of yacc.c  */
#line 4298 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 684:

/* Line 1464 of yacc.c  */
#line 4299 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 685:

/* Line 1464 of yacc.c  */
#line 4300 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 686:

/* Line 1464 of yacc.c  */
#line 4301 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 687:

/* Line 1464 of yacc.c  */
#line 4302 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 688:

/* Line 1464 of yacc.c  */
#line 4303 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 689:

/* Line 1464 of yacc.c  */
#line 4304 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 690:

/* Line 1464 of yacc.c  */
#line 4308 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 691:

/* Line 1464 of yacc.c  */
#line 4309 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 692:

/* Line 1464 of yacc.c  */
#line 4320 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 693:

/* Line 1464 of yacc.c  */
#line 4326 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 694:

/* Line 1464 of yacc.c  */
#line 4334 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 695:

/* Line 1464 of yacc.c  */
#line 4342 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 696:

/* Line 1464 of yacc.c  */
#line 4350 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 697:

/* Line 1464 of yacc.c  */
#line 4358 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 698:

/* Line 1464 of yacc.c  */
#line 4366 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 699:

/* Line 1464 of yacc.c  */
#line 4374 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 700:

/* Line 1464 of yacc.c  */
#line 4382 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 701:

/* Line 1464 of yacc.c  */
#line 4390 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1464 of yacc.c  */
#line 4398 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1464 of yacc.c  */
#line 4406 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 704:

/* Line 1464 of yacc.c  */
#line 4414 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 705:

/* Line 1464 of yacc.c  */
#line 4422 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 706:

/* Line 1464 of yacc.c  */
#line 4430 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 707:

/* Line 1464 of yacc.c  */
#line 4438 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 708:

/* Line 1464 of yacc.c  */
#line 4446 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 709:

/* Line 1464 of yacc.c  */
#line 4454 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 710:

/* Line 1464 of yacc.c  */
#line 4463 "gram.y"
    {;}
    break;

  case 711:

/* Line 1464 of yacc.c  */
#line 4464 "gram.y"
    {;}
    break;

  case 712:

/* Line 1464 of yacc.c  */
#line 4467 "gram.y"
    {;}
    break;

  case 713:

/* Line 1464 of yacc.c  */
#line 4468 "gram.y"
    {;}
    break;

  case 714:

/* Line 1464 of yacc.c  */
#line 4480 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 715:

/* Line 1464 of yacc.c  */
#line 4496 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 716:

/* Line 1464 of yacc.c  */
#line 4510 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 717:

/* Line 1464 of yacc.c  */
#line 4535 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 718:

/* Line 1464 of yacc.c  */
#line 4537 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 719:

/* Line 1464 of yacc.c  */
#line 4539 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 720:

/* Line 1464 of yacc.c  */
#line 4541 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 721:

/* Line 1464 of yacc.c  */
#line 4548 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 722:

/* Line 1464 of yacc.c  */
#line 4556 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 723:

/* Line 1464 of yacc.c  */
#line 4557 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 724:

/* Line 1464 of yacc.c  */
#line 4561 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 725:

/* Line 1464 of yacc.c  */
#line 4568 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 726:

/* Line 1464 of yacc.c  */
#line 4575 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 727:

/* Line 1464 of yacc.c  */
#line 4582 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 728:

/* Line 1464 of yacc.c  */
#line 4596 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 729:

/* Line 1464 of yacc.c  */
#line 4604 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 730:

/* Line 1464 of yacc.c  */
#line 4612 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 731:

/* Line 1464 of yacc.c  */
#line 4620 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 732:

/* Line 1464 of yacc.c  */
#line 4628 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 733:

/* Line 1464 of yacc.c  */
#line 4636 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 734:

/* Line 1464 of yacc.c  */
#line 4644 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 735:

/* Line 1464 of yacc.c  */
#line 4652 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 736:

/* Line 1464 of yacc.c  */
#line 4660 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 737:

/* Line 1464 of yacc.c  */
#line 4668 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 738:

/* Line 1464 of yacc.c  */
#line 4676 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 739:

/* Line 1464 of yacc.c  */
#line 4684 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 740:

/* Line 1464 of yacc.c  */
#line 4692 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 741:

/* Line 1464 of yacc.c  */
#line 4700 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 742:

/* Line 1464 of yacc.c  */
#line 4711 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 743:

/* Line 1464 of yacc.c  */
#line 4712 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 744:

/* Line 1464 of yacc.c  */
#line 4716 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 745:

/* Line 1464 of yacc.c  */
#line 4726 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 746:

/* Line 1464 of yacc.c  */
#line 4739 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 747:

/* Line 1464 of yacc.c  */
#line 4740 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 748:

/* Line 1464 of yacc.c  */
#line 4744 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 749:

/* Line 1464 of yacc.c  */
#line 4746 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 750:

/* Line 1464 of yacc.c  */
#line 4751 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 751:

/* Line 1464 of yacc.c  */
#line 4767 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 752:

/* Line 1464 of yacc.c  */
#line 4780 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 753:

/* Line 1464 of yacc.c  */
#line 4790 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 754:

/* Line 1464 of yacc.c  */
#line 4801 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 755:

/* Line 1464 of yacc.c  */
#line 4802 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 756:

/* Line 1464 of yacc.c  */
#line 4805 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 757:

/* Line 1464 of yacc.c  */
#line 4806 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 758:

/* Line 1464 of yacc.c  */
#line 4817 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 759:

/* Line 1464 of yacc.c  */
#line 4826 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 760:

/* Line 1464 of yacc.c  */
#line 4827 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 761:

/* Line 1464 of yacc.c  */
#line 4832 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 762:

/* Line 1464 of yacc.c  */
#line 4836 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 763:

/* Line 1464 of yacc.c  */
#line 4840 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 764:

/* Line 1464 of yacc.c  */
#line 4852 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 765:

/* Line 1464 of yacc.c  */
#line 4865 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 766:

/* Line 1464 of yacc.c  */
#line 4879 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 767:

/* Line 1464 of yacc.c  */
#line 4894 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; ;}
    break;

  case 768:

/* Line 1464 of yacc.c  */
#line 4895 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; ;}
    break;

  case 769:

/* Line 1464 of yacc.c  */
#line 4896 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; ;}
    break;

  case 770:

/* Line 1464 of yacc.c  */
#line 4911 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 771:

/* Line 1464 of yacc.c  */
#line 4927 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 772:

/* Line 1464 of yacc.c  */
#line 4928 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 773:

/* Line 1464 of yacc.c  */
#line 4932 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 774:

/* Line 1464 of yacc.c  */
#line 4933 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 775:

/* Line 1464 of yacc.c  */
#line 4937 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 776:

/* Line 1464 of yacc.c  */
#line 4938 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 777:

/* Line 1464 of yacc.c  */
#line 4942 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 778:

/* Line 1464 of yacc.c  */
#line 4943 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 779:

/* Line 1464 of yacc.c  */
#line 4946 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 780:

/* Line 1464 of yacc.c  */
#line 4947 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 781:

/* Line 1464 of yacc.c  */
#line 4956 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 782:

/* Line 1464 of yacc.c  */
#line 4966 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 783:

/* Line 1464 of yacc.c  */
#line 4976 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 784:

/* Line 1464 of yacc.c  */
#line 4987 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 785:

/* Line 1464 of yacc.c  */
#line 4988 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 786:

/* Line 1464 of yacc.c  */
#line 4989 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 787:

/* Line 1464 of yacc.c  */
#line 4992 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 788:

/* Line 1464 of yacc.c  */
#line 4993 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 789:

/* Line 1464 of yacc.c  */
#line 4994 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 790:

/* Line 1464 of yacc.c  */
#line 4997 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 791:

/* Line 1464 of yacc.c  */
#line 4998 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 792:

/* Line 1464 of yacc.c  */
#line 4999 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 793:

/* Line 1464 of yacc.c  */
#line 5017 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 794:

/* Line 1464 of yacc.c  */
#line 5029 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 795:

/* Line 1464 of yacc.c  */
#line 5042 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 796:

/* Line 1464 of yacc.c  */
#line 5055 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 797:

/* Line 1464 of yacc.c  */
#line 5056 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 798:

/* Line 1464 of yacc.c  */
#line 5059 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 799:

/* Line 1464 of yacc.c  */
#line 5060 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 800:

/* Line 1464 of yacc.c  */
#line 5064 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 801:

/* Line 1464 of yacc.c  */
#line 5065 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 802:

/* Line 1464 of yacc.c  */
#line 5073 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 803:

/* Line 1464 of yacc.c  */
#line 5074 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 804:

/* Line 1464 of yacc.c  */
#line 5078 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 805:

/* Line 1464 of yacc.c  */
#line 5080 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 806:

/* Line 1464 of yacc.c  */
#line 5095 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 807:

/* Line 1464 of yacc.c  */
#line 5104 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 808:

/* Line 1464 of yacc.c  */
#line 5113 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 809:

/* Line 1464 of yacc.c  */
#line 5122 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 810:

/* Line 1464 of yacc.c  */
#line 5131 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 811:

/* Line 1464 of yacc.c  */
#line 5142 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 812:

/* Line 1464 of yacc.c  */
#line 5143 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 813:

/* Line 1464 of yacc.c  */
#line 5144 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 814:

/* Line 1464 of yacc.c  */
#line 5145 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 815:

/* Line 1464 of yacc.c  */
#line 5146 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 817:

/* Line 1464 of yacc.c  */
#line 5157 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 818:

/* Line 1464 of yacc.c  */
#line 5171 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 819:

/* Line 1464 of yacc.c  */
#line 5173 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 820:

/* Line 1464 of yacc.c  */
#line 5179 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 821:

/* Line 1464 of yacc.c  */
#line 5189 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 822:

/* Line 1464 of yacc.c  */
#line 5193 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 823:

/* Line 1464 of yacc.c  */
#line 5198 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 824:

/* Line 1464 of yacc.c  */
#line 5207 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 825:

/* Line 1464 of yacc.c  */
#line 5208 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 826:

/* Line 1464 of yacc.c  */
#line 5216 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 827:

/* Line 1464 of yacc.c  */
#line 5220 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 828:

/* Line 1464 of yacc.c  */
#line 5224 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 829:

/* Line 1464 of yacc.c  */
#line 5228 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 830:

/* Line 1464 of yacc.c  */
#line 5232 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 831:

/* Line 1464 of yacc.c  */
#line 5236 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 832:

/* Line 1464 of yacc.c  */
#line 5240 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 833:

/* Line 1464 of yacc.c  */
#line 5244 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 834:

/* Line 1464 of yacc.c  */
#line 5248 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 835:

/* Line 1464 of yacc.c  */
#line 5252 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 836:

/* Line 1464 of yacc.c  */
#line 5256 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 837:

/* Line 1464 of yacc.c  */
#line 5260 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 838:

/* Line 1464 of yacc.c  */
#line 5264 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 839:

/* Line 1464 of yacc.c  */
#line 5272 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 840:

/* Line 1464 of yacc.c  */
#line 5276 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 841:

/* Line 1464 of yacc.c  */
#line 5280 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 842:

/* Line 1464 of yacc.c  */
#line 5284 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 843:

/* Line 1464 of yacc.c  */
#line 5289 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 844:

/* Line 1464 of yacc.c  */
#line 5291 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 845:

/* Line 1464 of yacc.c  */
#line 5297 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 846:

/* Line 1464 of yacc.c  */
#line 5298 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 847:

/* Line 1464 of yacc.c  */
#line 5302 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 848:

/* Line 1464 of yacc.c  */
#line 5314 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 849:

/* Line 1464 of yacc.c  */
#line 5318 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 850:

/* Line 1464 of yacc.c  */
#line 5333 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 851:

/* Line 1464 of yacc.c  */
#line 5343 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 852:

/* Line 1464 of yacc.c  */
#line 5344 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 855:

/* Line 1464 of yacc.c  */
#line 5366 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 856:

/* Line 1464 of yacc.c  */
#line 5376 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 857:

/* Line 1464 of yacc.c  */
#line 5389 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 858:

/* Line 1464 of yacc.c  */
#line 5399 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 859:

/* Line 1464 of yacc.c  */
#line 5412 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 860:

/* Line 1464 of yacc.c  */
#line 5422 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 861:

/* Line 1464 of yacc.c  */
#line 5435 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 862:

/* Line 1464 of yacc.c  */
#line 5443 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 863:

/* Line 1464 of yacc.c  */
#line 5445 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 864:

/* Line 1464 of yacc.c  */
#line 5447 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 865:

/* Line 1464 of yacc.c  */
#line 5452 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 866:

/* Line 1464 of yacc.c  */
#line 5454 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 867:

/* Line 1464 of yacc.c  */
#line 5467 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 868:

/* Line 1464 of yacc.c  */
#line 5475 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 869:

/* Line 1464 of yacc.c  */
#line 5476 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 870:

/* Line 1464 of yacc.c  */
#line 5481 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				;}
    break;

  case 871:

/* Line 1464 of yacc.c  */
#line 5485 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 872:

/* Line 1464 of yacc.c  */
#line 5498 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 873:

/* Line 1464 of yacc.c  */
#line 5509 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 874:

/* Line 1464 of yacc.c  */
#line 5520 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 875:

/* Line 1464 of yacc.c  */
#line 5531 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 876:

/* Line 1464 of yacc.c  */
#line 5532 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 877:

/* Line 1464 of yacc.c  */
#line 5533 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 878:

/* Line 1464 of yacc.c  */
#line 5538 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 879:

/* Line 1464 of yacc.c  */
#line 5548 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 880:

/* Line 1464 of yacc.c  */
#line 5549 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 881:

/* Line 1464 of yacc.c  */
#line 5564 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 882:

/* Line 1464 of yacc.c  */
#line 5572 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 883:

/* Line 1464 of yacc.c  */
#line 5582 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 884:

/* Line 1464 of yacc.c  */
#line 5594 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 885:

/* Line 1464 of yacc.c  */
#line 5595 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 886:

/* Line 1464 of yacc.c  */
#line 5598 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 887:

/* Line 1464 of yacc.c  */
#line 5599 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 888:

/* Line 1464 of yacc.c  */
#line 5610 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 889:

/* Line 1464 of yacc.c  */
#line 5619 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 890:

/* Line 1464 of yacc.c  */
#line 5627 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 891:

/* Line 1464 of yacc.c  */
#line 5635 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 892:

/* Line 1464 of yacc.c  */
#line 5644 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 893:

/* Line 1464 of yacc.c  */
#line 5652 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 894:

/* Line 1464 of yacc.c  */
#line 5660 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 895:

/* Line 1464 of yacc.c  */
#line 5669 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 896:

/* Line 1464 of yacc.c  */
#line 5678 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 897:

/* Line 1464 of yacc.c  */
#line 5686 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 898:

/* Line 1464 of yacc.c  */
#line 5695 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 899:

/* Line 1464 of yacc.c  */
#line 5704 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 900:

/* Line 1464 of yacc.c  */
#line 5713 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 901:

/* Line 1464 of yacc.c  */
#line 5722 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 902:

/* Line 1464 of yacc.c  */
#line 5731 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 903:

/* Line 1464 of yacc.c  */
#line 5740 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 904:

/* Line 1464 of yacc.c  */
#line 5748 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1464 of yacc.c  */
#line 5756 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1464 of yacc.c  */
#line 5764 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1464 of yacc.c  */
#line 5773 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 908:

/* Line 1464 of yacc.c  */
#line 5782 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 909:

/* Line 1464 of yacc.c  */
#line 5790 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 910:

/* Line 1464 of yacc.c  */
#line 5798 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 911:

/* Line 1464 of yacc.c  */
#line 5806 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 912:

/* Line 1464 of yacc.c  */
#line 5814 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 913:

/* Line 1464 of yacc.c  */
#line 5823 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 914:

/* Line 1464 of yacc.c  */
#line 5824 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 915:

/* Line 1464 of yacc.c  */
#line 5827 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 916:

/* Line 1464 of yacc.c  */
#line 5828 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 917:

/* Line 1464 of yacc.c  */
#line 5839 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 918:

/* Line 1464 of yacc.c  */
#line 5848 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 919:

/* Line 1464 of yacc.c  */
#line 5856 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 920:

/* Line 1464 of yacc.c  */
#line 5865 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 921:

/* Line 1464 of yacc.c  */
#line 5873 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 922:

/* Line 1464 of yacc.c  */
#line 5881 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 923:

/* Line 1464 of yacc.c  */
#line 5889 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 924:

/* Line 1464 of yacc.c  */
#line 5905 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 925:

/* Line 1464 of yacc.c  */
#line 5914 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 926:

/* Line 1464 of yacc.c  */
#line 5922 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 927:

/* Line 1464 of yacc.c  */
#line 5930 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 928:

/* Line 1464 of yacc.c  */
#line 5938 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 929:

/* Line 1464 of yacc.c  */
#line 5947 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 930:

/* Line 1464 of yacc.c  */
#line 5955 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 931:

/* Line 1464 of yacc.c  */
#line 5963 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 932:

/* Line 1464 of yacc.c  */
#line 5972 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 933:

/* Line 1464 of yacc.c  */
#line 5981 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 934:

/* Line 1464 of yacc.c  */
#line 5990 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 935:

/* Line 1464 of yacc.c  */
#line 5998 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 936:

/* Line 1464 of yacc.c  */
#line 6006 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 937:

/* Line 1464 of yacc.c  */
#line 6014 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 938:

/* Line 1464 of yacc.c  */
#line 6022 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 939:

/* Line 1464 of yacc.c  */
#line 6030 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 940:

/* Line 1464 of yacc.c  */
#line 6038 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 941:

/* Line 1464 of yacc.c  */
#line 6054 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 942:

/* Line 1464 of yacc.c  */
#line 6062 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 943:

/* Line 1464 of yacc.c  */
#line 6070 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 944:

/* Line 1464 of yacc.c  */
#line 6078 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (7)].range);
					n->addname = (yyvsp[(6) - (7)].str);
					n->secLabel = (yyvsp[(7) - (7)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 945:

/* Line 1464 of yacc.c  */
#line 6087 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 946:

/* Line 1464 of yacc.c  */
#line 6095 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 947:

/* Line 1464 of yacc.c  */
#line 6103 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (4)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (4)].funwithargs)->funcargs;
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 948:

/* Line 1464 of yacc.c  */
#line 6112 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (5)].list);
					n->objarg = (yyvsp[(4) - (5)].list);
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 949:

/* Line 1464 of yacc.c  */
#line 6121 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 950:

/* Line 1464 of yacc.c  */
#line 6129 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (4)].list);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 951:

/* Line 1464 of yacc.c  */
#line 6139 "gram.y"
    {
					(yyval.value) = makeString((yyvsp[(4) - (4)].str));
				;}
    break;

  case 952:

/* Line 1464 of yacc.c  */
#line 6153 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 953:

/* Line 1464 of yacc.c  */
#line 6167 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 954:

/* Line 1464 of yacc.c  */
#line 6168 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 955:

/* Line 1464 of yacc.c  */
#line 6169 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 956:

/* Line 1464 of yacc.c  */
#line 6175 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 957:

/* Line 1464 of yacc.c  */
#line 6181 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 963:

/* Line 1464 of yacc.c  */
#line 6197 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 964:

/* Line 1464 of yacc.c  */
#line 6198 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 965:

/* Line 1464 of yacc.c  */
#line 6201 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 966:

/* Line 1464 of yacc.c  */
#line 6202 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 967:

/* Line 1464 of yacc.c  */
#line 6203 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 968:

/* Line 1464 of yacc.c  */
#line 6204 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 969:

/* Line 1464 of yacc.c  */
#line 6208 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 970:

/* Line 1464 of yacc.c  */
#line 6209 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 971:

/* Line 1464 of yacc.c  */
#line 6210 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 972:

/* Line 1464 of yacc.c  */
#line 6216 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 973:

/* Line 1464 of yacc.c  */
#line 6226 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 974:

/* Line 1464 of yacc.c  */
#line 6247 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 975:

/* Line 1464 of yacc.c  */
#line 6256 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 976:

/* Line 1464 of yacc.c  */
#line 6257 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 977:

/* Line 1464 of yacc.c  */
#line 6261 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 978:

/* Line 1464 of yacc.c  */
#line 6270 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 979:

/* Line 1464 of yacc.c  */
#line 6276 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 980:

/* Line 1464 of yacc.c  */
#line 6295 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 981:

/* Line 1464 of yacc.c  */
#line 6302 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 982:

/* Line 1464 of yacc.c  */
#line 6309 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 983:

/* Line 1464 of yacc.c  */
#line 6316 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 984:

/* Line 1464 of yacc.c  */
#line 6323 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 985:

/* Line 1464 of yacc.c  */
#line 6330 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 986:

/* Line 1464 of yacc.c  */
#line 6337 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 987:

/* Line 1464 of yacc.c  */
#line 6345 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 988:

/* Line 1464 of yacc.c  */
#line 6353 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 989:

/* Line 1464 of yacc.c  */
#line 6361 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 990:

/* Line 1464 of yacc.c  */
#line 6369 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 991:

/* Line 1464 of yacc.c  */
#line 6377 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 992:

/* Line 1464 of yacc.c  */
#line 6384 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 993:

/* Line 1464 of yacc.c  */
#line 6391 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 994:

/* Line 1464 of yacc.c  */
#line 6399 "gram.y"
    {;}
    break;

  case 995:

/* Line 1464 of yacc.c  */
#line 6400 "gram.y"
    {;}
    break;

  case 996:

/* Line 1464 of yacc.c  */
#line 6401 "gram.y"
    {;}
    break;

  case 997:

/* Line 1464 of yacc.c  */
#line 6406 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 998:

/* Line 1464 of yacc.c  */
#line 6409 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 999:

/* Line 1464 of yacc.c  */
#line 6412 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 1000:

/* Line 1464 of yacc.c  */
#line 6419 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 1001:

/* Line 1464 of yacc.c  */
#line 6421 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 1002:

/* Line 1464 of yacc.c  */
#line 6423 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1004:

/* Line 1464 of yacc.c  */
#line 6429 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1005:

/* Line 1464 of yacc.c  */
#line 6443 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1006:

/* Line 1464 of yacc.c  */
#line 6454 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1007:

/* Line 1464 of yacc.c  */
#line 6467 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1008:

/* Line 1464 of yacc.c  */
#line 6473 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1009:

/* Line 1464 of yacc.c  */
#line 6479 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1010:

/* Line 1464 of yacc.c  */
#line 6484 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1011:

/* Line 1464 of yacc.c  */
#line 6495 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1012:

/* Line 1464 of yacc.c  */
#line 6511 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1013:

/* Line 1464 of yacc.c  */
#line 6520 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1014:

/* Line 1464 of yacc.c  */
#line 6521 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1015:

/* Line 1464 of yacc.c  */
#line 6526 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1016:

/* Line 1464 of yacc.c  */
#line 6530 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 1017:

/* Line 1464 of yacc.c  */
#line 6534 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1018:

/* Line 1464 of yacc.c  */
#line 6538 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 1019:

/* Line 1464 of yacc.c  */
#line 6542 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1020:

/* Line 1464 of yacc.c  */
#line 6546 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 1021:

/* Line 1464 of yacc.c  */
#line 6550 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1022:

/* Line 1464 of yacc.c  */
#line 6554 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 1023:

/* Line 1464 of yacc.c  */
#line 6558 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 1024:

/* Line 1464 of yacc.c  */
#line 6562 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1025:

/* Line 1464 of yacc.c  */
#line 6566 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 1026:

/* Line 1464 of yacc.c  */
#line 6570 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1027:

/* Line 1464 of yacc.c  */
#line 6574 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 1028:

/* Line 1464 of yacc.c  */
#line 6578 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1029:

/* Line 1464 of yacc.c  */
#line 6582 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1030:

/* Line 1464 of yacc.c  */
#line 6586 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 1031:

/* Line 1464 of yacc.c  */
#line 6595 "gram.y"
    {;}
    break;

  case 1032:

/* Line 1464 of yacc.c  */
#line 6596 "gram.y"
    {;}
    break;

  case 1033:

/* Line 1464 of yacc.c  */
#line 6608 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1034:

/* Line 1464 of yacc.c  */
#line 6615 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1035:

/* Line 1464 of yacc.c  */
#line 6626 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1036:

/* Line 1464 of yacc.c  */
#line 6636 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1037:

/* Line 1464 of yacc.c  */
#line 6637 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1038:

/* Line 1464 of yacc.c  */
#line 6642 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1039:

/* Line 1464 of yacc.c  */
#line 6656 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1040:

/* Line 1464 of yacc.c  */
#line 6663 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1041:

/* Line 1464 of yacc.c  */
#line 6680 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1042:

/* Line 1464 of yacc.c  */
#line 6692 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1043:

/* Line 1464 of yacc.c  */
#line 6701 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1044:

/* Line 1464 of yacc.c  */
#line 6709 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1045:

/* Line 1464 of yacc.c  */
#line 6717 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1046:

/* Line 1464 of yacc.c  */
#line 6726 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1047:

/* Line 1464 of yacc.c  */
#line 6736 "gram.y"
    {;}
    break;

  case 1048:

/* Line 1464 of yacc.c  */
#line 6737 "gram.y"
    {;}
    break;

  case 1049:

/* Line 1464 of yacc.c  */
#line 6749 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1050:

/* Line 1464 of yacc.c  */
#line 6759 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1051:

/* Line 1464 of yacc.c  */
#line 6769 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1052:

/* Line 1464 of yacc.c  */
#line 6779 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1053:

/* Line 1464 of yacc.c  */
#line 6789 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1054:

/* Line 1464 of yacc.c  */
#line 6799 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1055:

/* Line 1464 of yacc.c  */
#line 6807 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1056:

/* Line 1464 of yacc.c  */
#line 6829 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 1057:

/* Line 1464 of yacc.c  */
#line 6851 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1058:

/* Line 1464 of yacc.c  */
#line 6859 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1059:

/* Line 1464 of yacc.c  */
#line 6868 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1060:

/* Line 1464 of yacc.c  */
#line 6878 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 1061:

/* Line 1464 of yacc.c  */
#line 6879 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1062:

/* Line 1464 of yacc.c  */
#line 6892 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1063:

/* Line 1464 of yacc.c  */
#line 6906 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1064:

/* Line 1464 of yacc.c  */
#line 6920 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1065:

/* Line 1464 of yacc.c  */
#line 6932 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1066:

/* Line 1464 of yacc.c  */
#line 6944 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1067:

/* Line 1464 of yacc.c  */
#line 6960 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1068:

/* Line 1464 of yacc.c  */
#line 6961 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 1069:

/* Line 1464 of yacc.c  */
#line 6965 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; ;}
    break;

  case 1070:

/* Line 1464 of yacc.c  */
#line 6966 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; ;}
    break;

  case 1071:

/* Line 1464 of yacc.c  */
#line 6967 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; ;}
    break;

  case 1072:

/* Line 1464 of yacc.c  */
#line 6968 "gram.y"
    { (yyval.ival) = VACOPT_FULL; ;}
    break;

  case 1073:

/* Line 1464 of yacc.c  */
#line 6973 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1074:

/* Line 1464 of yacc.c  */
#line 6985 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1075:

/* Line 1464 of yacc.c  */
#line 6999 "gram.y"
    {;}
    break;

  case 1076:

/* Line 1464 of yacc.c  */
#line 7000 "gram.y"
    {;}
    break;

  case 1077:

/* Line 1464 of yacc.c  */
#line 7004 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1078:

/* Line 1464 of yacc.c  */
#line 7005 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1079:

/* Line 1464 of yacc.c  */
#line 7008 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1080:

/* Line 1464 of yacc.c  */
#line 7009 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1081:

/* Line 1464 of yacc.c  */
#line 7012 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1082:

/* Line 1464 of yacc.c  */
#line 7013 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1083:

/* Line 1464 of yacc.c  */
#line 7017 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1084:

/* Line 1464 of yacc.c  */
#line 7018 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1085:

/* Line 1464 of yacc.c  */
#line 7032 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1086:

/* Line 1464 of yacc.c  */
#line 7039 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1087:

/* Line 1464 of yacc.c  */
#line 7049 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1088:

/* Line 1464 of yacc.c  */
#line 7056 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1096:

/* Line 1464 of yacc.c  */
#line 7076 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 1097:

/* Line 1464 of yacc.c  */
#line 7080 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 1098:

/* Line 1464 of yacc.c  */
#line 7087 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1099:

/* Line 1464 of yacc.c  */
#line 7093 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1100:

/* Line 1464 of yacc.c  */
#line 7094 "gram.y"
    { (yyval.str) = "analyze"; ;}
    break;

  case 1101:

/* Line 1464 of yacc.c  */
#line 7095 "gram.y"
    { (yyval.str) = "verbose"; ;}
    break;

  case 1102:

/* Line 1464 of yacc.c  */
#line 7099 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1103:

/* Line 1464 of yacc.c  */
#line 7100 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1104:

/* Line 1464 of yacc.c  */
#line 7101 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 1105:

/* Line 1464 of yacc.c  */
#line 7102 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1106:

/* Line 1464 of yacc.c  */
#line 7113 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1107:

/* Line 1464 of yacc.c  */
#line 7122 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1108:

/* Line 1464 of yacc.c  */
#line 7123 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1113:

/* Line 1464 of yacc.c  */
#line 7141 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1114:

/* Line 1464 of yacc.c  */
#line 7150 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1115:

/* Line 1464 of yacc.c  */
#line 7165 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1116:

/* Line 1464 of yacc.c  */
#line 7166 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1117:

/* Line 1464 of yacc.c  */
#line 7177 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1118:

/* Line 1464 of yacc.c  */
#line 7183 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1119:

/* Line 1464 of yacc.c  */
#line 7189 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1120:

/* Line 1464 of yacc.c  */
#line 7195 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1121:

/* Line 1464 of yacc.c  */
#line 7211 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1122:

/* Line 1464 of yacc.c  */
#line 7220 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1123:

/* Line 1464 of yacc.c  */
#line 7226 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1124:

/* Line 1464 of yacc.c  */
#line 7232 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1125:

/* Line 1464 of yacc.c  */
#line 7241 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1126:

/* Line 1464 of yacc.c  */
#line 7243 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1127:

/* Line 1464 of yacc.c  */
#line 7248 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1128:

/* Line 1464 of yacc.c  */
#line 7258 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1129:

/* Line 1464 of yacc.c  */
#line 7259 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1130:

/* Line 1464 of yacc.c  */
#line 7272 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1131:

/* Line 1464 of yacc.c  */
#line 7283 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1132:

/* Line 1464 of yacc.c  */
#line 7284 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1133:

/* Line 1464 of yacc.c  */
#line 7296 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1134:

/* Line 1464 of yacc.c  */
#line 7306 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1135:

/* Line 1464 of yacc.c  */
#line 7307 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1136:

/* Line 1464 of yacc.c  */
#line 7310 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1137:

/* Line 1464 of yacc.c  */
#line 7311 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1138:

/* Line 1464 of yacc.c  */
#line 7312 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1139:

/* Line 1464 of yacc.c  */
#line 7313 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1140:

/* Line 1464 of yacc.c  */
#line 7314 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1141:

/* Line 1464 of yacc.c  */
#line 7315 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1142:

/* Line 1464 of yacc.c  */
#line 7316 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1143:

/* Line 1464 of yacc.c  */
#line 7317 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1144:

/* Line 1464 of yacc.c  */
#line 7320 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1145:

/* Line 1464 of yacc.c  */
#line 7321 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1146:

/* Line 1464 of yacc.c  */
#line 7337 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1147:

/* Line 1464 of yacc.c  */
#line 7349 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1148:

/* Line 1464 of yacc.c  */
#line 7350 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1149:

/* Line 1464 of yacc.c  */
#line 7354 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1150:

/* Line 1464 of yacc.c  */
#line 7355 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1151:

/* Line 1464 of yacc.c  */
#line 7360 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1152:

/* Line 1464 of yacc.c  */
#line 7368 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1153:

/* Line 1464 of yacc.c  */
#line 7396 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1154:

/* Line 1464 of yacc.c  */
#line 7406 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1155:

/* Line 1464 of yacc.c  */
#line 7407 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1156:

/* Line 1464 of yacc.c  */
#line 7418 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1157:

/* Line 1464 of yacc.c  */
#line 7428 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1158:

/* Line 1464 of yacc.c  */
#line 7431 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1159:

/* Line 1464 of yacc.c  */
#line 7432 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1160:

/* Line 1464 of yacc.c  */
#line 7433 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1161:

/* Line 1464 of yacc.c  */
#line 7434 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1162:

/* Line 1464 of yacc.c  */
#line 7435 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1163:

/* Line 1464 of yacc.c  */
#line 7438 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1164:

/* Line 1464 of yacc.c  */
#line 7439 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1165:

/* Line 1464 of yacc.c  */
#line 7440 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1168:

/* Line 1464 of yacc.c  */
#line 7493 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1169:

/* Line 1464 of yacc.c  */
#line 7494 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1170:

/* Line 1464 of yacc.c  */
#line 7508 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1171:

/* Line 1464 of yacc.c  */
#line 7510 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1172:

/* Line 1464 of yacc.c  */
#line 7517 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1173:

/* Line 1464 of yacc.c  */
#line 7525 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1174:

/* Line 1464 of yacc.c  */
#line 7533 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1175:

/* Line 1464 of yacc.c  */
#line 7541 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1176:

/* Line 1464 of yacc.c  */
#line 7549 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1177:

/* Line 1464 of yacc.c  */
#line 7557 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1178:

/* Line 1464 of yacc.c  */
#line 7567 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1179:

/* Line 1464 of yacc.c  */
#line 7568 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1180:

/* Line 1464 of yacc.c  */
#line 7598 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1181:

/* Line 1464 of yacc.c  */
#line 7610 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1182:

/* Line 1464 of yacc.c  */
#line 7612 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1183:

/* Line 1464 of yacc.c  */
#line 7631 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1184:

/* Line 1464 of yacc.c  */
#line 7635 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1185:

/* Line 1464 of yacc.c  */
#line 7639 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1186:

/* Line 1464 of yacc.c  */
#line 7654 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1187:

/* Line 1464 of yacc.c  */
#line 7661 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1188:

/* Line 1464 of yacc.c  */
#line 7670 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1189:

/* Line 1464 of yacc.c  */
#line 7671 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1190:

/* Line 1464 of yacc.c  */
#line 7675 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1191:

/* Line 1464 of yacc.c  */
#line 7687 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1192:

/* Line 1464 of yacc.c  */
#line 7696 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1193:

/* Line 1464 of yacc.c  */
#line 7705 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1194:

/* Line 1464 of yacc.c  */
#line 7710 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1195:

/* Line 1464 of yacc.c  */
#line 7715 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1196:

/* Line 1464 of yacc.c  */
#line 7720 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1197:

/* Line 1464 of yacc.c  */
#line 7725 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1198:

/* Line 1464 of yacc.c  */
#line 7730 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1199:

/* Line 1464 of yacc.c  */
#line 7735 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1200:

/* Line 1464 of yacc.c  */
#line 7740 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1201:

/* Line 1464 of yacc.c  */
#line 7746 "gram.y"
    {;}
    break;

  case 1202:

/* Line 1464 of yacc.c  */
#line 7747 "gram.y"
    {;}
    break;

  case 1203:

/* Line 1464 of yacc.c  */
#line 7750 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1204:

/* Line 1464 of yacc.c  */
#line 7751 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1205:

/* Line 1464 of yacc.c  */
#line 7752 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1206:

/* Line 1464 of yacc.c  */
#line 7759 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1207:

/* Line 1464 of yacc.c  */
#line 7760 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1208:

/* Line 1464 of yacc.c  */
#line 7761 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1209:

/* Line 1464 of yacc.c  */
#line 7762 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1210:

/* Line 1464 of yacc.c  */
#line 7766 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1211:

/* Line 1464 of yacc.c  */
#line 7767 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1212:

/* Line 1464 of yacc.c  */
#line 7771 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1213:

/* Line 1464 of yacc.c  */
#line 7775 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1214:

/* Line 1464 of yacc.c  */
#line 7776 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1215:

/* Line 1464 of yacc.c  */
#line 7780 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1216:

/* Line 1464 of yacc.c  */
#line 7789 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1217:

/* Line 1464 of yacc.c  */
#line 7801 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); ;}
    break;

  case 1218:

/* Line 1464 of yacc.c  */
#line 7802 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1219:

/* Line 1464 of yacc.c  */
#line 7803 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); ;}
    break;

  case 1220:

/* Line 1464 of yacc.c  */
#line 7804 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); ;}
    break;

  case 1221:

/* Line 1464 of yacc.c  */
#line 7808 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1222:

/* Line 1464 of yacc.c  */
#line 7809 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1223:

/* Line 1464 of yacc.c  */
#line 7814 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1224:

/* Line 1464 of yacc.c  */
#line 7816 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1225:

/* Line 1464 of yacc.c  */
#line 7826 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); ;}
    break;

  case 1226:

/* Line 1464 of yacc.c  */
#line 7831 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1227:

/* Line 1464 of yacc.c  */
#line 7834 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1228:

/* Line 1464 of yacc.c  */
#line 7838 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1229:

/* Line 1464 of yacc.c  */
#line 7840 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1230:

/* Line 1464 of yacc.c  */
#line 7847 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1231:

/* Line 1464 of yacc.c  */
#line 7857 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1232:

/* Line 1464 of yacc.c  */
#line 7858 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1233:

/* Line 1464 of yacc.c  */
#line 7859 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1234:

/* Line 1464 of yacc.c  */
#line 7867 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1235:

/* Line 1464 of yacc.c  */
#line 7871 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1236:

/* Line 1464 of yacc.c  */
#line 7872 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1237:

/* Line 1464 of yacc.c  */
#line 7875 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1238:

/* Line 1464 of yacc.c  */
#line 7876 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1239:

/* Line 1464 of yacc.c  */
#line 7881 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1240:

/* Line 1464 of yacc.c  */
#line 7882 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1241:

/* Line 1464 of yacc.c  */
#line 7886 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1242:

/* Line 1464 of yacc.c  */
#line 7887 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1243:

/* Line 1464 of yacc.c  */
#line 7891 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1244:

/* Line 1464 of yacc.c  */
#line 7892 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1245:

/* Line 1464 of yacc.c  */
#line 7896 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1246:

/* Line 1464 of yacc.c  */
#line 7897 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1247:

/* Line 1464 of yacc.c  */
#line 7901 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1248:

/* Line 1464 of yacc.c  */
#line 7902 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1249:

/* Line 1464 of yacc.c  */
#line 7907 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1250:

/* Line 1464 of yacc.c  */
#line 7915 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1251:

/* Line 1464 of yacc.c  */
#line 7925 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1252:

/* Line 1464 of yacc.c  */
#line 7926 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1253:

/* Line 1464 of yacc.c  */
#line 7932 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1254:

/* Line 1464 of yacc.c  */
#line 7938 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1255:

/* Line 1464 of yacc.c  */
#line 7955 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1256:

/* Line 1464 of yacc.c  */
#line 7956 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1257:

/* Line 1464 of yacc.c  */
#line 7960 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1258:

/* Line 1464 of yacc.c  */
#line 7961 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1259:

/* Line 1464 of yacc.c  */
#line 7972 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1260:

/* Line 1464 of yacc.c  */
#line 7976 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1261:

/* Line 1464 of yacc.c  */
#line 7981 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1262:

/* Line 1464 of yacc.c  */
#line 7988 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1263:

/* Line 1464 of yacc.c  */
#line 7996 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1264:

/* Line 1464 of yacc.c  */
#line 8003 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1265:

/* Line 1464 of yacc.c  */
#line 8013 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1266:

/* Line 1464 of yacc.c  */
#line 8023 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1267:

/* Line 1464 of yacc.c  */
#line 8051 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1268:

/* Line 1464 of yacc.c  */
#line 8058 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1269:

/* Line 1464 of yacc.c  */
#line 8062 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1270:

/* Line 1464 of yacc.c  */
#line 8088 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1271:

/* Line 1464 of yacc.c  */
#line 8092 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1272:

/* Line 1464 of yacc.c  */
#line 8104 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1273:

/* Line 1464 of yacc.c  */
#line 8117 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1274:

/* Line 1464 of yacc.c  */
#line 8131 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1275:

/* Line 1464 of yacc.c  */
#line 8142 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1276:

/* Line 1464 of yacc.c  */
#line 8157 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1277:

/* Line 1464 of yacc.c  */
#line 8163 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1278:

/* Line 1464 of yacc.c  */
#line 8168 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1279:

/* Line 1464 of yacc.c  */
#line 8174 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1280:

/* Line 1464 of yacc.c  */
#line 8180 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1281:

/* Line 1464 of yacc.c  */
#line 8181 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1282:

/* Line 1464 of yacc.c  */
#line 8182 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1283:

/* Line 1464 of yacc.c  */
#line 8183 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1284:

/* Line 1464 of yacc.c  */
#line 8187 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1285:

/* Line 1464 of yacc.c  */
#line 8188 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1286:

/* Line 1464 of yacc.c  */
#line 8200 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1287:

/* Line 1464 of yacc.c  */
#line 8201 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1288:

/* Line 1464 of yacc.c  */
#line 8207 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1289:

/* Line 1464 of yacc.c  */
#line 8214 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1290:

/* Line 1464 of yacc.c  */
#line 8221 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1291:

/* Line 1464 of yacc.c  */
#line 8228 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1292:

/* Line 1464 of yacc.c  */
#line 8238 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1293:

/* Line 1464 of yacc.c  */
#line 8239 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1294:

/* Line 1464 of yacc.c  */
#line 8253 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1295:

/* Line 1464 of yacc.c  */
#line 8257 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1296:

/* Line 1464 of yacc.c  */
#line 8264 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1297:

/* Line 1464 of yacc.c  */
#line 8273 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1298:

/* Line 1464 of yacc.c  */
#line 8278 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1299:

/* Line 1464 of yacc.c  */
#line 8279 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1300:

/* Line 1464 of yacc.c  */
#line 8284 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1301:

/* Line 1464 of yacc.c  */
#line 8286 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1302:

/* Line 1464 of yacc.c  */
#line 8293 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1303:

/* Line 1464 of yacc.c  */
#line 8299 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1304:

/* Line 1464 of yacc.c  */
#line 8303 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1305:

/* Line 1464 of yacc.c  */
#line 8309 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typeName = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1306:

/* Line 1464 of yacc.c  */
#line 8330 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1307:

/* Line 1464 of yacc.c  */
#line 8335 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1308:

/* Line 1464 of yacc.c  */
#line 8342 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1309:

/* Line 1464 of yacc.c  */
#line 8347 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1310:

/* Line 1464 of yacc.c  */
#line 8353 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1311:

/* Line 1464 of yacc.c  */
#line 8358 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1312:

/* Line 1464 of yacc.c  */
#line 8367 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1313:

/* Line 1464 of yacc.c  */
#line 8369 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1314:

/* Line 1464 of yacc.c  */
#line 8371 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1315:

/* Line 1464 of yacc.c  */
#line 8375 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1316:

/* Line 1464 of yacc.c  */
#line 8376 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1317:

/* Line 1464 of yacc.c  */
#line 8377 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1318:

/* Line 1464 of yacc.c  */
#line 8378 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1319:

/* Line 1464 of yacc.c  */
#line 8379 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1320:

/* Line 1464 of yacc.c  */
#line 8381 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1321:

/* Line 1464 of yacc.c  */
#line 8386 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1322:

/* Line 1464 of yacc.c  */
#line 8415 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1323:

/* Line 1464 of yacc.c  */
#line 8416 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1324:

/* Line 1464 of yacc.c  */
#line 8417 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1325:

/* Line 1464 of yacc.c  */
#line 8418 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1326:

/* Line 1464 of yacc.c  */
#line 8430 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1327:

/* Line 1464 of yacc.c  */
#line 8436 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1328:

/* Line 1464 of yacc.c  */
#line 8443 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1329:

/* Line 1464 of yacc.c  */
#line 8444 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1330:

/* Line 1464 of yacc.c  */
#line 8451 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1331:

/* Line 1464 of yacc.c  */
#line 8456 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1332:

/* Line 1464 of yacc.c  */
#line 8461 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1333:

/* Line 1464 of yacc.c  */
#line 8466 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1334:

/* Line 1464 of yacc.c  */
#line 8471 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1335:

/* Line 1464 of yacc.c  */
#line 8476 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1336:

/* Line 1464 of yacc.c  */
#line 8481 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1337:

/* Line 1464 of yacc.c  */
#line 8486 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1338:

/* Line 1464 of yacc.c  */
#line 8492 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1339:

/* Line 1464 of yacc.c  */
#line 8498 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1340:

/* Line 1464 of yacc.c  */
#line 8504 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1341:

/* Line 1464 of yacc.c  */
#line 8511 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1342:

/* Line 1464 of yacc.c  */
#line 8532 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1343:

/* Line 1464 of yacc.c  */
#line 8542 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1344:

/* Line 1464 of yacc.c  */
#line 8546 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1345:

/* Line 1464 of yacc.c  */
#line 8554 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1346:

/* Line 1464 of yacc.c  */
#line 8558 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1347:

/* Line 1464 of yacc.c  */
#line 8566 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1348:

/* Line 1464 of yacc.c  */
#line 8578 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1349:

/* Line 1464 of yacc.c  */
#line 8599 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1350:

/* Line 1464 of yacc.c  */
#line 8603 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1351:

/* Line 1464 of yacc.c  */
#line 8609 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1352:

/* Line 1464 of yacc.c  */
#line 8613 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1353:

/* Line 1464 of yacc.c  */
#line 8626 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1354:

/* Line 1464 of yacc.c  */
#line 8645 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1355:

/* Line 1464 of yacc.c  */
#line 8668 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1356:

/* Line 1464 of yacc.c  */
#line 8670 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1357:

/* Line 1464 of yacc.c  */
#line 8672 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1358:

/* Line 1464 of yacc.c  */
#line 8674 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1359:

/* Line 1464 of yacc.c  */
#line 8676 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1360:

/* Line 1464 of yacc.c  */
#line 8678 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1361:

/* Line 1464 of yacc.c  */
#line 8682 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1362:

/* Line 1464 of yacc.c  */
#line 8683 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1363:

/* Line 1464 of yacc.c  */
#line 8687 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1364:

/* Line 1464 of yacc.c  */
#line 8688 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1365:

/* Line 1464 of yacc.c  */
#line 8696 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1366:

/* Line 1464 of yacc.c  */
#line 8705 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1367:

/* Line 1464 of yacc.c  */
#line 8713 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1368:

/* Line 1464 of yacc.c  */
#line 8722 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1369:

/* Line 1464 of yacc.c  */
#line 8733 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1370:

/* Line 1464 of yacc.c  */
#line 8740 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1371:

/* Line 1464 of yacc.c  */
#line 8741 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1372:

/* Line 1464 of yacc.c  */
#line 8742 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1373:

/* Line 1464 of yacc.c  */
#line 8747 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1374:

/* Line 1464 of yacc.c  */
#line 8749 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1375:

/* Line 1464 of yacc.c  */
#line 8751 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1376:

/* Line 1464 of yacc.c  */
#line 8753 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1377:

/* Line 1464 of yacc.c  */
#line 8755 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1378:

/* Line 1464 of yacc.c  */
#line 8757 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1379:

/* Line 1464 of yacc.c  */
#line 8759 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1380:

/* Line 1464 of yacc.c  */
#line 8764 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1381:

/* Line 1464 of yacc.c  */
#line 8769 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1382:

/* Line 1464 of yacc.c  */
#line 8775 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1383:

/* Line 1464 of yacc.c  */
#line 8783 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1384:

/* Line 1464 of yacc.c  */
#line 8788 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1385:

/* Line 1464 of yacc.c  */
#line 8795 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1386:

/* Line 1464 of yacc.c  */
#line 8801 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1387:

/* Line 1464 of yacc.c  */
#line 8806 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1388:

/* Line 1464 of yacc.c  */
#line 8810 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1389:

/* Line 1464 of yacc.c  */
#line 8839 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1390:

/* Line 1464 of yacc.c  */
#line 8841 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1391:

/* Line 1464 of yacc.c  */
#line 8843 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1392:

/* Line 1464 of yacc.c  */
#line 8865 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1393:

/* Line 1464 of yacc.c  */
#line 8867 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1394:

/* Line 1464 of yacc.c  */
#line 8869 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1395:

/* Line 1464 of yacc.c  */
#line 8871 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1396:

/* Line 1464 of yacc.c  */
#line 8873 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1397:

/* Line 1464 of yacc.c  */
#line 8875 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1398:

/* Line 1464 of yacc.c  */
#line 8877 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1399:

/* Line 1464 of yacc.c  */
#line 8879 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1400:

/* Line 1464 of yacc.c  */
#line 8881 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1401:

/* Line 1464 of yacc.c  */
#line 8883 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1402:

/* Line 1464 of yacc.c  */
#line 8885 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1403:

/* Line 1464 of yacc.c  */
#line 8888 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1404:

/* Line 1464 of yacc.c  */
#line 8890 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1405:

/* Line 1464 of yacc.c  */
#line 8892 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1406:

/* Line 1464 of yacc.c  */
#line 8895 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1407:

/* Line 1464 of yacc.c  */
#line 8897 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1408:

/* Line 1464 of yacc.c  */
#line 8899 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1409:

/* Line 1464 of yacc.c  */
#line 8902 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1410:

/* Line 1464 of yacc.c  */
#line 8904 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1411:

/* Line 1464 of yacc.c  */
#line 8917 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1412:

/* Line 1464 of yacc.c  */
#line 8919 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1413:

/* Line 1464 of yacc.c  */
#line 8932 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1414:

/* Line 1464 of yacc.c  */
#line 8934 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1415:

/* Line 1464 of yacc.c  */
#line 8947 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1416:

/* Line 1464 of yacc.c  */
#line 8949 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1417:

/* Line 1464 of yacc.c  */
#line 8963 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1418:

/* Line 1464 of yacc.c  */
#line 8976 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1419:

/* Line 1464 of yacc.c  */
#line 8989 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1420:

/* Line 1464 of yacc.c  */
#line 9002 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1421:

/* Line 1464 of yacc.c  */
#line 9025 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1422:

/* Line 1464 of yacc.c  */
#line 9032 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1423:

/* Line 1464 of yacc.c  */
#line 9039 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1424:

/* Line 1464 of yacc.c  */
#line 9046 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1425:

/* Line 1464 of yacc.c  */
#line 9053 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]), yyscanner);
				;}
    break;

  case 1426:

/* Line 1464 of yacc.c  */
#line 9057 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1427:

/* Line 1464 of yacc.c  */
#line 9064 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1428:

/* Line 1464 of yacc.c  */
#line 9071 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1429:

/* Line 1464 of yacc.c  */
#line 9078 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1430:

/* Line 1464 of yacc.c  */
#line 9085 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1431:

/* Line 1464 of yacc.c  */
#line 9092 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1432:

/* Line 1464 of yacc.c  */
#line 9099 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1433:

/* Line 1464 of yacc.c  */
#line 9103 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1434:

/* Line 1464 of yacc.c  */
#line 9111 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1435:

/* Line 1464 of yacc.c  */
#line 9115 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1436:

/* Line 1464 of yacc.c  */
#line 9125 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1437:

/* Line 1464 of yacc.c  */
#line 9132 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1438:

/* Line 1464 of yacc.c  */
#line 9139 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1439:

/* Line 1464 of yacc.c  */
#line 9152 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1440:

/* Line 1464 of yacc.c  */
#line 9165 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1441:

/* Line 1464 of yacc.c  */
#line 9184 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1442:

/* Line 1464 of yacc.c  */
#line 9205 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1443:

/* Line 1464 of yacc.c  */
#line 9215 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1444:

/* Line 1464 of yacc.c  */
#line 9222 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1445:

/* Line 1464 of yacc.c  */
#line 9238 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1446:

/* Line 1464 of yacc.c  */
#line 9243 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1447:

/* Line 1464 of yacc.c  */
#line 9261 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1448:

/* Line 1464 of yacc.c  */
#line 9263 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1449:

/* Line 1464 of yacc.c  */
#line 9265 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1450:

/* Line 1464 of yacc.c  */
#line 9267 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1451:

/* Line 1464 of yacc.c  */
#line 9269 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1452:

/* Line 1464 of yacc.c  */
#line 9271 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1453:

/* Line 1464 of yacc.c  */
#line 9273 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1454:

/* Line 1464 of yacc.c  */
#line 9275 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1455:

/* Line 1464 of yacc.c  */
#line 9277 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1456:

/* Line 1464 of yacc.c  */
#line 9279 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1457:

/* Line 1464 of yacc.c  */
#line 9281 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1458:

/* Line 1464 of yacc.c  */
#line 9283 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1459:

/* Line 1464 of yacc.c  */
#line 9285 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1460:

/* Line 1464 of yacc.c  */
#line 9287 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1461:

/* Line 1464 of yacc.c  */
#line 9289 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1462:

/* Line 1464 of yacc.c  */
#line 9291 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1463:

/* Line 1464 of yacc.c  */
#line 9293 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1464:

/* Line 1464 of yacc.c  */
#line 9297 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1465:

/* Line 1464 of yacc.c  */
#line 9302 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1466:

/* Line 1464 of yacc.c  */
#line 9306 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1467:

/* Line 1464 of yacc.c  */
#line 9310 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1468:

/* Line 1464 of yacc.c  */
#line 9315 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1469:

/* Line 1464 of yacc.c  */
#line 9331 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1470:

/* Line 1464 of yacc.c  */
#line 9332 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1471:

/* Line 1464 of yacc.c  */
#line 9334 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1472:

/* Line 1464 of yacc.c  */
#line 9349 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1473:

/* Line 1464 of yacc.c  */
#line 9361 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1474:

/* Line 1464 of yacc.c  */
#line 9363 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1475:

/* Line 1464 of yacc.c  */
#line 9365 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1476:

/* Line 1464 of yacc.c  */
#line 9375 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1477:

/* Line 1464 of yacc.c  */
#line 9385 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1478:

/* Line 1464 of yacc.c  */
#line 9395 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1479:

/* Line 1464 of yacc.c  */
#line 9403 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1480:

/* Line 1464 of yacc.c  */
#line 9421 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1481:

/* Line 1464 of yacc.c  */
#line 9434 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1482:

/* Line 1464 of yacc.c  */
#line 9447 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1483:

/* Line 1464 of yacc.c  */
#line 9460 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1484:

/* Line 1464 of yacc.c  */
#line 9473 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1485:

/* Line 1464 of yacc.c  */
#line 9486 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1486:

/* Line 1464 of yacc.c  */
#line 9503 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1487:

/* Line 1464 of yacc.c  */
#line 9516 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1488:

/* Line 1464 of yacc.c  */
#line 9539 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1489:

/* Line 1464 of yacc.c  */
#line 9560 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1490:

/* Line 1464 of yacc.c  */
#line 9570 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1491:

/* Line 1464 of yacc.c  */
#line 9583 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1492:

/* Line 1464 of yacc.c  */
#line 9600 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1493:

/* Line 1464 of yacc.c  */
#line 9613 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1494:

/* Line 1464 of yacc.c  */
#line 9623 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1495:

/* Line 1464 of yacc.c  */
#line 9636 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1496:

/* Line 1464 of yacc.c  */
#line 9646 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1497:

/* Line 1464 of yacc.c  */
#line 9659 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1498:

/* Line 1464 of yacc.c  */
#line 9672 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1499:

/* Line 1464 of yacc.c  */
#line 9685 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1500:

/* Line 1464 of yacc.c  */
#line 9698 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1501:

/* Line 1464 of yacc.c  */
#line 9711 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1502:

/* Line 1464 of yacc.c  */
#line 9724 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1503:

/* Line 1464 of yacc.c  */
#line 9737 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1504:

/* Line 1464 of yacc.c  */
#line 9739 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1505:

/* Line 1464 of yacc.c  */
#line 9752 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1506:

/* Line 1464 of yacc.c  */
#line 9770 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1507:

/* Line 1464 of yacc.c  */
#line 9784 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1508:

/* Line 1464 of yacc.c  */
#line 9800 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1509:

/* Line 1464 of yacc.c  */
#line 9822 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1510:

/* Line 1464 of yacc.c  */
#line 9838 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1511:

/* Line 1464 of yacc.c  */
#line 9851 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1512:

/* Line 1464 of yacc.c  */
#line 9864 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1513:

/* Line 1464 of yacc.c  */
#line 9877 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1514:

/* Line 1464 of yacc.c  */
#line 9881 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1515:

/* Line 1464 of yacc.c  */
#line 9888 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1516:

/* Line 1464 of yacc.c  */
#line 9896 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1517:

/* Line 1464 of yacc.c  */
#line 9904 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1518:

/* Line 1464 of yacc.c  */
#line 9908 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1519:

/* Line 1464 of yacc.c  */
#line 9912 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1520:

/* Line 1464 of yacc.c  */
#line 9916 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1521:

/* Line 1464 of yacc.c  */
#line 9920 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1522:

/* Line 1464 of yacc.c  */
#line 9924 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1523:

/* Line 1464 of yacc.c  */
#line 9928 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1524:

/* Line 1464 of yacc.c  */
#line 9937 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1525:

/* Line 1464 of yacc.c  */
#line 9941 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1526:

/* Line 1464 of yacc.c  */
#line 9945 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1527:

/* Line 1464 of yacc.c  */
#line 9950 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1528:

/* Line 1464 of yacc.c  */
#line 9964 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1529:

/* Line 1464 of yacc.c  */
#line 9966 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1530:

/* Line 1464 of yacc.c  */
#line 9970 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1531:

/* Line 1464 of yacc.c  */
#line 9972 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1532:

/* Line 1464 of yacc.c  */
#line 9974 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1533:

/* Line 1464 of yacc.c  */
#line 9976 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1534:

/* Line 1464 of yacc.c  */
#line 9979 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1535:

/* Line 1464 of yacc.c  */
#line 9982 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1536:

/* Line 1464 of yacc.c  */
#line 9983 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1537:

/* Line 1464 of yacc.c  */
#line 9987 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1538:

/* Line 1464 of yacc.c  */
#line 9995 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1539:

/* Line 1464 of yacc.c  */
#line 10004 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1540:

/* Line 1464 of yacc.c  */
#line 10005 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1541:

/* Line 1464 of yacc.c  */
#line 10008 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1542:

/* Line 1464 of yacc.c  */
#line 10009 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1543:

/* Line 1464 of yacc.c  */
#line 10010 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1544:

/* Line 1464 of yacc.c  */
#line 10017 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1545:

/* Line 1464 of yacc.c  */
#line 10018 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1546:

/* Line 1464 of yacc.c  */
#line 10022 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1547:

/* Line 1464 of yacc.c  */
#line 10024 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1548:

/* Line 1464 of yacc.c  */
#line 10029 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1549:

/* Line 1464 of yacc.c  */
#line 10037 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1550:

/* Line 1464 of yacc.c  */
#line 10039 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1551:

/* Line 1464 of yacc.c  */
#line 10052 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1552:

/* Line 1464 of yacc.c  */
#line 10057 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1553:

/* Line 1464 of yacc.c  */
#line 10082 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1554:

/* Line 1464 of yacc.c  */
#line 10083 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1555:

/* Line 1464 of yacc.c  */
#line 10086 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1556:

/* Line 1464 of yacc.c  */
#line 10087 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1557:

/* Line 1464 of yacc.c  */
#line 10099 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				;}
    break;

  case 1558:

/* Line 1464 of yacc.c  */
#line 10117 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				;}
    break;

  case 1559:

/* Line 1464 of yacc.c  */
#line 10123 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1560:

/* Line 1464 of yacc.c  */
#line 10133 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				;}
    break;

  case 1561:

/* Line 1464 of yacc.c  */
#line 10150 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				;}
    break;

  case 1562:

/* Line 1464 of yacc.c  */
#line 10195 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1563:

/* Line 1464 of yacc.c  */
#line 10203 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1564:

/* Line 1464 of yacc.c  */
#line 10211 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1565:

/* Line 1464 of yacc.c  */
#line 10219 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1566:

/* Line 1464 of yacc.c  */
#line 10227 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1567:

/* Line 1464 of yacc.c  */
#line 10247 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1568:

/* Line 1464 of yacc.c  */
#line 10248 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1569:

/* Line 1464 of yacc.c  */
#line 10249 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1570:

/* Line 1464 of yacc.c  */
#line 10252 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1571:

/* Line 1464 of yacc.c  */
#line 10253 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1572:

/* Line 1464 of yacc.c  */
#line 10254 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1573:

/* Line 1464 of yacc.c  */
#line 10257 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1574:

/* Line 1464 of yacc.c  */
#line 10258 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1575:

/* Line 1464 of yacc.c  */
#line 10261 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1576:

/* Line 1464 of yacc.c  */
#line 10262 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1577:

/* Line 1464 of yacc.c  */
#line 10263 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1578:

/* Line 1464 of yacc.c  */
#line 10264 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1579:

/* Line 1464 of yacc.c  */
#line 10265 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1580:

/* Line 1464 of yacc.c  */
#line 10266 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1581:

/* Line 1464 of yacc.c  */
#line 10267 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1582:

/* Line 1464 of yacc.c  */
#line 10268 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1583:

/* Line 1464 of yacc.c  */
#line 10269 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1584:

/* Line 1464 of yacc.c  */
#line 10273 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1585:

/* Line 1464 of yacc.c  */
#line 10275 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1586:

/* Line 1464 of yacc.c  */
#line 10280 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1587:

/* Line 1464 of yacc.c  */
#line 10282 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1588:

/* Line 1464 of yacc.c  */
#line 10287 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1589:

/* Line 1464 of yacc.c  */
#line 10289 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1590:

/* Line 1464 of yacc.c  */
#line 10291 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1591:

/* Line 1464 of yacc.c  */
#line 10293 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1592:

/* Line 1464 of yacc.c  */
#line 10295 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1593:

/* Line 1464 of yacc.c  */
#line 10297 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1594:

/* Line 1464 of yacc.c  */
#line 10309 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1595:

/* Line 1464 of yacc.c  */
#line 10313 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1596:

/* Line 1464 of yacc.c  */
#line 10320 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1597:

/* Line 1464 of yacc.c  */
#line 10324 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1598:

/* Line 1464 of yacc.c  */
#line 10330 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1599:

/* Line 1464 of yacc.c  */
#line 10334 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				;}
    break;

  case 1600:

/* Line 1464 of yacc.c  */
#line 10344 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1601:

/* Line 1464 of yacc.c  */
#line 10345 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1602:

/* Line 1464 of yacc.c  */
#line 10349 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1603:

/* Line 1464 of yacc.c  */
#line 10353 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1604:

/* Line 1464 of yacc.c  */
#line 10357 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1605:

/* Line 1464 of yacc.c  */
#line 10362 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1606:

/* Line 1464 of yacc.c  */
#line 10363 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1607:

/* Line 1464 of yacc.c  */
#line 10369 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1608:

/* Line 1464 of yacc.c  */
#line 10372 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1609:

/* Line 1464 of yacc.c  */
#line 10379 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1610:

/* Line 1464 of yacc.c  */
#line 10380 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1611:

/* Line 1464 of yacc.c  */
#line 10381 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1612:

/* Line 1464 of yacc.c  */
#line 10382 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1613:

/* Line 1464 of yacc.c  */
#line 10383 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1614:

/* Line 1464 of yacc.c  */
#line 10384 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1615:

/* Line 1464 of yacc.c  */
#line 10385 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1616:

/* Line 1464 of yacc.c  */
#line 10386 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1617:

/* Line 1464 of yacc.c  */
#line 10397 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1618:

/* Line 1464 of yacc.c  */
#line 10401 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1619:

/* Line 1464 of yacc.c  */
#line 10408 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1620:

/* Line 1464 of yacc.c  */
#line 10414 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1621:

/* Line 1464 of yacc.c  */
#line 10415 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1622:

/* Line 1464 of yacc.c  */
#line 10432 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1623:

/* Line 1464 of yacc.c  */
#line 10436 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1624:

/* Line 1464 of yacc.c  */
#line 10441 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1625:

/* Line 1464 of yacc.c  */
#line 10445 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1626:

/* Line 1464 of yacc.c  */
#line 10460 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1627:

/* Line 1464 of yacc.c  */
#line 10464 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1628:

/* Line 1464 of yacc.c  */
#line 10468 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1629:

/* Line 1464 of yacc.c  */
#line 10471 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1630:

/* Line 1464 of yacc.c  */
#line 10474 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1631:

/* Line 1464 of yacc.c  */
#line 10475 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1632:

/* Line 1464 of yacc.c  */
#line 10476 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1633:

/* Line 1464 of yacc.c  */
#line 10480 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1634:

/* Line 1464 of yacc.c  */
#line 10486 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1635:

/* Line 1464 of yacc.c  */
#line 10497 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1636:

/* Line 1464 of yacc.c  */
#line 10510 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1637:

/* Line 1464 of yacc.c  */
#line 10511 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1638:

/* Line 1464 of yacc.c  */
#line 10516 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1639:

/* Line 1464 of yacc.c  */
#line 10526 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1640:

/* Line 1464 of yacc.c  */
#line 10527 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1641:

/* Line 1464 of yacc.c  */
#line 10530 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1642:

/* Line 1464 of yacc.c  */
#line 10531 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1643:

/* Line 1464 of yacc.c  */
#line 10535 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				;}
    break;

  case 1644:

/* Line 1464 of yacc.c  */
#line 10539 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				;}
    break;

  case 1645:

/* Line 1464 of yacc.c  */
#line 10546 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1646:

/* Line 1464 of yacc.c  */
#line 10550 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1647:

/* Line 1464 of yacc.c  */
#line 10554 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1648:

/* Line 1464 of yacc.c  */
#line 10561 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1649:

/* Line 1464 of yacc.c  */
#line 10570 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1650:

/* Line 1464 of yacc.c  */
#line 10571 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1651:

/* Line 1464 of yacc.c  */
#line 10575 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1652:

/* Line 1464 of yacc.c  */
#line 10576 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1655:

/* Line 1464 of yacc.c  */
#line 10591 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1656:

/* Line 1464 of yacc.c  */
#line 10593 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1657:

/* Line 1464 of yacc.c  */
#line 10601 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1658:

/* Line 1464 of yacc.c  */
#line 10602 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1659:

/* Line 1464 of yacc.c  */
#line 10610 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1660:

/* Line 1464 of yacc.c  */
#line 10621 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1661:

/* Line 1464 of yacc.c  */
#line 10622 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1662:

/* Line 1464 of yacc.c  */
#line 10626 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1663:

/* Line 1464 of yacc.c  */
#line 10642 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1664:

/* Line 1464 of yacc.c  */
#line 10650 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1665:

/* Line 1464 of yacc.c  */
#line 10658 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1666:

/* Line 1464 of yacc.c  */
#line 10679 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1667:

/* Line 1464 of yacc.c  */
#line 10680 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1668:

/* Line 1464 of yacc.c  */
#line 10692 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1669:

/* Line 1464 of yacc.c  */
#line 10700 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1670:

/* Line 1464 of yacc.c  */
#line 10728 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1671:

/* Line 1464 of yacc.c  */
#line 10730 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1672:

/* Line 1464 of yacc.c  */
#line 10734 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1673:

/* Line 1464 of yacc.c  */
#line 10737 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1674:

/* Line 1464 of yacc.c  */
#line 10740 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1675:

/* Line 1464 of yacc.c  */
#line 10742 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1676:

/* Line 1464 of yacc.c  */
#line 10744 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1677:

/* Line 1464 of yacc.c  */
#line 10746 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1678:

/* Line 1464 of yacc.c  */
#line 10757 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1679:

/* Line 1464 of yacc.c  */
#line 10759 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					;}
    break;

  case 1680:

/* Line 1464 of yacc.c  */
#line 10770 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1681:

/* Line 1464 of yacc.c  */
#line 10774 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1682:

/* Line 1464 of yacc.c  */
#line 10778 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1683:

/* Line 1464 of yacc.c  */
#line 10782 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1684:

/* Line 1464 of yacc.c  */
#line 10786 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1685:

/* Line 1464 of yacc.c  */
#line 10795 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1686:

/* Line 1464 of yacc.c  */
#line 10802 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
								    (errcode(ERRCODE_SYNTAX_ERROR),
								     errmsg("type modifier cannot have parameter name"),
								     parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1687:

/* Line 1464 of yacc.c  */
#line 10827 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1688:

/* Line 1464 of yacc.c  */
#line 10831 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1689:

/* Line 1464 of yacc.c  */
#line 10837 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1690:

/* Line 1464 of yacc.c  */
#line 10854 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1691:

/* Line 1464 of yacc.c  */
#line 10858 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1692:

/* Line 1464 of yacc.c  */
#line 10862 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1693:

/* Line 1464 of yacc.c  */
#line 10867 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1694:

/* Line 1464 of yacc.c  */
#line 10868 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1695:

/* Line 1464 of yacc.c  */
#line 10869 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1696:

/* Line 1464 of yacc.c  */
#line 10871 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1697:

/* Line 1464 of yacc.c  */
#line 10872 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1698:

/* Line 1464 of yacc.c  */
#line 10873 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1699:

/* Line 1464 of yacc.c  */
#line 10889 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1700:

/* Line 1464 of yacc.c  */
#line 10890 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1701:

/* Line 1464 of yacc.c  */
#line 10891 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1702:

/* Line 1464 of yacc.c  */
#line 10896 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1703:

/* Line 1464 of yacc.c  */
#line 10897 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1704:

/* Line 1464 of yacc.c  */
#line 10898 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1705:

/* Line 1464 of yacc.c  */
#line 10904 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1706:

/* Line 1464 of yacc.c  */
#line 10905 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1707:

/* Line 1464 of yacc.c  */
#line 10906 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1708:

/* Line 1464 of yacc.c  */
#line 10907 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1709:

/* Line 1464 of yacc.c  */
#line 10908 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;



/* Line 1464 of yacc.c  */
#line 33759 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, yyscanner, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, yyscanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, yyscanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 11361 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location, core_yyscan_t yyscanner)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 parser_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 parser_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_order = NIL;
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"

